/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

//General includes
#ifndef _SHARED_
	#include "Shared.h"
#endif

//Project includes
#ifndef _L2SERVER_
	#include "L2Server.h"
#endif
#ifndef _EX_USER_
	#include "ExUser.h"
#endif

#ifndef _AUTOSS_
	#define _AUTOSS_
#endif

using namespace std;
using namespace User;

//--------------------------------------------------------------------------------------------
//// Global Variables
//--------------------------------------------------------------------------------------------

struct AutoState
{
	DWORD * pSocket;	//player's socket
	WORD itemID;		//itemID to reload
};

//--------------------------------------------------------------------------------------------
//// Function Prototypes
//--------------------------------------------------------------------------------------------

// Handles the threaded reloading of AutoSS
//
// Parameters:
// LPVOID lpParameter - AutoState struct with pSocket and itemID
//
//DWORD WINAPI AutoSSThreadHandler(LPVOID lpParameter);

// Reply to Client Packet: RequestAutoSS(0xD0/0x05)
// Reply Packet Header: aOPCODE(OP_EXTENDED)/0x12
// Reply Packet Format: chdd
// 
// Enables the Auto SoulShots/SpiritShots functionality in-game
//
// Parameters:
// DWORD * pSocket - address of the socket ID for the client
// WORD itemID - item the client is trying to enable AutoSS on
// BYTE setting - whether to enable (1) or disable (0) AutoSS
//
void RequestAutoSS(DWORD * pSocket, WORD itemID, BYTE setting, BYTE shotsevent);
bool RequestAutoSS_C1(DWORD * pSocket, WORD itemID, BYTE setting, BYTE shotsevent);

// Will refresh the user's Soulshot/Spiritshot automatically
//
// Parameters:
// DWORD * pSocket - address of the socket ID for the client
// WORD itemID - itemID we will be using for AutoSS
//
void RefreshAutoSS(DWORD * pSocket, WORD itemID, BYTE shotsevent);
