#pragma once

#include "CriticalSection.h"

#define EXPORT extern "C" __declspec (dllexport)

class CCreature_;

#pragma pack(1)

typedef  void (__stdcall *MEMBERLIST_FREEDATA) (void *ptr);
EXPORT MEMBERLIST_FREEDATA MemberList_FreeData;

class CMemberList
{
public:
        int nUnkVar1;
        CCreature_ **ppUserBegin;
        CCreature_ **ppUserEnd;
        int nUnkVar2;
		void Cleanup()
		{
			if (ppUserBegin!=NULL)
			{
				MemberList_FreeData(ppUserBegin);
			}
		}
};

class CPartyData
{
public:
	int Unk00; //00
	int Unk04; //04
	int Unk08; //08
	int Unk0C; //0C
	int Unk10; //10
	int Unk14; //14
	int Unk18; //18
	int Unk1C; //1C
	int Unk20; //20
	int Unk24; //24
	int Unk28; //28
	int Unk2C; //2C
	int Unk30; //30
	int Unk34; //34
	int Unk38; //38
	int Unk3C; //3C
	int Unk40; //40
	int Unk44; //44
	int Unk48; //48
	int Unk4C; //4C
	int Unk50; //50
	int Unk54; //54
	int Unk58; //58
	int Unk5C; //5C
	int Unk60; //60
	int Unk64; //64
	int Unk68; //68
	int Unk6C; //6C
	int nMasterID; //70
	int Unk74; //74
	int Unk78; //78
	int Unk7C; //7C
	int Unk80; //80
};

class CParty_
{
public:
        UCHAR unk1[ 0x24 ];                             // offset 0x0000
        CCriticalSection **ppCriticalSection;           // offset 0x0024
        CPartyData *pData;                                  // offset 0x0028
        UCHAR unk2[ 0x14 ];                             // offset 0x002C
        int nNumMembers;                                // offset 0x0040
		int nLootDistribution; //offset 44

        void UpdateWindowPacket(CCreature_ *pUser, INT nUpdateType);
		void OpenAllWindowPacket(CCreature_ *pUser);

		void GetAllMembers(CMemberList *lstMember);
		
		void SetMaster(CCreature_ *pUser);
		CCreature_ *GetMaster();

		void Dismiss();
		void Withdraw(CCreature_ *pUser);
		int GetMemberCount();
		int GetMasterID() 
		{
			return pData->nMasterID;
		}
		int GetLootDistribution()
		{
			return nLootDistribution & 0xF;
		}
		int GetLootTurn()
		{
			return nLootDistribution >> 8;
		}
		void SetLootTurn(int nTurn)
		{
			nLootDistribution = GetLootDistribution() | (nTurn<<8);
		}

		void ChangePartyLeader(CCreature_ *pUser);
};
#pragma pack()


typedef VOID (CParty_::*CPARTY_UPDATEWINDOWPACKET)(CCreature_ *pUser, INT nUpdateType);
EXPORT CPARTY_UPDATEWINDOWPACKET CParty_UpdateWindowPacket;

typedef VOID (CParty_::*CPARTY_OPENALLWINDOWPACKET)(CCreature_ *pUser);
EXPORT CPARTY_OPENALLWINDOWPACKET CParty_OpenAllWindowPacket;