/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

#ifndef _COMBAT_POINTS_
	#define _COMBAT_POINTS_
#endif

//General includes
#include "Shared.h"

//Project includes
#ifndef _L2SERVER_
	#include "L2Server.h"
#endif
#ifndef _EX_USER_
	#include "ExUser.h"
#endif

using namespace User;




//--------------------------------------------------------------------------------------------
//// Global Variables
//--------------------------------------------------------------------------------------------

#define CP_RUN_REGEN_RATE 1			//CP regen multiplier when running/standing
#define CP_WALK_REGEN_RATE 1.5		//CP regen multiplier when walking
#define CP_SIT_REGEN_RATE 2			//CP regen multiplier when sitting

#define CP_POTION_TIME 3600 //60 seconds
//#define CP_POTION_REGEN 18			//CP regen amount per tick (~3 seconds)
#define CP_POTION_HEAL 50			//Restores 50 CP Instantly
#define CP_GREATER_POTION_HEAL 200	//Restores 200 CP Instantly

#define CP_GREATER_POTION2 6409
#define CP_GREATER_POTION 5592
#define CP_POTION 5591



//[0] = Level 1 Multiplier, and [86] = level 87 Multiplier
//These are from the retail C4 scripts (PC_parameter.txt)
static double LevelMultiplier[87] = {0.9, 0.91, 0.92, 0.93, 0.94, 0.95, 0.96, 0.97, 0.98, 0.99, 1, 1.01, 1.02, 1.03, 1.04, 1.05, 1.06, 1.07, 1.08, 1.09, 1.1, 1.11, 1.12, 1.13, 1.14, 1.15, 1.16, 1.17, 1.18, 1.19, 1.2, 1.21, 1.22, 1.23, 1.24, 1.25, 1.26, 1.27, 1.28, 1.29, 1.3, 1.31, 1.32, 1.33, 1.34, 1.35, 1.36, 1.37, 1.38, 1.39, 1.4, 1.41, 1.42, 1.43, 1.44, 1.45, 1.46, 1.47, 1.48, 1.49, 1.5, 1.51, 1.52, 1.53, 1.54, 1.55, 1.56, 1.57, 1.58, 1.59, 1.6, 1.61, 1.62, 1.63, 1.64, 1.65, 1.66, 1.67, 1.68, 1.69, 1.70, 1.71, 1.72, 1.73, 1.74, 1.75, 1.76};

//0.98 = 27 AKA BASE CON (-2) // ~26.6667 = 0 AKA True BASE CON
//Values go from 1 CON to 99 CON ([0] = 1 CON, [98] = 99 CON)
static double ConMultiplier[99] = {0.46, 0.47, 0.48, 0.50, 0.51, 0.53, 0.54, 0.56, 0.58, 0.59, 0.61, 0.63, 0.65, 0.67, 0.69, 0.71, 0.73, 0.75, 0.78, 0.80, 0.82, 0.85, 0.87, 0.90, 0.93, 0.95, 0.98, 1.01, 1.04, 1.07, 1.1, 1.14, 1.17, 1.21, 1.24, 1.28, 1.32, 1.36, 1.4, 1.44, 1.48, 1.53, 1.58, 1.62, 1.67, 1.72, 1.77, 1.83, 1.87, 1.94, 2, 2.06, 2.12, 2.18, 2.25, 2.31, 2.38, 2.45, 2.53, 2.6, 2.68, 2.76, 2.84, 2.93, 3.02, 3.11, 3.2, 3.3, 3.4, 3.5, 3.6, 3.71, 3.82, 3.94, 4.06, 4.18, 4.3, 4.43, 4.56, 4.7, 4.84, 4.99, 5.14, 5.29, 5.45, 5.61, 5.78, 5.96, 6.13, 6.32, 6.51, 6.7, 6.9, 7.11, 7.33, 7.54, 7.77, 8, 8.24};

//Holds the CP tables for all the base classes and 2nd classes
//These are from the retail C4 scripts (manual_pch.txt)
static double CPByClassID[58][80] =
{
	//0 - Fighter
	{32, 36.732, 41.516, 46.352, 51.24, 56.18, 61.172, 66.216, 71.312, 76.46, 81.66, 86.912, 92.216, 97.572, 102.98, 108.44, 113.952, 119.516, 125.132, 130.8, 136.52, 142.292, 148.116, 153.992, 159.92, 165.9, 171.932, 178.016, 184.152, 190.34, 196.58, 202.872, 209.216, 215.612, 222.06, 228.56, 235.112, 241.716, 248.372, 255.08, 261.84, 268.652, 275.516, 282.432, 289.4, 296.42, 303.492, 310.616, 317.792, 325.02, 332.3, 339.632, 347.016, 354.452, 361.94, 369.48, 377.072, 384.716, 392.412, 400.16, 407.96, 415.812, 423.716, 431.672, 439.68, 447.74, 455.852, 464.016, 472.232, 480.5, 488.82, 497.192, 505.616, 514.092, 522.62, 531.2, 539.832, 548.516, 557.252, 566.04},
	//1 - Warrior
	{64, 73.464, 83.032, 92.704, 102.48, 112.36, 122.344, 132.432, 142.624, 152.92, 163.32, 173.824, 184.432, 195.144, 205.96, 216.88, 227.904, 239.032, 250.264, 261.6, 288, 314.64, 341.52, 368.64, 396, 423.6, 451.44, 479.52, 507.84, 536.4, 565.2, 594.24, 623.52, 653.04, 682.8, 712.8, 743.04, 773.52, 804.24, 835.2, 866.4, 897.84, 929.52, 961.44, 993.6, 1026, 1058.64, 1091.52, 1124.64, 1158, 1191.6, 1225.44, 1259.52, 1293.84, 1328.4, 1363.2, 1398.24, 1433.52, 1469.04, 1504.8, 1540.8, 1577.04, 1613.52, 1650.24, 1687.2, 1724.4, 1761.84, 1799.52, 1837.44, 1875.6, 1914, 1952.64, 1991.52, 2030.64, 2070, 2109.6, 2149.44, 2189.52, 2229.84, 2270.4},
	//2 - Gladiator
	{72, 82.647, 93.411, 104.292, 115.29, 126.405, 137.637, 148.986, 160.452, 172.035, 183.735, 195.552, 207.486, 219.537, 231.705, 243.99, 256.392, 268.911, 281.547, 294.3, 324, 353.97, 384.21, 414.72, 445.5, 476.55, 507.87, 539.46, 571.32, 603.45, 635.85, 668.52, 701.46, 734.67, 768.15, 801.9, 835.92, 870.21, 904.77, 939.6, 984.06, 1028.862, 1074.006, 1119.492, 1165.32, 1211.49, 1258.002, 1304.856, 1352.052, 1399.59, 1447.47, 1495.692, 1544.256, 1593.162, 1642.41, 1692, 1741.932, 1792.206, 1842.822, 1893.78, 1945.08, 1996.722, 2048.706, 2101.032, 2153.7, 2206.71, 2260.062, 2313.756, 2367.792, 2422.17, 2476.89, 2531.952, 2587.356, 2643.102, 2699.19, 2755.62, 2812.392, 2869.506, 2926.962, 2984.76},
	//3 - Warlord
	{64, 73.464, 83.032, 92.704, 102.48, 112.36, 122.344, 132.432, 142.624, 152.92, 163.32, 173.824, 184.432, 195.144, 205.96, 216.88, 227.904, 239.032, 250.264, 261.6, 288, 314.64, 341.52, 368.64, 396, 423.6, 451.44, 479.52, 507.84, 536.4, 565.2, 594.24, 623.52, 653.04, 682.8, 712.8, 743.04, 773.52, 804.24, 835.2, 878.88, 922.896, 967.248, 1011.936, 1056.96, 1102.32, 1148.016, 1194.048, 1240.416, 1287.12, 1334.16, 1381.536, 1429.248, 1477.296, 1525.68, 1574.4, 1623.456, 1672.848, 1722.576, 1772.64, 1823.04, 1873.776, 1924.848, 1976.256, 2028, 2080.08, 2132.496, 2185.248, 2238.336, 2291.76, 2345.52, 2399.616, 2454.048, 2508.816, 2563.92, 2619.36, 2675.136, 2731.248, 2787.696, 2844.48},
	//4 - Knight
	{48, 55.098, 62.274, 69.528, 76.86, 84.27, 91.758, 99.324, 106.968, 114.69, 122.49, 130.368, 138.324, 146.358, 154.47, 162.66, 170.928, 179.274, 187.698, 196.2, 214.02, 232.002, 250.146, 268.452, 286.92, 305.55, 324.342, 343.296, 362.412, 381.69, 401.13, 420.732, 440.496, 460.422, 480.51, 500.76, 521.172, 541.746, 562.482, 583.38, 604.44, 625.662, 647.046, 668.592, 690.3, 712.17, 734.202, 756.396, 778.752, 801.27, 823.95, 846.792, 869.796, 892.962, 916.29, 939.78, 963.432, 987.246, 1011.222, 1035.36, 1059.66, 1084.122, 1108.746, 1133.532, 1158.48, 1183.59, 1208.862, 1234.296, 1259.892, 1285.65, 1311.57, 1337.652, 1363.896, 1390.302, 1416.87, 1443.6, 1470.492, 1497.546, 1524.762, 1552.14},
	//5 - Paladin
	{48, 55.098, 62.274, 69.528, 76.86, 84.27, 91.758, 99.324, 106.968, 114.69, 122.49, 130.368, 138.324, 146.358, 154.47, 162.66, 170.928, 179.274, 187.698, 196.2, 214.02, 232.002, 250.146, 268.452, 286.92, 305.55, 324.342, 343.296, 362.412, 381.69, 401.13, 420.732, 440.496, 460.422, 480.51, 500.76, 521.172, 541.746, 562.482, 583.38, 611.46, 639.756, 668.268, 696.996, 725.94, 755.1, 784.476, 814.068, 843.876, 873.9, 904.14, 934.596, 965.268, 996.156, 1027.26, 1058.58, 1090.116, 1121.868, 1153.836, 1186.02, 1218.42, 1251.036, 1283.868, 1316.916, 1350.18, 1383.66, 1417.356, 1451.268, 1485.396, 1519.74, 1554.3, 1589.076, 1624.068, 1659.276, 1694.7, 1730.34, 1766.196, 1802.268, 1838.556, 1875.06},
	//6 - Dark Avenger
	{48, 55.098, 62.274, 69.528, 76.86, 84.27, 91.758, 99.324, 106.968, 114.69, 122.49, 130.368, 138.324, 146.358, 154.47, 162.66, 170.928, 179.274, 187.698, 196.2, 214.02, 232.002, 250.146, 268.452, 286.92, 305.55, 324.342, 343.296, 362.412, 381.69, 401.13, 420.732, 440.496, 460.422, 480.51, 500.76, 521.172, 541.746, 562.482, 583.38, 611.46, 639.756, 668.268, 696.996, 725.94, 755.1, 784.476, 814.068, 843.876, 873.9, 904.14, 934.596, 965.268, 996.156, 1027.26, 1058.58, 1090.116, 1121.868, 1153.836, 1186.02, 1218.42, 1251.036, 1283.868, 1316.916, 1350.18, 1383.66, 1417.356, 1451.268, 1485.396, 1519.74, 1554.3, 1589.076, 1624.068, 1659.276, 1694.7, 1730.34, 1766.196, 1802.268, 1838.556, 1875.06},
	//7 - Rogue
	{32, 36.732, 41.516, 46.352, 51.24, 56.18, 61.172, 66.216, 71.312, 76.46, 81.66, 86.912, 92.216, 97.572, 102.98, 108.44, 113.952, 119.516, 125.132, 130.8, 141.8, 152.9, 164.1, 175.4, 186.8, 198.3, 209.9, 221.6, 233.4, 245.3, 257.3, 269.4, 281.6, 293.9, 306.3, 318.8, 331.4, 344.1, 356.9, 369.8, 382.8, 395.9, 409.1, 422.4, 435.8, 449.3, 462.9, 476.6, 490.4, 504.3, 518.3, 532.4, 546.6, 560.9, 575.3, 589.8, 604.4, 619.1, 633.9, 648.8, 663.8, 678.9, 694.1, 709.4, 724.8, 740.3, 755.9, 771.6, 787.4, 803.3, 819.3, 835.4, 851.6, 867.9, 884.3, 900.8, 917.4, 934.1, 950.9, 967.8},
	//8 - Treasure Hunter
	{32, 36.732, 41.516, 46.352, 51.24, 56.18, 61.172, 66.216, 71.312, 76.46, 81.66, 86.912, 92.216, 97.572, 102.98, 108.44, 113.952, 119.516, 125.132, 130.8, 141.8, 152.9, 164.1, 175.4, 186.8, 198.3, 209.9, 221.6, 233.4, 245.3, 257.3, 269.4, 281.6, 293.9, 306.3, 318.8, 331.4, 344.1, 356.9, 369.8, 386.44, 403.208, 420.104, 437.128, 454.28, 471.56, 488.968, 506.504, 524.168, 541.96, 559.88, 577.928, 596.104, 614.408, 632.84, 651.4, 670.088, 688.904, 707.848, 726.92, 746.12, 765.448, 784.904, 804.488, 824.2, 844.04, 864.008, 884.104, 904.328, 924.68, 945.16, 965.768, 986.504, 1007.368, 1028.36, 1049.48, 1070.728, 1092.104, 1113.608, 1135.24},
	//9 - Hawkeye
	{56, 64.281, 72.653, 81.116, 89.67, 98.315, 107.051, 115.878, 124.796, 133.805, 142.905, 152.096, 161.378, 170.751, 180.215, 189.77, 199.416, 209.153, 218.981, 228.9, 248.15, 267.575, 287.175, 306.95, 326.9, 347.025, 367.325, 387.8, 408.45, 429.275, 450.275, 471.45, 492.8, 514.325, 536.025, 557.9, 579.95, 602.175, 624.575, 647.15, 678.09, 709.268, 740.684, 772.338, 804.23, 836.36, 868.728, 901.334, 934.178, 967.26, 1000.58, 1034.138, 1067.934, 1101.968, 1136.24, 1170.75, 1205.498, 1240.484, 1275.708, 1311.17, 1346.87, 1382.808, 1418.984, 1455.398, 1492.05, 1528.94, 1566.068, 1603.434, 1641.038, 1678.88, 1716.96, 1755.278, 1793.834, 1832.628, 1871.66, 1910.93, 1950.438, 1990.184, 2030.168, 2070.39},
	//10 - Mage
	{50.5, 58.235, 66.055, 73.96, 81.95, 90.025, 98.185, 106.43, 114.76, 123.175, 131.675, 140.26, 148.93, 157.685, 166.525, 175.45, 184.46, 193.555, 202.735, 212, 221.35, 230.785, 240.305, 249.91, 259.6, 269.375, 279.235, 289.18, 299.21, 309.325, 319.525, 329.81, 340.18, 350.635, 361.175, 371.8, 382.51, 393.305, 404.185, 415.15, 426.2, 437.335, 448.555, 459.86, 471.25, 482.725, 494.285, 505.93, 517.66, 529.475, 541.375, 553.36, 565.43, 577.585, 589.825, 602.15, 614.56, 627.055, 639.635, 652.3, 665.05, 677.885, 690.805, 703.81, 716.9, 730.075, 743.335, 756.68, 770.11, 783.625, 797.225, 810.91, 824.68, 838.535, 852.475, 866.5, 880.61, 894.805, 909.085, 923.45},
	//11 - Wizard
	{50.5, 58.235, 66.055, 73.96, 81.95, 90.025, 98.185, 106.43, 114.76, 123.175, 131.675, 140.26, 148.93, 157.685, 166.525, 175.45, 184.46, 193.555, 202.735, 212, 225.75, 239.625, 253.625, 267.75, 282, 296.375, 310.875, 325.5, 340.25, 355.125, 370.125, 385.25, 400.5, 415.875, 431.375, 447, 462.75, 478.625, 494.625, 510.75, 527, 543.375, 559.875, 576.5, 593.25, 610.125, 627.125, 644.25, 661.5, 678.875, 696.375, 714, 731.75, 749.625, 767.625, 785.75, 804, 822.375, 840.875, 859.5, 878.25, 897.125, 916.125, 935.25, 954.5, 973.875, 993.375, 1013, 1032.75, 1052.625, 1072.625, 1092.75, 1113, 1133.375, 1153.875, 1174.5, 1195.25, 1216.125, 1237.125, 1258.25},
	//12 - Sorceror
	{50.5, 58.235, 66.055, 73.96, 81.95, 90.025, 98.185, 106.43, 114.76, 123.175, 131.675, 140.26, 148.93, 157.685, 166.525, 175.45, 184.46, 193.555, 202.735, 212, 225.75, 239.625, 253.625, 267.75, 282, 296.375, 310.875, 325.5, 340.25, 355.125, 370.125, 385.25, 400.5, 415.875, 431.375, 447, 462.75, 478.625, 494.625, 510.75, 533.5, 556.425, 579.525, 602.8, 626.25, 649.875, 673.675, 697.65, 721.8, 746.125, 770.625, 795.3, 820.15, 845.175, 870.375, 895.75, 921.3, 947.025, 972.925, 999, 1025.25, 1051.675, 1078.275, 1105.05, 1132, 1159.125, 1186.425, 1213.9, 1241.55, 1269.375, 1297.375, 1325.55, 1353.9, 1382.425, 1411.125, 1440, 1469.05, 1498.275, 1527.675, 1557.25},
	//13 - Necromancer
	{50.5, 58.235, 66.055, 73.96, 81.95, 90.025, 98.185, 106.43, 114.76, 123.175, 131.675, 140.26, 148.93, 157.685, 166.525, 175.45, 184.46, 193.555, 202.735, 212, 225.75, 239.625, 253.625, 267.75, 282, 296.375, 310.875, 325.5, 340.25, 355.125, 370.125, 385.25, 400.5, 415.875, 431.375, 447, 462.75, 478.625, 494.625, 510.75, 533.5, 556.425, 579.525, 602.8, 626.25, 649.875, 673.675, 697.65, 721.8, 746.125, 770.625, 795.3, 820.15, 845.175, 870.375, 895.75, 921.3, 947.025, 972.925, 999, 1025.25, 1051.675, 1078.275, 1105.05, 1132, 1159.125, 1186.425, 1213.9, 1241.55, 1269.375, 1297.375, 1325.55, 1353.9, 1382.425, 1411.125, 1440, 1469.05, 1498.275, 1527.675, 1557.25},
	//14 - Warlock
	{60.6, 69.882, 79.266, 88.752, 98.34, 108.03, 117.822, 127.716, 137.712, 147.81, 158.01, 168.312, 178.716, 189.222, 199.83, 210.54, 221.352, 232.266, 243.282, 254.4, 270.9, 287.55, 304.35, 321.3, 338.4, 355.65, 373.05, 390.6, 408.3, 426.15, 444.15, 462.3, 480.6, 499.05, 517.65, 536.4, 555.3, 574.35, 593.55, 612.9, 642.54, 672.408, 702.504, 732.828, 763.38, 794.16, 825.168, 856.404, 887.868, 919.56, 951.48, 983.628, 1016.004, 1048.608, 1081.44, 1114.5, 1147.788, 1181.304, 1215.048, 1249.02, 1283.22, 1317.648, 1352.304, 1387.188, 1422.3, 1457.64, 1493.208, 1529.004, 1565.028, 1601.28, 1637.76, 1674.468, 1711.404, 1748.568, 1785.96, 1823.58, 1861.428, 1899.504, 1937.808, 1976.34},
	//15 - Cleric
	{50.5, 58.235, 66.055, 73.96, 81.95, 90.025, 98.185, 106.43, 114.76, 123.175, 131.675, 140.26, 148.93, 157.685, 166.525, 175.45, 184.46, 193.555, 202.735, 212, 229.05, 246.255, 263.615, 281.13, 298.8, 316.625, 334.605, 352.74, 371.03, 389.475, 408.075, 426.83, 445.74, 464.805, 484.025, 503.4, 522.93, 542.615, 562.455, 582.45, 602.6, 622.905, 643.365, 663.98, 684.75, 705.675, 726.755, 747.99, 769.38, 790.925, 812.625, 834.48, 856.49, 878.655, 900.975, 923.45, 946.08, 968.865, 991.805, 1014.9, 1038.15, 1061.555, 1085.115, 1108.83, 1132.7, 1156.725, 1180.905, 1205.24, 1229.73, 1254.375, 1279.175, 1304.13, 1329.24, 1354.505, 1379.925, 1405.5, 1431.23, 1457.115, 1483.155, 1509.35},
	//16 - Bishop
	{70.7, 81.529, 92.477, 103.544, 114.73, 126.035, 137.459, 149.002, 160.664, 172.445, 184.345, 196.364, 208.502, 220.759, 233.135, 245.63, 258.244, 270.977, 283.829, 296.8, 320.67, 344.757, 369.061, 393.582, 418.32, 443.275, 468.447, 493.836, 519.442, 545.265, 571.305, 597.562, 624.036, 650.727, 677.635, 704.76, 732.102, 759.661, 787.437, 815.43, 850.01, 884.856, 919.968, 955.346, 990.99, 1026.9, 1063.076, 1099.518, 1136.226, 1173.2, 1210.44, 1247.946, 1285.718, 1323.756, 1362.06, 1400.63, 1439.466, 1478.568, 1517.936, 1557.57, 1597.47, 1637.636, 1678.068, 1718.766, 1759.73, 1800.96, 1842.456, 1884.218, 1926.246, 1968.54, 2011.1, 2053.926, 2097.018, 2140.376, 2184, 2227.89, 2272.046, 2316.468, 2361.156, 2406.11},
	//17 - Prophet
	{50.5, 58.235, 66.055, 73.96, 81.95, 90.025, 98.185, 106.43, 114.76, 123.175, 131.675, 140.26, 148.93, 157.685, 166.525, 175.45, 184.46, 193.555, 202.735, 212, 229.05, 246.255, 263.615, 281.13, 298.8, 316.625, 334.605, 352.74, 371.03, 389.475, 408.075, 426.83, 445.74, 464.805, 484.025, 503.4, 522.93, 542.615, 562.455, 582.45, 609.1, 635.955, 663.015, 690.28, 717.75, 745.425, 773.305, 801.39, 829.68, 858.175, 886.875, 915.78, 944.89, 974.205, 1003.725, 1033.45, 1063.38, 1093.515, 1123.855, 1154.4, 1185.15, 1216.105, 1247.265, 1278.63, 1310.2, 1341.975, 1373.955, 1406.14, 1438.53, 1471.125, 1503.925, 1536.93, 1570.14, 1603.555, 1637.175, 1671, 1705.03, 1739.265, 1773.705, 1808.35},
	//18 - Elven Fighter
	{35.6, 40.696, 45.848, 51.056, 56.32, 61.64, 67.016, 72.448, 77.936, 83.48, 89.08, 94.736, 100.448, 106.216, 112.04, 117.92, 123.856, 129.848, 135.896, 142, 148.16, 154.376, 160.648, 166.976, 173.36, 179.8, 186.296, 192.848, 199.456, 206.12, 212.84, 219.616, 226.448, 233.336, 240.28, 247.28, 254.336, 261.448, 268.616, 275.84, 283.12, 290.456, 297.848, 305.296, 312.8, 320.36, 327.976, 335.648, 343.376, 351.16, 359, 366.896, 374.848, 382.856, 390.92, 399.04, 407.216, 415.448, 423.736, 432.08, 440.48, 448.936, 457.448, 466.016, 474.64, 483.32, 492.056, 500.848, 509.696, 518.6, 527.56, 536.576, 545.648, 554.776, 563.96, 573.2, 582.496, 591.848, 601.256, 610.72},
	//19 - Elven Knight
	{44.5, 50.87, 57.31, 63.82, 70.4, 77.05, 83.77, 90.56, 97.42, 104.35, 111.35, 118.42, 125.56, 132.77, 140.05, 147.4, 154.82, 162.31, 169.87, 177.5, 194, 210.65, 227.45, 244.4, 261.5, 278.75, 296.15, 313.7, 331.4, 349.25, 367.25, 385.4, 403.7, 422.15, 440.75, 459.5, 478.4, 497.45, 516.65, 536, 555.5, 575.15, 594.95, 614.9, 635, 655.25, 675.65, 696.2, 716.9, 737.75, 758.75, 779.9, 801.2, 822.65, 844.25, 866, 887.9, 909.95, 932.15, 954.5, 977, 999.65, 1022.45, 1045.4, 1068.5, 1091.75, 1115.15, 1138.7, 1162.4, 1186.25, 1210.25, 1234.4, 1258.7, 1283.15, 1307.75, 1332.5, 1357.4, 1382.45, 1407.65, 1433},
	//20 - Temple Knight
	{53.4, 61.044, 68.772, 76.584, 84.48, 92.46, 100.524, 108.672, 116.904, 125.22, 133.62, 142.104, 150.672, 159.324, 168.06, 176.88, 185.784, 194.772, 203.844, 213, 232.8, 252.78, 272.94, 293.28, 313.8, 334.5, 355.38, 376.44, 397.68, 419.1, 440.7, 462.48, 484.44, 506.58, 528.9, 551.4, 574.08, 596.94, 619.98, 643.2, 674.4, 705.84, 737.52, 769.44, 801.6, 834, 866.64, 899.52, 932.64, 966, 999.6, 1033.44, 1067.52, 1101.84, 1136.4, 1171.2, 1206.24, 1241.52, 1277.04, 1312.8, 1348.8, 1385.04, 1421.52, 1458.24, 1495.2, 1532.4, 1569.84, 1607.52, 1645.44, 1683.6, 1722, 1760.64, 1799.52, 1838.64, 1878, 1917.6, 1957.44, 1997.52, 2037.84, 2078.4},
	//21 - Sword Singer
	{44.5, 50.87, 57.31, 63.82, 70.4, 77.05, 83.77, 90.56, 97.42, 104.35, 111.35, 118.42, 125.56, 132.77, 140.05, 147.4, 154.82, 162.31, 169.87, 177.5, 194, 210.65, 227.45, 244.4, 261.5, 278.75, 296.15, 313.7, 331.4, 349.25, 367.25, 385.4, 403.7, 422.15, 440.75, 459.5, 478.4, 497.45, 516.65, 536, 563.3, 590.81, 618.53, 646.46, 674.6, 702.95, 731.51, 760.28, 789.26, 818.45, 847.85, 877.46, 907.28, 937.31, 967.55, 998, 1028.66, 1059.53, 1090.61, 1121.9, 1153.4, 1185.11, 1217.03, 1249.16, 1281.5, 1314.05, 1346.81, 1379.78, 1412.96, 1446.35, 1479.95, 1513.76, 1547.78, 1582.01, 1616.45, 1651.1, 1685.96, 1721.03, 1756.31, 1791.8},
	//22 - Elven Scout
	{35.6, 40.696, 45.848, 51.056, 56.32, 61.64, 67.016, 72.448, 77.936, 83.48, 89.08, 94.736, 100.448, 106.216, 112.04, 117.92, 123.856, 129.848, 135.896, 142, 154.32, 166.752, 179.296, 191.952, 204.72, 217.6, 230.592, 243.696, 256.912, 270.24, 283.68, 297.232, 310.896, 324.672, 338.56, 352.56, 366.672, 380.896, 395.232, 409.68, 424.24, 438.912, 453.696, 468.592, 483.6, 498.72, 513.952, 529.296, 544.752, 560.32, 576, 591.792, 607.696, 623.712, 639.84, 656.08, 672.432, 688.896, 705.472, 722.16, 738.96, 755.872, 772.896, 790.032, 807.28, 824.64, 842.112, 859.696, 877.392, 895.2, 913.12, 931.152, 949.296, 967.552, 985.92, 1004.4, 1022.992, 1041.696, 1060.512, 1079.44},
	//23 - Plains Walker
	{35.6, 40.696, 45.848, 51.056, 56.32, 61.64, 67.016, 72.448, 77.936, 83.48, 89.08, 94.736, 100.448, 106.216, 112.04, 117.92, 123.856, 129.848, 135.896, 142, 154.32, 166.752, 179.296, 191.952, 204.72, 217.6, 230.592, 243.696, 256.912, 270.24, 283.68, 297.232, 310.896, 324.672, 338.56, 352.56, 366.672, 380.896, 395.232, 409.68, 428.4, 447.264, 466.272, 485.424, 504.72, 524.16, 543.744, 563.472, 583.344, 603.36, 623.52, 643.824, 664.272, 684.864, 705.6, 726.48, 747.504, 768.672, 789.984, 811.44, 833.04, 854.784, 876.672, 898.704, 920.88, 943.2, 965.664, 988.272, 1011.024, 1033.92, 1056.96, 1080.144, 1103.472, 1126.944, 1150.56, 1174.32, 1198.224, 1222.272, 1246.464, 1270.8},
	//24 - Silver Ranger
	{44.5, 50.87, 57.31, 63.82, 70.4, 77.05, 83.77, 90.56, 97.42, 104.35, 111.35, 118.42, 125.56, 132.77, 140.05, 147.4, 154.82, 162.31, 169.87, 177.5, 192.9, 208.44, 224.12, 239.94, 255.9, 272, 288.24, 304.62, 321.14, 337.8, 354.6, 371.54, 388.62, 405.84, 423.2, 440.7, 458.34, 476.12, 494.04, 512.1, 536.8, 561.69, 586.77, 612.04, 637.5, 663.15, 688.99, 715.02, 741.24, 767.65, 794.25, 821.04, 848.02, 875.19, 902.55, 930.1, 957.84, 985.77, 1013.89, 1042.2, 1070.7, 1099.39, 1128.27, 1157.34, 1186.6, 1216.05, 1245.69, 1275.52, 1305.54, 1335.75, 1366.15, 1396.74, 1427.52, 1458.49, 1489.65, 1521, 1552.54, 1584.27, 1616.19, 1648.3},
	//25 - Elven Mage
	{52, 59.735, 67.555, 75.46, 83.45, 91.525, 99.685, 107.93, 116.26, 124.675, 133.175, 141.76, 150.43, 159.185, 168.025, 176.95, 185.96, 195.055, 204.235, 213.5, 222.85, 232.285, 241.805, 251.41, 261.1, 270.875, 280.735, 290.68, 300.71, 310.825, 321.025, 331.31, 341.68, 352.135, 362.675, 373.3, 384.01, 394.805, 405.685, 416.65, 427.7, 438.835, 450.055, 461.36, 472.75, 484.225, 495.785, 507.43, 519.16, 530.975, 542.875, 554.86, 566.93, 579.085, 591.325, 603.65, 616.06, 628.555, 641.135, 653.8, 666.55, 679.385, 692.305, 705.31, 718.4, 731.575, 744.835, 758.18, 771.61, 785.125, 798.725, 812.41, 826.18, 840.035, 853.975, 868, 882.11, 896.305, 910.585, 924.95},
	//26 - Elven Wizard
	{52, 59.735, 67.555, 75.46, 83.45, 91.525, 99.685, 107.93, 116.26, 124.675, 133.175, 141.76, 150.43, 159.185, 168.025, 176.95, 185.96, 195.055, 204.235, 213.5, 227.8, 242.23, 256.79, 271.48, 286.3, 301.25, 316.33, 331.54, 346.88, 362.35, 377.95, 393.68, 409.54, 425.53, 441.65, 457.9, 474.28, 490.79, 507.43, 524.2, 541.1, 558.13, 575.29, 592.58, 610, 627.55, 645.23, 663.04, 680.98, 699.05, 717.25, 735.58, 754.04, 772.63, 791.35, 810.2, 829.18, 848.29, 867.53, 886.9, 906.4, 926.03, 945.79, 965.68, 985.7, 1005.85, 1026.13, 1046.54, 1067.08, 1087.75, 1108.55, 1129.48, 1150.54, 1171.73, 1193.05, 1214.5, 1236.08, 1257.79, 1279.63, 1301.6},
	//27 - Spell Singer
	{52, 59.735, 67.555, 75.46, 83.45, 91.525, 99.685, 107.93, 116.26, 124.675, 133.175, 141.76, 150.43, 159.185, 168.025, 176.95, 185.96, 195.055, 204.235, 213.5, 227.8, 242.23, 256.79, 271.48, 286.3, 301.25, 316.33, 331.54, 346.88, 362.35, 377.95, 393.68, 409.54, 425.53, 441.65, 457.9, 474.28, 490.79, 507.43, 524.2, 548.25, 572.485, 596.905, 621.51, 646.3, 671.275, 696.435, 721.78, 747.31, 773.025, 798.925, 825.01, 851.28, 877.735, 904.375, 931.2, 958.21, 985.405, 1012.785, 1040.35, 1068.1, 1096.035, 1124.155, 1152.46, 1180.95, 1209.625, 1238.485, 1267.53, 1296.76, 1326.175, 1355.775, 1385.56, 1415.53, 1445.685, 1476.025, 1506.55, 1537.26, 1568.155, 1599.235, 1630.5},
	//28 - Elemental Summoner
	{62.4, 71.682, 81.066, 90.552, 100.14, 109.83, 119.622, 129.516, 139.512, 149.61, 159.81, 170.112, 180.516, 191.022, 201.63, 212.34, 223.152, 234.066, 245.082, 256.2, 273.36, 290.676, 308.148, 325.776, 343.56, 361.5, 379.596, 397.848, 416.256, 434.82, 453.54, 472.416, 491.448, 510.636, 529.98, 549.48, 569.136, 588.948, 608.916, 629.04, 659.46, 690.114, 721.002, 752.124, 783.48, 815.07, 846.894, 878.952, 911.244, 943.77, 976.53, 1009.524, 1042.752, 1076.214, 1109.91, 1143.84, 1178.004, 1212.402, 1247.034, 1281.9, 1317, 1352.334, 1387.902, 1423.704, 1459.74, 1496.01, 1532.514, 1569.252, 1606.224, 1643.43, 1680.87, 1718.544, 1756.452, 1794.594, 1832.97, 1871.58, 1910.424, 1949.502, 1988.814, 2028.36},
	//29 - Elven Oracle
	{52, 59.735, 67.555, 75.46, 83.45, 91.525, 99.685, 107.93, 116.26, 124.675, 133.175, 141.76, 150.43, 159.185, 168.025, 176.95, 185.96, 195.055, 204.235, 213.5, 231.1, 248.86, 266.78, 284.86, 303.1, 321.5, 340.06, 358.78, 377.66, 396.7, 415.9, 435.26, 454.78, 474.46, 494.3, 514.3, 534.46, 554.78, 575.26, 595.9, 616.7, 637.66, 658.78, 680.06, 701.5, 723.1, 744.86, 766.78, 788.86, 811.1, 833.5, 856.06, 878.78, 901.66, 924.7, 947.9, 971.26, 994.78, 1018.46, 1042.3, 1066.3, 1090.46, 1114.78, 1139.26, 1163.9, 1188.7, 1213.66, 1238.78, 1264.06, 1289.5, 1315.1, 1340.86, 1366.78, 1392.86, 1419.1, 1445.5, 1472.06, 1498.78, 1525.66, 1552.7},
	//30 - Elven Elder
	{52, 59.735, 67.555, 75.46, 83.45, 91.525, 99.685, 107.93, 116.26, 124.675, 133.175, 141.76, 150.43, 159.185, 168.025, 176.95, 185.96, 195.055, 204.235, 213.5, 231.1, 248.86, 266.78, 284.86, 303.1, 321.5, 340.06, 358.78, 377.66, 396.7, 415.9, 435.26, 454.78, 474.46, 494.3, 514.3, 534.46, 554.78, 575.26, 595.9, 623.2, 650.71, 678.43, 706.36, 734.5, 762.85, 791.41, 820.18, 849.16, 878.35, 907.75, 937.36, 967.18, 997.21, 1027.45, 1057.9, 1088.56, 1119.43, 1150.51, 1181.8, 1213.3, 1245.01, 1276.93, 1309.06, 1341.4, 1373.95, 1406.71, 1439.68, 1472.86, 1506.25, 1539.85, 1573.66, 1607.68, 1641.91, 1676.35, 1711, 1745.86, 1780.93, 1816.21, 1851.7},
	//31 - Dark Elven Fighter
	{37.6, 43.06, 48.58, 54.16, 59.8, 65.5, 71.26, 77.08, 82.96, 88.9, 94.9, 100.96, 107.08, 113.26, 119.5, 125.8, 132.16, 138.58, 145.06, 151.6, 158.2, 164.86, 171.58, 178.36, 185.2, 192.1, 199.06, 206.08, 213.16, 220.3, 227.5, 234.76, 242.08, 249.46, 256.9, 264.4, 271.96, 279.58, 287.26, 295, 302.8, 310.66, 318.58, 326.56, 334.6, 342.7, 350.86, 359.08, 367.36, 375.7, 384.1, 392.56, 401.08, 409.66, 418.3, 427, 435.76, 444.58, 453.46, 462.4, 471.4, 480.46, 489.58, 498.76, 508, 517.3, 526.66, 536.08, 545.56, 555.1, 564.7, 574.36, 584.08, 593.86, 603.7, 613.6, 623.56, 633.58, 643.66, 653.8},
	//32 - Palus Knight
	{47, 53.825, 60.725, 67.7, 74.75, 81.875, 89.075, 96.35, 103.7, 111.125, 118.625, 126.2, 133.85, 141.575, 149.375, 157.25, 165.2, 173.225, 181.325, 189.5, 207.1, 224.86, 242.78, 260.86, 279.1, 297.5, 316.06, 334.78, 353.66, 372.7, 391.9, 411.26, 430.78, 450.46, 470.3, 490.3, 510.46, 530.78, 551.26, 571.9, 592.7, 613.66, 634.78, 656.06, 677.5, 699.1, 720.86, 742.78, 764.86, 787.1, 809.5, 832.06, 854.78, 877.66, 900.7, 923.9, 947.26, 970.78, 994.46, 1018.3, 1042.3, 1066.46, 1090.78, 1115.26, 1139.9, 1164.7, 1189.66, 1214.78, 1240.06, 1265.5, 1291.1, 1316.86, 1342.78, 1368.86, 1395.1, 1421.5, 1448.06, 1474.78, 1501.66, 1528.7},
	//33 - Shillien Knight
	{56.4, 64.59, 72.87, 81.24, 89.7, 98.25, 106.89, 115.62, 124.44, 133.35, 142.35, 151.44, 160.62, 169.89, 179.25, 188.7, 198.24, 207.87, 217.59, 227.4, 248.52, 269.832, 291.336, 313.032, 334.92, 357, 379.272, 401.736, 424.392, 447.24, 470.28, 493.512, 516.936, 540.552, 564.36, 588.36, 612.552, 636.936, 661.512, 686.28, 719.04, 752.052, 785.316, 818.832, 852.6, 886.62, 920.892, 955.416, 990.192, 1025.22, 1060.5, 1096.032, 1131.816, 1167.852, 1204.14, 1240.68, 1277.472, 1314.516, 1351.812, 1389.36, 1427.16, 1465.212, 1503.516, 1542.072, 1580.88, 1619.94, 1659.252, 1698.816, 1738.632, 1778.7, 1819.02, 1859.592, 1900.416, 1941.492, 1982.82, 2024.4, 2066.232, 2108.316, 2150.652, 2193.24},
	//34 - Blade Dancer
	{47, 53.825, 60.725, 67.7, 74.75, 81.875, 89.075, 96.35, 103.7, 111.125, 118.625, 126.2, 133.85, 141.575, 149.375, 157.25, 165.2, 173.225, 181.325, 189.5, 207.1, 224.86, 242.78, 260.86, 279.1, 297.5, 316.06, 334.78, 353.66, 372.7, 391.9, 411.26, 430.78, 450.46, 470.3, 490.3, 510.46, 530.78, 551.26, 571.9, 601.15, 630.625, 660.325, 690.25, 720.4, 750.775, 781.375, 812.2, 843.25, 874.525, 906.025, 937.75, 969.7, 1001.875, 1034.275, 1066.9, 1099.75, 1132.825, 1166.125, 1199.65, 1233.4, 1267.375, 1301.575, 1336, 1370.65, 1405.525, 1440.625, 1475.95, 1511.5, 1547.275, 1583.275, 1619.5, 1655.95, 1692.625, 1729.525, 1766.65, 1804, 1841.575, 1879.375, 1917.4},
	//35 - Assassin
	{37.6, 43.06, 48.58, 54.16, 59.8, 65.5, 71.26, 77.08, 82.96, 88.9, 94.9, 100.96, 107.08, 113.26, 119.5, 125.8, 132.16, 138.58, 145.06, 151.6, 164.8, 178.12, 191.56, 205.12, 218.8, 232.6, 246.52, 260.56, 274.72, 289, 303.4, 317.92, 332.56, 347.32, 362.2, 377.2, 392.32, 407.56, 422.92, 438.4, 454, 469.72, 485.56, 501.52, 517.6, 533.8, 550.12, 566.56, 583.12, 599.8, 616.6, 633.52, 650.56, 667.72, 685, 702.4, 719.92, 737.56, 755.32, 773.2, 791.2, 809.32, 827.56, 845.92, 864.4, 883, 901.72, 920.56, 939.52, 958.6, 977.8, 997.12, 1016.56, 1036.12, 1055.8, 1075.6, 1095.52, 1115.56, 1135.72, 1156},
	//36 - Abyss Walker
	{37.6, 43.06, 48.58, 54.16, 59.8, 65.5, 71.26, 77.08, 82.96, 88.9, 94.9, 100.96, 107.08, 113.26, 119.5, 125.8, 132.16, 138.58, 145.06, 151.6, 164.8, 178.12, 191.56, 205.12, 218.8, 232.6, 246.52, 260.56, 274.72, 289, 303.4, 317.92, 332.56, 347.32, 362.2, 377.2, 392.32, 407.56, 422.92, 438.4, 458.16, 478.072, 498.136, 518.352, 538.72, 559.24, 579.912, 600.736, 621.712, 642.84, 664.12, 685.552, 707.136, 728.872, 750.76, 772.8, 794.992, 817.336, 839.832, 862.48, 885.28, 908.232, 931.336, 954.592, 978, 1001.56, 1025.272, 1049.136, 1073.152, 1097.32, 1121.64, 1146.112, 1170.736, 1195.512, 1220.44, 1245.52, 1270.752, 1296.136, 1321.672, 1347.36},
	//37 - Phantom Ranger
	{47, 53.825, 60.725, 67.7, 74.75, 81.875, 89.075, 96.35, 103.7, 111.125, 118.625, 126.2, 133.85, 141.575, 149.375, 157.25, 165.2, 173.225, 181.325, 189.5, 206, 222.65, 239.45, 256.4, 273.5, 290.75, 308.15, 325.7, 343.4, 361.25, 379.25, 397.4, 415.7, 434.15, 452.75, 471.5, 490.4, 509.45, 528.65, 548, 574, 600.2, 626.6, 653.2, 680, 707, 734.2, 761.6, 789.2, 817, 845, 873.2, 901.6, 930.2, 959, 988, 1017.2, 1046.6, 1076.2, 1106, 1136, 1166.2, 1196.6, 1227.2, 1258, 1289, 1320.2, 1351.6, 1383.2, 1415, 1447, 1479.2, 1511.6, 1544.2, 1577, 1610, 1643.2, 1676.6, 1710.2, 1744},
	//38 - Dark Elven Mage
	{53, 60.735, 68.555, 76.46, 84.45, 92.525, 100.685, 108.93, 117.26, 125.675, 134.175, 142.76, 151.43, 160.185, 169.025, 177.95, 186.96, 196.055, 205.235, 214.5, 223.85, 233.285, 242.805, 252.41, 262.1, 271.875, 281.735, 291.68, 301.71, 311.825, 322.025, 332.31, 342.68, 353.135, 363.675, 374.3, 385.01, 395.805, 406.685, 417.65, 428.7, 439.835, 451.055, 462.36, 473.75, 485.225, 496.785, 508.43, 520.16, 531.975, 543.875, 555.86, 567.93, 580.085, 592.325, 604.65, 617.06, 629.555, 642.135, 654.8, 667.55, 680.385, 693.305, 706.31, 719.4, 732.575, 745.835, 759.18, 772.61, 786.125, 799.725, 813.41, 827.18, 841.035, 854.975, 869, 883.11, 897.305, 911.585, 925.95},
	//39 - Dark Elven Wizard
	{53, 60.735, 68.555, 76.46, 84.45, 92.525, 100.685, 108.93, 117.26, 125.675, 134.175, 142.76, 151.43, 160.185, 169.025, 177.95, 186.96, 196.055, 205.235, 214.5, 229.35, 244.335, 259.455, 274.71, 290.1, 305.625, 321.285, 337.08, 353.01, 369.075, 385.275, 401.61, 418.08, 434.685, 451.425, 468.3, 485.31, 502.455, 519.735, 537.15, 554.7, 572.385, 590.205, 608.16, 626.25, 644.475, 662.835, 681.33, 699.96, 718.725, 737.625, 756.66, 775.83, 795.135, 814.575, 834.15, 853.86, 873.705, 893.685, 913.8, 934.05, 954.435, 974.955, 995.61, 1016.4, 1037.325, 1058.385, 1079.58, 1100.91, 1122.375, 1143.975, 1165.71, 1187.58, 1209.585, 1231.725, 1254, 1276.41, 1298.955, 1321.635, 1344.45},
	//40 - Spell Howler
	{53, 60.735, 68.555, 76.46, 84.45, 92.525, 100.685, 108.93, 117.26, 125.675, 134.175, 142.76, 151.43, 160.185, 169.025, 177.95, 186.96, 196.055, 205.235, 214.5, 229.35, 244.335, 259.455, 274.71, 290.1, 305.625, 321.285, 337.08, 353.01, 369.075, 385.275, 401.61, 418.08, 434.685, 451.425, 468.3, 485.31, 502.455, 519.735, 537.15, 561.2, 585.435, 609.855, 634.46, 659.25, 684.225, 709.385, 734.73, 760.26, 785.975, 811.875, 837.96, 864.23, 890.685, 917.325, 944.15, 971.16, 998.355, 1025.735, 1053.3, 1081.05, 1108.985, 1137.105, 1165.41, 1193.9, 1222.575, 1251.435, 1280.48, 1309.71, 1339.125, 1368.725, 1398.51, 1428.48, 1458.635, 1488.975, 1519.5, 1550.21, 1581.105, 1612.185, 1643.45},
	//41 - Phantom Summoner
	{63.6, 72.882, 82.266, 91.752, 101.34, 111.03, 120.822, 130.716, 140.712, 150.81, 161.01, 171.312, 181.716, 192.222, 202.83, 213.54, 224.352, 235.266, 246.282, 257.4, 275.22, 293.202, 311.346, 329.652, 348.12, 366.75, 385.542, 404.496, 423.612, 442.89, 462.33, 481.932, 501.696, 521.622, 541.71, 561.96, 582.372, 602.946, 623.682, 644.58, 675.78, 707.22, 738.9, 770.82, 802.98, 835.38, 868.02, 900.9, 934.02, 967.38, 1000.98, 1034.82, 1068.9, 1103.22, 1137.78, 1172.58, 1207.62, 1242.9, 1278.42, 1314.18, 1350.18, 1386.42, 1422.9, 1459.62, 1496.58, 1533.78, 1571.22, 1608.9, 1646.82, 1684.98, 1723.38, 1762.02, 1800.9, 1840.02, 1879.38, 1918.98, 1958.82, 1998.9, 2039.22, 2079.78},
	//42 - Shillien Oracle
	{53, 60.735, 68.555, 76.46, 84.45, 92.525, 100.685, 108.93, 117.26, 125.675, 134.175, 142.76, 151.43, 160.185, 169.025, 177.95, 186.96, 196.055, 205.235, 214.5, 232.65, 250.965, 269.445, 288.09, 306.9, 325.875, 345.015, 364.32, 383.79, 403.425, 423.225, 443.19, 463.32, 483.615, 504.075, 524.7, 545.49, 566.445, 587.565, 608.85, 630.3, 651.915, 673.695, 695.64, 717.75, 740.025, 762.465, 785.07, 807.84, 830.775, 853.875, 877.14, 900.57, 924.165, 947.925, 971.85, 995.94, 1020.195, 1044.615, 1069.2, 1093.95, 1118.865, 1143.945, 1169.19, 1194.6, 1220.175, 1245.915, 1271.82, 1297.89, 1324.125, 1350.525, 1377.09, 1403.82, 1430.715, 1457.775, 1485, 1512.39, 1539.945, 1567.665, 1595.55},
	//43 - Shillien Elder
	{53, 60.735, 68.555, 76.46, 84.45, 92.525, 100.685, 108.93, 117.26, 125.675, 134.175, 142.76, 151.43, 160.185, 169.025, 177.95, 186.96, 196.055, 205.235, 214.5, 232.65, 250.965, 269.445, 288.09, 306.9, 325.875, 345.015, 364.32, 383.79, 403.425, 423.225, 443.19, 463.32, 483.615, 504.075, 524.7, 545.49, 566.445, 587.565, 608.85, 636.15, 663.66, 691.38, 719.31, 747.45, 775.8, 804.36, 833.13, 862.11, 891.3, 920.7, 950.31, 980.13, 1010.16, 1040.4, 1070.85, 1101.51, 1132.38, 1163.46, 1194.75, 1226.25, 1257.96, 1289.88, 1322.01, 1354.35, 1386.9, 1419.66, 1452.63, 1485.81, 1519.2, 1552.8, 1586.61, 1620.63, 1654.86, 1689.3, 1723.95, 1758.81, 1793.88, 1829.16, 1864.65},
	//44 - Orc Fighter
	{40, 46.37, 52.81, 59.32, 65.9, 72.55, 79.27, 86.06, 92.92, 99.85, 106.85, 113.92, 121.06, 128.27, 135.55, 142.9, 150.32, 157.81, 165.37, 173, 180.7, 188.47, 196.31, 204.22, 212.2, 220.25, 228.37, 236.56, 244.82, 253.15, 261.55, 270.02, 278.56, 287.17, 295.85, 304.6, 313.42, 322.31, 331.27, 340.3, 349.4, 358.57, 367.81, 377.12, 386.5, 395.95, 405.47, 415.06, 424.72, 434.45, 444.25, 454.12, 464.06, 474.07, 484.15, 494.3, 504.52, 514.81, 525.17, 535.6, 546.1, 556.67, 567.31, 578.02, 588.8, 599.65, 610.57, 621.56, 632.62, 643.75, 654.95, 666.22, 677.56, 688.97, 700.45, 712, 723.62, 735.31, 747.07, 758.9},
	//45 - Orc Raider
	{56, 64.918, 73.934, 83.048, 92.26, 101.57, 110.978, 120.484, 130.088, 139.79, 149.59, 159.488, 169.484, 179.578, 189.77, 200.06, 210.448, 220.934, 231.518, 242.2, 266.84, 291.704, 316.792, 342.104, 367.64, 393.4, 419.384, 445.592, 472.024, 498.68, 525.56, 552.664, 579.992, 607.544, 635.32, 663.32, 691.544, 719.992, 748.664, 777.56, 806.68, 836.024, 865.592, 895.384, 925.4, 955.64, 986.104, 1016.792, 1047.704, 1078.84, 1110.2, 1141.784, 1173.592, 1205.624, 1237.88, 1270.36, 1303.064, 1335.992, 1369.144, 1402.52, 1436.12, 1469.944, 1503.992, 1538.264, 1572.76, 1607.48, 1642.424, 1677.592, 1712.984, 1748.6, 1784.44, 1820.504, 1856.792, 1893.304, 1930.04, 1967, 2004.184, 2041.592, 2079.224, 2117.08},
	//46 - Destroyer
	{56, 64.918, 73.934, 83.048, 92.26, 101.57, 110.978, 120.484, 130.088, 139.79, 149.59, 159.488, 169.484, 179.578, 189.77, 200.06, 210.448, 220.934, 231.518, 242.2, 266.84, 291.704, 316.792, 342.104, 367.64, 393.4, 419.384, 445.592, 472.024, 498.68, 525.56, 552.664, 579.992, 607.544, 635.32, 663.32, 691.544, 719.992, 748.664, 777.56, 817.6, 857.948, 898.604, 939.568, 980.84, 1022.42, 1064.308, 1106.504, 1149.008, 1191.82, 1234.94, 1278.368, 1322.104, 1366.148, 1410.5, 1455.16, 1500.128, 1545.404, 1590.988, 1636.88, 1683.08, 1729.588, 1776.404, 1823.528, 1870.96, 1918.7, 1966.748, 2015.104, 2063.768, 2112.74, 2162.02, 2211.608, 2261.504, 2311.708, 2362.22, 2413.04, 2464.168, 2515.604, 2567.348, 2619.4},
	//47 - Orc Monk
	{40, 46.37, 52.81, 59.32, 65.9, 72.55, 79.27, 86.06, 92.92, 99.85, 106.85, 113.92, 121.06, 128.27, 135.55, 142.9, 150.32, 157.81, 165.37, 173, 189.5, 206.15, 222.95, 239.9, 257, 274.25, 291.65, 309.2, 326.9, 344.75, 362.75, 380.9, 399.2, 417.65, 436.25, 455, 473.9, 492.95, 512.15, 531.5, 551, 570.65, 590.45, 610.4, 630.5, 650.75, 671.15, 691.7, 712.4, 733.25, 754.25, 775.4, 796.7, 818.15, 839.75, 861.5, 883.4, 905.45, 927.65, 950, 972.5, 995.15, 1017.95, 1040.9, 1064, 1087.25, 1110.65, 1134.2, 1157.9, 1181.75, 1205.75, 1229.9, 1254.2, 1278.65, 1303.25, 1328, 1352.9, 1377.95, 1403.15, 1428.5},
	//48 - Tyrant
	{40, 46.37, 52.81, 59.32, 65.9, 72.55, 79.27, 86.06, 92.92, 99.85, 106.85, 113.92, 121.06, 128.27, 135.55, 142.9, 150.32, 157.81, 165.37, 173, 189.5, 206.15, 222.95, 239.9, 257, 274.25, 291.65, 309.2, 326.9, 344.75, 362.75, 380.9, 399.2, 417.65, 436.25, 455, 473.9, 492.95, 512.15, 531.5, 558.8, 586.31, 614.03, 641.96, 670.1, 698.45, 727.01, 755.78, 784.76, 813.95, 843.35, 872.96, 902.78, 932.81, 963.05, 993.5, 1024.16, 1055.03, 1086.11, 1117.4, 1148.9, 1180.61, 1212.53, 1244.66, 1277, 1309.55, 1342.31, 1375.28, 1408.46, 1441.85, 1475.45, 1509.26, 1543.28, 1577.51, 1611.95, 1646.6, 1681.46, 1716.53, 1751.81, 1787.3},
	//49 - Orc Mage
	{47.5, 55.235, 63.055, 70.96, 78.95, 87.025, 95.185, 103.43, 111.76, 120.175, 128.675, 137.26, 145.93, 154.685, 163.525, 172.45, 181.46, 190.555, 199.735, 209, 218.35, 227.785, 237.305, 246.91, 256.6, 266.375, 276.235, 286.18, 296.21, 306.325, 316.525, 326.81, 337.18, 347.635, 358.175, 368.8, 379.51, 390.305, 401.185, 412.15, 423.2, 434.335, 445.555, 456.86, 468.25, 479.725, 491.285, 502.93, 514.66, 526.475, 538.375, 550.36, 562.43, 574.585, 586.825, 599.15, 611.56, 624.055, 636.635, 649.3, 662.05, 674.885, 687.805, 700.81, 713.9, 727.075, 740.335, 753.68, 767.11, 780.625, 794.225, 807.91, 821.68, 835.535, 849.475, 863.5, 877.61, 891.805, 906.085, 920.45},
	//50 - Orc Shaman
	{47.5, 55.235, 63.055, 70.96, 78.95, 87.025, 95.185, 103.43, 111.76, 120.175, 128.675, 137.26, 145.93, 154.685, 163.525, 172.45, 181.46, 190.555, 199.735, 209, 226.6, 244.36, 262.28, 280.36, 298.6, 317, 335.56, 354.28, 373.16, 392.2, 411.4, 430.76, 450.28, 469.96, 489.8, 509.8, 529.96, 550.28, 570.76, 591.4, 612.2, 633.16, 654.28, 675.56, 697, 718.6, 740.36, 762.28, 784.36, 806.6, 829, 851.56, 874.28, 897.16, 920.2, 943.4, 966.76, 990.28, 1013.96, 1037.8, 1061.8, 1085.96, 1110.28, 1134.76, 1159.4, 1184.2, 1209.16, 1234.28, 1259.56, 1285, 1310.6, 1336.36, 1362.28, 1388.36, 1414.6, 1441, 1467.56, 1494.28, 1521.16, 1548.2},
	//51 - Overlord
	{76, 88.376, 100.888, 113.536, 126.32, 139.24, 152.296, 165.488, 178.816, 192.28, 205.88, 219.616, 233.488, 247.496, 261.64, 275.92, 290.336, 304.888, 319.576, 334.4, 362.56, 390.976, 419.648, 448.576, 477.76, 507.2, 536.896, 566.848, 597.056, 627.52, 658.24, 689.216, 720.448, 751.936, 783.68, 815.68, 847.936, 880.448, 913.216, 946.24, 988.88, 1031.848, 1075.144, 1118.768, 1162.72, 1207, 1251.608, 1296.544, 1341.808, 1387.4, 1433.32, 1479.568, 1526.144, 1573.048, 1620.28, 1667.84, 1715.728, 1763.944, 1812.488, 1861.36, 1910.56, 1960.088, 2009.944, 2060.128, 2110.64, 2161.48, 2212.648, 2264.144, 2315.968, 2368.12, 2420.6, 2473.408, 2526.544, 2580.008, 2633.8, 2687.92, 2742.368, 2797.144, 2852.248, 2907.68},
	//52 - Warcryer
	{47.5, 55.235, 63.055, 70.96, 78.95, 87.025, 95.185, 103.43, 111.76, 120.175, 128.675, 137.26, 145.93, 154.685, 163.525, 172.45, 181.46, 190.555, 199.735, 209, 226.6, 244.36, 262.28, 280.36, 298.6, 317, 335.56, 354.28, 373.16, 392.2, 411.4, 430.76, 450.28, 469.96, 489.8, 509.8, 529.96, 550.28, 570.76, 591.4, 618.05, 644.905, 671.965, 699.23, 726.7, 754.375, 782.255, 810.34, 838.63, 867.125, 895.825, 924.73, 953.84, 983.155, 1012.675, 1042.4, 1072.33, 1102.465, 1132.805, 1163.35, 1194.1, 1225.055, 1256.215, 1287.58, 1319.15, 1350.925, 1382.905, 1415.09, 1447.48, 1480.075, 1512.875, 1545.88, 1579.09, 1612.505, 1646.125, 1679.95, 1713.98, 1748.215, 1782.655, 1817.3},
	//53 - Dwarven Fighter
	{56, 64.918, 73.934, 83.048, 92.26, 101.57, 110.978, 120.484, 130.088, 139.79, 149.59, 159.488, 169.484, 179.578, 189.77, 200.06, 210.448, 220.934, 231.518, 242.2, 252.98, 263.858, 274.834, 285.908, 297.08, 308.35, 319.718, 331.184, 342.748, 354.41, 366.17, 378.028, 389.984, 402.038, 414.19, 426.44, 438.788, 451.234, 463.778, 476.42, 489.16, 501.998, 514.934, 527.968, 541.1, 554.33, 567.658, 581.084, 594.608, 608.23, 621.95, 635.768, 649.684, 663.698, 677.81, 692.02, 706.328, 720.734, 735.238, 749.84, 764.54, 779.338, 794.234, 809.228, 824.32, 839.51, 854.798, 870.184, 885.668, 901.25, 916.93, 932.708, 948.584, 964.558, 980.63, 996.8, 1013.068, 1029.434, 1045.898, 1062.46},
	//54 - Scavenger
	{56, 64.918, 73.934, 83.048, 92.26, 101.57, 110.978, 120.484, 130.088, 139.79, 149.59, 159.488, 169.484, 179.578, 189.77, 200.06, 210.448, 220.934, 231.518, 242.2, 266.84, 291.704, 316.792, 342.104, 367.64, 393.4, 419.384, 445.592, 472.024, 498.68, 525.56, 552.664, 579.992, 607.544, 635.32, 663.32, 691.544, 719.992, 748.664, 777.56, 806.68, 836.024, 865.592, 895.384, 925.4, 955.64, 986.104, 1016.792, 1047.704, 1078.84, 1110.2, 1141.784, 1173.592, 1205.624, 1237.88, 1270.36, 1303.064, 1335.992, 1369.144, 1402.52, 1436.12, 1469.944, 1503.992, 1538.264, 1572.76, 1607.48, 1642.424, 1677.592, 1712.984, 1748.6, 1784.44, 1820.504, 1856.792, 1893.304, 1930.04, 1967, 2004.184, 2041.592, 2079.224, 2117.08},
	//55 - Bounty Hunter
	{56, 64.918, 73.934, 83.048, 92.26, 101.57, 110.978, 120.484, 130.088, 139.79, 149.59, 159.488, 169.484, 179.578, 189.77, 200.06, 210.448, 220.934, 231.518, 242.2, 266.84, 291.704, 316.792, 342.104, 367.64, 393.4, 419.384, 445.592, 472.024, 498.68, 525.56, 552.664, 579.992, 607.544, 635.32, 663.32, 691.544, 719.992, 748.664, 777.56, 817.6, 857.948, 898.604, 939.568, 980.84, 1022.42, 1064.308, 1106.504, 1149.008, 1191.82, 1234.94, 1278.368, 1322.104, 1366.148, 1410.5, 1455.16, 1500.128, 1545.404, 1590.988, 1636.88, 1683.08, 1729.588, 1776.404, 1823.528, 1870.96, 1918.7, 1966.748, 2015.104, 2063.768, 2112.74, 2162.02, 2211.608, 2261.504, 2311.708, 2362.22, 2413.04, 2464.168, 2515.604, 2567.348, 2619.4},
	//56 - Artisan
	{64, 74.192, 84.496, 94.912, 105.44, 116.08, 126.832, 137.696, 148.672, 159.76, 170.96, 182.272, 193.696, 205.232, 216.88, 228.64, 240.512, 252.496, 264.592, 276.8, 303.2, 329.84, 356.72, 383.84, 411.2, 438.8, 466.64, 494.72, 523.04, 551.6, 580.4, 609.44, 638.72, 668.24, 698, 728, 758.24, 788.72, 819.44, 850.4, 881.6, 913.04, 944.72, 976.64, 1008.8, 1041.2, 1073.84, 1106.72, 1139.84, 1173.2, 1206.8, 1240.64, 1274.72, 1309.04, 1343.6, 1378.4, 1413.44, 1448.72, 1484.24, 1520, 1556, 1592.24, 1628.72, 1665.44, 1702.4, 1739.6, 1777.04, 1814.72, 1852.64, 1890.8, 1929.2, 1967.84, 2006.72, 2045.84, 2085.2, 2124.8, 2164.64, 2204.72, 2245.04, 2285.6},
	//57 - Warsmith
	{64, 74.192, 84.496, 94.912, 105.44, 116.08, 126.832, 137.696, 148.672, 159.76, 170.96, 182.272, 193.696, 205.232, 216.88, 228.64, 240.512, 252.496, 264.592, 276.8, 303.2, 329.84, 356.72, 383.84, 411.2, 438.8, 466.64, 494.72, 523.04, 551.6, 580.4, 609.44, 638.72, 668.24, 698, 728, 758.24, 788.72, 819.44, 850.4, 894.08, 938.096, 982.448, 1027.136, 1072.16, 1117.52, 1163.216, 1209.248, 1255.616, 1302.32, 1349.36, 1396.736, 1444.448, 1492.496, 1540.88, 1589.6, 1638.656, 1688.048, 1737.776, 1787.84, 1838.24, 1888.976, 1940.048, 1991.456, 2043.2, 2095.28, 2147.696, 2200.448, 2253.536, 2306.96, 2360.72, 2414.816, 2469.248, 2524.016, 2579.12, 2634.56, 2690.336, 2746.448, 2802.896, 2859.68}
};

/*
//Holds the CP tables for all the 3rd classes (IDs are 88 to 118)
//These are from the retail C4 scripts (manual_pch.txt)
static cp_float CPByClassIDFor3rdClass[31][80] =
{
	//88 - Duelist
	{72, 82.647, 93.411, 104.292, 115.29, 126.405, 137.637, 148.986, 160.452, 172.035, 183.735, 195.552, 207.486, 219.537, 231.705, 243.99, 256.392, 268.911, 281.547, 294.3, 324, 353.97, 384.21, 414.72, 445.5, 476.55, 507.87, 539.46, 571.32, 603.45, 635.85, 668.52, 701.46, 734.67, 768.15, 801.9, 835.92, 870.21, 904.77, 939.6, 984.06, 1028.862, 1074.006, 1119.492, 1165.32, 1211.49, 1258.002, 1304.856, 1352.052, 1399.59, 1447.47, 1495.692, 1544.256, 1593.162, 1642.41, 1692, 1741.932, 1792.206, 1842.822, 1893.78, 1945.08, 1996.722, 2048.706, 2101.032, 2153.7, 2206.71, 2260.062, 2313.756, 2367.792, 2422.17, 2476.89, 2531.952, 2587.356, 2643.102, 2699.19, 2755.62, 2812.392, 2869.506, 2926.962, 2984.76},
	//89 - Dreadnought
	{64, 73.464, 83.032, 92.704, 102.48, 112.36, 122.344, 132.432, 142.624, 152.92, 163.32, 173.824, 184.432, 195.144, 205.96, 216.88, 227.904, 239.032, 250.264, 261.6, 288, 314.64, 341.52, 368.64, 396, 423.6, 451.44, 479.52, 507.84, 536.4, 565.2, 594.24, 623.52, 653.04, 682.8, 712.8, 743.04, 773.52, 804.24, 835.2, 878.88, 922.896, 967.248, 1011.936, 1056.96, 1102.32, 1148.016, 1194.048, 1240.416, 1287.12, 1334.16, 1381.536, 1429.248, 1477.296, 1525.68, 1574.4, 1623.456, 1672.848, 1722.576, 1772.64, 1823.04, 1873.776, 1924.848, 1976.256, 2028, 2080.08, 2132.496, 2185.248, 2238.336, 2291.76, 2345.52, 2399.616, 2454.048, 2508.816, 2563.92, 2619.36, 2675.136, 2731.248, 2787.696, 2844.48},
	//90 - Phoenix Knight
	{48, 55.098, 62.274, 69.528, 76.86, 84.27, 91.758, 99.324, 106.968, 114.69, 122.49, 130.368, 138.324, 146.358, 154.47, 162.66, 170.928, 179.274, 187.698, 196.2, 214.02, 232.002, 250.146, 268.452, 286.92, 305.55, 324.342, 343.296, 362.412, 381.69, 401.13, 420.732, 440.496, 460.422, 480.51, 500.76, 521.172, 541.746, 562.482, 583.38, 611.46, 639.756, 668.268, 696.996, 725.94, 755.1, 784.476, 814.068, 843.876, 873.9, 904.14, 934.596, 965.268, 996.156, 1027.26, 1058.58, 1090.116, 1121.868, 1153.836, 1186.02, 1218.42, 1251.036, 1283.868, 1316.916, 1350.18, 1383.66, 1417.356, 1451.268, 1485.396, 1519.74, 1554.3, 1589.076, 1624.068, 1659.276, 1694.7, 1730.34, 1766.196, 1802.268, 1838.556, 1875.06},
	//91 - Hell Knight
	{48, 55.098, 62.274, 69.528, 76.86, 84.27, 91.758, 99.324, 106.968, 114.69, 122.49, 130.368, 138.324, 146.358, 154.47, 162.66, 170.928, 179.274, 187.698, 196.2, 214.02, 232.002, 250.146, 268.452, 286.92, 305.55, 324.342, 343.296, 362.412, 381.69, 401.13, 420.732, 440.496, 460.422, 480.51, 500.76, 521.172, 541.746, 562.482, 583.38, 611.46, 639.756, 668.268, 696.996, 725.94, 755.1, 784.476, 814.068, 843.876, 873.9, 904.14, 934.596, 965.268, 996.156, 1027.26, 1058.58, 1090.116, 1121.868, 1153.836, 1186.02, 1218.42, 1251.036, 1283.868, 1316.916, 1350.18, 1383.66, 1417.356, 1451.268, 1485.396, 1519.74, 1554.3, 1589.076, 1624.068, 1659.276, 1694.7, 1730.34, 1766.196, 1802.268, 1838.556, 1875.06},
	//92 - Sagittarius
	{56, 64.281, 72.653, 81.116, 89.67, 98.315, 107.051, 115.878, 124.796, 133.805, 142.905, 152.096, 161.378, 170.751, 180.215, 189.77, 199.416, 209.153, 218.981, 228.9, 248.15, 267.575, 287.175, 306.95, 326.9, 347.025, 367.325, 387.8, 408.45, 429.275, 450.275, 471.45, 492.8, 514.325, 536.025, 557.9, 579.95, 602.175, 624.575, 647.15, 678.09, 709.268, 740.684, 772.338, 804.23, 836.36, 868.728, 901.334, 934.178, 967.26, 1000.58, 1034.138, 1067.934, 1101.968, 1136.24, 1170.75, 1205.498, 1240.484, 1275.708, 1311.17, 1346.87, 1382.808, 1418.984, 1455.398, 1492.05, 1528.94, 1566.068, 1603.434, 1641.038, 1678.88, 1716.96, 1755.278, 1793.834, 1832.628, 1871.66, 1910.93, 1950.438, 1990.184, 2030.168, 2070.39},
	//93 - Adventurer
	{32, 36.732, 41.516, 46.352, 51.24, 56.18, 61.172, 66.216, 71.312, 76.46, 81.66, 86.912, 92.216, 97.572, 102.98, 108.44, 113.952, 119.516, 125.132, 130.8, 141.8, 152.9, 164.1, 175.4, 186.8, 198.3, 209.9, 221.6, 233.4, 245.3, 257.3, 269.4, 281.6, 293.9, 306.3, 318.8, 331.4, 344.1, 356.9, 369.8, 386.44, 403.208, 420.104, 437.128, 454.28, 471.56, 488.968, 506.504, 524.168, 541.96, 559.88, 577.928, 596.104, 614.408, 632.84, 651.4, 670.088, 688.904, 707.848, 726.92, 746.12, 765.448, 784.904, 804.488, 824.2, 844.04, 864.008, 884.104, 904.328, 924.68, 945.16, 965.768, 986.504, 1007.368, 1028.36, 1049.48, 1070.728, 1092.104, 1113.608, 1135.24},
	//94 - Archmage
	{50.5, 58.235, 66.055, 73.96, 81.95, 90.025, 98.185, 106.43, 114.76, 123.175, 131.675, 140.26, 148.93, 157.685, 166.525, 175.45, 184.46, 193.555, 202.735, 212, 225.75, 239.625, 253.625, 267.75, 282, 296.375, 310.875, 325.5, 340.25, 355.125, 370.125, 385.25, 400.5, 415.875, 431.375, 447, 462.75, 478.625, 494.625, 510.75, 533.5, 556.425, 579.525, 602.8, 626.25, 649.875, 673.675, 697.65, 721.8, 746.125, 770.625, 795.3, 820.15, 845.175, 870.375, 895.75, 921.3, 947.025, 972.925, 999, 1025.25, 1051.675, 1078.275, 1105.05, 1132, 1159.125, 1186.425, 1213.9, 1241.55, 1269.375, 1297.375, 1325.55, 1353.9, 1382.425, 1411.125, 1440, 1469.05, 1498.275, 1527.675, 1557.25},
	//95 - Soultaker
	{50.5, 58.235, 66.055, 73.96, 81.95, 90.025, 98.185, 106.43, 114.76, 123.175, 131.675, 140.26, 148.93, 157.685, 166.525, 175.45, 184.46, 193.555, 202.735, 212, 225.75, 239.625, 253.625, 267.75, 282, 296.375, 310.875, 325.5, 340.25, 355.125, 370.125, 385.25, 400.5, 415.875, 431.375, 447, 462.75, 478.625, 494.625, 510.75, 533.5, 556.425, 579.525, 602.8, 626.25, 649.875, 673.675, 697.65, 721.8, 746.125, 770.625, 795.3, 820.15, 845.175, 870.375, 895.75, 921.3, 947.025, 972.925, 999, 1025.25, 1051.675, 1078.275, 1105.05, 1132, 1159.125, 1186.425, 1213.9, 1241.55, 1269.375, 1297.375, 1325.55, 1353.9, 1382.425, 1411.125, 1440, 1469.05, 1498.275, 1527.675, 1557.25},
	//96 - Arcana Lord
	{60.6, 69.882, 79.266, 88.752, 98.34, 108.03, 117.822, 127.716, 137.712, 147.81, 158.01, 168.312, 178.716, 189.222, 199.83, 210.54, 221.352, 232.266, 243.282, 254.4, 270.9, 287.55, 304.35, 321.3, 338.4, 355.65, 373.05, 390.6, 408.3, 426.15, 444.15, 462.3, 480.6, 499.05, 517.65, 536.4, 555.3, 574.35, 593.55, 612.9, 642.54, 672.408, 702.504, 732.828, 763.38, 794.16, 825.168, 856.404, 887.868, 919.56, 951.48, 983.628, 1016.004, 1048.608, 1081.44, 1114.5, 1147.788, 1181.304, 1215.048, 1249.02, 1283.22, 1317.648, 1352.304, 1387.188, 1422.3, 1457.64, 1493.208, 1529.004, 1565.028, 1601.28, 1637.76, 1674.468, 1711.404, 1748.568, 1785.96, 1823.58, 1861.428, 1899.504, 1937.808, 1976.34},
	//97 - Cardinal
	{70.7, 81.529, 92.477, 103.544, 114.73, 126.035, 137.459, 149.002, 160.664, 172.445, 184.345, 196.364, 208.502, 220.759, 233.135, 245.63, 258.244, 270.977, 283.829, 296.8, 320.67, 344.757, 369.061, 393.582, 418.32, 443.275, 468.447, 493.836, 519.442, 545.265, 571.305, 597.562, 624.036, 650.727, 677.635, 704.76, 732.102, 759.661, 787.437, 815.43, 850.01, 884.856, 919.968, 955.346, 990.99, 1026.9, 1063.076, 1099.518, 1136.226, 1173.2, 1210.44, 1247.946, 1285.718, 1323.756, 1362.06, 1400.63, 1439.466, 1478.568, 1517.936, 1557.57, 1597.47, 1637.636, 1678.068, 1718.766, 1759.73, 1800.96, 1842.456, 1884.218, 1926.246, 1968.54, 2011.1, 2053.926, 2097.018, 2140.376, 2184, 2227.89, 2272.046, 2316.468, 2361.156, 2406.11},
	//98 - Heirophant
	{50.5, 58.235, 66.055, 73.96, 81.95, 90.025, 98.185, 106.43, 114.76, 123.175, 131.675, 140.26, 148.93, 157.685, 166.525, 175.45, 184.46, 193.555, 202.735, 212, 229.05, 246.255, 263.615, 281.13, 298.8, 316.625, 334.605, 352.74, 371.03, 389.475, 408.075, 426.83, 445.74, 464.805, 484.025, 503.4, 522.93, 542.615, 562.455, 582.45, 609.1, 635.955, 663.015, 690.28, 717.75, 745.425, 773.305, 801.39, 829.68, 858.175, 886.875, 915.78, 944.89, 974.205, 1003.725, 1033.45, 1063.38, 1093.515, 1123.855, 1154.4, 1185.15, 1216.105, 1247.265, 1278.63, 1310.2, 1341.975, 1373.955, 1406.14, 1438.53, 1471.125, 1503.925, 1536.93, 1570.14, 1603.555, 1637.175, 1671, 1705.03, 1739.265, 1773.705, 1808.35},
	//99 - Eva's Templar
	{53.4, 61.044, 68.772, 76.584, 84.48, 92.46, 100.524, 108.672, 116.904, 125.22, 133.62, 142.104, 150.672, 159.324, 168.06, 176.88, 185.784, 194.772, 203.844, 213, 232.8, 252.78, 272.94, 293.28, 313.8, 334.5, 355.38, 376.44, 397.68, 419.1, 440.7, 462.48, 484.44, 506.58, 528.9, 551.4, 574.08, 596.94, 619.98, 643.2, 674.4, 705.84, 737.52, 769.44, 801.6, 834, 866.64, 899.52, 932.64, 966, 999.6, 1033.44, 1067.52, 1101.84, 1136.4, 1171.2, 1206.24, 1241.52, 1277.04, 1312.8, 1348.8, 1385.04, 1421.52, 1458.24, 1495.2, 1532.4, 1569.84, 1607.52, 1645.44, 1683.6, 1722, 1760.64, 1799.52, 1838.64, 1878, 1917.6, 1957.44, 1997.52, 2037.84, 2078.4},
	//100 - Sword Muse
	{44.5, 50.87, 57.31, 63.82, 70.4, 77.05, 83.77, 90.56, 97.42, 104.35, 111.35, 118.42, 125.56, 132.77, 140.05, 147.4, 154.82, 162.31, 169.87, 177.5, 194, 210.65, 227.45, 244.4, 261.5, 278.75, 296.15, 313.7, 331.4, 349.25, 367.25, 385.4, 403.7, 422.15, 440.75, 459.5, 478.4, 497.45, 516.65, 536, 563.3, 590.81, 618.53, 646.46, 674.6, 702.95, 731.51, 760.28, 789.26, 818.45, 847.85, 877.46, 907.28, 937.31, 967.55, 998, 1028.66, 1059.53, 1090.61, 1121.9, 1153.4, 1185.11, 1217.03, 1249.16, 1281.5, 1314.05, 1346.81, 1379.78, 1412.96, 1446.35, 1479.95, 1513.76, 1547.78, 1582.01, 1616.45, 1651.1, 1685.96, 1721.03, 1756.31, 1791.8},
	//101 - Wind Rider
	{35.6, 40.696, 45.848, 51.056, 56.32, 61.64, 67.016, 72.448, 77.936, 83.48, 89.08, 94.736, 100.448, 106.216, 112.04, 117.92, 123.856, 129.848, 135.896, 142, 154.32, 166.752, 179.296, 191.952, 204.72, 217.6, 230.592, 243.696, 256.912, 270.24, 283.68, 297.232, 310.896, 324.672, 338.56, 352.56, 366.672, 380.896, 395.232, 409.68, 428.4, 447.264, 466.272, 485.424, 504.72, 524.16, 543.744, 563.472, 583.344, 603.36, 623.52, 643.824, 664.272, 684.864, 705.6, 726.48, 747.504, 768.672, 789.984, 811.44, 833.04, 854.784, 876.672, 898.704, 920.88, 943.2, 965.664, 988.272, 1011.024, 1033.92, 1056.96, 1080.144, 1103.472, 1126.944, 1150.56, 1174.32, 1198.224, 1222.272, 1246.464, 1270.8},
	//102 - Moonlight Sentinel
	{44.5, 50.87, 57.31, 63.82, 70.4, 77.05, 83.77, 90.56, 97.42, 104.35, 111.35, 118.42, 125.56, 132.77, 140.05, 147.4, 154.82, 162.31, 169.87, 177.5, 192.9, 208.44, 224.12, 239.94, 255.9, 272, 288.24, 304.62, 321.14, 337.8, 354.6, 371.54, 388.62, 405.84, 423.2, 440.7, 458.34, 476.12, 494.04, 512.1, 536.8, 561.69, 586.77, 612.04, 637.5, 663.15, 688.99, 715.02, 741.24, 767.65, 794.25, 821.04, 848.02, 875.19, 902.55, 930.1, 957.84, 985.77, 1013.89, 1042.2, 1070.7, 1099.39, 1128.27, 1157.34, 1186.6, 1216.05, 1245.69, 1275.52, 1305.54, 1335.75, 1366.15, 1396.74, 1427.52, 1458.49, 1489.65, 1521, 1552.54, 1584.27, 1616.19, 1648.3},
	//103 - Mystic Muse
	{52, 59.735, 67.555, 75.46, 83.45, 91.525, 99.685, 107.93, 116.26, 124.675, 133.175, 141.76, 150.43, 159.185, 168.025, 176.95, 185.96, 195.055, 204.235, 213.5, 227.8, 242.23, 256.79, 271.48, 286.3, 301.25, 316.33, 331.54, 346.88, 362.35, 377.95, 393.68, 409.54, 425.53, 441.65, 457.9, 474.28, 490.79, 507.43, 524.2, 548.25, 572.485, 596.905, 621.51, 646.3, 671.275, 696.435, 721.78, 747.31, 773.025, 798.925, 825.01, 851.28, 877.735, 904.375, 931.2, 958.21, 985.405, 1012.785, 1040.35, 1068.1, 1096.035, 1124.155, 1152.46, 1180.95, 1209.625, 1238.485, 1267.53, 1296.76, 1326.175, 1355.775, 1385.56, 1415.53, 1445.685, 1476.025, 1506.55, 1537.26, 1568.155, 1599.235, 1630.5},
	//104 - Elemental Master
	{62.4, 71.682, 81.066, 90.552, 100.14, 109.83, 119.622, 129.516, 139.512, 149.61, 159.81, 170.112, 180.516, 191.022, 201.63, 212.34, 223.152, 234.066, 245.082, 256.2, 273.36, 290.676, 308.148, 325.776, 343.56, 361.5, 379.596, 397.848, 416.256, 434.82, 453.54, 472.416, 491.448, 510.636, 529.98, 549.48, 569.136, 588.948, 608.916, 629.04, 659.46, 690.114, 721.002, 752.124, 783.48, 815.07, 846.894, 878.952, 911.244, 943.77, 976.53, 1009.524, 1042.752, 1076.214, 1109.91, 1143.84, 1178.004, 1212.402, 1247.034, 1281.9, 1317, 1352.334, 1387.902, 1423.704, 1459.74, 1496.01, 1532.514, 1569.252, 1606.224, 1643.43, 1680.87, 1718.544, 1756.452, 1794.594, 1832.97, 1871.58, 1910.424, 1949.502, 1988.814, 2028.36},
	//105 - Eva's Saint
	{52, 59.735, 67.555, 75.46, 83.45, 91.525, 99.685, 107.93, 116.26, 124.675, 133.175, 141.76, 150.43, 159.185, 168.025, 176.95, 185.96, 195.055, 204.235, 213.5, 231.1, 248.86, 266.78, 284.86, 303.1, 321.5, 340.06, 358.78, 377.66, 396.7, 415.9, 435.26, 454.78, 474.46, 494.3, 514.3, 534.46, 554.78, 575.26, 595.9, 623.2, 650.71, 678.43, 706.36, 734.5, 762.85, 791.41, 820.18, 849.16, 878.35, 907.75, 937.36, 967.18, 997.21, 1027.45, 1057.9, 1088.56, 1119.43, 1150.51, 1181.8, 1213.3, 1245.01, 1276.93, 1309.06, 1341.4, 1373.95, 1406.71, 1439.68, 1472.86, 1506.25, 1539.85, 1573.66, 1607.68, 1641.91, 1676.35, 1711, 1745.86, 1780.93, 1816.21, 1851.7},
	//106 - Shillien Templar
	{56.4, 64.59, 72.87, 81.24, 89.7, 98.25, 106.89, 115.62, 124.44, 133.35, 142.35, 151.44, 160.62, 169.89, 179.25, 188.7, 198.24, 207.87, 217.59, 227.4, 248.52, 269.832, 291.336, 313.032, 334.92, 357, 379.272, 401.736, 424.392, 447.24, 470.28, 493.512, 516.936, 540.552, 564.36, 588.36, 612.552, 636.936, 661.512, 686.28, 719.04, 752.052, 785.316, 818.832, 852.6, 886.62, 920.892, 955.416, 990.192, 1025.22, 1060.5, 1096.032, 1131.816, 1167.852, 1204.14, 1240.68, 1277.472, 1314.516, 1351.812, 1389.36, 1427.16, 1465.212, 1503.516, 1542.072, 1580.88, 1619.94, 1659.252, 1698.816, 1738.632, 1778.7, 1819.02, 1859.592, 1900.416, 1941.492, 1982.82, 2024.4, 2066.232, 2108.316, 2150.652, 2193.24},
	//107 - Spectral Dancer
	{47, 53.825, 60.725, 67.7, 74.75, 81.875, 89.075, 96.35, 103.7, 111.125, 118.625, 126.2, 133.85, 141.575, 149.375, 157.25, 165.2, 173.225, 181.325, 189.5, 207.1, 224.86, 242.78, 260.86, 279.1, 297.5, 316.06, 334.78, 353.66, 372.7, 391.9, 411.26, 430.78, 450.46, 470.3, 490.3, 510.46, 530.78, 551.26, 571.9, 601.15, 630.625, 660.325, 690.25, 720.4, 750.775, 781.375, 812.2, 843.25, 874.525, 906.025, 937.75, 969.7, 1001.875, 1034.275, 1066.9, 1099.75, 1132.825, 1166.125, 1199.65, 1233.4, 1267.375, 1301.575, 1336, 1370.65, 1405.525, 1440.625, 1475.95, 1511.5, 1547.275, 1583.275, 1619.5, 1655.95, 1692.625, 1729.525, 1766.65, 1804, 1841.575, 1879.375, 1917.4},
	//108 - Ghost Hunter
	{37.6, 43.06, 48.58, 54.16, 59.8, 65.5, 71.26, 77.08, 82.96, 88.9, 94.9, 100.96, 107.08, 113.26, 119.5, 125.8, 132.16, 138.58, 145.06, 151.6, 164.8, 178.12, 191.56, 205.12, 218.8, 232.6, 246.52, 260.56, 274.72, 289, 303.4, 317.92, 332.56, 347.32, 362.2, 377.2, 392.32, 407.56, 422.92, 438.4, 458.16, 478.072, 498.136, 518.352, 538.72, 559.24, 579.912, 600.736, 621.712, 642.84, 664.12, 685.552, 707.136, 728.872, 750.76, 772.8, 794.992, 817.336, 839.832, 862.48, 885.28, 908.232, 931.336, 954.592, 978, 1001.56, 1025.272, 1049.136, 1073.152, 1097.32, 1121.64, 1146.112, 1170.736, 1195.512, 1220.44, 1245.52, 1270.752, 1296.136, 1321.672, 1347.36},
	//109 - Ghost Sentinel
	{47, 53.825, 60.725, 67.7, 74.75, 81.875, 89.075, 96.35, 103.7, 111.125, 118.625, 126.2, 133.85, 141.575, 149.375, 157.25, 165.2, 173.225, 181.325, 189.5, 206, 222.65, 239.45, 256.4, 273.5, 290.75, 308.15, 325.7, 343.4, 361.25, 379.25, 397.4, 415.7, 434.15, 452.75, 471.5, 490.4, 509.45, 528.65, 548, 574, 600.2, 626.6, 653.2, 680, 707, 734.2, 761.6, 789.2, 817, 845, 873.2, 901.6, 930.2, 959, 988, 1017.2, 1046.6, 1076.2, 1106, 1136, 1166.2, 1196.6, 1227.2, 1258, 1289, 1320.2, 1351.6, 1383.2, 1415, 1447, 1479.2, 1511.6, 1544.2, 1577, 1610, 1643.2, 1676.6, 1710.2, 1744},
	//110 - Storm Screamer
	{53, 60.735, 68.555, 76.46, 84.45, 92.525, 100.685, 108.93, 117.26, 125.675, 134.175, 142.76, 151.43, 160.185, 169.025, 177.95, 186.96, 196.055, 205.235, 214.5, 229.35, 244.335, 259.455, 274.71, 290.1, 305.625, 321.285, 337.08, 353.01, 369.075, 385.275, 401.61, 418.08, 434.685, 451.425, 468.3, 485.31, 502.455, 519.735, 537.15, 561.2, 585.435, 609.855, 634.46, 659.25, 684.225, 709.385, 734.73, 760.26, 785.975, 811.875, 837.96, 864.23, 890.685, 917.325, 944.15, 971.16, 998.355, 1025.735, 1053.3, 1081.05, 1108.985, 1137.105, 1165.41, 1193.9, 1222.575, 1251.435, 1280.48, 1309.71, 1339.125, 1368.725, 1398.51, 1428.48, 1458.635, 1488.975, 1519.5, 1550.21, 1581.105, 1612.185, 1643.45},
	//111 - Spectral Master
	{63.6, 72.882, 82.266, 91.752, 101.34, 111.03, 120.822, 130.716, 140.712, 150.81, 161.01, 171.312, 181.716, 192.222, 202.83, 213.54, 224.352, 235.266, 246.282, 257.4, 275.22, 293.202, 311.346, 329.652, 348.12, 366.75, 385.542, 404.496, 423.612, 442.89, 462.33, 481.932, 501.696, 521.622, 541.71, 561.96, 582.372, 602.946, 623.682, 644.58, 675.78, 707.22, 738.9, 770.82, 802.98, 835.38, 868.02, 900.9, 934.02, 967.38, 1000.98, 1034.82, 1068.9, 1103.22, 1137.78, 1172.58, 1207.62, 1242.9, 1278.42, 1314.18, 1350.18, 1386.42, 1422.9, 1459.62, 1496.58, 1533.78, 1571.22, 1608.9, 1646.82, 1684.98, 1723.38, 1762.02, 1800.9, 1840.02, 1879.38, 1918.98, 1958.82, 1998.9, 2039.22, 2079.78},
	//112 - Shillien Saint
	{53, 60.735, 68.555, 76.46, 84.45, 92.525, 100.685, 108.93, 117.26, 125.675, 134.175, 142.76, 151.43, 160.185, 169.025, 177.95, 186.96, 196.055, 205.235, 214.5, 232.65, 250.965, 269.445, 288.09, 306.9, 325.875, 345.015, 364.32, 383.79, 403.425, 423.225, 443.19, 463.32, 483.615, 504.075, 524.7, 545.49, 566.445, 587.565, 608.85, 636.15, 663.66, 691.38, 719.31, 747.45, 775.8, 804.36, 833.13, 862.11, 891.3, 920.7, 950.31, 980.13, 1010.16, 1040.4, 1070.85, 1101.51, 1132.38, 1163.46, 1194.75, 1226.25, 1257.96, 1289.88, 1322.01, 1354.35, 1386.9, 1419.66, 1452.63, 1485.81, 1519.2, 1552.8, 1586.61, 1620.63, 1654.86, 1689.3, 1723.95, 1758.81, 1793.88, 1829.16, 1864.65},
	//113 - Titan
	{56, 64.918, 73.934, 83.048, 92.26, 101.57, 110.978, 120.484, 130.088, 139.79, 149.59, 159.488, 169.484, 179.578, 189.77, 200.06, 210.448, 220.934, 231.518, 242.2, 266.84, 291.704, 316.792, 342.104, 367.64, 393.4, 419.384, 445.592, 472.024, 498.68, 525.56, 552.664, 579.992, 607.544, 635.32, 663.32, 691.544, 719.992, 748.664, 777.56, 817.6, 857.948, 898.604, 939.568, 980.84, 1022.42, 1064.308, 1106.504, 1149.008, 1191.82, 1234.94, 1278.368, 1322.104, 1366.148, 1410.5, 1455.16, 1500.128, 1545.404, 1590.988, 1636.88, 1683.08, 1729.588, 1776.404, 1823.528, 1870.96, 1918.7, 1966.748, 2015.104, 2063.768, 2112.74, 2162.02, 2211.608, 2261.504, 2311.708, 2362.22, 2413.04, 2464.168, 2515.604, 2567.348, 2619.4},
	//114 - Grand Khavatari
	{40, 46.37, 52.81, 59.32, 65.9, 72.55, 79.27, 86.06, 92.92, 99.85, 106.85, 113.92, 121.06, 128.27, 135.55, 142.9, 150.32, 157.81, 165.37, 173, 189.5, 206.15, 222.95, 239.9, 257, 274.25, 291.65, 309.2, 326.9, 344.75, 362.75, 380.9, 399.2, 417.65, 436.25, 455, 473.9, 492.95, 512.15, 531.5, 558.8, 586.31, 614.03, 641.96, 670.1, 698.45, 727.01, 755.78, 784.76, 813.95, 843.35, 872.96, 902.78, 932.81, 963.05, 993.5, 1024.16, 1055.03, 1086.11, 1117.4, 1148.9, 1180.61, 1212.53, 1244.66, 1277, 1309.55, 1342.31, 1375.28, 1408.46, 1441.85, 1475.45, 1509.26, 1543.28, 1577.51, 1611.95, 1646.6, 1681.46, 1716.53, 1751.81, 1787.3},
	//115 - Dominator
	{76, 88.376, 100.888, 113.536, 126.32, 139.24, 152.296, 165.488, 178.816, 192.28, 205.88, 219.616, 233.488, 247.496, 261.64, 275.92, 290.336, 304.888, 319.576, 334.4, 362.56, 390.976, 419.648, 448.576, 477.76, 507.2, 536.896, 566.848, 597.056, 627.52, 658.24, 689.216, 720.448, 751.936, 783.68, 815.68, 847.936, 880.448, 913.216, 946.24, 988.88, 1031.848, 1075.144, 1118.768, 1162.72, 1207, 1251.608, 1296.544, 1341.808, 1387.4, 1433.32, 1479.568, 1526.144, 1573.048, 1620.28, 1667.84, 1715.728, 1763.944, 1812.488, 1861.36, 1910.56, 1960.088, 2009.944, 2060.128, 2110.64, 2161.48, 2212.648, 2264.144, 2315.968, 2368.12, 2420.6, 2473.408, 2526.544, 2580.008, 2633.8, 2687.92, 2742.368, 2797.144, 2852.248, 2907.68},
	//116 - Doomcryer
	{47.5, 55.235, 63.055, 70.96, 78.95, 87.025, 95.185, 103.43, 111.76, 120.175, 128.675, 137.26, 145.93, 154.685, 163.525, 172.45, 181.46, 190.555, 199.735, 209, 226.6, 244.36, 262.28, 280.36, 298.6, 317, 335.56, 354.28, 373.16, 392.2, 411.4, 430.76, 450.28, 469.96, 489.8, 509.8, 529.96, 550.28, 570.76, 591.4, 618.05, 644.905, 671.965, 699.23, 726.7, 754.375, 782.255, 810.34, 838.63, 867.125, 895.825, 924.73, 953.84, 983.155, 1012.675, 1042.4, 1072.33, 1102.465, 1132.805, 1163.35, 1194.1, 1225.055, 1256.215, 1287.58, 1319.15, 1350.925, 1382.905, 1415.09, 1447.48, 1480.075, 1512.875, 1545.88, 1579.09, 1612.505, 1646.125, 1679.95, 1713.98, 1748.215, 1782.655, 1817.3},
	//117 - Fortune Seeker
	{56, 64.918, 73.934, 83.048, 92.26, 101.57, 110.978, 120.484, 130.088, 139.79, 149.59, 159.488, 169.484, 179.578, 189.77, 200.06, 210.448, 220.934, 231.518, 242.2, 266.84, 291.704, 316.792, 342.104, 367.64, 393.4, 419.384, 445.592, 472.024, 498.68, 525.56, 552.664, 579.992, 607.544, 635.32, 663.32, 691.544, 719.992, 748.664, 777.56, 817.6, 857.948, 898.604, 939.568, 980.84, 1022.42, 1064.308, 1106.504, 1149.008, 1191.82, 1234.94, 1278.368, 1322.104, 1366.148, 1410.5, 1455.16, 1500.128, 1545.404, 1590.988, 1636.88, 1683.08, 1729.588, 1776.404, 1823.528, 1870.96, 1918.7, 1966.748, 2015.104, 2063.768, 2112.74, 2162.02, 2211.608, 2261.504, 2311.708, 2362.22, 2413.04, 2464.168, 2515.604, 2567.348, 2619.4},
	//118 - Maestro
	{64, 74.192, 84.496, 94.912, 105.44, 116.08, 126.832, 137.696, 148.672, 159.76, 170.96, 182.272, 193.696, 205.232, 216.88, 228.64, 240.512, 252.496, 264.592, 276.8, 303.2, 329.84, 356.72, 383.84, 411.2, 438.8, 466.64, 494.72, 523.04, 551.6, 580.4, 609.44, 638.72, 668.24, 698, 728, 758.24, 788.72, 819.44, 850.4, 894.08, 938.096, 982.448, 1027.136, 1072.16, 1117.52, 1163.216, 1209.248, 1255.616, 1302.32, 1349.36, 1396.736, 1444.448, 1492.496, 1540.88, 1589.6, 1638.656, 1688.048, 1737.776, 1787.84, 1838.24, 1888.976, 1940.048, 1991.456, 2043.2, 2095.28, 2147.696, 2200.448, 2253.536, 2306.96, 2360.72, 2414.816, 2469.248, 2524.016, 2579.12, 2634.56, 2690.336, 2746.448, 2802.896, 2859.68}
};
*/

//--------------------------------------------------------------------------------------------
//// Function Prototypes
//--------------------------------------------------------------------------------------------
int CheckHP(DWORD *pCreature, DWORD statustype, DWORD statusammount, DWORD isBroadcast);
void Awakening_StatusUpdate1();
void Awakening_StatusUpdate2();
void Awakening_StatusUpdate3();
void Awakening_StatusUpdate4();
void Awakening_StatusUpdate5();
void Awakening_StatusUpdate6();
void Awakening_StatusUpdate7();
void Awakening_StatusUpdate8();
void Lind558_StatusUpdate5();
void Lind558_StatusUpdate6();
void Lind558_StatusUpdate7();
void Lind558_StatusUpdate8();
//broadcasts
void StatusUpdate2();
void StatusUpdate3();
void StatusUpdate4();


void CombatPointsRegeneration(DWORD * pUser);
//void CombatPointsRegenerationC2(DWORD * pUser);


void CombatPointsDamageHandler(DWORD * pUser, DWORD * pAttacker, double * pDamage);
void CombatPointsDamageMagic(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4);
void CombatPointsDamageMagicAttack(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4);
void CombatPointsDamageMagicBackstab(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4);
void CombatPointsDamagePhysicalFatal(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4);
void CombatPointsDamageSkillPhysical(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4);
void CombatPointsDamageSkillEnergy(DWORD * pTarget, DWORD * pAttacker, double *pDamage, DWORD *What3, DWORD What4);
void CombatPointsDamagePhysical(DWORD * pUser, DWORD * pAttacker, double * pDamage);
void CombatPointsDamagePoison(DWORD * pUser, DWORD * pAttacker, double * pDamage);
int CombatPointsNewbieZone(DWORD * pUser);
double CombatPointsDistance(DWORD * pUser,double x1, double y1, double z1, double maxDist);
//int CombatPointsGetBuff(DWORD * pUser, int buffid);
int FindBuffINSharedData(DWORD *pUser, PTCharBaseData CSharedDat, int buffID);
int FindOverbuff(DWORD *pUser, PTCharBaseData CSharedDat);


void CSkillEffect_i_p_attack(); //physical
void CSkillEffect_i_p_attack_over_hit(); //physical
void CSkillEffect_i_death_link();
void CSkillEffect_i_fatal_blow(); //physical
void CSkillEffect_i_hp_drain();
void CSkillEffect_i_m_attack();
void CSkillEffect_i_backstab();
void CSkillEffect_i_energy_attack(); //physical
void CSkillEffect_i_cub_m_attack();
void CSkillEffect_i_cub_hp_drain();
void CSkillEffect_t_hp__Tick();
void CSkillEffect_t_cub_hp__Tick();
//void CSkillEffect_p_damage_shield_Check();
//void CSkillEffect_p_damage_shield_Pump();
void CreatureAttackedBy_DamageShield();

void CombatPointsLevelChange(DWORD * pUser, bool bLevelUp);

void CombatPointsLevelChangeGF(DWORD * pUser, bool bLevelUp);
void HookCCreatureLevelUpGF();

void CombatPointsDie(DWORD * pUser);


//void CombatPointsDieCursed(DWORD * pUser);
void RedSky(DWORD *pSocket, int skyTime);


void StartCombatPointPotion(DWORD * pUser, WORD itemID);



void BuilderCommandHealthyCP(DWORD * pUser);



DWORD GetMaxCP(BYTE level, BYTE classID, BYTE statCON);
DWORD GetMaxVP(BYTE level, BYTE classID, BYTE statCON);


//dominion wars
//BYTE isDominionEnemies(DWORD *pUser1, DWORD *pUser2);
//BYTE isRacialEnemies(DWORD *pUser1, DWORD *pUser2);
//void checkDominion(DWORD *pUser);
//void domwarInicialize();
//void domwarReInicialize();
//void racialwarInicialize();
//void racialwarReInicialize();

static const int _regionsNEWBIE[18][10]=
	{
	   {0,0,0,0,0,0,0,0,0,0}, //y=9
	   {0,0,0,0,0,0,4,4,4,4}, //10
	   {0,0,0,0,0,0,4,4,4,4}, //11
	   {0,0,0,0,0,0,4,4,4,4}, //12
	   {0,0,3,3,3,0,0,0,0,0}, //13
	   {0,0,3,3,3,0,0,0,0,0}, //14
	   {0,0,3,3,3,0,0,0,0,0}, //15
	   {0,0,0,0,0,0,0,0,0,0}, //16
	   {0,0,0,0,0,0,0,0,0,0}, //17
	   {0,0,0,2,2,0,0,0,0,0}, //18
	   {0,0,2,2,1,1,0,0,0,0}, //19
	   {0,0,2,1,1,1,0,0,0,0}, //20
	   {0,0,0,0,5,0,0,0,0,0}, //21
	   {5,5,0,0,0,0,0,0,0,0}, //22
	   {5,5,5,5,0,0,0,0,0,0}, //23
	   {5,5,5,0,0,0,0,0,0,0}, //24
	   {5,5,0,0,0,5,0,0,0,0}, //25
	   {5,5,0,0,0,0,0,0,0,0}  //y=26 by smeli
       //x=16 by smeli             x=25
	};


void CP_patch();
void PetAutofood(DWORD *pUser);



//bool IsBackPosition(int pos1, int pos2);
int j_getHeadingTo(int _heading, int _x, int _y, int heading2, int x2, int y2, bool toChar);
bool j_isBehindTarget(int _heading, int _x, int _y, int heading2, int x2, int y2);
bool j_isInFront(int _heading, int _x, int _y, int heading2, int x2, int y2, int degrees);