#ifndef _EX_DOOR_
	#define _EX_DOOR_
#endif

//you must put  the library named "stdafx.h" first.
//ex:
//#include "stdafx.h"
//#include "stdio.h"
//#include "math.h"


//General includes
#include "Shared.h"
#include "BaseStruct.h"
#include "SimpleIni.h"
#include "BufferWriter.h"
#include <vector>
#include <math.h> 


//Project includes
#ifndef _L2SERVER_
	#include "L2Server.h"
#endif
#ifndef _COMBAT_POINTS_
	#include "CombatPoints.h"
#endif

using namespace std;
using namespace User;

//--------------------------------------------------------------------------------------------
//// Global Variables
//--------------------------------------------------------------------------------------------

struct ExDoor
{
	DWORD doorID;
	DWORD objectID;
	DWORD ocupantID;
};





//#define EX_DOOR_ARRAY_SIZE 100
//static ExDoor ExDoorArray[EX_DOOR_ARRAY_SIZE];


static const int throneCount=9;
static const int chairCount=35;
static const long CastleThrones[throneCount]=
{19210010,20220010,22190010,23220010,24180017,23250010,24160024,22130016,20160010};

static ExDoor Chairs[chairCount]=
{
{18130010,0,0},
{18130011,0,0},
{18130012,0,0},
{18130013,0,0},
{18130014,0,0},
{18130015,0,0},
{18130016,0,0},
{18130020,0,0},
{18130021,0,0},
{18130022,0,0},
{18130023,0,0},
{18130024,0,0},
{18130025,0,0},
{18130026,0,0},
{18130030,0,0},
{18130031,0,0},
{18130032,0,0},
{18130033,0,0},
{18130034,0,0},
{18130035,0,0},
{18130036,0,0},
{18130040,0,0},
{18130041,0,0},
{18130042,0,0},
{18130043,0,0},
{18130044,0,0},
{18130045,0,0},
{18130046,0,0},
{18130050,0,0},
{18130051,0,0},
{18130052,0,0},
{18130053,0,0},
{18130054,0,0},
{18130055,0,0},
{18130056,0,0} //	pub chair
};


static const short VoidDoorz=18;
static short VoidDoor[VoidDoorz] ={1825,25, 2026,6, 1926, 23, 1716, 40, 1620, 16, 2025,9, 1925,4, 2423, 13, 1224, 31};
void SendVoidDoors(DWORD *pSocket, int doormap);
//int map_tile(int f1, int f2); //moved to Shared.h


//DWORD SetExDoorOBJID(DWORD doorOBJID, DWORD doorID, DWORD x, DWORD y, DWORD z);
//DWORD GetExDoorID(DWORD doorOBJID);
//ExDoor *GetExDoor(DWORD doorOBJID);
//DWORD GetNearExDoorID(DWORD x, DWORD y, DWORD z);




struct FVector1
{
	union
	{
		double v[3];
		struct
		{
			double x, y, z;
		};
	};
	FVector1() : x(0), y(0), z(0) {}
	FVector1(double _x, double _y, double _z) : x(_x), y(_y), z(_z) {}
	FVector1(const FVector1& other) : x(other.x), y(other.y), z(other.z) {}
	inline void set(double i, double j, double k) { x=i; y=j; z=k; }
	// Operator Overloads
	inline bool operator == (const FVector1& other)
	{
		if(x == other.x && y == other.y && z == other.z)
		{
			return true;
		}
		return false;
	}
	inline FVector1& operator *= (double Right)
	{
		x *= Right;
		y *= Right;
		z *= Right;
		return *this;
	}

	inline FVector1& operator /= (double Right)
	{
		x /= Right;
		y /= Right;
		z /= Right;
		return *this;
	}

	inline FVector1& operator *= (UINT Right)
	{
		x *= Right;
		y *= Right;
		z *= Right;
		return *this;
	}

	inline FVector1& operator /= (UINT Right)
	{
		x /= Right;
		y /= Right;
		z /= Right;
		return *this;
	}

	inline FVector1& operator += (const FVector1 &Right)
	{
		x += Right.x;
		y += Right.y;
		z += Right.z;
		return *this;
	}

	inline FVector1& operator -= (const FVector1 &Right)
	{
		x -= Right.x;
		y -= Right.y;
		z -= Right.z;
		return *this;
	}

	inline FVector1 operator + (double Right) const
	{
		return FVector1(x + Right,
			y + Right,
			z + Right);
	}
	inline FVector1 operator * (double Right) const
	{
		return FVector1(x * Right,
			y * Right,
			z * Right);
	}

	inline FVector1 operator / (double Right) const
	{
		return FVector1(x / Right,
			y / Right,
			z / Right);
	}

	inline FVector1 operator + (const FVector1 &Right) const
	{
		return FVector1(x + Right.x,
			y + Right.y,
			z + Right.z);
	}

	inline FVector1 operator - (const FVector1 &Right) const
	{
		return FVector1(x - Right.x,
			y - Right.y,
			z - Right.z);
	}

	inline FVector1 operator - (const FVector1 &V)
	{
		return FVector1(-V.x, -V.y, -V.z);
	}

	inline double Distance(const FVector1 &other)
	{
		const double XDiff = other.x - x;
		const double YDiff = other.y - y;
		const double ZDiff = other.z - z;
		return sqrt(XDiff * XDiff + YDiff * YDiff + ZDiff * ZDiff);
	}

	inline double Length() const
	{
		return sqrt(x * x + y * y + z * z);
	}
	inline FVector1 Cross( const FVector1 &other) const
	{
		//
		FVector1 r;
		r.x = y*other.z - z*other.y;
		r.y = z*other.x - x*other.z;
		r.z = x*other.y - y*other.x;
		return r;
	}

	inline FVector1 Normalize() const
	{
		double Len = Length();
		if(Len == 0.0f)
		{
			return FVector1(x, y, z);
		}
		else
		{
			double Factor = 1.0f / Len;
			return FVector1(x * Factor, y * Factor, z * Factor);
		}
	}
	inline FVector1 Join(const FVector1& other) const
	{
		FVector1 r;
		r.x = other.x - x;
		r.y = other.y - y;
		r.z = other.z - z;
		return r;
	}
	inline double Dot(const FVector1 &Right) const
	{
		return (x * Right.x + y * Right.y + z * Right.z);
	}
};




class CDoorGeo
{
	FVector1 m_Normal;
	double m_D;	// ax +by +cz + d = 0
	FVector1 m_Range[4];
	double m_MinX;
	double m_MaxX;
	double m_MinY;
	double m_MaxY;
	double m_MinZ;
	double m_MaxZ;
	FVector1 m_Pos;
	UINT m_Id;

public:
	CDoorGeo();
	CDoorGeo(FVector1 range[4], FVector1 pos);
	void Init(FVector1 range[4], FVector1 pos, UINT id);
	bool InLineCollision(const FVector1& p1, const FVector1& p2, FVector1& hit);
	FVector1 GetNormal(FVector1 p, FVector1 q, FVector1 r, double& d);
	inline const FVector1& GetPos() { return m_Pos; };
};


struct DoorInfo
{
	UINT objectId;	//static object id
	CDoorGeo doorGeo;
	DWORD *pObject;//CDoor *pObject;
	DoorInfo() : pObject(0), objectId(0) {};
};


class CDoorData
{
	BOOL m_Enabled;
	vector<DoorInfo*> m_Doors;
	double m_SearchRange;
	double m_MissingHpPercent;
	double m_BlockRideRange;
	BOOL m_AffectCloseCombat;
	BOOL m_Disable2ndSkillGeoCheck;
	void LoadData();
public:
	void Init();
	void GatherNearestDoors(FVector1 l1, vector<DoorInfo*>& doors, double range);
	bool CanSee(FVector1 l1, FVector1 l2);
	static bool OnGeoCanSee(PVOID pInstance, FVector1 pos1, FVector pos2);
	static bool ReturnTrue();
	bool IsIntersection(FVector1 l1, FVector1 l2, FVector1 b1, FVector1 b2);
	inline BOOL IsEnabled() { return m_Enabled; };
	inline BOOL IsAffectCloseCombat() { return m_AffectCloseCombat; };
	inline double GetBlockRideRange() { return m_BlockRideRange; };
};

extern CDoorData g_DoorData;