/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

#ifndef _EX_USER_
	#define _EX_USER_
#endif

//General includes
#include "Shared.h"
#include "SimpleIni.h"
#include "BufferWriter.h"
#include <vector>

#ifndef _STRING_
	#include <string>
#endif

//Project includes
#ifndef _L2SERVER_
	#include "L2Server.h"
#endif
#ifndef _COMBAT_POINTS_
	#include "CombatPoints.h"
	//#include "UserCommand.h"
#endif

using namespace std;
using namespace User;

//--------------------------------------------------------------------------------------------
//// Global Variables
//--------------------------------------------------------------------------------------------
static CSimpleIniA ini;
//static CSimpleIniW iniw;
static int iniLoad;
static BYTE iniValueB;
static const char * pDebug;
static BYTE RacialWars = 0;



DWORD helmet_on(DWORD headitem);
DWORD helmet_on_wizard(DWORD headitem);
DWORD helmet_class1(DWORD userclass);

//---------------------------------------------
// USER info new
//---------------------------------------------

	static int UI1_NONE = 0;
	static int UI1_PERSONAL_STORE = 1;
	static int UI1_FACIAL_FEATURES = 2;
	static int UI1_WEAPON_GLOW = 4;
	static int UI1_CURRENT_STATS = 8;
	static int UI1_MAX_STATS = 0x10;
	static int UI1_BASE_STATS = 0x20;
	static int UI1_APPEARANCE = 0x40;
	static int UI1_ROLES = 0x80;
//CharacterMasksUI2
	static int UI2_NONE = 0;
	static int UI2_PLEDGE_INFO = 1;
	static int UI2_ELEMENTAL_OFFENSE_STATS = 2;
	static int UI2_OBJECT_BOUNDARIES = 4;
	static int UI2_ANIMATION_SPEED = 8;
	static int UI2_MOVEMENT_SPEED = 0x10;
	static int UI2_LOCATION = 0x20;
	static int UI2_ELEMENTAL_DEFENSE_STATS = 0x40;
	static int UI2_STATS_V2 = 0x80;
//CharacterMasksUI3
	static int UI3_NONE = 0;
	static int UI3_UNDEFINED = 1;
	static int UI3_UNKNOWN_1 = 2;
	static int UI3_INVENTORY_SLOTS = 4;
	static int UI3_NAME_TITLE_COLOR = 8;
	static int UI3_MOVEMENT_TYPES = 0x10;
	static int UI3_TALISMANS = 0x20;
	static int UI3_VITALITY = 0x40;
	static int UI3_SOCIAL = 0x80;
//----------------------------------------

//npc:
//0C C3 3F 10 48 00 25 00 
//ED BE 4E A2 0C 
//07 00 00 00 00 00 00 00 
//38 00 
//C0 CC 0F 00 E0 46 01 00 30 38 02 00 B8 F2 FF FF 00 00 00 00 01 00 00 00 00 00 00 00 00 00 80 3F 97 08 8A 3F 01 01 00 00 00 00 00 00 00 00 00 84 10 00 00 84 10 00 00 0C 00 00

//0
static BYTE NPC_MASK1_ID[2]={0x80, 4};
static BYTE NPC_MASK1_ATTACKABLE[2]={0x40, 1};
static BYTE NPC_MASK1_UNKNOWN1[2]={0x20, 4};
static BYTE NPC_MASK1_NAME[2]={0x10, 2}; //needed by pet
static BYTE NPC_MASK1_POSITION[2]={0x08, 12};
static BYTE NPC_MASK1_HEADING[2]={0x04, 4};
//static BYTE NPC_MASK1_UNKNOWN2[2]={0x02, 4};
static BYTE NPC_MASK1_ATK_CAST_SPEED[2]={0x01, 8};
	
// 1
static BYTE NPC_MASK2_SPEED_MULTIPLIER[2]={0x80, 2 * 4};
static BYTE NPC_MASK2_EQUIPPED[2]={0x40, 12};
static BYTE NPC_MASK2_ALIVE[2]={0x20, 1};
static BYTE NPC_MASK2_RUNNING[2]={0x10, 1};
static BYTE NPC_MASK2_UNKNOWN3[2]={0x08, 0};
static BYTE NPC_MASK2_UNKNOWN4[2]={0x04, 0};
static BYTE NPC_MASK2_SWIM_OR_FLY[2]={0x02, 1};
static BYTE NPC_MASK2_TEAM[2]={0x01, 1};

// 2

//static BYTE NPC_MASK3_ENCHANT[2]={0x80, 4};
static BYTE NPC_MASK3_FLYING[2]={0x40, 4};
//static BYTE NPC_MASK3_CLONE[2]={0x20, 4};
//static BYTE NPC_MASK3_FORM[2]={0x10, 4};
static BYTE NPC_MASK3_UNKNOWN5[2]={0x08, 0};
static BYTE NPC_MASK3_UNKNOWN6[2]={0x04, 0};
static BYTE NPC_MASK3_DISPLAY_EFFECT[2]={0x02, 4};
//static BYTE NPC_MASK3_TRANSFORMATION[2]={0x01, 4};


	// 3
static BYTE NPC_MASK4_CURRENT_HP[2]={0x80, 4};
//static BYTE NPC_MASK4_CURRENT_MP[2]={0x40, 4};
static BYTE NPC_MASK4_MAX_HP[2]={0x20, 4};
//static BYTE NPC_MASK4_MAX_MP[2]={0x10, 4};
//static BYTE NPC_MASK4_DECOY_TYPE[2]={0x08, 1};
//static BYTE NPC_MASK4_FOLLOW_OBJECT[2]={0x04, (2 * 4)};
static BYTE NPC_MASK4_TITLE[2]={0x02, 2};
//static BYTE NPC_MASK4_NAME_NPCSTRINGID[2]={0x01, 4}; 
	
	// 4
//static BYTE NPC_MASK5_TITLE_NPCSTRINGID[2]={0x80, 4}; 
static BYTE NPC_MASK5_PVP_FLAG[2]={0x40, 1}; //needed by pet
static BYTE NPC_MASK5_NAME_COLOR[2]={0x20, 4}; //needed by pet
//static BYTE NPC_MASK5_CLAN[2]={0x10, (5 * 4)};
static BYTE NPC_MASK5_ABNORMALS[2]={0x08, 0}; //5*2}; //(5*2)};
static BYTE NPC_MASK5_VISUAL_STATE[2]={0x04, 1};

//=============================================================
//removed

//0
//static BYTE NPC_MASK1_NAME[2]={0, 0};
static BYTE NPC_MASK1_UNKNOWN2[2]={0, 0}; 
//1
//static BYTE NPC_MASK2_SWIM_OR_FLY[2]={0, 0};
//static BYTE NPC_MASK2_EQUIPPED[2]={0, 0}; 
//static BYTE NPC_MASK2_TEAM[2]={0, 0};
//2
static BYTE NPC_MASK3_ENCHANT[2]={0, 0};
//static BYTE NPC_MASK3_FLYING[2]={0, 0};
static BYTE NPC_MASK3_CLONE[2]={0, 0};
static BYTE NPC_MASK3_FORM[2]={0, 0};
//static BYTE NPC_MASK3_DISPLAY_EFFECT[2]={0, 0};
static BYTE NPC_MASK3_TRANSFORMATION[2]={0, 0};
	// 3
static BYTE NPC_MASK4_CURRENT_MP[2]={0, 0};
static BYTE NPC_MASK4_MAX_MP[2]={0, 0};
static BYTE NPC_MASK4_DECOY_TYPE[2]={0, 0};
static BYTE NPC_MASK4_FOLLOW_OBJECT[2]={0, 0};
static BYTE NPC_MASK4_NAME_NPCSTRINGID[2]={0, 0};
	// 4
static BYTE NPC_MASK5_TITLE_NPCSTRINGID[2]={0, 0};
//static BYTE NPC_MASK5_PVP_FLAG[2]={0, 0};
//static BYTE NPC_MASK5_NAME_COLOR[2]={0, 0};
static BYTE NPC_MASK5_CLAN[2]={0, 0};
//static BYTE NPC_MASK5_ABNORMALS[2]={0, 0};
//static BYTE NPC_MASK5_VISUAL_STATE[2]={0, 0};



//----------------------------------------------------
// CONTAINERS
//----------------------------------------------------
/*
class UserContainer
{
public:

	UserContainer();

	static UserContainer *Instance();

	void AddUser(BYTE *pUser);
	void DeleteUser(BYTE *pUser);

	bool UserExists(BYTE *pUser);

	BYTE *GetUserByACC(DWORD *pUser, int acc, bool includepuser);
	BYTE *GetUserByName(wchar_t *szName);
	BYTE *GetUserByObjId(int iObjId);
	BYTE *GetUserByWeapon(int wId);
	BYTE *GetUserByNpcIndex(int iNpcIndex);
	BYTE *GetUserByLevel(BYTE level, BYTE variation, BYTE countN);


	~UserContainer();


private:

	vector<BYTE *> pContainer;
	vector<BYTE *>::iterator UCIT;

};
*/


class NPCContainer
{
public:

	NPCContainer();

	static NPCContainer *Instance();

	void AddNPC(BYTE *pUser);
	void DeleteNPC(BYTE *pUser);

	bool NPCExists(BYTE *pUser);
	BYTE NPCCount(DWORD npcID);
	PTCharBaseData NPCFindFirst(DWORD npcID);
	PTCharBaseData NPCFindFirstByLevel(DWORD *pSocket,DWORD npcID, BYTE level_low, BYTE level_high);
	BYTE *GetNPCByPledgeId(int iObjId);
	BYTE DominionCellCount(BYTE iObjId, BYTE iObjId2);

	~NPCContainer();


private:

	vector<BYTE *> pContainer;
	vector<BYTE *>::iterator UCIT;

};


class NPCContainer2
{
public:

	NPCContainer2();

	static NPCContainer2 *Instance();

	void AddNPC(BYTE *pUser);
	void DeleteNPC(BYTE *pUser);

	bool NPCExists(BYTE *pUser);
	bool PKHunt(DWORD *pUser);
	BYTE NPCCount(DWORD npcID);
	PTCharBaseData NPCFindFirst(DWORD npcID);

	~NPCContainer2();


private:

	vector<BYTE *> pContainer;
	vector<BYTE *>::iterator UCIT;

};




//cursed weapon event container
class CursedContainer
{
public:

	CursedContainer();

	static CursedContainer *Instance();

	void AddUser(BYTE *pUser);
	void DeleteUser(BYTE *pUser);

	bool UserExists(BYTE *pUser);
	BYTE * GetUserByCWeapon(int wId);

	~CursedContainer();


private:

	vector<BYTE *> pContainer;
	vector<BYTE *>::iterator UCIT;

};





//GM container, all GMs goes here automatically

class GMContainer
{
public:
	GMContainer();

	static GMContainer *Instance();

	void AddUser(BYTE *pUser);
	void DeleteUser(BYTE *pUser);

	bool UserExists(BYTE *pUser);

	~GMContainer();


private:

	vector<BYTE *> pContainer;
	vector<BYTE *>::iterator UCIT;

};



//	void AddUserSMS(BYTE *pUser, wchar_t *szName, wchar_t *szSMS);
//	void DeleteUserSMS(BYTE *pUser, wchar_t *szName, wchar_t *szSMS);
//	wchar_t * GetUserSMS(BYTE *pUser, wchar_t *szName);

//-----------------------------------------



//------------------------------------------------------
// EX USER
//------------------------------------------------------


struct ExSocket
{
	DWORD floodticks[256];
	BYTE ex2ndlogin;
	DWORD ex2ndlogtime;
};

struct ExUserInfo
{
	BYTE loaded;
	int loaded2;
	BYTE ui1;
	BYTE ui2;
	BYTE ui3;
	BYTE exui1; //weight
	BYTE exui2; //equip
	BYTE exui3; //abnormals
	wchar_t *_title;
	wchar_t *_name;






//npc section
int _npcID;
int _isAttackable;
u8 _isHideName;
u8 _isRunning;
u8 _isInCombat;
u8 _isAlikeDead;
int _titleColor;
int _unknown1;
u8 _isFlying;
int _isFlyingINT;
u8 _team;
int _abnormal_1;
int _abnormal_2;
int _abnormal_3;
int _abnormal_4;



//pet section
int _pet_type;
int _pet_curfood;
int _pet_maxfood;
int _pet_expThisLevel;
int _pet_expNextLevel;
int _pet_rideable;


	int Transformation;
	int _abnormals;
	int _x;
	int _y;
	int _z;
	int _heading;
	int _objectID;
//character name
	int _race;
	int _sex;
	int _class;
	int _level;
	int _exp;
	int _STR;
	int _DEX;
	int _CON;
	int _INT;
	int _WIT;
	int _MEN;
	int _maxHP;
	int _currHP;
	int _maxMP;
	int _currMP;
	int _SPoints;
	int _curLoad;
	int _maxLoad;
	int _weaponFlag;

	int _invo_underwear;
	int _invo_earring_r;
	int _invo_earring_l;
	int _invo_necklace;
	int _invo_finger_r;
	int _invo_finger_l;
	int _invo_head;
	int _invo_rhand;
	int _invo_lhand;
	int _invo_gloves;
	int _invo_chest;
	int _invo_legs;
	int _invo_feet;
	int _invo_back;
	int _invo_lrhand;

int _invo_hair; //c3 addon

	int _inv_underwear;
	int _inv_earring_r;
	int _inv_earring_l;
	int _inv_necklace;
	int _inv_finger_r;
	int _inv_finger_l;
	int _inv_head;
	int _inv_rhand;
	int _inv_lhand;
	int _inv_gloves;
	int _inv_chest;
	int _inv_legs;
	int _inv_feet;
	int _inv_back;
	int _inv_lrhand;

int _inv_hair; //c3 addon

	int _PAttack;
	int _PAttackSpeed;
	int _PDef;
	int _Evasion;
	int _Accuracy;
	int _PCriticalHit;
	int _MAttack;
	int _MAttackSpeed;
	int _PAttackSpeed2;
	int _MDef;
	int _PVPflag; //0-non-pvp  1-pvp = violett name 2 - blinking violet
	int _Karma;

	int _runSpeed;
	int _walkSpeed;
	int _runSwimSpeed;
	int _walkSwimSpeed;
	int _runFloatSpeed;
	int _walkFloadSpeed;
	int _runFlySpeed;
	int _walkFlySpeed;
	double _movspeedMultipl;
	double _attackspeedMultipl;
	double _collisionRadius;
	double _collisionHeight;

	int _hairStyle;
	int _hairColor;
	int _face;
	int _builderLevel;
//title - nickname

	int _pledgeID;
	int _pledgeCrestId;
	int _allyID;
	int _allyCrestID;
	int _relation; //pledge leader flags. siege flags...
	BYTE _MountType; //c c1 mount!
	BYTE _privateStore; //c
	BYTE _dwarvenCraft; //c
	int _PKCount;
	int _PVPCount;
	WORD _cubicsCount; //h
	WORD _cubicID[4]; //h

	BYTE _findPartyMembers; //c

//new values
	DWORD _enchantEffect;
	DWORD _enchantEffectA;
	WORD _LUC;
	WORD _CHA;




};

struct ExUser
{
	short abnormal2;


	BYTE PET_PICKUP_ENCHANT;
	BYTE PET_PICKUP_ITEM;
	BYTE SENT_ACTION_FAIL;
	BYTE SENT_DELETE_OBJECT;
	BYTE ROTATIONEX;
	BYTE SHOW_ACCESSORY;
	BYTE KICK;
	BYTE NEWCHAR;

	BYTE ALCHEMY;
	int	ALCHEMY_item1;
	int	ALCHEMY_item2;
	BYTE LUCK;
	BYTE LUCK_CARDS;

	BYTE ExTeleportToLocationActivate;
	DWORD CHAR_ID;
	DWORD CHAR_OBJECTID;
	DWORD CHAR_PLEGEOID;
	DWORD RACE;
	DWORD RACE_CLASSIC;

	DWORD protocol;
	BYTE IS_GM;
	//vitality level 100 1 vitality level, 2000 2 vitality level, 15000 3 vitality level
	DWORD CurrentVP;		//The current value of VITALITY points
	DWORD MaxVP;			//The max value of VITALITY points
	DWORD MaxVPEx;		    //The max value of VITALITY points Extended

	DWORD CurrentCP;		//The current value of Combat points
	DWORD MaxCP;			//The max value of Combat points
	BYTE PotionTimer;		//A timer used for CP potions
	WORD AutoSoulShot;		//0 = not enabled.  Otherwise, it equals itemID
	WORD AutoSpiritShot;	//0 = not enabled.  Otherwise, it equals itemID
	BYTE SoulShotEvil;
	BYTE TeamCircle;		//0 = none, 1 = blue, 2 = red
	BYTE ClanPrivs;			//TODO
	BYTE EvalScore;		//now use for PacketFlood    //Current Recommend score (0-255)
	DWORD EvalLeft;			//NOW using for PKPardon		//Remaining Recommend points (0-6)

	bool DwarvenCraft;		//0 = Common Craft, 1 = Dwarven Craft
	bool HeroIcon;			//Hero icon in the Char menu			//NOTE: possibly merge both hero bools?
	bool HeroAura;			//Whether or not to show the Hero Aura
	bool Fishing;			//NOW used as triger for cursed    //Whether or not a player is fishing
//new smeli values
	BYTE PlayerJustDied;	//Just died swith
	BYTE GoingToDie;
	BYTE OffTradeHours;
	DWORD DeathTimer;
	DWORD LOGGED_IN3;
	bool PartyRessurect;
	bool htmlbypass;

	DWORD NameColor;	//name color of player 0x00FFFFFF
	DWORD TitleColor;	//title color of player 0x00ECF9A2
	DWORD PacketReceived;	
	DWORD PacketSaved;	
	DWORD SpecialEffects; //special effects on player
//racial wars addons
//	bool WarPeriod;		//racial war period; if true then war is ON
	int	RPK;			//racial wars PK

BYTE MOB_HIT_LEVEL; 
DWORD MOB_HIT_OID; 
DWORD MOB_HIT_ID; 
DWORD Transformation;
DWORD Agathion;
DWORD LOOT_TIME;
DWORD MOB_HIT_TIME;
DWORD LOGGED_IN2;
BYTE shield_success; // cKarma;
DWORD fortressID;
DWORD faceOBJ;
DWORD faceID;
DWORD helmetID;
DWORD chestOBJ;
DWORD chestID;
DWORD underwearOBJ;
DWORD underwearID;



DWORD doorID;
DWORD x;
DWORD y;
DWORD z;
BYTE Vehicle;
DWORD Transformation2;
DWORD Aura;
DWORD postID;
BYTE BlockBuff;
BYTE Observer;

//BYTE Chronicle;			//Chronicle number

DWORD lastuseditem;
DWORD lastusedrecipe;
WORD recipeid;
DWORD tradeadd_time;
DWORD trade_id;
DWORD trade_packet;
BYTE MY_CLAN;
BYTE MY_ALLY;
BYTE MY_FRIEND;
BYTE MY_LEVEL;
BYTE MY_EXPLOIT;
DWORD MY_FRIEND_ID;


// DOMINION WAR ID
BYTE domwarmerc; 
BYTE domcitizen;
BYTE occupiedcells;
int trueMaxCP;
int maraudertime;
int JUST_TELEPORTED_TICK;
BYTE VIP_PERSON; //donator or whatever important

int premium_tick; //current premium tick
int premium_time; //accumulated premium time
int premium_stop_tick; //premium stop tick 

DWORD *pMerchant;

//
BYTE LOGGED_IN1; //packet03used
BYTE BLOCK_ACT;
BYTE PK_PROTECTION;

//skills
BYTE SEED_OF_FIRE;
BYTE SEED_OF_WATER;
BYTE SEED_OF_WIND;
DWORD SEED_TIMER;
DWORD *pDefender;


// 7 signs
BYTE SSQ;
BYTE SSQ_KILLS;

//chat ban gm
BYTE CHAT_BAN_GM;

int pixy_of_feldi;
BYTE illegal_healer;
BYTE overbuff_checker;
BYTE pk_checker;

DWORD hate_attack;
DWORD hate_object_id;

//ab
BYTE player_helper10; //bot report
BYTE player_helper20;
BYTE player_helper30;
BYTE player_helper40;


//energy for destroyers and gladiators
DWORD ENERGY_SAVED;

//tauti abnormals
int tautiAB[16];

//PVP section
int PVP_SPEC_STATUS; 
int WAREHOUSE_OP; 

/*
//OLYMPIAD SECTION
BYTE ol_competition_type; //1 knight, 2- support, 3 damage dealer
DWORD ol_charID; //this id will help to restore olypiad information after relogin
DWORD ol_charOID; //this is object id which is used in CCreature::GetCreature
DWORD ol_id; //olympiad id
DWORD ol_fights;
DWORD ol_wins;
DWORD ol_timer;
DWORD ol_3x3_id; //party ID?
DWORD ol_pledgeOID; //registered in pledge competition, 0 - individual registration
*/

BYTE BEAUTY_SHOP_TYPE;
BYTE BEAUTY_SHOP_OLD;
BYTE BEAUTY_SHOP_OLD_FACE;
BYTE BEAUTY_SHOP_OLD_HAIR;
BYTE BEAUTY_SHOP_OLD_COLOR;

WORD MAILCOUNT;
DWORD MAILTIMER;
DWORD MARRIED;
DWORD MARRIED_OID;


DWORD LEAVE_PARTY_TIME;

//shots section
	WORD SoulShot;		
	WORD SpiritShot;	
	WORD SoulShotCount;		
	WORD SpiritShotCount;
	WORD BSoulShot;		
	WORD BSpiritShot;	
	WORD BSoulShotCount;		
	WORD BSpiritShotCount;

	WORD SoulShotBless;		
	WORD SpiritShotBless;	
	WORD SoulShotCountBless;		
	WORD SpiritShotCountBless;

	//DWORD SoulVal;
	//DWORD SpiritVal;

	WORD LastShot;		
	WORD LastShotCount;

	


};

static ExUser EmptyExUser = {
	0, //abnormal2
	0,0,0,0,0,0,0,0, //kick
	0,0,0,0,0, //luck
	0,0,0,0,0,0, //ExTeleportToLocationActivate, char id , object id, pledge oid, race, race_classic
	0, //protocol
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	false, false, false, false, 0,0,0,0,0,true,false,
	NAME_COLOR,TITLE_COLOR,0,0,0,
	0, //rpk 
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0, //trade
	0,0,0,0,0,0,0,0,0,0,0, //DOMINION WAR ID
	0,0,0,
	0,0,0,0,0, ////skills
	0,0, //// 7 signs
	0, ////chat ban gm
	0,0,0,0,0,0,
	0,0,0,0,
	0, //energy for destroyers and gladiators
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	//pvp section
	0,
	0,
	//olympiad section
	//0,0,0,0,0,0,0,0,0,
	//beauty shop section
	0,0,0,0,0,
	//mail section
	0,0,0,0,
	0,
	//shots section
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,

};

#define EX_USER_ARRAY_SIZE 50000
#define PACKET_ARRAY_SIZE 1000



struct SavedPacket
{
	DWORD saveID;
	DWORD accID;
	BYTE opcode;
	DWORD buffer1;
	DWORD buffer2;
};


static ExUserInfo ExUserInfoArray[EX_USER_ARRAY_SIZE];
static ExUser ExUserArray[EX_USER_ARRAY_SIZE];
static ExSocket ExSocketArray[EX_USER_ARRAY_SIZE];





//static CRITICAL_SECTION cs;

#ifdef __DEBUG__
	#ifndef _FSTREAM_
		#include <fstream>
	#endif
	static ofstream fileEx("L2EP[Elhaym]_ExUser.log", std::ios::out);
#endif

//--------------------------------------------------------------------------------------------
//// Function Prototypes
//--------------------------------------------------------------------------------------------


void ExNPCCreation(DWORD * pUser);
void ExUserCreation(DWORD * pUser);
void ExUserCreationKamael(DWORD * pUser);
void ExUserCreationGOD(DWORD * pUser);

void ExUserDeletion(DWORD * pUser);

ExUserInfo * GetExUserInfo(DWORD * pUser);
ExUser * GetExUser(DWORD * pUser);
ExUser * GetExUserById(DWORD NpcIndex);

ExUser * GetExUserC5(DWORD * pUser);
ExUser * GetExUserC6(DWORD * pUser);
ExUser * GetExUserCT(DWORD * pUser);
ExUser * GetExUserTauti(DWORD * pUser);
ExUser * GetExUserTautiCT(DWORD * pUser);


//TODO
bool LoadExUserFromDB(ExUser * pExUser);

//TODO
bool SaveExUserToDB(ExUser * pExUser);

//
void PledgeMembersShowMe(DWORD *pSocket);

//ini
int ini_load(const char * inifile);
const char * ini_read(const char * section, const char * sectionvalue, int iniLoaded);
int ini_load2(CSimpleIniA iniA,const char * inifile);
const char * ini_read2(CSimpleIniA iniA, const char * section, const char * sectionvalue, int iniLoaded);



//race wars teleport
void enemyTeleport(DWORD * pUser);
void user_teleport(DWORD *pSocket, int x, int y, int z);


//gm macro
void set_macro4gm(DWORD *pSocket);
void set_karma(DWORD *pUser, DWORD karma);
void exploitLog(DWORD * pUser, BYTE *kBuffer, BYTE opCodeK);
void crashLog(DWORD * pSocket, BYTE * kBuffer, BYTE opCodeK);
void exploitLogDupe(DWORD * pSocket, BYTE * kBuffer, BYTE opCodeK);
bool exploitLogFlood(BYTE opCode, DWORD * pSocket, DWORD * pBuffer, const char *packetstring, const char *packetstring2, int flooddelta, int mindelta, DWORD acc_id, DWORD action);


//bans
int check4chatban(DWORD *pUser, DWORD *pSocket);
/*
static const BYTE _banned_acc_cnt=10;
static DWORD _banned_acc[_banned_acc_cnt] =
{
0,
0,
0,
0,
0,
0,
0,
0,
0,
0
};
*/

//spec party
void RequestCaptureOrc(DWORD * pSocket, DWORD targetID);




static const int helmetsize=25;
static int helmets_[helmetsize][3]= {
/*
non-grade
[cloth_cap] = 41
[leather_cap] = 42
[wooden_helmet] = 43
[leather_helmet] = 44
[hard_leather_helmet] = 1148
*/

	{41,8563,8563}, //hat
	{42,8918,8918}, //rokie sailor
	{43,8243,8243}, //shaman mask //8950 l2 day feathered hat 
	{44,8919,8919}, //comondore
	{1148,8922,8922}, //pirate


/*
d-grade
[bone_helmet] = 45
[bronze_helmet] = 46
[helmet] = 47
[brigandine_helmet] = 2411
[plate_helmet] = 2412
*/

	{45,7346,7346}, //ok
	{46,7343,7402}, //ok

	{47,7382,7382},

	{2411,8186,8186}, //ok
	{2412,19426,19429}, //ok



/*
c-grade
[great_helmet] = 500
[composite_helmet] = 517
[shining_circlet] = 1149
[chain_hood] = 2413
[full_plate_helmet] = 2414
*/

	{500,7347,19436}, //ok

	{517,91888,19431}, //ok

	{1149,19433,19433}, //ok

	{2413, 19419,19440}, //ok

	{2414,19425,19430}, //ok



/*
b-grade
[shrnoen's_helmet] = 503
[avadon_circlet] = 2415
[blue_wolve's_helmet] = 2416
[doom_helmet] = 2417
*/

	{503,8253,19434}, //ok 7447

	{2415,8250,8250}, //ok 
	
	{2416, 7345,19432}, //ok

	{2417,7381,19437}, //ok



	//donator helmets

	{9640,7449,7449}, //valakas
 
	{9740,8249,8249},  //benom

	{9760, 7357,8256}, //normal

	{7850, 7364, 19438}, //clan oath


	//GM helmet
	{9050,8242,8242}, //liviona

	
	{0,0,0}
};

//allowed trade zones:

static const int tradezonessize=6; //how many zones defined in array bellow
//1)zonetype (0-no more 1-zone disabled/ignore, 2-buy, 3-sell, 4-both sell and buy), 
//2) x center coordinate
//3) y center coordinate
//4) zone lenghtX
//5) zone lenghtY

//giran harbor safe trade
//if ((CSharedDat->y > 187500) && (CSharedDat->y < 192100) && (CSharedDat->x > 42000) && (CSharedDat->x < 45800)) 

static int tradezones_enable[tradezonessize][5]= {
	{4,-83160,150872,700,700}, //Gludin
	{4,43900,189800,1900,2300}, //Giran Harbour spec zone
	{4,-14285,123586,700,700}, //Gludio
	{4,18784,145395,700,700}, //Dion
	{4,81900,148611,700,700}, //Giran
	{0,0,0,0,0}
};

static const int tradezonessize_d=22;
static int tradezones_disable[tradezonessize_d][5]= {
	{4,-84108,244604,400,400}, //TI
	{4,-80752,149776,400,400}, //Gludin
	{4,-12736,122816,400,400}, //Gludio
	{4,115072,-178176,400,400}, //Dwarf
	{4,-45264,-112512,400,400}, //Orc
	{4,47984,186832,400,400}, //giran harbor
	{4,146737,25807,400,400}, //aden
	{4,111386,219413,400,400}, //heine
	{4,105888,109808,400,400}, //hardin
	{4,117129,76917,400,400}, //hunters
	{4,15631,142885,400,400}, //dion
	{4,9670,15537,400,400}, //darkelf
	{4,46926,51511,400,400}, //elf
	{4,82992,53171,400,400}, //oren

	{4,83396,147904,650,650}, //giran
	{4,80752,146400,400,400}, //giran taurin
	{4,81543,147448,200,200}, //giran pass1
	{4,81215,146917,200,200}, //giran pass2
	{4,81817,146574,200,200}, //giran pass3
	{4,81217,145544,200,200}, //giran pass4
	{4,82000,147782,1000,100}, //giran way1

	{0,0,0,0,0}
};



DWORD trade_zone_check_e(double x, double y); 
DWORD trade_zone_check_d(double x, double y); 

//special peace zones

static const int peacezonessize=2; //how many zones defined in array bellow
//1)zonetype (0-no more 1-zone disabled/ignore, 2-town peace, 3-castle or clan hall, 4-limited access/closed territories), 
//2) x center coordinate
//3) y center coordinate
//4) zone lenghtX
//5) zone lenghtY
static int peacezones_[peacezonessize][5]= {
	{4,98296,212976,49128,49128}, //heine: 22_23,23_23,22_24,23_24,22_25,23_25, harbour/pirate 21_23,21_24,21_25, isle of souls 24_23,24_24,24_25
	{0,0,0,0,0} //square size is 32752
};

DWORD peace_zone_check(double x, double y); 



void MyNewSkill(DWORD *pTarget, WORD skillID, BYTE skillLevel);
void HookDispellByName(); //2011-08-29
void Hook_C_HP(); //2011-09-18

void material_hook1(); //2011-09-21
void material_hook2(); //2011-09-21

void Hook_target_is_my_pledge(); //2011-09-22

int ex_exUserTransfer(DWORD *pUser, DWORD *pSocket);


static const int _beautyshop_face_cnt=6;
static const int _beautyshop_hair_cnt=19;
static const int _beautyshop_color_cnt=0x31;

static const int _beuatyshop_face[_beautyshop_face_cnt][6] = {
//0 id, 1 adena cost, 2 coincost, 3 restriction fighter, 4 restriction mage , 5 ??? send along with 0th
//restriction:  race human sex male 0x1, sex female 0x1*0x100, both 0x1 | (0x1*0x100)
//restriction:  race elf sex male 0x2, sex female 0x2*0x100, both 0x2 | (0x2*0x100)


{20000, 0, 0, 0, 0, 0},
{20001, 200000, 50, 0, 0, 99999982},
{20002, 200000, 50, 0, 0, 99999970},
{20003, 200000, 50, 0, 0, 99999981},
{20004, 1000000, 50, 0, 0, 99999937},
{20005, 1000000, 50, 0, 0, 99999956},
//{20006, 1000000, 0, 0, 0, 0},
//{20007, 1000000, 0, 0, 0, 0},
//{20008, 1000000, 0, 0, 0, 0}
};

static const int _beuatyshop_hair[_beautyshop_hair_cnt][6] = {
{10000, 0, 0, 0, 0},
{10001, 1500000, 100, 0, 0, 99999959},
{10002, 1500000, 100, 0, 0, 99999982},
{10003, 1500000, 100, 0, 0, 99999948},
{10004, 1500000, 100, 0, 0, 99999936},
{10005, 1500000, 100, 0, 0, 99999992},
{10006, 1500000, 100, 0, 0, 99999987},
{10007, 1500000, 100, 0, 0, 99999962},
{10008, 1500000, 100, 0, 0, 99999972},
{10009, 1500000, 100, 0, 0, 99999936},
{10010, 1500000, 100, 0, 0, 99999927},
{10011, 1500000, 100, 0, 0, 0},
{10012, 1500000, 100, 0, 0, 0},
{10013, 1500000, 100, 0, 0, 0},
{10014, 1500000, 100, 0, 0, 0},
{10015, 1500000, 100, 0, 0, 0},
{15001, 1500000, 100, 0, 0, 0},
{15002, 1500000, 100, 0, 0, 0},
{15003, 1500000, 100, 0, 0, 0}
};

static const short _beautyshop_buffer_size=1000;
static const short _beautyshop_buffer_size2=2000;



static const int _beuatyshop_color[_beautyshop_color_cnt][6] = {
{100, 0, 0, 0, 0},

{101, 0, 0, 0, 0, 0x2711},
{101, 0, 0, 0, 0, 0x2112},
{101, 300000, 10, 0, 0, 0x2713},
{101, 300000, 10, 0, 0, 0x2714},
{101, 0, 0, 0, 0, 0x2715},
{101, 0, 0, 0, 0, 0x2716},
{101, 0, 0, 0, 0, 0x2717},
{101, 0, 0, 0, 0, 0x2718},
{101, 0, 0, 0, 0, 0x2719},
{101, 0, 0, 0, 0, 0x271A},
{101, 300000, 10, 0, 0, 0x271B},
{101, 300000, 10, 0, 0, 0x271D}, //4+4+4
//{101, 0, 0, 0, 0, 15001},
//{101, 0, 0, 0, 0, 15002},

{102, 300000, 10, 0, 0, 0x2713},
{102, 300000, 10, 0, 0, 0x2714},
{102, 300000, 10, 0, 0, 0x271B},
{102, 300000, 10, 0, 0, 0x271D}, //4

{103, 300000, 10, 0, 0, 0x2713},
{103, 300000, 10, 0, 0, 0x2714},
{103, 300000, 10, 0, 0, 0x271B},
{103, 300000, 10, 0, 0, 0x271D}, //4

{104, 300000, 10, 0, 0, 0x2713},
{104, 300000, 10, 0, 0, 0x2714},
{104, 300000, 10, 0, 0, 0x271B},
{104, 300000, 10, 0, 0, 0x271D}, //4

{105, 300000, 10, 0, 0, 0x2713},
{105, 300000, 10, 0, 0, 0x2714},
{105, 300000, 10, 0, 0, 0x271B},
{105, 300000, 10, 0, 0, 0x271D}, //4

{106, 300000, 10, 0, 0, 0x2713},
{106, 300000, 10, 0, 0, 0x2714},
{106, 300000, 10, 0, 0, 0x271B},
{106, 300000, 10, 0, 0, 0x271D}, //4

{107, 300000, 10, 0, 0, 0x2713},
{107, 300000, 10, 0, 0, 0x2714},
{107, 300000, 10, 0, 0, 0x271B},
{107, 300000, 10, 0, 0, 0x271D}, //4

{108, 300000, 10, 0, 0, 0x2713},
{108, 300000, 10, 0, 0, 0x2714},
{108, 300000, 10, 0, 0, 0x271B},
{108, 300000, 10, 0, 0, 0x271D}, //4

{109, 300000, 10, 0, 0, 0x2713},
{109, 300000, 10, 0, 0, 0x2714},
{109, 300000, 10, 0, 0, 0x271B},
{109, 300000, 10, 0, 0, 0x271D}, //4

{110, 300000, 10, 0, 0, 0x2713},
{110, 300000, 10, 0, 0, 0x2714},
{110, 300000, 10, 0, 0, 0x271B},
{110, 300000, 10, 0, 0, 0x271D} //4


};


static const long _siege_npcs[1000] = {
12000,
29001, //queen ant	
29002,	
29003,	
29004,	
29005,	
1012006,	
1012007,	
1012008,	
35064,	//duke_lewin_waldner
35065,
35066,
35067,
35068,
35069,
35070,
35071,
35072,
35073,
35074,
35075,
35076,
35077,
35078,
35062,
35079,
35080,	
35081,
35082,
35083,
35084,
35085,
35086,
35087,
35088,
35089,
35090,
35091,
35368, //bloody_lord_nurka	
35369,
35370,
35371,	
35372,
35373,
35374,
35375,
35376,
35377,
35378,
35379,
35380,
35381,	
29006, //core	
31842, //teleport cube	
29007, //b02_death_knight	
29008,	
29009,
29010,
29011,	
29012,
29013,
1012061,	
1012062,	
1012063	,
1012064	,
1012065	,
1012066	,
1012067	,
1012068	,
1012069	,
1012070	,
1012071	,
1012072	,
1012073	,
1012074	,
1012075	,
12313	,//hatchling
12077, //pet_wolf_a	
31843,	
18001,
18002,	
35099, //royal	
18003,	
31844,
31845, //bloody_pixy
31846,	
31847,	
31848,
31849,
31850,
31851,
31852,
31853,
35106, //duke_byron_ashton
35107,	
35108,
35109,
35110,
35111,	
35112,
35113,
35114,
35115,
35116,
35117,
35118,
35119,
35120,
35121,
35122,
35123,
35124,
35125,
35126,
35127,
35128,
35129,
35130,
35131,
35132,
35133,
35142,	
35146,
35105,
35148,	
35149,
35150,
35151,
35152,
35153,
35154,
35155,
35156,
35157,
35158,
35159,
35160,
35161,
35162,
35163,
35164,
35165,
35166,
35167,
35168,
35169,
35170,
35171,
35172,
35173,
35174,
35175,
35184,	
35188,
35147, //giran holything	
35134,	
35135,
35136,
35137,	
35138,
35139,
35141, //royal
35176,	
35177,
35178,
35179,
35180,
35181,
35183, //royal
29014,	//orfen
29015,
29016,
29017,
29018,
18004, //succeptor_prime
1012175,	
1012176	,
1012177	,
1012178	,
1012179	,
1012180	,
1012181	,
1012182	,
1012183	,
1012184	,
1012185	,
1012186	,
1012187	,
1012188	,
1012189	,
1012190	,
1012191	,
1012192	,
1012193	,
1012194	,
1012195	,
1012196	,
1012197	,
1012198	,
1012199	,
1012200	,
1012201	,
1012202	,
1012203	,
1012204	,
1012205	,
1012206	,
1012207	,
1012208	,
1012209	,
1012210	,
29019, //antaras
35190, //van deik	
35191,
35192,
35193,
35194,
35195,
35196,
35197,
35198,
35199,
35200,
35201,
35202,
35203,
35204,
35205,
35206,
35207,
35208,
35209,
35210,
35211,	
35212,
35213,
35214,
35215,
35216,
35217,
35226,
35232,
35189, //oren holything
35218,
35219,
35220,
35221,
35222,
35223,
35225,	//royal
13001,	
1012251,	//siege golem
35100,	
35104,	
35234, //king cadmus
35274,	//chamberlain logan
35274,	//chamberlaid radcliff
35278, //sir shamus
35278, //sir morpheus
35278, //sir_ruford
31854, //event human	
31855,	
31856,
31857,
31858,
35235, //aden knight	
35236,
35237,
35238,
35239,
35240,
35241,
35242,
35243,
35244,
35245,
35246,
35247,
35248,
35249,
35250,
35251,
35252,
35253,
35254,
35255,
35256,
35257,
35258,
35259,
35260,
35233,	 //aden holything
35261,	
35262,	
35263,	
35264,	
35265,	
35266,	
35267,
35268,
35273, //aden royal gatekeeper
35010,	
35011,
35012,
35013,
35014,
35015,
35016,
35017,
35018,
35019,
12311,	//hatchling w
12312,	//hatchling s
12313, //hatchling t	
13002,	
13003,	
35102,	
35144,	
35228,	
35186, //arvid	
35276,	
1012321,	//rodd
35269,	
35270,	
31859, //teleport cube antaras	
35092,	
35093,	
35094,
35134,	
35135,
35136,
35176,	
35177,
35178,
35218,	
35219,	
35220,
35261, //aden_default_teleporter	
35262,
35263,
35264,
35265,
13004, 	
13005, //flame controll dead	
1012344,	
1012345,	
1012346,	
1012347,	
1012348,	
1012349,	
1012350,	
1012351,	
1012352,	
1012353,	
1012354,	
1012355,	
1012356,	
1012357,	
1012358,	
1012359,	
1012360,	
1012361,	
1012362,	
1012363,	
1012364,	
1012365,	
1012366,	
1012367,	
1012368,	
1012369,	
1012370,	
31860, //ebent_heart //antaras?	
29020, //baium	
29021,
29022,
1012375, //__range_golem	
29023, //doll_blader_b
29024, //vale_master_b
1012378,	
1012379,	
1012380,	
1012381,	
1012382,	
1012383,	
1012384,	
1012385,	
1012386,	
1012387,	
1012388,	
1012389,	
1012390,	
1012391,	
1012392,	
1012393,	
1012394,	
1012395,	
1012396,	
1012397,	
1012398,	
1012399,	
1012400,	
1012401,	
1012402,	
1012403,	
1012404,	
1012405,	
1012406,	
1012407,	
1012408,	
1012409,	
35594, //mimic	
1012411,	
1012412,	
1012413,	
1012414,	
1012415,	
1012416,	
1012417,	
1012418,	
1012419,	
1012420,	
1012421,	
1012422,	
1012423,	
1012424,	
1012425,	
1012426,	
1012427,	
1012428,	
1012429,	
1012430,	
1012431,	
1012432,	
1012433,	
1012434,
1012435,	
1012436,	
1012437,	
1012438,	
1012439,	
1012440,	
1012441,	
1012442,	
1012443,	
1012444,	
1012445,	
1012446,	
1012447,	
1012448,	
1012449,	
1012450,	
1012451,	
1012452,
1012453,	
1012454,	
1012455,	
1012456,	
1012457,	
1012458,	
1012459,	
1012460,	
1012461,	
1012462,	
1012463,	
1012464,	
1012465,
1012466,	
1012467,	
1012468,	
1012469,	
1012470,	
1012471,	
1012472,	
1012473,	
1012474,	
1012475,	
1012476,	
1012477,	
1012478,	
1012479,	
1012480,	
1012481,	
1012482,	
1012483,	
1012484,	
1012485,	
1012486,	
1012487,	
1012488,	
1012489,	
1012490,	
1012491,	
1012492,	
1012493,	
1012494,	
1012495,	
1012496,	
1012497,	
1012498,	
1012499,	
1012500,	
1012501,	
1012502,	
1012503,	
1012504,	
1012505,	
1012506,	
1012507,	
1012508,	
1012509,	
1012510,	
1012511,	
1012512,	
1012513,	
1012514,	
1012515,	
14702,	//pet_big_boom
1012517,	
1012518,	
1012519,	
1012520,	
1012521,	
1012522,	
1012523,	
1012524,	
1012525,	
12526,	//wstrider
12527,	//sstrider
12528,	//tstrider
1012529,	
1012530,
1012531,	
35408,	
35409,	
35410, //gustav	
29025, //baium npc
1012536,	
1012537,	
1012538,	
35428, //oel_mahum_berserker
35429,	
35430,
35431,
35432,
29026, //pirates zombie captain_b	
29027,	
1012546, //__moveguard_hu	
1012547, //__moveguard_e	
1012548, //__moveguard_de	
1012549, //__moveguard_dw	
1012550, //__moveguard_orc	
35422,	
35423,
35424,
35425,
35426,
35427,
35433,
35434,
35435,
35436,	
35437,	
35438,	
31861, //baium gatekeeper	
1012564, //pet_fox, pet of erthea	
35411,
35412,
35413,
35414,	
35415,	
35416, //doom_knight_agit	
31862, //dimension vertex_4	
35280,	
35281, //sir schacht	
35282,	
35283,	
35284,	
35285,	
35286,	
35287,	
35288,	
35289,	
35290,
35291,
35292,	
35293,
35294,
35295,
35296,
35297,
35298,
35299,
35300,
35301,
35302,
35303,
35304,
35305,
35306,
35307,
35316, //chamberlain_meurath
35320, //sir raibel	
35279, //innadrile hollything	
35308, //innadrile_df_teleporter
35309,	
35310,	
35311,
35312,	
35313,	
35315,	//royal
1012610,	//__innadrile_teleporter1
1012611,	//__innadrile_teleporter2
1012612,	//__innadrile_teleporter3
35318, //solinus	
18006,
18007,	
18008, //karik_a
31863, //santa1	
31864, //santa 2	
13006, //xmas_tree_a	
13007,	//xmas_tree_b	
12621,	//wyvern
13006, //christmas_tree_a1	
1012623,
1012624,
1012625,
1012626,
34157, //pub 2015
34158,
34159,
34160,
34161,
34162,
34163,
34164,
34165,
34166,
34167,
34168,
34170,
34180,
34181,
34182,
34183,
34184,
34185,
34186,
34187,
34188,
34200,
34202,
34203,
34204,
34205,
34206,
34207,
34083, //sexy girl
34171, //queen
8650, //female warrior
8616, //royal guard male
34173, //royal guard female
1012661,
1012662,	
1012663,	
1012664,
1012665,
1012666,
1012667,
1012668,
1012669,
1012670,
1012671,
1012672,	
1012673,	
1012674,
1012675,
1012676,
1012677,
1012678,
1012679,
1012680, 
1012681, 
1012682, 
1012683,	
1012684,
1012685,
1012686,
1012687,
1012688,
1012689,
1012690,
1012691,	
1012692,	
1012693,	
1012694,
1012695,
1012696,
1012697,
1012698,
1012699,
1012700,
1012701,
1012702,	
1012703,
1012704,
1012705,
1012706,
1012707,
1012708,
1012709,
1012710,
1012711,	
1012712,	
1012713,
1012714,
1012715,
1012716,
1012717,
1012718,
1012719,
1012720,
1012721	,
1012722	,
1012723,
1012724,
1012725,
1012726,
1012727,
1012728,
1012729,
1012730,
1012731	,
1012732	,
1012733,
1012734,
1012735,
1012736,
1012737,
1012738,
1012739,
1012740,
1012741	,
1012742	,
1012743,
1012744,
1012745,
1012746,
1012747,
1012748,
1012749,
1012750,
1012751	,
1012752	,
1012753,
1012754,
1012755,
1012756,
1012757,
1012758,
1012759,
1012760, 
1012761, 
1012762, 
1012763,
1012764,
1012765,
1012766,
1012767,
1012768,
1012769,
1012770,
1012771,
1012772,
1012773,
1012774,
1012775,
1012776,
1012777,
1012778,
1012779,
12780, //pet_baby_bufalo	
12781, //pet_baby_kukaburo	
12782, //pet_baby_cougar
1012783,
1012784,
1012785,
1012786,
1012787,
1012788,
1012789,
//godard siege
35365,
35363, //chamberlain alfred
35367,
35324, //sir haenz
35325, //duke_morah_ken_abigail
35326,
35327,
35328,
35329,
35330,
35331,
35332,
35333,
35334,
35335,
35336,
35337,
35338,
35339,
35340,
35341,
35342,
35343,
35344,
35345,
35346,
35347,
35348,
35349,
35350,
35351,
35352,
35353,
35354,
35355,
35356,
35357,
35358,
35359,
35360,
35271,
35322, //godard hollything r
35323, //godard hollything l
35453, //custodian adriene	
35455, //custodian bianca	
35451, //custodian emma
35457, //custodian gladys	
35459, //custodian regina
//rune siege
35469, //rune hollything
35470, //king_astair_van_holter
35471,
35472,
35473,
35474,
35475,
35476,
35477,
35478,
35479,
35480,
35481,
35482,
35483,
35484,
35485,
35486,
35487,
35488,
35489,
35490,
35491,
35492,
35493,
35494,
35495,
35496,
35497,
35498,
35499,
35500,
35501,
35502,
35503,
35504,
35505,
35506,
35507,
35508,
35509, //chamberlain_frederick
35511,
35361, //godard smith
35362, //godard keeper
35553, //shutgart smith
35554, //shutgart keeper
35557, //merc_manager_kendrew
1012885	,
1012886	,
1012887,
1012888,
1012889,
1012890	,
1012891	,
1012892	,
1012893	,
1012894	,
35467, //custodian_branhilde
35465, //custodian_milicent
35463, //custodian_helga
35461, //custodian_aida
29028, //valakas	
29029, //valakas lavasaurus
//sutgart siege
35555, //chamberlain_august
35559, //sir daguerre
35513, //sir_sherman == sir_siemens
35514, //shutgart hollything r
35515, //shutgart hollything l
35516, //sir verus
35517,
35518,
35519,
35520,
35521,
35522,
35523,
35524,
35525,
35526,
35527,
35528,
35529,
35530,
35531,
35532,
35533,
35534,
35535,
35536,
35537,
35538,
35539,
35540,
35541,
35542,
35543,
35544,
35545,
35546,
35547,
35548,
35549,
35550,
35551,
35552


};




int getVisualHelmetEx(PTCharBaseData CSharedDat,ExUser * tempExUser, DWORD *pUser);
void AddValueToAB(ExUser * tempExUser, WORD value);