#include "Lines.h"
//#include "L2Server.h"

int DoLineSegmentIntersection(const Vector& p0, const Vector& p1, const Vector& p2, const Vector& p3)
{
    LineSegment linesegment0(p0, p1);
    LineSegment linesegment1(p2, p3);

    Vector intersection;

   // std::cout << "Line Segment 0: (" << p0.x_ << ", " << p0.y_ << ") to (" << p1.x_ << ", " << p1.y_ << ")\n"
   //           << "Line Segment 1: (" << p2.x_ << ", " << p2.y_ << ") to (" << p3.x_ << ", " << p3.y_ << ")\n";

    switch(linesegment0.Intersect(linesegment1, intersection))
    {
    case LineSegment::PARALLEL:
        //std::cout << "The lines are parallel\n\n";
		return 2;
        break;
    case LineSegment::COINCIDENT:
        //std::cout << "The lines are coincident\n\n";
		return 3;
        break;
    case LineSegment::NOT_INTERESECTING:
        //std::cout << "The lines do not intersect\n\n";
		return 0;
        break;
    case LineSegment::INTERESECTING:
        //std::cout << "The lines intersect at (" << intersection.x_ << ", " << intersection.y_ << ")\n\n";
		return 1;
        break;
    }
	return 0;
}

int DoLineSegmentIntersection_F(float p1x1, float p1y1, float p2x1, float p2y1, float p3x1, float p3y1, float p4x1, float p4y1)
{
	return DoLineSegmentIntersection(Vector(p1x1, p1y1), Vector(p2x1, p2y1), Vector(p3x1, p3y1), Vector(p4x1, p4y1));

}


/*
void main()
{
    DoLineSegmentIntersection(Vector(0.0f, 0.0f), Vector(5.0f, 5.0f), Vector(5.0f, 0.0f), Vector(0.0f, 5.0f));
    DoLineSegmentIntersection(Vector(1.0f, 3.0f), Vector(9.0f, 3.0f), Vector(0.0f, 1.0f), Vector(2.0f, 1.0f));
    DoLineSegmentIntersection(Vector(1.0f, 5.0f), Vector(6.0f, 8.0f), Vector(0.5f, 3.0f), Vector(6.0f, 4.0f));
    DoLineSegmentIntersection(Vector(1.0f, 1.0f), Vector(3.0f, 8.0f), Vector(0.5f, 2.0f), Vector(4.0f, 7.0f));
    DoLineSegmentIntersection(Vector(1.0f, 2.0f), Vector(3.0f, 6.0f), Vector(2.0f, 4.0f), Vector(4.0f, 8.0f));
    DoLineSegmentIntersection(Vector(3.5f, 9.0f), Vector(3.5f, 0.5f), Vector(3.0f, 1.0f), Vector(9.0f, 1.0f));
    DoLineSegmentIntersection(Vector(2.0f, 3.0f), Vector(7.0f, 9.0f), Vector(1.0f, 2.0f), Vector(5.0f, 7.0f));
}
*/






int isBarrierLinesCossing(float x1, float y1, float x2, float y2, int z1, int action)
{

	bool contn=true;
	for (int i=1; i<=MagicBarrier_ARRAY_SIZE && contn; i++)
	{
		if(BarrierArray[i].id==0) {
			contn=false;
		} else {
			if (DoLineSegmentIntersection_F((float)BarrierArray[i].x1, (float)BarrierArray[i].y1, (float)BarrierArray[i].x2, (float)BarrierArray[i].y2, x1, y1, x2, y2) == 1)
			{
				return BarrierArray[i].htmMessageId;

			}


		}
	}
	return 0;

}

int is2LinesCossing(float l1x1, float l1y1, float l1x2, float l1y2, float l2x1, float l2y1, float l2x2, float l2y2, int z1, int action)
{
	if (DoLineSegmentIntersection_F(l1x1, l1y1, l1x2, l1y2, l2x1, l2y1, l2x2, l2y2) == 1)
	{
		return 1;
	}

	return 0;

}



bool wyvern_restrictor(int x, int y)
{
    // if( (x < 65544) || (y <163848)) return true; //heine territory only

	if (y < -163848) return true; //dwarven willagae, olympiad stadiums, some dungeons

	if ((x > 131080) && (y >98312) && ((x < 196600) && (y <131064))) return true; //loa - lair of antaras

	if ((x > 107684) && (y >10020) && ((x < 121356) && (y <22076))) return true; //toi - tower of insolence

	if ((x > 201736) && (y >-124792) && ((x < 223736) && (y <-103432))) return true; //lov - lair of valakas

	if ((x > 10200) && (y >106632) && ((x < 25240) && (y <121656))) return true; //ct - cruma tower

	if ((x > 32776) && (y >196616) && ((x < 63736) && (y <228344))) return true; //zaken - pirate island


	return false;

}

bool loot_restrictor(int x, int y)
{
	if ((x > 107684) && (y >10020) && ((x < 121356) && (y <22076))) return true; //toi - tower of insolence
	return false;
}


void IniBarrier()
{
	BarrierArray[1].id =1; //heine border barrier
	BarrierArray[1].x1 =66952; 
	BarrierArray[1].y1 =184056;
	BarrierArray[1].z1 =-4248;
	BarrierArray[1].x2 =86520; //p2
	BarrierArray[1].y2 =158728;
	BarrierArray[1].z2 =-3888;
	BarrierArray[1].isZMatters =2;
	BarrierArray[1].isForMoving =1;
	BarrierArray[1].isForAttack =0;
	BarrierArray[1].htmMessageId =3;

	BarrierArray[2].id =0; 


}


void IniNoFlyZones()
{
	

	//#################### oren01_mb2220_ugoz01_flyno
	NoFlyArray[1].id =1; 
	NoFlyArray[1].pointCount =4;

	NoFlyArray[1].points[1].x=88417;
	NoFlyArray[1].points[1].y=77085;
	NoFlyArray[1].points[1].z_min=-15000;
	NoFlyArray[1].points[1].z_max=32767;

	NoFlyArray[1].points[2].x=105546;
	NoFlyArray[1].points[2].y=77041;
	NoFlyArray[1].points[2].z_min=-15000;
	NoFlyArray[1].points[2].z_max=32767;

	NoFlyArray[1].points[3].x=105421;
	NoFlyArray[1].points[3].y=92728;
	NoFlyArray[1].points[3].z_min=-15000;
	NoFlyArray[1].points[3].z_max=32767;

	NoFlyArray[1].points[4].x=88481;
	NoFlyArray[1].points[4].y=92787;
	NoFlyArray[1].points[4].z_min=-15000;
	NoFlyArray[1].points[4].z_max=32767;



	NoFlyArray[2].id =0; 


}


int checkZoneInside(int x, int y)
{

	bool contn=true;
	for (int i=1; i<=NOFLY_ARRAY_SIZE && contn; i++)
	{
		if(NoFlyArray[i].id==0) {
			contn=false;
		} else {
			//if (DoLineSegmentIntersection_F((float)BarrierArray[i].x1, (float)BarrierArray[i].y1, (float)BarrierArray[i].x2, (float)BarrierArray[i].y2, x1, y1, x2, y2) == 1)
			{
				return 1;

			}


		}
	}
	return 0;


}



/*
bool IsTargetVisible(DWORD *pUser, DWORD *pTarget, int nInZoneObjectId, bool bCheckPlaneCollision)
{


									FVector vPosActor;
							vPosActor.x=(float) -18360;
							vPosActor.y=(float) 113272;
							vPosActor.z=(float) -2760;

									FVector vPosTarget;
							vPosTarget.x=(float) -18344;
							vPosTarget.y=(float) 112696;
							vPosTarget.z=(float) -2760;

	bool bIsVisible = false;
	//bIsVisible = this->_IsTargetVisible(vPosActor,vPosTarget);
	bIsVisible = true;
	//if (bIsVisible && bCheckPlaneCollision)
	{
		FVector vPosCollisionOut;
		//521920 CWorldPlaneCollision::CheckCollision(const FVector &vStart, const FVector &vEnd, double dRadius, FVector &Out>
	//	if (g_WorldPlaneCollision.CheckCollision(vPosActor,vPosTarget,1,vPosCollisionOut,nInZoneObjectId))
		if (L2Server::g_WorldPlaneCollision_CheckCollision(G_WORLDPLANECOLLISION_OBJECT,vPosActor,vPosTarget,1,vPosCollisionOut))
		{
			bIsVisible = false;
		}
	}
	return bIsVisible;
}
*/