#pragma once

#pragma warning(disable: 4311)

#include "MemoryObject.h"

/*
enum L2_RTTI //c4
{
	CUSERSOCKET_CLASS=0x00A8EE78,
	CUSER_CLASS=0x00A871B8,
	CSUMMON_CLASS=0x00A4A708,
	CPET_CLASS=0x00A4B078,
	CBOSS_CLASS=0x00988F78,
	CNPC_CLASS=0x00A289D8,
	CETCITEM_CLASS=0x00A0A448,
	CACCESSARY_CLASS=0x00A08DC8,
	CQUESTITEM_CLASS=0x00A0ABD8,
	CWEAPON_CLASS=0x00A0B368,
	CARMOR_CLASS=0x00A09CC8,
	CASSET_CLASS=0x00A09558,
	CPLEDGE_CLASS=0x00A53448,
	CPARTY_CLASS=0x00A40418
};
*/

class CIOObject : public MemoryObject
{
public:
	/* 0x18 */      void *pPayLoad;  // or MemoryObject* payload.
};


class CObject : public CIOObject
{
public:
	/* 0x020 */     int databaseId;
	/* 0x024 */     int objectId;
	/* 0x028 */     int objectType;
	/* 0x02C */     int unk02C;
	
	static CObject* GetObject(UINT32 objectID)
	{
		typedef CObject* (*TGetObject) (UINT32);
		TGetObject _GetObject = (TGetObject)0x004AD870; //6F4920;
		return _GetObject(objectID);
	}

/*
	bool IsObjectOf(L2_RTTI c)
	{
		if(this==NULL) { 
			return false; 
		}
		if((DWORD)this<0x1000000) { 
			return false; 
		}
		if(*(DWORD*)this!=c) { 
			return false; 
		}
		return true;
	}
*/

	CObject* AddRef(const char* caller, UINT32 line, UINT32 unk)
	{
		typedef CObject* (*TLockInc) (CObject*,const char*,UINT32,UINT32);
		TLockInc _LockInc = (TLockInc)*(__int64*)(((BYTE*)*(__int64*)this)+0x08);
		return _LockInc(this,caller,line,unk);
	}

	bool IsItem() //????
	{
		typedef bool (*TIsItem) (CObject*);
		TIsItem _IsItem = (TIsItem)*(__int64*)(((BYTE*)*(__int64*)this)+0x18);
		return _IsItem(this);
	}

	bool IsUser()
	{
		typedef bool (*TIsUser) (CObject*);
		TIsUser _IsUser = (TIsUser)*(__int64*)(((BYTE*)*(__int64*)this)+0x28);
		return _IsUser(this);
	}

	bool IsCreature()
	{
		typedef bool (*TIsCreature) (CObject*);
		TIsCreature _IsCreature = (TIsCreature)*(__int64*)(((BYTE*)*(__int64*)this)+0x38);
		return _IsCreature(this);
	}
private:
	CObject();
};

class CObjectDB
{
public:
	static CObjectDB* getInstance()
	{
		static CObjectDB* objectDB=(CObjectDB*)0x0141C9D78; //BC5D810;
		return objectDB;
	}

	UINT32 GetClassIdFromName(const wchar_t* name)
	{
		typedef UINT32 (*TGetClassIdFromName) (CObjectDB*, const wchar_t*);
		TGetClassIdFromName _GetClassIdFromName = (TGetClassIdFromName)0x004B08B0; //6FB7F0;
		return _GetClassIdFromName(this, name);
	}

	wchar_t* GetName(UINT32 pch)
	{
		typedef wchar_t* (*TGetName) (CObjectDB*, UINT32);
		TGetName _GetName = (TGetName)0x004B0360; //6FA690;
		return _GetName(this, pch);
	}

	CObject* GetObject(UINT32 pch)
	{
		typedef CObject* (*TGetObject) (CObjectDB*, UINT32);
		TGetObject _GetObject = (TGetObject)0x004B0470; //6FA900;
		return _GetObject(this, pch);
	}

	CObject* SetGetObject(UINT32 classID)
	{
		typedef CObject* (*TSetGetObject) (CObjectDB*, UINT32);
		TSetGetObject _SetGetObject = (TSetGetObject)0x004B06D0; //6FB0C0;
		return _SetGetObject(this, classID);
	}


	class CObject* CreateItem(UINT32 itemID)
	{
		typedef class CObject* (*TCreateItem) (CObjectDB*, UINT32);
		TCreateItem _CreateItem = (TCreateItem)0x004B0530; //6FAB60;
		return _CreateItem(this, itemID);
	}
private:
	CObjectDB();
};


class CContainer
{
public:
	void PopItem(class CItem* pItem)
	{
		typedef void (*TPop) (CContainer*, class CItem*);
		TPop _Pop = (TPop)0x004CD8B0; //78A2C0;
		return _Pop(this, pItem);
	}
};

class CContainerDB
{
public:
	static CContainerDB* getInstance()
	{
		static CContainerDB* containerDB=(CContainerDB*)0x0167E3EF0; //E289B50;
		return containerDB;
	}

	CContainer* GetContainer(UINT32 index)
	{
		typedef CContainer* (*TGetContainer) (CContainerDB*, UINT32);
		TGetContainer _GetContainer = (TGetContainer)0x004CE210; //7885C0;
		return _GetContainer(this, index);
	}
private:
	CContainerDB();
};

/*
.text:00443A9A                 push    offset aNohtml_htm ; "nohtml.htm"
.text:00443A9F                 lea     eax, [ebp+var_220]
.text:00443AA5                 push    eax
.text:00443AA6
.text:00443AA6 loc_443AA6:                             ; CODE XREF: CCreature__UseItem_443630+468j
.text:00443AA6                 call    sub_58C33E
.text:00443AAB                 add     esp, 8
.text:00443AAE                 lea     ecx, [ebp+var_220]
.text:00443AB4                 push    ecx
.text:00443AB5                 mov     ecx, 3490100h
.text:00443ABA                 call    WCHAR_const$_GetHTMLFile_538900
.text:00443ABF                 mov     edx, [esi]
.text:00443AC1                 mov     ecx, esi
.text:00443AC3                 mov     edi, eax
.text:00443AC5                 call    dword ptr [edx+78h]
.text:00443AC8                 mov     eax, [eax+19B8h]
.text:00443ACE                 push    edi
.text:00443ACF                 push    0
.text:00443AD1                 push    1Bh
.text:00443AD3                 push    offset aCds     ; "cdS"
.text:00443AD8                 push    eax
.text:00443AD9                 call    CSocket__Send_4DFC70
.text:00443ADE                 add     esp, 14h
.text:00443AE1                 jmp     loc_443762      ; default
*/
class CHTMLCacheManager
{
public:
	static CHTMLCacheManager* getInstance()
	{
		static CHTMLCacheManager* HTMLCacheManager=(CHTMLCacheManager*)0x3490100; //6F8BF40;
		return HTMLCacheManager;
	}

//pUser->ShowHTML(L"pl_ex_acad_taken.htm",CHTMLCacheManager::getInstance()->GetHTMLFile(L"pl_ex_acad_taken.htm",0),0);
	wchar_t* GetHTMLFile(const wchar_t* fileName, int lang)
	{
		typedef wchar_t* (*TGetHTMLFile) (CHTMLCacheManager*, const wchar_t*); //, int);
		TGetHTMLFile _GetHTMLFile = (TGetHTMLFile)0x00538900; //5F7E60;
		return _GetHTMLFile(this, fileName); //, lang);
	}
private:
	CHTMLCacheManager();
};




class CL2Time: public CObject
{
public:
	static CL2Time* getInstance()
	{
		static CL2Time* l2Time=(CL2Time*)0x03493808; //6F8E3A0;
		return l2Time;
	}

	void TimerExpired(UINT32 timerID)
	{
		typedef void (*TTimerExpired) (CL2Time*, UINT32);
		TTimerExpired _TimerExpired = (TTimerExpired)0x00491400; //64AB70;
		_TimerExpired(this, timerID);
	}
private:
	CL2Time();
};


class CWorld {
public:
	static CWorld* getInstance()
	{
		static CWorld* world=(CWorld*)0x018ACD030; //E8AA840;
		return world;
	}

	void DestroyItem(CItem* item)
	{
		typedef void (*TAdd) (CWorld*, CItem*);
		TAdd _Add = (TAdd)0x00503560; //7791D0;
		_Add(this, item);
	}

	bool TryPickItem(CItem* pItem, int* pCreature)
	{
		typedef bool (*TTryPickItem) (CWorld*,CItem*,int*);
		TTryPickItem _TryPickItem = (TTryPickItem)0x0055A930; //8C1070;
		return _TryPickItem(this, pItem, pCreature);
	}

	/*
	bool InRange(FVector& origin, FVector& destination, UINT32 range)
	{
		typedef bool (*TInRange) (CWorld*, FVector&, FVector&, UINT32);
		TInRange _InRange = (TInRange)0x008AE6C0;
		return _InRange(this, origin, destination, range);
	}
	*/
};