/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

//General includes
#ifndef _SHARED_
	#include "Shared.h"
#endif

//Project includes
#ifndef _L2SERVER_
	#include "L2Server.h"
#endif

#ifndef _PARTY_
	#define _PARTY_
#endif

//--------------------------------------------------------------------------------------------
//// Global Variables
//--------------------------------------------------------------------------------------------

//None

//--------------------------------------------------------------------------------------------
//// Function Prototypes
//--------------------------------------------------------------------------------------------

// Fixes the RequestParty functionality in C4 by converting the
// charName string passed in the packet back into an ObjectID.
//
// Parameters:
// DWORD * pBuffer - address of the packet sent by the client
//
void RequestPartyFix(DWORD * pBuffer);

// Converts a charName into a character User struct by finding
// a User struct for that charName.  ObjectID is inside of it.
//
// Parameters:
// DWORD * charName - address of a wstring name (offset wchar * charName)
//
DWORD * FindUserByCharName(DWORD * charName);



//corrund functions

void EnterPartyBuff(DWORD * pUser);
void PartyBuff(DWORD * pUser);
void HookEnterPartyBuff();
void HookPartyBuff();

void EnterPartyBuffC3(DWORD * pUser);
void PartyBuffC3(DWORD * pUser);
void HookEnterPartyBuffC3();
void HookPartyBuffC3();

void EnterPartyBuffCT(DWORD * pUser);
void PartyBuffCT(DWORD * pUser);
void HookEnterPartyBuffCT();
void HookPartyBuffCT();

void PetBuffCT(DWORD * pUser);
void SummonBuffCT(DWORD * pUser);
void PartySummonDeleteCT(DWORD * pUser, DWORD opCode);