/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

#define _CRT_SECURE_NO_DEPRECATE 1

//General includes
#ifndef _WINDOWS_
	#include <windows.h>
#endif



//--------------------------------------------------------------------------------------------
//// Special Function Definitions
//--------------------------------------------------------------------------------------------

//allows functions to be exported into other programs
#define DllExport __declspec( dllexport )
//doesn't compile functions with prologue/epilogue asm code
#define Naked __declspec( naked )

//--------------------------------------------------------------------------------------------
//// Debug Settings
//--------------------------------------------------------------------------------------------
//standard level of debug messages
#define __DEBUG__
//very detailed level of debug messages
//#define __DEBUG_VERBOSE__  //original mcrabben7 debug
//#define __RACIALWARS__ //racial wars debug
#define __DEBUG_RACIALWARS__ //racial wars debug
//#define __DEBUG_DUMP_PACKETS__ //used for defuging packets in smeli log
//#define __CURSED_WEAPON_MAP__ 
//#define __AB_TEST__

//#define  __C1_PACKETS__ //old C1 serverpackets support - various bus. must use original l2serverSINA
#ifndef __C1_PACKETS__
//##########################################
//uncoment all 3 of them for chaotic throne
//#########################################

#define __KAMAEL_PACKETS__ //kamael packet handling
#define __KAMAEL_PACKETS_SEND__ //kamael packet handling
#define __KAMAEL_PACKETS_RECEIVE__ //kamael packet handling

#endif

//Set up our global log file if debugging is set for compiling
#ifdef __DEBUG__
	#ifndef _FSTREAM_
		#include <fstream>
		static std::ofstream fileElhaym("L2EP[Elhaym].log", std::ios::out);
		static std::ofstream fileRecipes("../script/recipe.txt", std::ios::in);

		//std::basic_string<wchar_t> b_string;
		//std::vector<std::basic_string<wchar_t>> b_vector;
	#endif
#endif



//--------------------------------------------------------------------------------------------
//// Config File Class
//--------------------------------------------------------------------------------------------

//ConfigLoader Config class L2EP
//#ifndef _CONFIG_L2EP_
//	#include "./ConfigLoader/ConfigObjects/Config_L2EP.h"
//#endif

//Global Config Loader
//TODO: write the Config_L2EP class to extend Config_Template
//Config_L2EP config("L2EP[Elhaym].cfg");
//config.parseConfig();
//USAGE: var = config.VARNAME;

//--------------------------------------------------------------------------------------------
//// Console Report Interface
//--------------------------------------------------------------------------------------------


const std::string& ConvertUnicodeToAnsi(const std::wstring& str, std::string& tmp);


int map_tile(int f1, int f2);
