#ifndef __TCPCLIENTSOCKET_H__
#define __TCPCLIENTSOCKET_H__

#include <winsock2.h>
//#define _WINSOCKAPI_
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include "TCPBaseSocket.h"

enum TCPSocketErrorLevel
{
	SEL_NOT_INITIALIZED,
	SEL_NET_DOWN,
	SEL_BUF_FAULT,
	SEL_NOT_CONNECTED,
	SEL_BLOCK_CANCELED,
	SEL_BLOCK_IN_PROGRESS,
	SEL_UNEXPECTED_CLOSED,
	SEL_SHUTDOWN,
	SEL_WOULD_BLOCK,
	SEL_BUF_TRUNCATED,
	SEL_UNKNOWN_ERROR,
	SEL_GRACEFULLY_CLOSED,
	SEL_FINE
};

class TCPClientSocket : public TCPBaseSocket
{
public:
	TCPClientSocket(const char *Ip, unsigned short Port);
	TCPClientSocket(SOCKET &Socket, SOCKADDR_IN &AddrIn);
	virtual ~TCPClientSocket();

	void SetBlocking(bool Block);
	TCPSocketErrorLevel Read(char *Buffer, unsigned int BufferLen, int &ReceivedBytes);
	TCPSocketErrorLevel Write(const char *Buffer, unsigned int BufferLen, int &WrittenBytes);
	TCPSocketErrorLevel Write(char *Buffer, int &WrittenBytes);
};

#endif