#include "TCPServerSocket.h"

TCPServerSocket::TCPServerSocket(unsigned short Port)
: TCPBaseSocket(), m_Port(Port)
{
	if (m_Socket == INVALID_SOCKET)
		return;

	m_AddrIn.sin_family = AF_INET;
	m_AddrIn.sin_addr.s_addr = INADDR_ANY;
	m_AddrIn.sin_port = htons(Port);

	if (bind(m_Socket, (LPSOCKADDR)&m_AddrIn, sizeof(struct sockaddr)) == SOCKET_ERROR)
	{
		Close();
		return;
	}

	if (gethostname(m_ServerMachineName, sizeof(m_ServerMachineName)) == SOCKET_ERROR)
	{
		Close();
		return;
	}

	if (listen(m_Socket, SOMAXCONN) == SOCKET_ERROR)
	{
		Close();
		return;
	}
}

TCPServerSocket::~TCPServerSocket()
{}

TCPClientSocket *TCPServerSocket::Accept()
{
	SOCKET ClientSocket;
	SOCKADDR_IN ClientAddrIn;
	int ClientAddrLen = sizeof(struct sockaddr);

	ClientSocket = accept(m_Socket, (LPSOCKADDR)&ClientAddrIn, &ClientAddrLen);

	if (ClientSocket == INVALID_SOCKET)
	{
		closesocket(ClientSocket);
		return 0;
	}

	return new TCPClientSocket(ClientSocket, ClientAddrIn);
}

const char *TCPServerSocket::GetServerMachineName()
{
	return m_ServerMachineName;
}