/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */

//.data:006BB280 AuthFunctionTable_VTM dd offset AuthRequestAboutToPlay_46E1D0
//.data:006BAFA0 ServerPacketTable2_VTM dd offset CacheVersionPacket_453430
//.data:006C0D68 ServerPacketTable1_VTM dd offset VersionPacket_5010F0
//.data:006BDC28 NPCFunctionTable_VTM dd offset NpcVersionPacket_4AAB50
//.rdata:005C885C CREATUE_FUNCTION_TABLE dd offset CCreature____destructor_CCreature_438700


//General includes
#include "Shared.h"
#include "time.h"
#include "opcodes.h"
#include "opcodesAwake.h"
#include "opcodesC.h"


#include "SimpleIni.h"
#include "IniFile.h"


//--------------------------------------------------------------------------------------------
//// Global Variables
//--------------------------------------------------------------------------------------------
//static CSimpleIniA ini_;


//Project includes
#ifndef _L2EP_
#define _L2EP_
	//Crucial includes
	#ifndef _L2SERVER_
		#include "L2Server.h"
	#endif
	#ifndef _EX_USER_
		#include "ExUser.h"
	#endif

	#ifndef _EX_DOOR_
		#include "ExDoor.h"
	#endif

	#ifndef _BUFFER_WRITTER_
		#include "BufferWriter.h"
	#endif

	#ifndef _PACKET_READER_
		#include "PacketReader.h"
	#endif

	//Functionality includes
	#ifndef _COMBAT_POINTS_
		#include "CombatPoints.h"
	#endif
	#ifndef _AUTOSS_
		#include "AutoSS.h"
	#endif
//	#ifndef _EVALUATE_
//		#include "Evaluate.h"
//	#endif
//	#ifndef _MINIMAP_
//		#include "MiniMap.h"
//	#endif
//	#ifndef _RECIPE_BOOK_
//		#include "RecipeBook.h"
//	#endif
//	#ifndef _RECIPE_SHOP_
//		#include "RecipeShop.h"
//	#endif
	#ifndef _PARTY_
		#include "Party.h"
	#endif

	#ifndef _MACROS_
		#include "macros.h"
	#endif

//	#ifndef _EXSOCKET_
//		#include "ExSocket.h"
//	#endif

	#ifndef _USER_COMMAND_
		#include "UserCommand.h"
	#endif


#endif



using namespace std;

/*
typedef struct tagTPFloodExploitFix
{
	CPacketAssembler 	packet; 
	int		psize;
	int		state;  //0 free, 1 busy, 2 locked
	CSocket	*lastpSocket;
	time_t	recordTime;

} TPFloodExploitFix, *PTPFloodExploitFix;
*/

//--------------------------------------------------------------------------------------------
//// Global Variables
//--------------------------------------------------------------------------------------------

DWORD * pUser_G;
DWORD * pUserData_G;

/*
PTPFloodExploitFix packetFrom8to13_a;
PTPFloodExploitFix packetFrom8to13_b;
int floodTimeLimit = 1000;
int idleTimeLimit = 10000;
*/
//--------------------------------------------------------------------------------------------
//// Function Prototypes
//--------------------------------------------------------------------------------------------
char *EncPwdL2(char *Password);
char GetHexVal(char Hex);
void Hex2Bin(char *Src, char *Dst);
void Str2Hex(char *Src, char *Dest);




////--------------------------------------------------------------------------------------------
////// Main DLL and Hook functions
////--------------------------------------------------------------------------------------------

//DLL Main
DllExport BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpReserved);

void CachedPacketProcessor(char *Format, char *datastring, wchar_t *name1, int name1num, char *admin);

//void Salvation_inv_list_MAIN();
//void Salvation_inv_list_no_userinfo();

void Crusade_private_store_ex();
void Crusade_spawnitem_1();
void Crusade_spawnitem_2();
void Crusade_dropitem();
void Crusade_charinfo();
void Crusade_bcccharinfo();
void Crusade_MyTargetSelected();
void Crusade_questlist_ch();

//saviors 2016
void Saviors_loginresult();
void Saviors_multisell_3();
void Saviors_multisell_4();
void TutorialShowQuestionMark_Saviors_01();
void TutorialShowQuestionMark_Saviors_02();

void Saviors_trade_a();
void Saviors_trade_a00();
void Saviors_trade_b();
void Saviors_trade_c();
void Saviors_trade_d();
void Saviors_trade_d00();
void Saviors_trade_e();
void Saviors_trade_f();
void Saviors_trade_1();
void Saviors_trade_2();
void Saviors_trade_3();
void Saviors_trade_4();
void Saviors_trade_5();
void Saviors_trade_6();
void Saviors_trade_7();
void Saviors_trade_8();
 

//age of splendor 2015
 void Splendor2_multisell_1();
  void Splendor2_multisell_2();
  void Splendor2_multisell_2esp();
 

//infinity
//void ShortcutInfItem_Infinity();


//classic
void FriendAddRequest();

void Classic_NPCHTMLPacket();

void EnchantFix_Classic1();
void EnchantFix_Classic2();

void Classic_NewCharacterSuccess();
void Classic_Whisper();
void Classic_AbnormalStatusUpdate1();
void Classic_AbnormalStatusUpdate2();

void NPCInfo_classic();
void NPCInfo2_classic();
void PetInfo_Classic();

void CharInfoPacketFaceFix_Classic();
void BCCharInfoPacketFaceFix_Classic();
void BCCharInfoPacketFix_Classic();
void CharInfoPacketFix_Classic();
void BCCharInfoPacketFix_Lind558();
void CharInfoPacketFix_Lind558();
void GMUserInfo_Classic();
void GMUserInfo_Classic_FACE();
void GMUserInfo_Classic_AUGM();
void GMUserInfo_Infinity_AUGM();
 
void Classic_Relation1();
void Classic_Relation2();

void Classic_UpdateWindowPacketFix();
void Classic_AddWindowPacketFix();
void Classic_OpenAllWindowPacketFix();

void PledgeInfo_Classic();
void PledgeWindowOpenAll_Classic();
void PledgeWindowOpenAllesp_Classic();
void PledgeStatusChanged1_Classic();
void PledgeStatusChanged2_Classic();
void PledgeMemberListOpen_Classic();
void PledgeMemberListOpenesp_Classic();
void GMPledgeInfo2_Classic();
//void PledgeWindowAdd_c();
//void PledgeWindowAddesp_c();
void PledgeWindowOpen_c(); //windowadd in show all
void PledgeWindowOpenesp_c();


void SkillAquireList_Classic();
void SkillAquireList_ClassicSKILLS();
void SkillAquireInfo_Classic();

void Classic_trade_crash1();
void Classic_trade_crash2();
void Classic_trade_crash3();
void Classic_trade_1();
void Classic_trade_2();
void Classic_trade_3();
void Classic_trade_4();
void Classic_trade_5();
void Classic_trade_6();
void Classic_trade_7();
void Classic_trade_8();
void Classic_trade_9();
void Classic_trade_10();
void Classic_trade_11();
void Classic_trade_g();
void Classic_trade_h();
//void Classic_trade_main();


//package
void Classic_PackageFix();
//wh deposit
void Classic_warehouseC1();
void Classic_warehouseC2();
void Classic_warehouseD1();
void Classic_warehouseD2();
//wh withdraw
void Classic_warehouseA1();
void Classic_warehouseA2();
void Classic_warehouseB1();
void Classic_warehouseB2();
//GM view
void Classic_warehouseE1();

//epeisodion
void SkillAquireList_EpeiSKILLS(); //ok
void CharInfoPacketFaceFix_Epei();
void BCCharInfoPacketFaceFix_Epei();
void Ep_inv_upd1();
void Ep_inv_upd1a();
void Ep_inv_upd2();
void Ep_inv_upd2b();
void Ep_inv_list1();
void Ep_inv_list2();
void Ep_inv_list3();
void Ep_inv_list3a();
void Ep_inv_list3b();
void Epei_warehouseA1();
void Epei_warehouseA2();
void Epei_warehouseB1();
void Epei_warehouseB2();
void Epei_warehouseAA2();
void Epei_warehouseBB2();
void Epei_warehouseC1();
void Epei_warehouseC2();
void Epei_warehouseD1();
void Epei_warehouseD2();
void Epei_warehouseE1();
void Epei_warehouseEE2();
void Epei_warehouseCC2();
void Epei_warehouseDD2();
void Epei_PackageFix();
void GMUserInfo_Epei();
void GMUserInfo_Epei_AUGM();
void GMUserInfo_Epei_FACE();
void Epei_pet_inv_upd1();
void Epei_pet_inv_upd2();
void Epei_pet_inv_list1();
void Epei_pet_inv_list2();
void Epei_pet_inv_list3();
void Epei_trade_9();
void Epei_trade_10();
void Epei_trade_11();
//void Awake_privatestore_5B();
//void Awake_privatestore_6B();
void Epei_privatestore_1();
void Epei_privatestore_2();
void Epei_privatestore_3();
void Epei_privatestore_4();
void Epei_privatestore_5();
void Epei_privatestore_6();
void Epei_pet_inv_upd1();
void Epei_pet_inv_upd2();
void Epei_pet_inv_list1();
void Epei_pet_inv_list2();
void Epei_pet_inv_list3();
void PetInfo_Epei();
void Epei_buy_1();
void Epei_buy_2();
void Epei_sell_1();
void Epei_sell_2();
void AllyCrest_Epei2();
void AllyCrest_Epei1();
void PledgeCrest_Epei2();
void PledgeCrest_Epei1();

//lindvior
void Lindvior_warehouseA1();
void Lindvior_warehouseA2();
void Lindvior_warehouseB1();
void Lindvior_warehouseB2();
void Lindvior_warehouseAA2();
void Lindvior_warehouseBB2();
void Lindvior_warehouseC1();
void Lindvior_warehouseC2();
void Lindvior_warehouseD1();
void Lindvior_warehouseD2();
void Lindvior_warehouseE1();
void Lindvior_warehouseEE2();
void Lindvior_warehouseCC2();
void Lindvior_warehouseDD2();
void Lindvior_PackageFix();

void Classic_privatestore_1();
void Classic_privatestore_2();
void Classic_privatestore_3();
void Classic_privatestore_4();
void Classic_privatestore_5();
void Classic_privatestore_6();

void Classic_multisell_2();
void Classic_multisell_2esp();
void Classic_multisell_3();

void Classic_sell_1();
void Classic_sell_2();
void Classic_sell_c();
void Classic_buy_c();
void Classic_buy_1();
void Classic_buy_2();
void buy_1();
void buy_2();
void buy_c();

void Classic_inv_upd1();
void Classic_inv_upd2();
void Classic_inv_upd1a();
void Classic_inv_upd2b();
void Classic_inv_list1();
void Classic_inv_list2();
void Classic_inv_list3();
void Classic_inv_list3a();
void Classic_inv_list3b();
void Classic_pet_inv_upd1();
void Classic_pet_inv_upd2();
void Classic_pet_inv_list1();
void Classic_pet_inv_list2();
void Classic_pet_inv_list3();
void Classic_pet_inv_updA();
void Classic_pet_inv_updB();
void Classic_pet_inv_listA();
void Classic_pet_inv_listB();

int PETInfoClassic(DWORD *pSocket, DWORD *pUser, u8 *pBuffer, PTCharBaseData CSharedDat, ExUserInfo *tempExUserInfo);
int NPCInfoClassic(DWORD *pSocket, DWORD *pUser, u8 *pBuffer, PTCharBaseData CSharedDat, ExUserInfo *tempExUserInfo);
int UserInfoClassic(DWORD *pSocket, DWORD *pUser, u8 *pBuffer, PTCharBaseData CSharedDat, ExUser * tempExUser, ExUserInfo *tempExUserInfo);
int SendUserInfoClassic(DWORD *pSocket, DWORD *pUser, u8 *pBuffer, BYTE uiv1, BYTE uiv2, BYTE uiv3, PTCharBaseData CSharedDat, ExUser * tempExUser, ExUserInfo * tempExUserInfo);
void Classic_SendCubbic(DWORD *pSocket, ExUserInfo *tempExUserInfo);
void Classic_SendAbnormalVisualEffects(DWORD *pSocket, DWORD *pUser, ExUserInfo *tempExUserInfo,BYTE isHidden,ExUser *tempExUser);
void Classic_SendWeight(DWORD *pSocket, ExUserInfo *tempExUserInfo);
void Classic_SendFishing(DWORD *pSocket, ExUserInfo *tempExUserInfo);
void Classic_SendEquip(DWORD *pSocket, ExUserInfo *tempExUserInfo, ExUser *tempExUser);


//grade
void GradeUpdate1();
void GradeUpdate2();
void GradeUpdate3();

void CSocketWriteHook();
void CSocketWriteFunc(DWORD *pSocket, DWORD *pBuffer, BYTE state);

void testPacket(DWORD *pSocket);
void crashfix_sendV();
void crashfix_CPacket_OnIOCallback();
void crashfix_CIOSocket_xWrite();

//Hooks the L2Server at a place where it can catch all outgoing
//packets before they get sent to the client.
bool NewSkillsHandler(DWORD *pTargetSocket, DWORD *pTarget, PTCharBaseData pTargetShareD, ExUser * pTargetEXuser, DWORD skillID, DWORD skillLVL);
void CSkillEffect_i_hp_per_max_expand();
void HookSendPacket();
void HookSendPacketInterlude();
void HookSendPacketIL746();
void HookSendPacketKamael();
void HookSendPacketC5Q1();
void HookSendPacketC5Q2();
 void HookSendPacketIL2010();

//Hooks the L2Server at a place where it can catch all incoming
//packets before they get handled by the server.
void HookReceivePacket();
void HookReceivePacketEx();


//void HookReceivePacketInterlude();
//void HookReceivePacketKamael(); 
//void HookReceivePacketKamael2();
//void HookReceivePacketKamael3();

void HookReceivePacketInterlude_new();
void HookReceivePacketKamael_new(); 
void HookReceivePacketKamael_test();
void ReceivePacketKamael_test(DWORD * pBuffer, DWORD * pSocket);

//socket close, read
//void CSocketCloseHook();
//void CSocketCloseFunc(DWORD *pSocket);



////--------------------------------------------------------------------------------------------
////// Internal handler functions called from hook functions
////--------------------------------------------------------------------------------------------

// Handles incoming packets by checking the packet headers.
//
// Parameters:
// DWORD * pBuffer - the address of the start of the packet
// DWORD * pSocket - the address of the user socket
//
void SendPacket(DWORD * pBuffer, DWORD * pSocket);
void SendPacketC2(DWORD * pBuffer, DWORD * pSocket);
void SendPacketC3(DWORD * pBuffer, DWORD * pSocket);
void SendPacketIL746(DWORD * pBuffer, DWORD * pSocket);
void SendPacketC5Q(DWORD * pBuffer, DWORD * pSocket);



// Handles outgoing packets by checking the packet headers.
//
// Parameters:
// DWORD * pBuffer - the address of the start of the packet
// DWORD * pSocket - the address of the user socket
//
void ReceivePacket(DWORD * pBuffer, DWORD * pSocket);
void ReceivePacketC3(DWORD * pBuffer, DWORD * pSocket);
void ReceivePacketC1(DWORD * pBuffer, DWORD * pSocket, DWORD packetSize);
void ReceivePacketIL(DWORD * pBuffer, DWORD * pSocket, DWORD packetSize);



////--------------------------------------------------------------------------------------------
////// Hooks that fix functions inside L2Server
////--------------------------------------------------------------------------------------------

//privilegies
int CheckPledgeLeaderOnline(DWORD *pUser,bool check4warehouse);
int CheckPledgeLevel(DWORD *pUser, int checklevel);
int CheckViewPrivilegiesPriv(PTCharBaseData CSharedDat);
void TempBlockPrivilegies(DWORD *pUser, int blockFlags);
void WarehousePrivilegies();
void TitlePrivilegies();
void JoinPledgePrivilegies();
void JoinPledgeAnswerPrivilegies();

//
bool ChekTrade(DWORD *pUser);
void GMannounce();
void PackageFix();
void HookDoorOpen();

//c2 petinfo
void PetInfo_C2();
//c4 petinfo
void PetInfo();
void NPCInfo();
void NPCInfo2();


//100% C4 UserInfo Packet, as well as ExUser pulled data, and AVE after death fixed.
void UserInfoPacketFixC5();
void UserInfoPacketAddrFixC5Q();
void UserInfoPacketFix4();
void UserInfoPacketAddrFix();

//c2
void UserInfoPacketFix_C1();
void UserInfoPacketFix_C2();
void CharInfoPacketFix_C2();
void BCCharInfoPacketFix_C2();


//Interlude UserInfo
void UserInfoPacketFixC6();
//void UserInfoPacketAugmentFix();
void UserInfoPacketAugmentFixC6();
void UserInfoPacketFaceFix();
void UserInfoPacketFaceFixC6();
void UserInfoPacketAddrFixC6();

//Interlude char info
void CharInfoPacketFix_6();
void CharInfoPacketFaceFix_6();
void BCCharInfoPacketFix_6();
void BCCharInfoPacketFaceFix_6();

//kamael user info
void UserInfoPacketFixC7();
void UserInfoPacketAugmentFix7();
void UserInfoPacketFaceFix7();
void UserInfoPacketAddrFixC7();

//kamael char info
void CharInfoPacketFix_7();
void CharInfoPacketFaceFix_7();
void BCCharInfoPacketFix_7();
void BCCharInfoPacketFaceFix_7();
void CharInfoPacketFaceFix_7B();
void BCCharInfoPacketFaceFix_7B();

//Q fix
void UserInfoPacketAddrFixC6Q();
void UserInfoPacketQFixFix();
void PetInfoQ();
void PetStatusQ();
void CharSelectedC6Q();
void CharSelectedClassic();

//interlude inventory
void interlude_inv_upd1();
void interlude_inv_upd2();
void interlude_inv_list1();
void interlude_inv_list2();
void interlude_inv_list3();
void interlude_multisell_1();
void interlude_multisell_2();

void ShortcutInfItem_6();
void ShortcutInfSkill_6();
void ShortcutInfSkillEsp_6();
void ShortcutInfAction_6();

void SkillAquireInfoC6();

void warehouseA1();
void warehouseA2();
void warehouseB1();
void warehouseB2();
void warehouseC1();
void warehouseC2();
void warehouseD1();
void warehouseD2();
void warehouseE1();
void warehouse_gm();

void GMUserInfoPacketFixC5(); //c3-c5
void GMUserInfoInterludeFix();
void GMUserInfoInterludeAUGM();
void GMUserInfoInterludeFACE();
void GMUserInfoInterludeQ();


//c3 hooks

void C3Warehouse1();
void C3Warehouse2();
void C3Warehouse3();
void C3SkillLearinig1();
void C3SkillLearinig2();
void C3PrivateStore1();
void C3PrivateStore2();
void C3PrivateStore3();
void C3Multisell1();
void C3Multisell1_555();
void C3Multisell2();
void C3Multisell2_555();
void C3Multisell3();
void C3GMViewItemList();
void C2Multisell1();
void C2Multisell2();
void C2Multisell3();

//CharInfo Packet, as well as ExUser pulled data, and AVE after death fixed.
void CharInfoPacketFix_4();

//c2 hooks
void SetupGaugeC2Fix();
void GMUserC2FixA();
void GMUserC2FixB();
void UserInfoPacketC2FixD();
void UserInfoPacketC2FixC();
void UserInfoPacketC2FixB();
void UserInfoPacketC2FixA();
void CharacterInfoPacketC2Fix();
//void CharacterInfoPacketC2FixC();
void BCCharacterInfoPacketC2Fix();
//void BCCharacterInfoPacketC2FixC();
void HookSendPacketC2();
void ClanInfoC2Fix();
void PartyWindowAddC2();
void PartyWindowAllC2();
void C3PartyMatchDetail();

//Broadcast others except self packet
void BCCharInfoPacketFix_4();

//Character selection info fix by smeli
void CharSelectInfoCT0(DWORD *pSocket, u8 *pBuffer);
void CharSelectInfoC5Q(DWORD *pSocket, u8 *pBuffer);
void CharSelectInfoC2(DWORD *pSocket, u8 *pBuffer);
//void CharSelectInfoFix(DWORD *pSocket, const char *szFormat, BYTE bOpCode, DWORD dwCharNum, DWORD dwPacketSize, DWORD *pOldPacket);


//smeli fixes for skilllist and shortcuts for skills C4support
void SkillListFix1A();
void SkillListFix2A();
void SkillListFix3A();
void SkillListFix1Esp();
void SkillListFix2Esp();
void SkillListFix3Esp();

void SkillListFix1();
void SkillListFix2();
void SkillListFix3();


void ShortcutInfA();
void ShortcutRegA();
void ShortcutInfEsp();
void ShortcutRegEsp();

//smeli pledge packets fix
void PledgeWindowOpen();
void PledgeWindowOpenAll();
void PledgeWindowOpenAll_C3_a();
void PledgeMemberListOpen();
void PledgeWindowAdd();
void PledgeShowInfoUpdate();
//--------
void PledgeWindowOpenesp();
void PledgeWindowOpenAllesp();
void PledgeMemberListOpenesp();
void PledgeWindowAddesp();
void PledgeShowInfoUpdateesp();
//--------
void GMPledgeInfo();
void GMPledgeInfo2();
//-------
void PledgeWindowOpenAll_CT2F();
void PledgeWindowOpenAll_CT2F_a();
void PledgeWindowOpenAll_CT2F_b();
void PledgeWindowOpenAllesp_CT2F();
void PledgeShowInfoUpdate_7();
void PledgeShowInfoUpdateesp_7();
void GMPledgeInfo2_7();


//c4-ct1 key call
//void InitialKeyC1Call();
void InitialKeyCall();
void KeyCall();
void InitialKeyCallClassic();
void InitialKeyCallClassic0();

//Allows us to do ExUser creation, as well as other actions, upon login.
void HookEnterWorld();
void HookEnterWorldKamael();
void HookEnterWorldGOD();
void HookNPCEnterWorld();

//Allows us to do ExUser deletion, as well as other actions, upon logout.
void HookExitWorld();

//Allows us to send new messages to the client at login (/time, Seven Signs, etc.)
void HookLoginMessagesC2();
void HookLoginMessagesC3();
void HookLoginMessagesC4();
void HookLoginMessagesC5();
void HookLoginMessagesC6();
void HookLoginMessagesKamael();
void HookLoginMessagesCT2F();
void HookLoginMessagesCT2P();
void HookLoginMessagesCT2Freya();
void HookLoginMessages_Awakening();
void HookLoginMessages_Lindvior();

//2009 crash fix
//void RessurectInPlaceFix();

void HookCCreatureChangeClass();

//TODO: call SaveInfectedSkills() to prevent the after death buff exploit
//TODO: if the above works, hex out the SaveInfectedSkills() on respawn??
void HookCCreatureDie();
void HookCCreatureDieC5(); //CURSED die
void HookDiePacket(); //for fortress and GM
DWORD fortressDie(DWORD objID);

void HookCCreatureLevelUp();


void HookCCreatureLevelDown();


void HookCCreatureUseItem();


void WyvernFix(DWORD * pUser, DWORD * pTarget);
int PartyLeaderLeaveWorld(DWORD * pLeader, DWORD * pParty);
void CB_PartyLeaderLeaveWorld();
void PartyChangeLeader(DWORD * pUser);
void PartyTeleport(DWORD * pUser, int x, int y, int z);


void HookCWorldSpell();
void HookCWorldAttack();

// Fixes the AskJoinParty packet that is sent to the client.
// Will send the charName instead of the objectID, as well
// as the proper loot type.
void AskJoinPartyPacketFix();

//Hooks the CCreature::GotDamagedBy() function right after
//where it sends msgID 35 (YOU_GAVE_S1_DAMAGE) to the player.
void HookSystemMessageGaveDamage();

//Hooks the L2Server at a place where it can catch the heal
//System Messages being used, and replace them.
void HealCharMessageFix();

////--------------------------------------------------------------------------------------------
////// Party Hooks
////--------------------------------------------------------------------------------------------

//Thanks Torune for the original code
void OpenAllWindowPacketFix();

//NOTE: Currently this causes crashes calling GetParty()
//Don't use this until the code is debugged and fixed
//Thanks Torune for the original code
void OpenAllWindowPacketLeaderPatch();

//Thanks Torune for the original code 2006 - CRASHING SERVER 2013
//void UpdateWindowPacketFix();
void UpdateWindowPacketFix_by_Smeli();

//Thanks Torune for the original code
void AddWindowPacketFix();

////--------------------------------------------------------------------------------------------
////// Combat Points (CP) / HP / Other Stat Hooks and Fixes
////--------------------------------------------------------------------------------------------


void HookCombatPointsRegeneration();
void HookCombatPointsRegenerationC2();



void HookCombatPointsDamage();


void BuilderCommandHealthyFix();

void ExpOverflowFix();

//CDB
//void HookTest1();
//void HookTest2();
//void HookTest3();
//void createCharFix();




////--------------------------------------------------------------------------------------------
////// General / Misc. functions
////--------------------------------------------------------------------------------------------

void PartyChangeLeader(DWORD * pUser, DWORD *pUser2);

// Allows for the complete dump of a packet to the log file
//
// Parameters:
// DWORD * packet - the address of the start of the packet (pBuffer)
// DWORD bytes - how many bytes to dump to the log file
//
void DumpPacket(DWORD * packet, DWORD bytes);
void DumpPacketEx(DWORD * packet, DWORD bytes);

// CWorld::Spell
// function for PUB music box
// function for RacialWars buffer and healer traitors
// also was used for auto spirit shots
void CWorldSpell(DWORD * pUser, DWORD * pTarget, DWORD spellID, DWORD spellLVL);

//for test purposes by smeli
void testGameMode(DWORD * pSocket);

void PledgeMembShowMe(DWORD *pSocket);
bool checkInvalidPledge(PTCharBaseData CSharedDat, DWORD *pSocket, BYTE *kBuffer, BYTE opCodeK);


//corund item func
//PItemData GetActiveItem(DWORD * pUser);
//PItem InventoryFirstItemByClassId(DWORD * pUser, int ClassID);
//PItem InventoryNextItemByClassId(DWORD * pUser, int prevIndex);
//PItemData GetItemData(PItem itm);
//PItem InventoryGetItemByIDX(DWORD * pUser, int IDX);
//PItem InventoryGetItemBySOID(DWORD * pUser, int SOID);
//PItemData GetItemDataC(int Index);



//================================================
//CT1 KAMAEL
//================================================
void GMUserInfoKamaelFix();
void GMUserInfoKamaelAUGM();
void GMUserInfoKamaelFACE();


//kamael inventory
void Kamael_inv_upd1();
void Kamael_inv_upd2();
void Kamael_inv_upd1a();
void Kamael_inv_upd2b();

void Kamael_inv_list1();
void Kamael_inv_list2();
void Kamael_inv_list3();
void Kamael_inv_list3a();
void Kamael_inv_list3b();


void Kamael_pet_inv_upd1();
void Kamael_pet_inv_upd2();
void Kamael_pet_inv_list1();
void Kamael_pet_inv_list2();
void Kamael_pet_inv_list3();

void kamael_privatestore_1();
void kamael_privatestore_2();
void kamael_privatestore_3();
void kamael_privatestore_4();
void kamael_privatestore_5();
void kamael_privatestore_6();


void kamael_buy_1();
void kamael_buy_2();
void kamael_sell_1();
void kamael_sell_2();

void Kamael_PackageFix();
void Kamael_warehouseA1();
void Kamael_warehouseA2();
void Kamael_warehouseB1();
void Kamael_warehouseB2();
void Kamael_warehouseC1();
void Kamael_warehouseC2();
void Kamael_warehouseD1();
void Kamael_warehouseD2();
void Kamael_warehouseE1();
void Kamael_warehouse_gm();


//spec
void CharSelectInfoCT1(DWORD *pSocket, u8 *pBuffer);
void ExBasicActionList(DWORD *pSocket);
void SendPacketKamael(DWORD * pBuffer, DWORD * pSocket);
void SendPacketCT1(DWORD * pBuffer, DWORD * pSocket);
void ReceivePacketKamael(DWORD * pBuffer, DWORD * pSocket, DWORD packetSize);


//multisell
void Kamael_multisell_1();
void Kamael_multisell_2();
void Kamael_multisell_2esp();

//trade
void kamael_trade_1();
void kamael_trade_2();
void kamael_trade_3();
void kamael_trade_4();
void kamael_trade_5();
void kamael_trade_6();
void kamael_trade_7();
void kamael_trade_8();
void kamael_trade_9();
void kamael_trade_10();
void kamael_trade_11();
void kamael_trade_12();

void IconActionCT1();
void RideActionCT1();
void RideSpeedCT1();
void RidePacketCT1_a();
void RidePacketCT1_b();
//void RidePacketCT1_b_xyz();
void RideCharinfoCT1();
void RideCharinfoCT1BC();

void ShortcutRegCT1();
void ShortcutInfItem_7();
void ShortcutInfItem_Tauti();


void harbringersOPcodes();
void kamaelOPcodes();
void AwakeningOPcodes();
void InitialKeyCallCT1();
void HookNpcServerSend();

//void DoorStatusCT1();
//void DoorStatusCT1b();
void ObjectStatusCT1();
void MyTargetSelectedCT1();
void TargetSelectedCT1();

//================================================
//CT2 Gracia 2
//================================================
//Gracia inventory
void Gracia_inv_upd1();
void Gracia_inv_upd2();
void Gracia_inv_list1();
void Gracia_inv_list2();
void Gracia_inv_list3();

void Gracia_warehouseA1();
void Gracia_warehouseA2();
void Gracia_warehouseB1();
void Gracia_warehouseB2();
void Gracia_warehouseC1();
void Gracia_warehouseC2();
void Gracia_warehouseD1();
void Gracia_warehouseD2();
void Gracia_warehouseE1();

//================================================
//CT2 Gracia Final
//================================================

void SendPacketCT2F(DWORD * pBuffer, DWORD * pSocket);
void HookSendPacketCT2F();
void CharSelectInfoCT2F(DWORD *pSocket, u8 *pBuffer);
void CharSelectInfoClassic(DWORD *pSocket, u8 *pBuffer);

void UserInfoPacketCT2F();
void UserInfoPacketGD2Tauti();
void UserInfoPacketAddrFixCT2F();
void UserInfoPacketAddrFixGD2Tauti();
void UserInfoPacketAddrFixGD2TautiUS();




void UserInfoPacketAugmentFixCT2F();
void UserInfoPacketFaceFixCT2F();
void CharInfoPacketFaceFix_CT2F();
void BCCharInfoPacketFaceFix_CT2F();
void CharInfoPacketFaceFix2_CT2F();
void BCCharInfoPacketFaceFix2_CT2F();

void CharInfoPacketFaceFix_Tauti();
void BCCharInfoPacketFaceFix_Tauti();

//void UserInfoPacketFlyFixCT2F();

//GraciaF inventory
void GraciaF_inv_upd1();
void GraciaF_inv_upd2();
void GraciaF_inv_upd1a();
void GraciaF_inv_upd2b();

void GraciaF_inv_list1();
void GraciaF_inv_list2();
void GraciaF_inv_list3();
void GraciaF_inv_list3a();
void GraciaF_inv_list3b();

void GraciaF_pet_inv_updA();
void GraciaF_pet_inv_updB();
void GraciaF_pet_inv_listA();
void GraciaF_pet_inv_listB();

//warehouse
void GraciaF_warehouseAA0();
void GraciaF_warehouseAA1();
void GraciaF_warehouseAA2();
void GraciaF_warehouseBB0();
void GraciaF_warehouseBB1();
void GraciaF_warehouseBB2();
void GraciaF_warehouseCC0();
void GraciaF_warehouseCC1();
void GraciaF_warehouseCC2();
void GraciaF_warehouseDD0();
void GraciaF_warehouseDD1();
void GraciaF_warehouseDD2();
void GraciaF_warehouseEE0();
void GraciaF_warehouseEE1();
void GraciaF_warehouseEE11();
void GraciaF_warehouseEE2();

//multisell
void GraciaF_multisell_1();
void GraciaF_multisell_2();
void GraciaF_multisell_2esp();
void C4_multisell_1();

//trade
void GraciaF_trade_a();
void GraciaF_trade_a00();
void GraciaF_trade_b();
void GraciaF_trade_c();
void GraciaF_trade_d();
void GraciaF_trade_d00();
void GraciaF_trade_e();
void GraciaF_trade_f();
void GraciaF_trade_g();
void GraciaF_trade_h();

//buy-sell
void GraciaF_buy_1();
void GraciaF_buy_2();
void GraciaF_sell_1();
void GraciaF_sell_2();

void GraciaF_buy_a();
void GraciaF_buy_b();
void GraciaF_buy_c();
void GraciaF_sell_a();
void GraciaF_sell_b();
void GraciaF_sell_c();

//drop
void CT2F_dropitem();

//npcinfo
void NPCInfo_CT2F();
void NPCInfo2_CT2F();

//privatestore
void GraciaF_privatestore_1();
void GraciaF_privatestore_2();
//void GraciaF_privatestore_3();
void GraciaF_privatestore_4();
void GraciaF_privatestore_5();
void GraciaF_privatestore_6();

void GraciaF_privatestore_1A();
void GraciaF_privatestore_2A();
void GraciaF_privatestore_3A();
void GraciaF_privatestore_4A();
void GraciaF_privatestore_5A();
void GraciaF_privatestore_6A();


void GraciaF_privatestore_1B();
void GraciaF_privatestore_3B();
void GraciaF_privatestore_5B();
void GraciaF_privatestore_6B();

//vehicles

void GraciaF_VehicleInfo();
void GraciaF_Vehicle_ValidateLoc1();
void GraciaF_Vehicle_ValidateLoc2();
void GraciaF_Vehicle_GetOn();
void GraciaF_Vehicle_GetOff();
void GraciaF_Vehicle_StopIn();
void GraciaF_Vehicle_MoveToLoc1();
void GraciaF_Vehicle_MoveToLoc2();

void GraciaF_Vehicle_Depart();
void GraciaF_Vehicle_GetOnS();
void GraciaF_Vehicle_GetOffS();
void GraciaF_Vehicle_MoveToLocS();
void GraciaF_Vehicle_StopInS();
void GraciaF_Vehicle_ValidateLocS();
void GraciaF_VehicleInfoS();

void GraciaF_QuestList();
void Lindvior_QuestList();
void Lindvior_QuestList2();
//new
void GraciaF_Package();
void GraciaF_PackageC();

void GraciaFF_buy_a();
void GraciaFF_buy_b();
void GraciaFF_sell_a();
void GraciaFF_sell_b();

void CharInfoPacketFix_CT2F();
void BCCharInfoPacketFix_CT2F();
void CharInfoPacketFix_GD2Tauti();
void BCCharInfoPacketFix_GD2Tauti();
void CharInfoPacketFix_Classic();
void BCCharInfoPacketFix_Classic();
void GraciaFinal_teleporttoloc_1();
void GraciaFinal_teleporttoloc_2();
void GraciaFinal_skillAquireInfo();



//other 2009
void hideName();
void hideName1();
void hideName2();
void hideHP();
void hideHP1();
void hideHP2();
void BBSFix1();
void BBSFix2();
void BBSFix3a();
void BBSFix3b();

/*
//----------------------------------------------------
//Vehicles
pDebug = ini_read("general", "CT2GraciaFVehicles", 0);
if (pDebug == NULL)	pDebug="0";

if (atoi(pDebug) == 1)
{

//WriteHook(JMP_HOOK,0x0051a095, GraciaF_VehicleInfo, 0);
//WriteMemory8(0x0051a0e7,0x44);

//WriteHook(JMP_HOOK,0x004484b2, GraciaF_Vehicle_ValidateLoc1, 3);
//WriteMemory8(0x0044851D,0x48);

//WriteHook(JMP_HOOK,0x004485A5, GraciaF_Vehicle_ValidateLoc2, 3);
//WriteMemory8(0x00448611,0x48);

//WriteHook(JMP_HOOK,0x00484044, GraciaF_Vehicle_GetOn, 3);
//WriteMemory8(0x004840b3,0x44);

//WriteHook(JMP_HOOK,0x00484176, GraciaF_Vehicle_GetOff, 3);
//WriteMemory8(0x004841e1,0x44);

//WriteHook(JMP_HOOK,0x0049e1f6, GraciaF_Vehicle_StopIn, 1);
//WriteMemory8(0x0049e271,0x48);

//WriteHook(JMP_HOOK,0x0049ef25, GraciaF_Vehicle_MoveToLoc1, 3);
//WriteMemory8(0x0049efbc,0x50);

//WriteHook(JMP_HOOK,0x0049f3af, GraciaF_Vehicle_MoveToLoc2, 3);
//WriteMemory8(0x0049f447,0x50);
//single
//WriteHook(JMP_HOOK,0x0051A1FC, GraciaF_Vehicle_Depart, 1);
//WriteMemory8(0x0051a227,0x28);

//WriteHook(JMP_HOOK,0x00484001, GraciaF_Vehicle_GetOnS, 0);
//WriteMemory8(0x00484030,0x24);

//WriteHook(JMP_HOOK,0x00484138, GraciaF_Vehicle_GetOffS, 0);
//WriteMemory8(0x00484167,0x24);

//WriteHook(JMP_HOOK,0x0049eeC9, GraciaF_Vehicle_MoveToLocS, 0);
//WriteMemory8(0x0049ef1f,0x30);

//WriteHook(JMP_HOOK,0x0049e1b1, GraciaF_Vehicle_StopInS, 1);
//WriteMemory8(0x0049e201,0x24);

//WriteHook(JMP_HOOK,0x004e8445, GraciaF_Vehicle_ValidateLocS, 0);
//WriteMemory8(0x004e8479,0x28);

//WriteHook(JMP_HOOK,0x0051a198, GraciaF_VehicleInfoS, 0);
//WriteMemory8(0x0051a1ce,0x24);

//WriteHook(JMP_HOOK,0x00, GraciaF_Vehicle, 0);
//WriteMemory8(0x00,0x);

}
*/


void SkillListFix1_CT2();
void SkillListFix2_CT2();
void SkillListFix3_CT2();
void SkillListFix1_Awakening();
void SkillListFix2_Awakening();
void SkillListFix3_Awakening();
void NPCInf_pch1();
void NPCInf_pch2();


//skills def

void tontor_bypass();
void tontor_npchtml();
void tontor_teleport();
void tontor_link();
void tontor_npcshowhtmlstring();


//==============
void HookCropDropFix();
void RessurectInPlaceFix();
bool TestESI(DWORD Object);
void AVEHook();
void ABNHook();
void ABNHook2();



void ResshopBuy(DWORD *pSocket, BYTE mchronicle, int adenacount);
void ResshopBuy_TEST(DWORD *pSocket, BYTE mchronicle, int adenacount);
void ResBuy(DWORD *pUser, int itemid, int itemcount);
void ResshopSell(DWORD *pSocket, BYTE mchronicle, int adenacount);
void ResshopSell_TEST(DWORD *pSocket, BYTE mchronicle, int adenacount);
void ResSell(DWORD *pUser, int itemid, int itemcount);


bool IsUserSocket(DWORD * pSocket);

//Freya

void Freya_SetupGauge_01();
void Freya_SetupGauge_02();
void Freya_SetupGauge_03();
void Freya_SetupGauge_04();

void Freya_inv_upd1();
void Freya_inv_upd2();
void Freya_inv_upd1a();
void Freya_inv_upd2b();

void Freya_inv_list3a();
void Freya_inv_list3b();
void Freya_inv_list1();
void Freya_inv_list2();
void Freya_inv_list3();
void Freya_inv_list_esp();

void Freya_warehouseAA0();
void Freya_warehouseAA1();
void Freya_warehouseAA2();
void Freya_warehouseBB0();
void Freya_warehouseBB1();
void Freya_warehouseBB2();
void Freya_warehouseCC0();
void Freya_warehouseCC1();
void Freya_warehouseCC2();
void Freya_warehouseDD0();
void Freya_warehouseDD1();
void Freya_warehouseDD2();
void Freya_warehouseEE0();
void Freya_warehouseEE1();
void Freya_warehouseEE11();
void Freya_warehouseEE2();

void Freya_warehouseA1();
void Freya_warehouseA2();
void Freya_warehouseB1();
void Freya_warehouseB2();
void Freya_warehouseC1();
void Freya_warehouseC2();
void Freya_warehouseD1();
void Freya_warehouseD2();
void Freya_warehouseE1();

void Freya_pet_inv_updA();
void Freya_pet_inv_updB();
void Freya_pet_inv_listA();
void Freya_pet_inv_listB();

void Freya_pet_inv_upd1();
void Freya_pet_inv_upd2();
void Freya_pet_inv_list1();
void Freya_pet_inv_list2();
void Freya_pet_inv_list3();










//trade
void Freya_trade_a();
void Freya_trade_a00();
void Freya_trade_b();
void Freya_trade_c();
void Freya_trade_d();
void Freya_trade_d00();
void Freya_trade_e();
void Freya_trade_f();
void Freya_trade_g();
void Freya_trade_h();

void Freya_trade_1();
void Freya_trade_2();
void Freya_trade_3();
void Freya_trade_4();
void Freya_trade_5();
void Freya_trade_6();
void Freya_trade_7();
void Freya_trade_8();
void Freya_trade_9();
void Freya_trade_10();
void Freya_trade_11();
void Freya_trade_12();







//---------------------------------
//privatestore
void Freya_privatestore_1();
void Freya_privatestore_2();
void Freya_privatestore_3();
void Freya_privatestore_4();
void Freya_privatestore_5();
void Freya_privatestore_6();

void Freya_privatestore_1A();
void Freya_privatestore_2A();
void Freya_privatestore_3A();
void Freya_privatestore_4A();
void Freya_privatestore_5A();
void Freya_privatestore_6A();


void Freya_privatestore_1B();
void Freya_privatestore_3B();
void Freya_privatestore_5B();
void Freya_privatestore_6B();


void Freya_Package();
void Freya_PackageFix();


void Freya_multisell_1();
void Freya_multisell_2();
void Freya_multisell_2esp();
void Freya_multisell_3();


void Freya_NPCSayBroadcast();
void Freya_NPCShout();

void Freya_Relation1();
void Freya_Relation2();
void Awake_Relation1();
void Awake_Relation2();


void UserInfoPacketQH5Fix();
void UserInfoPacketAddrFixCT2H5();
void PetInfoH5();
void NPCInfo_Awake(); //H5
void NPCInfo2_Awake(); //H5
void HookLoginMessages_H5();

void NPCInfo_Tauti(); 
void NPCInfo2_Tauti(); 


void CWorld_PickItem_herb3();
void CWorld_PickItem_herb2();
void CWorld_PickItem_herb1();

void Awakening_UserInfoEx();
void UserInfoPacketAddrFixCT3A();
void UserInfoPacketAugmentFixGOD1();


void ShortcutInfSkill_Awakening();
void ShortcutInfSkillEsp_Awakening();
void ShortcutRegA_Awake();
void ShortcutRegEsp_Awake();


void Awakening_MagicSkillLaunched_1();
void Awakening_MagicSkillLaunched_2();
void Awakening_MagicSkillLaunched_3();
void Awakening_MagicSkillLaunched_4();
void Awakening_MagicSkillLaunched_4_ex1();
void Awakening_MagicSkillLaunched_4_ex2();


void Awakening_MagicSkillLaunched_3_fake();
void Awakening_MagicSkillLaunched_4_fake();


//void Awakening_MagicSkillLaunched_4_test();
//void Awakening_MagicSkillLaunched_4_test2();
//void Awakening_MagicSkillLaunched_4_test3();

/*
WriteHook(JMP_HOOK,0x004a0BD0, Awakening_MagicSkillLaunched_4_test, 0); 
//.text:00548A72                 call    CreatureController_LaunchMagicSkill
//.text:00548A77
//.text:00548A77 loc_548A77:                             ; CODE XREF: CSkillAction2__OnTick_5484A0+5BEj
//.text:00548A77                 mov     eax, [ebx+4Ch]
//.text:00548A7A                 cmp     eax, 50h
//.text:00548A7D                 mov     [ebp+var_4], 3
//.text:00548A84                 jge     loc_548F24
WriteHook(JMP_HOOK,0x00548a77, Awakening_MagicSkillLaunched_4_test2, 1); 
WriteHook(JMP_HOOK,0x004a0a70, Awakening_MagicSkillLaunched_4_test3, 0); 
*/

/*
int class_destruct_mskill_launched=0x439610;
int RemoveObject_temp1=0x4923B0;
static const wchar_t *fnTestESP=L"ElhaymTestESP::[%d][%d][%d]";
static const wchar_t *fnTestPOP=L"ElhaymTestPOP::[%d][%d][%d][%d][%d]";

//4a0BD0 + 0 nop
__declspec(naked) void Awakening_MagicSkillLaunched_4_test()
{
//format cddddb->cdddddb offset: 4a0bdc
//esp 4c->50 offset: 4a0c07

	__asm
	{



		push edx
		mov	edx,[ebp][00]
		push eax
		push ebx

		
push 0 //Awakening addon
push 054h //c1: 8E
//push 005C71F4h //format
push FORMAT_SKILLLAUNCHED4_Awake



		sub esp,20h //20h


		pushad
		push	0
		push	esp
		push	1
		push	fnTestESP 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 18h
		popad

		mov eax,esp
		fstp qword ptr[esp][18h] //18
		mov	[esp][50h],esp //50
		push eax
		mov ecx,ebp
		call dword ptr[edx][38h]
		mov	ecx,[168ad244h]
		push	00000A000h
		push	ebx
		push	ecx

		call CSOCKET_BROADCAST

		pushad
		push	0
		push	esp
		push	2
		push	fnTestESP 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 18h
		popad




//add	esp,4ch //4C
add	esp,50h

	


		pushad
		push	0
		push	esp
		push	3
		push	fnTestESP 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 18h
		popad

		test edi,edi
		mov dword ptr[esp][201Ch],0ffffffffh //1C

		pushad
		push	0
		push	[esp][201Ch]
		push	4
		push	fnTestESP 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 18h
		popad

		je loc_4A0C3Fh
		mov	ebx,[esp][00002034h] //34

		pushad
		push	0
		push	[esp][00002034h]
		push	5
		push	fnTestESP 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 18h
		popad

		cmp	edi,ebx
		mov esi,edi
		je loc_4A0C34h


loc_4A0C24h:
		push 0
		mov	 ecx,esi
		call class_destruct_mskill_launched
		add esi,008h
		cmp esi,ebx
		jne loc_4A0C24h

loc_4A0C34h:
		push edi
		mov ecx,017D0C9Ch
		call RemoveObject_temp1

		pushad
		push	esi
		push	[esp][00002014h]
		push	6
		push	fnTestESP 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 18h
		popad

loc_4A0C3Fh:
		mov	ecx,[esp][00002014h]


		pushad
		push	0
		push	esp
		push	7
		push	fnTestESP 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 18h
		popad


		pop edi
		pop esi
		pop ebp
		pop ebx
		
		mov ebx,edi
		mov edi,esi

		pushad

		push    0
		push    edi
		push	esi
		push	ebp
		push	ebx
		push	fnTestPOP 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 20h
		popad

		push ebx
		push 4a0C49h //f: 4a0a50
		retn

	}
}

//548a77 + 1 nop
static const wchar_t *fnTest2=L"ElhaymTestTimer::[%d][%d][%d][%d]";
__declspec(naked) void Awakening_MagicSkillLaunched_4_test2()
{
__asm
	{
		pushad
		push    edi
		push	esi
		push	ebp
		push	ebx
		push	fnTest2 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 1ch
		popad



	mov eax,[ebx][4Ch] //4C
	cmp eax,50h

		push 548a7dh
		retn
}
}


//4a0a70 + 0 nop
static const wchar_t *fnTest3=L"ElhaymTestEBX::[%d][%d][%d][%d]";
__declspec(naked) void Awakening_MagicSkillLaunched_4_test3()
{
__asm
	{
		pushad
		push    edi
		push	esi
		push	ebp
		push	ebx
		push	fnTest3 
		push	2 //red collor
		push	018aa81d8h //CLog
		call	CLOG_ADDU //addLog Unicode
		add esp, 1ch
		popad



	push ebp
	push esi
	//push edi
	push ebx
	xor ebx,ebx

		push 4a0a75h
		retn
}
}

*/


void Awakening_Attack_single();
void Awakening_Attack_multi();
void Awakening_Attack_multi_ddc();

void Awakening_inv_upd1();
void Awakening_inv_upd1a();
void Awakening_inv_upd2();
void Awakening_inv_upd2b();
void Awakening_inv_list1();
void Awakening_inv_list2();
void Awakening_inv_list3();
void Awakening_inv_list3a();
void Awakening_inv_list3b();

void PetInfo_Awakening();
void PetInfo_Tauti();
void PetInfoAwakeKarma();
void Awakening_pet_inv_upd1();
void Awakening_pet_inv_upd2();
void Awakening_pet_inv_list1();
void Awakening_pet_inv_list2();
void Awakening_pet_inv_list3();
void Awakening_trade_1();
void Awakening_trade_2();
void Awakening_trade_3();
void Awakening_trade_4();
void Awakening_trade_5();
void Awakening_trade_6();
void Awakening_trade_7();
void Awakening_trade_8();
void Awakening_trade_9();
void Awakening_trade_10();
void Awakening_trade_11();

void Awake_privatestore_5B();
void Awake_privatestore_6B();
void Awakening_privatestore_1();
void Awakening_privatestore_2();
void Awakening_privatestore_3();
void Awakening_privatestore_4();
void Awakening_privatestore_5();
void Awakening_privatestore_6();


void Awakening_warehouseA1();
void Awakening_warehouseA2();
void Awakening_warehouseB1();
void Awakening_warehouseB2();
void Awakening_warehouseC1();
void Awakening_warehouseC2();
void Awakening_warehouseD1();
void Awakening_warehouseD2();
void Awakening_warehouseE1();
void Awake_warehouseAA0();
void Awake_warehouseAA1();
void Awake_warehouseAA2();
void Awake_warehouseBB0();
void Awake_warehouseBB1();
void Awake_warehouseBB2();
void Awake_warehouseCC0();
void Awake_warehouseCC1();
void Awake_warehouseCC2();
void Awake_warehouseDD0();
void Awake_warehouseDD1();
void Awake_warehouseDD2();
void Awake_warehouseEE0();
void Awake_warehouseEE1();
void Awake_warehouseEE11();
void Awake_warehouseEE2();

void Glory_warehouseAA2();
void Glory_warehouseBB2();
void Glory_warehouseA1();
void Glory_warehouseA2();
void Glory_warehouseB1();
void Glory_warehouseB2();


void Awakening_PackageFix();
void Awakening_multisell_1();
void Awakening_multisell_2();
void Awakening_multisell_3();
void Awakening_multisell_2esp();

void Classic_MagicSkillUse_1();
void Classic_MagicSkillUse_2();
void Classic_MagicSkillUse_3();
void Classic_MagicSkillUse_4();
void Classic_MagicSkillUse_5();
void Classic_MagicSkillUse_6();
void Classic_MagicSkillUse_7();

void Awakening_MagicSkillUse_1();
void Awakening_MagicSkillUse_2();
void Awakening_MagicSkillUse_3();
void Awakening_MagicSkillUse_4();
void Awakening_MagicSkillUse_5();
void Awakening_MagicSkillUse_6();
void Awakening_MagicSkillUse_7();
void Awakening_buy_1();
void Awakening_buy_2();
void Awakening_sell_1();
void Awakening_sell_2();

void Awakening_AddWindowPacketFix();
void Awakening_OpenAllWindowPacketFix();
void Awakening_UpdateWindowPacketFix();

void Awake_NPCSayBroadcast();
void Awake_NPCShout();

void BCCharInfoPacketFaceFix_Awake();
void CharInfoPacketFaceFix_Awake();

void Awake_Say2_01();
void Awake_Say2_02();
void Awake_Say2_03();
void Awake_Say2_04();
void Awake_Say2_05();
void Awake_Say2_06();
void Awake_Say2_07();
void Awake_Say2_08();
void Awake_Say2_09();
void Awake_Say2_10();


void PetStatusShow_GD1Awake();
void TutorialShowHtml_GD1Awake_01();
void TutorialShowHtml_GD1Awake_02();
void TutorialShowHtml_GD1Awake_03();

//awake pledges
void PledgeWindowOpenAll_awake();
void PledgeWindowOpenAll_awake_a();
void PledgeWindowOpenAllesp_awake();
void PledgeShowInfoUpdate_awake();
void PledgeShowInfoUpdateesp_awake();
void GMPledgeInfo2_awake();
void PledgeShowInfoUpdate_Lind();
void PledgeShowInfoUpdateesp_Lind();

void PledgeWindowOpenAll_classic();
//void PledgeWindowOpenAll_awake_a();
void PledgeWindowOpenAllesp_classic();


//int SQLKonect();
bool IsTargetVisible(DWORD *pUser, DWORD *pTarget, int nInZoneObjectId, bool bCheckPlaneCollision);

 int antiStringExploitFix(DWORD *pSocket, BYTE *kBuffer, int maxLength, int positionInBuffer);
 int split_string_by_first_space(DWORD *pSocket, BYTE *kBuffer, int maxLength, int positionInBuffer);

 double getExpPercent(int level, int exp);




 void UserInfoPacketAugmentFixGOD1h();
 void UserInfoPacketAddrFixCT3GOD1h();

 void Harmony_inv_upd1();
void Harmony_inv_upd2();
void Harmony_inv_list1();
void Harmony_inv_list2();
void Harmony_inv_list3();

void BCCharInfoPacketFaceFix_Harmony();
void CharInfoPacketFaceFix_Harmony();


void GMUserInfoGFAUGM();
void GMUserInfoGFFACE();
void GMUserInfoGFFix();
void GMUserInfoH5();
void GMUserKarma2Reputation();


int ListBuffs(DWORD * pSocket, DWORD * pUser, int action,  PTCharBaseData CSharedDat); //int GM, int Premium);


//void TutorialShowQuestionMark_Tauti_01();
//void TutorialShowQuestionMark_Tauti_02();

void BBS_ShowNewBoard(DWORD *pSocket, DWORD *pBuffer, BYTE opCode, BYTE useC1, wchar_t *htm);

void BBS_HTMLHandler_Hook_01();
void BBS_HTMLHandler_Hook_02();
void BBS_HTMLHandler_Hook_03();
void BBS_HTMLHandler_Hook_04();
void BBS_HTMLHandler_Hook_05();
void BBS_HTMLHandler_Hook_06();
void BBS_HTMLHandler_Hook_07();
void BBS_HTMLHandler_Hook_08();
void BBS_HTMLHandler_Hook_09();
void BBS_HTMLHandler_Hook_10();


void OpcodeRefix_c2();
void del_radar_c2();
void show_radar_c2();
void GM_del_radar_c2();
void GM_show_radar_c2();


void CalculateJumpNodeNext(DWORD *pSocket, DWORD *pUser, int newChoice);
void ChooseJumpNode(DWORD *pSocket, DWORD *pUser, int choice);


void Glory_warehouseAA0();
void Glory_warehouseAA1();

void Glory_warehouseBB0();
void Glory_warehouseBB1();

void PolymorphNPCInfo_fix1();
void PolymorphNPCInfo_fix2();
void PolymorphNPCInfo_H5_fix1();
void PolymorphNPCInfo_H5_fix2();
void PolymorphNPCInfo_C5_fix1();
void PolymorphNPCInfo_C5_fix2();


void user_skill_delete(DWORD *pUser, DWORD skillID);
void user_skill_aquire(DWORD *pUser, DWORD skillID, DWORD skillLevel, bool toDB);
int PledgeSetSkill(DWORD *pUser, DWORD skillID, DWORD skillLevel, int membercount);
void AquirePledgeSkill(DWORD *pUser, DWORD skillID);
bool teachPledgeSkills(DWORD *pUser, DWORD *pMember);
bool deletePledgeSkills(DWORD *pUser);

/*
int ol_register_stadium(int x1, int y1, int z1, int x2, int y2, int z2);
void ol_npcmessage_handler(DWORD *pSocket, DWORD *pUser,PTCharBaseData CSharedDat, int msgid, int olid);
void ol_register_ol(int olID, int maxstadiums);
void ol_clear_all();
int ol_search_combat(DWORD *pSocket,int fights);
void ol_testExUser(DWORD *pUser, DWORD *pSocket);
//int ol_exUserTransfer(DWORD *pUser, DWORD *pSocket);
*/

void blockListPacket(DWORD *pSocket, DWORD *pUser);


void PledgeInfo_1();
void AllyCrest_2();
void AllyCrest_1();
void PledgeCrest_2();
void PledgeCrest_1();
void Friend_add_result();
void Friend_delete();
void Friend_looged_in();
void FriendList_awake();

void c2_trade_1();
void c2_trade_2();
void c2_trade_3();
void c2_trade_4();
void c2_trade_5();
void c2_trade_6();
void c2_trade_7();
void c2_trade_8();


void UserInfoPacketHairFix1();
void UserInfoPacketHairFix2();
void CharInfoPacketHairFix();
void BCCharInfoPacketHairFix();
void UserInfoPacketHairFix1_A();
void UserInfoPacketHairFix2_A();
void CharInfoPacketHairFix_A();
void BCCharInfoPacketHairFix_A();


void got_damage();
void avoided_damage();
void resisted_magic();
void got_damage_checkNPC();
