
//---------------
//SERVER Opcodes

/*
0x00 :: DiePacket :: maybe trigger
0x01 :: RevivePacket :: maybe trigger
0x02 :: AttackOutofRangePacket :: maybe trigger
0x03 :: AttackinCoolTimePacket :: maybe trigger
0x04 :: AttackDeadTargetPacket :: maybe trigger
0x05 :: SpawnItemPacket :: maybe trigger
0x06 :: SellListPacket ::  ddd ddddd Sdd dddddQ dddQd ddQ
0x07 :: BuyListPacket ::  cddQhddhhhhhhhh dQ ddhhQQd
0x08 :: DeleteObjectPacket ::  dd
0x09 :: CharacterSelectionInfoPacket ::  dc cd SdSddddddddddffdQfddddddddddddddddddddddddddddddddddddddddffdddchhdddddffdd
0x0a :: LoginFailPacket ::  dc dddddddd dd
0x0b :: CharacterSelectedPacket ::  SdSddddddddddffdQddddddddddd dddd dddd
0x0c :: NpcInfoPacket ::  dddcdddddddddh ddd dd ddddddddffd dd
0x0d :: NewCharacterSuccessPacket ::  ddd ddd
0x0e :: NewCharacterFailPacket :: maybe trigger
0x0f :: CharacterCreateSuccessPacket :: maybe trigger
0x10 :: CharacterCreateFailPacket :: maybe trigger
0x11 :: ItemListPacket ::  cdd cd cddQ cd
0x12 :: SunRisePacket :: maybe trigger
0x13 :: SunSetPacket :: maybe trigger
0x14 :: TradeStartPacket ::  hh ddQhhdhhhdhhhhhhhh ddQhhdhhhdhhhhhhhhhhh ddQhhdhhhdhhhhhhhhhhh
0x15 :: TradeStartOkPacket :: maybe trigger
0x16 :: DropItemPacket :: maybe trigger
0x17 :: GetItemPacket ::  dSdd dddd dd ddddd
0x18 :: StatusUpdatePacket ::  dh dhddd
0x19 :: NpcHtmlMessagePacket ::  dSdd
0x1a :: TradeOwnAddPacket ::  hh ddQhhdhhhdhhhhhhhh ddQhhdhhhdhhhhhhhhhhh ddQhhdhhhdhhhhhhhhhhh
0x1b :: TradeOtherAddPacket ::  hh ddQhhdhhhdhhhhhhhh
0x1c :: TradeDonePacket ::  dd dd ddd
0x1d :: CharacterDeleteSuccessPacket :: maybe trigger
0x1e :: CharacterDeleteFailPacket :: maybe trigger
0x1f :: ActionFailPacket :: maybe trigger
0x20 :: SeverClosePacket :: maybe trigger
0x21 :: InventoryUpdatePacket ::  ddddd dhd dddddd dddddd
0x22 :: TeleportToLocationPacket ::  ddddd dhd dddddd dddddd
0x23 :: TargetSelectedPacket ::  ddddd dhd
0x24 :: TargetUnselectedPacket ::  ddd ddddd
0x25 :: AutoAttackStartPacket ::  ddd ddd
0x26 :: AutoAttackStopPacket ::  ddddd ddd ddd
0x27 :: SocialActionPacket ::  cdddd cddd cd cd cd
0x28 :: ChangeMoveTypePacket ::  cdddd cdddd cddd cd cd
0x29 :: ChangeWaitTypePacket ::  chdddd cdddd cdddd cddd cd
0x2a :: ManagePledgePowerPacket ::  ddddddddd ddddddddddddddddddddddddddddd ddd dhd dd ddd
0x2b :: CreatePledgePacket ::  dSSd ddSS
0x2c :: AskJoinPledgePacket ::  dSSd
0x2d :: JoinPledgePacket ::  dd
0x2e :: VersionCheckPacket :: maybe trigger
0x2f :: MTLPacket ::  dddddd dddddddd
0x30 :: NSPacket :: maybe trigger
0x31 :: CIPacket :: maybe trigger
0x32 :: UIPacket :: maybe trigger
0x33 :: AttackPacket :: maybe trigger
0x34 :: WithdrawalPledgePacket ::  dd
0x35 :: OustPledgeMemberPacket ::  dd
0x36 :: SetOustPledgeMemberPacket :: maybe trigger
0x37 :: DismissPledgePacket ::  dd
0x38 :: SetDismissPledgePacket :: maybe trigger
0x39 :: AskJoinPartyPacket ::  Sdddd SS
0x3a :: JoinPartyPacket ::  Sdddd SS
0x3b :: WithdrawalPartyPacket :: maybe trigger
0x3c :: OustPartyMemberPacket :: maybe trigger
0x3d :: SetOustPartyMemberPacket :: maybe trigger
0x3e :: DismissPartyPacket :: maybe trigger
0x3f :: SetDismissPartyPacket :: maybe trigger
0x40 :: MagicAndSkillList ::  dQQ
0x41 :: WareHouseDepositListPacket ::  ccdcS dQ dQ
0x42 :: WareHouseWithdrawListPacket ::  ddddd hQh
0x43 :: WareHouseDonePacket ::  dddcddd dd dd dd dd
0x44 :: ShortCutRegisterPacket ::  dd dddddhh dddcddd dd dd dd dd
0x45 :: ShortCutInitPacket ::  dd dddddhh dddcd dd dd dd dd
0x46 :: ShortCutDeletePacket :: maybe trigger
0x47 :: StopMovePacket ::  dddddd dddddd
0x48 :: MagicSkillUse ::  hdccc ddd
0x49 :: MagicSkillCanceled ::  dd dd Sd SSSSS
0x4a :: SayPacket2 ::  dd dd Sd SSSSS
0x4b :: EquipUpdatePacket ::  dddSS dddddddddddSddd Sdddddd ddd
0x4c :: DoorInfoPacket :: maybe trigger
0x4d :: DoorStatusUpdatePacket :: maybe trigger
0x4e :: PartySmallWindowAllPacket ::  dddSdddddddddddddd ddd dSddddddddddddddd dddSddddd
0x4f :: PartySmallWindowAddPacket ::  dSdddddddddd dS dddSdddddddddddddd
0x50 :: PartySmallWindowDeleteAllPacket ::  ch
0x51 :: PartySmallWindowDeletePacket ::  ch
0x52 :: PartySmallWindowUpdatePacket ::  ddddcc dSdddddddddd
0x53 :: TradePressOwnOkPacket :: maybe trigger
0x54 :: MagicSkillLaunchedPacket ::  dd
0x55 :: FriendAddRequestResult ::  dS cd
0x56 :: FriendAdd ::  Sd dS cd
0x57 :: FriendRemove ::  dddSS cddQddQ SSQQQd Sd dS
0x58 :: FriendList ::  dddf dSSS dSd ddSdd dSddddS
0x59 :: FriendStatus ::  dccSS dddf dSSS dSd
0x5a :: PledgeShowMemberListAllPacket ::  Sddddddd dddSS dddddddddddSddd Sdddddd
0x5b :: PledgeShowMemberListUpdatePacket ::  Sdddddd Sddddddd
0x5c :: PledgeShowMemberListAddPacket ::  Sdddddd
0x5d :: PledgeShowMemberListDeletePacket ::  SddSddddddddSd dSS
0x5e :: MagicListPacket :: maybe trigger
0x5f :: SkillListPacket ::  ddddd dd dd
0x60 :: VehicleInfoPacket ::  ddddddd dddddd ddddd
0x61 :: FinishRotatingPacket :: maybe trigger
0x62 :: SystemMessagePacket ::  ddcdddddddh dddd
0x63 :: StartPledgeWarPacket :: maybe trigger
0x64 :: ReplyStartPledgeWarPacket :: maybe trigger
0x65 :: StopPledgeWarPacket :: maybe trigger
0x66 :: ReplyStopPledgeWarPacket :: maybe trigger
0x67 :: SurrenderPledgeWarPacket :: maybe trigger
0x68 :: ReplySurrenderPledgeWarPacket :: maybe trigger
0x69 :: SetPledgeCrestPacket :: maybe trigger
0x6a :: PledgeCrestPacket ::  Sd dd
0x6b :: SetupGaugePacket ::  dddd
0x6c :: VehicleDeparturePacket :: maybe trigger
0x6d :: VehicleCheckLocationPacket ::  ddd dddd
0x6e :: GetOnVehiclePacket :: maybe trigger
0x6f :: GetOffVehiclePacket :: maybe trigger
0x70 :: TradeRequestPacket ::  cdd cd cddQ cd
0x71 :: RestartResponsePacket ::  dhh dd ddd dSSSSS ddd dS
0x72 :: MoveToPawnPacket ::  dddd ddddd ddddddddd
0x73 :: SSQInfoPacket ::  dSd ddSdd dSddddS dddd cc
0x74 :: GameGuardQueryPacket ::  dSSS dSd ddSdd dSddddS dddd
0x75 :: L2FriendListPacket ::  dddf dSSS dSd ddSdd dSddddS
0x76 :: L2FriendPacket ::  dccSS dddf dSSS
0x77 :: L2FriendStatusPacket ::  dccSS dddf dSSS dSd
0x78 :: L2FriendSayPacket ::  dccSS dddf dSSS
0x79 :: ValidateLocationPacket ::  ddddd dddddd
0x7a :: StartRotatingPacket :: maybe trigger
0x7b :: ShowBoardPacket ::  SSSSSSSSS
0x7c :: ChooseInventoryItemPacket :: maybe trigger
0x7d :: DummyPacket :: maybe trigger
0x7e :: MoveToLocationInVehiclePacket ::  chddddddd chdd chddd chddddddd cddddddd
0x7f :: StopMoveInVehiclePacket :: maybe trigger
0x80 :: ValidateLocationInVehiclePacket :: maybe trigger
0x81 :: TradeUpdatePacket :: maybe trigger
0x82 :: TradePressOtherOkPacket :: maybe trigger
0x83 :: FriendAddRequest ::  Sd dS cd
0x84 :: LogOutOkPacket ::  dddcddddddddh ddd ddd
0x85 :: AbnormalStatusUpdatePacket ::  dh dhddd
0x86 :: QuestListPacket ::  dd
0x87 :: EnchantResultPacket ::  hdh ddd
0x88 :: PledgeShowMemberListDeleteAllPacket :: maybe trigger
0x89 :: PledgeInfoPacket ::  SddSddddddddSd dSS
0x8a :: PledgeExtendedInfoPacket ::  ddddddddddddSdddd SddSddddddddSd
0x8b :: SurrenderPersonallyPacket :: maybe trigger
0x8c :: RidePacket :: maybe trigger
0x8d :: DummyPacket :: maybe trigger
0x8e :: PledgeShowInfoUpdatePacket ::  ddd dSddddddddddddddd dddSddddd ddddddddddddSdddd
0x8f :: ClientActionPacket ::  dd ddddd
0x90 :: AcquireSkillListPacket ::  dddd ddQd dd ddddd
0x91 :: AcquireSkillInfoPacket ::  ddd dddd ddQd
0x92 :: ServerObjectInfoPacket ::  dS dddddSddddQfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddcccddhhddddccdccddhhhhhhhhdd
0x93 :: GMHidePacket ::  dd dSddddSd dS
0x94 :: AcquireSkillDonePacket :: maybe trigger
0x95 :: GMViewCharacterInfoPacket ::  ddd dS dddddSddddQfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddcccddhhddddccdccddhhhhhhhhdd
0x96 :: GMViewPledgeInfoPacket ::  ddddcc dSddSS dddddddddddSddd Sdddddd
0x97 :: GMViewSkillInfoPacket ::  Sd ddd Sd
0x98 :: GMViewMagicInfoPacket ::  dhd Sd
0x99 :: GMViewQuestInfoPacket ::  Sddd Sh dd ddQd
0x9a :: GMViewItemListPacket ::  hh SQh Sdhh
0x9b :: GMViewWarehouseWithdrawListPacket ::  ddQhhdhhhdhhhhhhhhhhh hh SQh
0x9c :: ListPartyWatingPacket ::  ddddddS dd dSddddSd dS
0x9d :: PartyRoomInfoPacket ::  dSdddddd ddddddS
0x9e :: PlaySoundPacket ::  dSddSS dddddddddddSddd Sdddddd dSdddddd
0x9f :: StaticObjectPacket ::  dQQQdd cQQ dQQ dQd dQQQd QQ ddQc ddddddddddd ddddS
0xa0 :: PrivateStoreManageList :: maybe trigger
0xa1 :: PrivateStoreList ::  cddQhddhhhhhhhh dQ ddhhQQd dhhQQhhhhhhhhd
0xa2 :: PrivateStoreMsg ::  SSQQQd cQdd dS dQdd dQd dS
0xa3 :: ShowMinimapPacket ::  dSSS dc
0xa4 :: ReviveRequestPacket :: maybe trigger
0xa5 :: AbnormalVisualEffectPacket ::  dddddd dddddd
0xa6 :: TutorialShowHtmlPacket ::  ddd ddddd ddddd dS
0xa7 :: TutorialShowQuestionMarkPacket ::  ddd ddddd ddddd
0xa8 :: TutorialEnableClientEventPacket ::  ddd ddddd ddddd
0xa9 :: TutorialCloseHtmlPacket :: maybe trigger
0xaa :: ShowRadarPacket ::  dd dd dddd ddd ddddd
0xab :: WithdrawAlliancePacket ::  dSddddS dd
0xac :: OustAllianceMemberPledgePacket ::  dSddddS dd
0xad :: DismissAlliancePacket ::  dSddddS dd
0xae :: SetAllianceCrestPacket :: maybe trigger
0xaf :: AllianceCrestPacket :: maybe trigger
0xb0 :: ServerCloseSocketPacket :: maybe trigger
0xb1 :: PetStatusShowPacket :: maybe trigger
0xb2 :: PetInfoPacket ::  dddddddddddddddddddffffdddcccccdSdSdddddddddddQQQdddddddddddddddddccddddddd
0xb3 :: PetItemListPacket :: maybe trigger
0xb4 :: PetInventoryUpdatePacket ::  Qdh ddQhhdhhhQhhhhhhhh
0xb5 :: AllianceInfoPacket :: maybe trigger
0xb6 :: PetStatusUpdatePacket :: maybe trigger
0xb7 :: PetDeletePacket :: maybe trigger
0xb8 :: DeleteRadarPacket ::  dd dd dddd ddd
0xb9 :: MyTargetSelectedPacket ::  ddddd dhd
0xba :: PartyMemberPositionPacket ::  dd dd dddd
0xbb :: AskJoinAlliancePacket ::  dd dSSS
0xbc :: JoinAlliancePacket ::  dd
0xbd :: PrivateStoreBuyManageList :: maybe trigger
0xbe :: PrivateStoreBuyList ::  cddQhddhhhhhhhh dQ ddhhQQd
0xbf :: PrivateStoreBuyMsg ::  ddddddd dS dddd dddddddddd dQd SSQQQd cQdd dS
0xc0 :: VehicleStartPacket ::  dddddd dS SS SS dddd dd
0xc1 :: RequestTimeCheckPacket :: maybe trigger
0xc2 :: StartAllianceWarPacket :: maybe trigger
0xc3 :: ReplyStartAllianceWarPacket :: maybe trigger
0xc4 :: StopAllianceWarPacket :: maybe trigger
0xc5 :: ReplyStopAllianceWarPacket :: maybe trigger
0xc6 :: SurrenderAllianceWarPacket :: maybe trigger
0xc7 :: SkillCoolTimePacket ::  dddddd dS SS SS dddd
0xc8 :: PackageToListPacket ::  SS dddddd dS
0xc9 :: CastleSiegeInfoPacket ::  dd dc dddddd dSSddddSSd dddddd dSSdddSSd dddSSdSdd
0xca :: CastleSiegeAttackerListPacket :: maybe trigger
0xcb :: CastleSiegeDefenderListPacket :: maybe trigger
0xcc :: NickNameChangedPacket :: maybe trigger
0xcd :: PledgeStatusChangedPacket :: maybe trigger
0xce :: RelationChangedPacket :: maybe trigger
0xcf :: EventTriggerPacket :: maybe trigger
0xd0 :: MultiSellListPacket ::  ddddddd dddddc dchddhhhhhhhhhh ddhQhdddhhhhhhhh dhQhddhhhhhhhh
0xd1 :: SetSummonRemainTimePacket ::  ddQ ddddd ddd dd dSddSS dd
0xd2 :: PackageSendableListPacket ::  ddddddddddd ddddd ddddddd dS dddd dddddddddd dQd
0xd3 :: EarthQuakePacket :: maybe trigger
0xd4 :: FlyToLocationPacket :: maybe trigger
0xd5 :: BlockListPacket ::  dd dc dddddd dSSddddSSd dddddd dSSdddSSd dddSSdSdd
0xd6 :: SpecialCameraPacket :: maybe trigger
0xd7 :: NormalCameraPacket :: maybe trigger
0xd8 :: SkillRemainSecPacket ::  dQdh dhhQ dddddd dS
0xd9 :: NetPingPacket :: maybe trigger
0xda :: DicePacket ::  ddddddd dQdh dhhQ dddddd
0xdb :: SnoopPacket ::  dddd dd ddQ ddddd ddd dd dSddSS
0xdc :: RecipeBookItemListPacket ::  ddQ dddd dd ddQ ddddd ddd dd
0xdd :: RecipeItemMakeInfoPacket ::  dddddQ dddQd ddQ dddd dd ddQ ddddd
0xde :: RecipeShopManageListPacket ::  Sdd dddddQ dddQd ddQ dddd dd ddQ
0xdf :: RecipeShopSellListPacket ::  ddd ddddd Sdd dddddQ dddQd ddQ
0xe0 :: RecipeShopItemInfoPacket ::  dd ddd ddddd Sdd dddddQ
0xe1 :: RecipeShopMsgPacket ::  dQdh dhhQ dddddd dS
0xe2 :: ShowCalcPacket ::  dSSS
0xe3 :: MonRaceInfoPacket :: maybe trigger
0xe4 :: HennaItemInfoPacket ::  Qdd ddQQd ccccccdd dd ccccccdd dd ddQQdQdcdcdcdcdcdc
0xe5 :: HennaInfoPacket ::  Qdd ddQQd ccccccdd dd
0xe6 :: HennaUnequipListPacket ::  dSSScc ccdcS Qdd ddQQd
0xe7 :: HennaUnequipInfoPacket ::  ddddddddddddddddddddddddddddd ddd dhd dd ddd ddQQdQdcdcdcdcdcdc
0xe8 :: MacroListPacket ::  dhd dd ddd ddQQdQdcdcdcdcdcdc dSSScc ccdcS
0xe9 :: BuyListSeedPacket ::  Qdh ddQhh dhhh Qddh
0xea :: ShowTownMapPacket ::  Qdd ddQQd dd ddd ddddd Sdd
0xeb :: ObserverStartPacket ::  ddQQdQdcdcdcdcdcdc Qdd ddQQd dd ddd ddddd
0xec :: ObserverEndPacket ::  dd ddQQdQdcdcdcdcdcdc Qdd ddQQd dd ddd
0xed :: ChairSitPacket ::  ccccccdd dd ddQQdQdcdcdcdcdcdc Qdd ddQQd dd
0xee :: HennaEquipListPacket ::  ccccccdd dd ccccccdd dd ddQQdQdcdcdcdcdcdc Qdd ddQQd
0xef :: SellListProcurePacket ::  Sh dd ddQd Qdh ddQhh dhhh
0xf0 :: GMHennaInfoPacket ::  Qdd ddQQd ccccccdd dd
0xf1 :: RadarControlPacket :: maybe trigger
0xf2 :: ClientSetTimePacket ::  ddd ddddddddd ddddddddddddddddddddddddddddd ddd dhd dd
0xf3 :: ConfirmDlgPacket ::  dddd dd ddd dd
0xf4 :: PartySpelledPacket :: maybe trigger
0xf5 :: ShopPreviewListPacket :: maybe trigger
0xf6 :: ShopPreviewInfoPacket :: maybe trigger
0xf7 :: CameraModePacket :: maybe trigger
0xf8 :: ShowXMasSealPacket ::  Qc ccc cccc cc ccd ddd ddddddddd
0xf9 :: EtcStatusUpdatePacket ::  cdQc Qc ccc cccc cc ccd ddd ddddddddd
0xfa :: ShortBuffStatusUpdatePacket ::  dddccQQQQQcQQQc cc cdQc Qc ccc cccc cc ccd ddd
0xfb :: SSQStatusPacket ::  dddccQQQQQcQQQc cc cdQc Qc ccc cccc cc ccd
0xfc :: PetitionVotePacket :: maybe trigger
0xfd :: AgitDecoInfoPacket ::  dSd ddSdd dSddddS dddd cc
0xfe :: DummyPacket :: maybe trigger
*/



	static const char* servToClientTXT[0x100] = 
	{
"0x0 0x2E, VersionCheck",
"0x1 0x2F, MoveToLocation",
"0x2 0x30, NPC Say",
"0x3 0x31, CharInfo",
"0x4 0x32, User Info",
"0x5 0x33, Attack",
"0x6 0x00, Die",
"0x7 0x01, Revive",
"0x8 0x02, AttackOutOfRange",
"0x9 0x03, AttackInCoolTime",
"0xa 0x04, AttackDeadTarget",
"0xb 0x05, Spawn Item",
"0xc 0x16, Drop Item",
"0xd 0x17, Get Item",
"0xe 0x18, Status Update",
"0xf 0x19, NPC HTML Message",
"0x10 0x06, SellList",
"0x11 0x07, BuyList",
"0x12 0x08, DeleteObject",
"0x13 0x09, CharacterSelectionInfo",
"0x14 0x0A, LoginFail",
"0x15 0x0b, CharacterSelected",
"0x16 0x0c, NpcInfo",
"0x17 0x0d, NewCharacterSucess",
"0x18 0x0e, NewCharacterFail",
"0x19 0x0f, CharacterCreatesuccess",
"0x1a 0x10, CharacterCreateFail",
"0x1b 0x11, ItemList",
"0x1c 0x12, SunRise",
"0x1d 0x13, SunSet 2d",
"0x1e 0x14, TradeStart",
"0x1f 0x15, TradeStartOk",
"0x20 0x1a, TradeOwnAdd",
"0x21 0x1b, TradeOtherAdd",
"0x22 0x1c, TradeDone",
"0x23 0x1d, CharacterDeletesuccess",
"0x24 0x1e, CharacterDeleteFail",
"0x25 0x1f, ActionFail",
"0x26 0x20, SeverClose",
"0x27 0x21, InventoryUpdate",
"0x28 0x22, TeleportToLocaton",
"0x29 0x23, TargetSelected",
"0x2a 0x24, TargetUnselected",
"0x2b 0x25, AutoAttackStart",
"0x2c 0x26, AutoAttackStop",
"0x2d 0x27, SocialAction",
"0x2e 0x28, ChangeMoveType",
"0x2f 0x29, ChangeWaitType",
"0x30 0x2a, ManagePledgePowr",
"0x31 0x2b, CreatePledge",
"0x32 0x2c, AskJoinPledge",
"0x33 0x2d, JoinPledge",
"0x34 0x34, WithdrawalPledge",
"0x35 0x35, OustPledgeMember",
"0x36 0x36, SetOustPledgeMeber",
"0x37 0x37, DismissPledge",
"0x38 0x38, SetDismissPledge",
"0x39 0x39, AskJoinParty",
"0x3a 0x3a, JoinParty",
"0x3b 0x3b, WithdrawalParty",
"0x3c 0x3c, OustPartyMember",
"0x3d 0x3d, SetOustPartyMemer",
"0x3e 0x3e, DismissParty",
"0x3f 0x3f, SetDismissParty",
"0x40 0x40, MagicAndSkillList",
"0x41 0x41, WareHouseDeposiList",
"0x42 0x42, WareHouseWithdrwList",
"0x43 0x43, WareHouseDone",
"0x44 0x44, ShortCutRegister",
"0x45 0x45, ShortCutInit",
"0x46 0x46, ShortCutDelete",
"0x47 0x47, StopMove",
"0x48 0x48, MagicSkillUse",
"0x49 0x49, MagicSkillCanceled",
"0x4a 0x4a, Say2",
"0x4b 0x4b, EquipUpdate",
"0x4c 0x4c, DoorInfo",
"0x4d 0x4d, DoorStatusUpdate",
"0x4e 0x4e, PartySmallWindowAll",
"0x4f 0x4f, PartySmallWindowAdd",
"0x50 0x50, PartySmallWindowDeleteAll",
"0x51 0x51, PartySmallWindowDelete",
"0x52 0x52, PartySmallWindowUpdate",
"0x53 0x5a, PledgeShowMembeListAll",
"0x54 0x5b, PledgeShowMembeListUpdate",
"0x55 0x5c, PledgeShowMembeListAdd",
"0x56 0x5d, PledgeShowMembeListDelete",
"0x57 0x5e, MagicList",
"0x58 0x5f, SkillList",
"0x59 0x60, VehicleInfo",
"0x5a 0x6c, VehicleDeparture",
"0x5b 0x6d, VehicleCheckLoction",
"0x5c 0x6e, GetOnVehicle",
"0x5d 0x6f, GetOffVehicle",
"0x5e 0x70, TradeRequest",
"0x5f 0x71, RestartResponse",
"0x60 0x72, MoveToPawn",
"0x61 0x79, ValidateLocation",
"0x62 0x7a, StartRotating",
"0x63 0x61, FinishRotating",
"0x64 0x62, SystemMessage",
"0x65 0x63, StartPledgeWar",
"0x66 0x64, ReplyStartPledgWar",
"0x67 0x65, StopPledgeWar",
"0x68 0x66, ReplyStopPledgeWar",
"0x69 0x67, SurrenderPledgeWar",
"0x6a 0x68, ReplySurrenderPedgeWar",
"0x6b 0x69, SetPledgeCrest",
"0x6c 0x6a, PledgeCrest",
"0x6d 0x6b, SetupGauge",
"0x6e 0x7b, ShowBoard",
"0x6f 0x7c, ChooseInventoryItem",
"0x70 0x7d, Dummy Packet",
"0x71 0x7e, MoveToLocationIVehicle",
"0x72 0x7f, StopMoveInVehice",
"0x73 0x80, ValidateLocatioInVehicle",
"0x74 0x81, TradeUpdate",
"0x75 0x53, TradePressOwnOk",
"0x76 0x54, MagicSkillLaunced",
"0x77 0x55, FriendAddRequesResult",
"0x78 0x56, FriendAdd",
"0x79 0x57, FriendRemove",
"0x7a 0x58, FriendList",
"0x7b 0x59, FriendStatus",
"0x7c 0x82, TradePressOtherOk",
"0x7d 0x83, FriendAddRequest",
"0x7e 0x84, LogOutOk",
"0x7f 0x85, AbnormalStatusUdate",
"0x80 0x86, QuestList",
"0x81 0x87, EnchantResult",
"0x82 0x88, PledgeShowMembeListDeleteAll",
"0x83 0x89, PledgeInfo",
"0x84 0x8a, PledgeExtendedInfo",
"0x85 0x8b, SurrenderPersonlly",
"0x86 0x8c, Ride",
"0x87 0x8d, unkn dummy?",
"0x88 0x8e, PledgeShowInfoUdate",
"0x89 0x8f, ClientAction",
"0x8a 0x90, AcquireSkillList",
"0x8b 0x91, AcquireSkillInfo",
"0x8c 0x92, ServerObjectInfo",
"0x8d 0x93, GMHide",
"0x8e 0x94, AcquireSkillDone",
"0x8f 0x95, GMViewCharacterInfo",
"0x90 0x96, GMViewPledgeInfo",
"0x91 0x97, GMViewSkillInfo",
"0x92 0x98, GMViewMagicInfo",
"0x93 0x99, GMViewQuestInfo",
"0x94 0x9a, GMViewItemList",
"0x95 0x9b, GMViewWarehouseithdrawList",
"0x96 0x9c, ListPartyWating",
"0x97 0x9d, PartyRoomInfo (PartyMatchDetail)",
"0x98 0x9e, PlaySound",
"0x99 0x9f, StaticObject",
"0x9a 0xa0, PrivateStoreMangeListSell",
"0x9b 0xa1, PrivateStoreList",
"0x9c 0xa2, PrivateStoreMsg",
"0x9d 0xa3, ShowMinimap",
"0x9e 0xa4, ReviveRequest",
"0x9f 0xa5, AbnormalVisualEfect",
"0xa0 0xa6, TutorialShowHtml",
"0xa1 0xa7, TutorialShowQuestionMark",
"0xa2 0xa8, TutorialEnableCientEvent",
"0xa3 0xa9, TutorialCloseHtml",
"0xa4 0xaa, ShowRadar",
"0xa5 0xb8, DeleteRadar",
"0xa6 0xb9, MyTargetSelected",
"0xa7 0xba, PartyMemberPosition",
"0xa8 0xbb, AskJoinAlliance",
"0xa9 0xbc, JoinAlliance",
"0xaa 0xab, WithdrawAlliance",
"0xab 0xac, OustAllianceMemerPledge",
"0xac 0xad, DismissAlliance",
"0xad 0xae, SetAllianceCrest",
"0xae 0xaf, AllianceCrest",
"0xaf 0xb0, ServerCloseSocket",
"0xb0 0xb1, PetStatusShow",
"0xb1 0xb2, PetInfo",
"0xb2 0xb3, PetItemList",
"0xb3 0xb4, PetInventoryUpdate",
"0xb4 0xb5, AllianceInfo",
"0xb5 0xb6, PetStatusUpdate",
"0xb6 0xb7, PetDelete",
"0xb7 0xbd, PrivateStoreBuyManageList",
"0xb8 0xbe, PrivateStoreBuyList",
"0xb9 0xbf, PrivateStoreBuyMsg",
"0xba 0xc0, VehicleStart",
"0xbb 0xc1, RequestTimeCheck",
"0xbc 0xc2, StartAllianceWar",
"0xbd 0xc3, ReplyStartAlliaceWar",
"0xbe 0xc4, StopAllianceWar",
"0xbf 0xc5, ReplyStopAllianeWar",
"0xc0 0xc6, SurrenderAllianeWar",
"0xc1 0xc7, SkillCoolTime",
"0xc2 0xc8, PackageToList",
"0xc3 0xd2, PackageSendableList",
"0xc4 0xd3, EarthQuake",
"0xc5 0xd4, FlyToLoaction",
"0xc6 0xd5, BlockList",
"0xc7 0xd6, SpecialCamera",
"0xc8 0xd7, NormalCamera",
"0xc9 0xc9, CastleSiegeInfo",
"0xca 0xca, CastleSiegeAttakerList",
"0xcb 0xcb, CastleSiegeDefederList",
"0xcc 0xcc, NickNameChanged",
"0xcd 0xcd, PledgeStatusChaged",
"0xce 0xce, RelationChanged",
"0xcf 0xcf, EventTrigger",
"0xd0 0xd0, MultiSellList",
"0xd1 0xd1, SetSummonRemainTime",
"0xd2 0xd8, SkillRemainSec",
"0xd3 0xd9, NetPing",
"0xd4 0xda, Dice",
"0xd5 0xdb, Snoop",
"0xd6 0xdc, RecipeBookItemList",
"0xd7 0xdd, RecipeItemMakeInfo",
"0xd8 0xde, RecipeShopManagList",
"0xd9 0xdf, RecipeShopSellList",
"0xda 0xe0, RecipeShopItemInfo",
"0xdb 0xe1, RecipeShopMsg",
"0xdc 0xe2, ShowCalc",
"0xdd 0xe3, MonRaceInfo",
"0xde 0xea, ShowTownMap",
"0xdf 0xeb, ObserverStart",
"0xe0 0xec, ObserverEnd",
"0xe1 0xed, ChairSit",
"0xe2 0xee, HennaEquipList",
"0xe3 0xe4, HennaItemInfo",
"0xe4 0xe5, HennaInfo",
"0xe5 0xe6, HennaUnequipList",
"0xe6 0xe7, HennaUnequipInfo",
"0xe7 0xe8, MacroList",
"0xe8 0xe9, BuyListSeed",
"0xe9 0xef, SellListProcure",
"0xea 0xf0, GMHennaInfo",
"0xeb 0xf1, RadarControl",
"0xec 0xf2, ClientSetTime",
"0xed 0xf3, ConfirmDlg",
"0xee 0xf4, PartySpelled",
"0xef 0xf5, ShopPreviewList",
"0xf0 0xf6, ShopPreviewInfo",
"0xf1 0xf7, CameraMode",
"0xf2 0xf8, ShowXMasSeal",
"0xf3 0xf9, EtcStatusUpdate",
"0xf4 0xfa, ShortBuffStatusUpdate",
"0xf5 0xfb, SSQStatus",
"0xf6 0xfc, PetitionVote",
"0xf7 0xfd, AgitDecoInfo",
"0xf8 0x73, SSQInfo",
"0xf9 0x74, GameGuardQuery",
"0xfa 0x75, L2FriendList",
"0xfb 0x76, L2Friend",
"0xfc 0x77, L2FriendStatus",
"0xfd 0x78, L2FriendSay",
"0xfe 0xFE,  UserEx"
"0xff 0xFF  ???"
};


static const char* servToClientExTXT[0x100] =
{
"0x0 0x00,ExDummy",
"0x1 0x01, ExRegenMax",
"0x2 0x0D, ExEventMatchList",
"0x3 0x0E, ExEventMatchObserver",
"0x4 0x0F, ExEventMatchMessage",
"0x5 0x10, ExEventMatchScore",
"0x6 0x1C, ExEventMatchTeamInfo",
"0x7 0x1D, ExEventMatchCreate",
"0x8 0x02, ExEventMatchUserInfo",
"0x9 0x03, ExColosseumFenceInfo",
"0xa 0x04, ExEventMatchSpelledInfo",
"0xb 0x05, ExEventMatchFirecracker",
"0xc 0x06, ExEventMatchTeamUnlocked",
"0xd 0x07, ExEventMatchGMTest",
"0xe 0x08, ExPartyRoomMember",
"0xf 0x09, ExClosePartyRoom",
"0x10 0x0A, ExManagePartyRoomMember",
"0x11 0x0B, ExEventMatchLockResult",
"0x12 0x0C, ExAutoSoulShot",
"0x13 0x1E, ExFishingStart",
"0x14 0x1F, ExFishingEnd",
"0x15 0x27, ExFishingStartCombat",
"0x16 0x28, ExHpRegen",
"0x17 0x29, ExEnchantSkillList",
"0x18 0x2A, ExEnchantSkillInfo",
"0x19 0x20, ExShowQuestInfo",
"0x1a 0x21, ExShowQuestMark",
"0x1b 0x22, ExSendManorList",
"0x1c 0x23, ExSendSeedInfo",
"0x1d 0x24, ExSendCropInfo",
"0x1e 0x25, ExShowManorDefaultInfo",
"0x1f 0x26, ExShowSeedSetting",
"0x20 0x2B, ExShowCropSetting",
"0x21 0x2C, ExShowSellCropList",
"0x22 0x78, ExShowProcureCropDetail",
"0x23 0x79, ExHeroList",
"0x24 0x11, ExServerPrimitive",
"0x25 0x12, ExOpenMultiPartyCommandChannelMPCC",
"0x26 0x13, ExCloseMultiPartyCommandChannelMPCC",
"0x27 0x1A, ExAskJoinMultiPartyCommandChannelMPCC",
"0x28 0x1B, ExPledgeCrestLarge",
"0x29 0x7A, ExOlympiadUserInfo",
"0x2a 0x7B, ExOlympiadSpelledInfo",
"0x2b 0x7C, OlympiadMode",
"0x2c 0x2D, OlympiadMatchEnd",
"0x2d 0x2E, ExMailArrived",
"0x2e 0x2F, ExStorageMaxCount",
"0x2f 0x30, ExEventMatchManage",
"0x30 0x31, ExMultiPartyCommandChannelMPCCInfo",
"0x31 0x32, ExPCCafePointInfoPacket",
"0x32 0x33, ExSetCompassZoneCode",
"0x33 0x34, ExGetBossRecord",
"0x34 0x35, ExAskJoinPartyRoom",
"0x35 0x36, ExListPartyMatchingWaitingRoom",
"0x36 0x37, ExSetMultiPartyCommandChannelMPCCRouting",
"0x37 0x38, ExShowAdventurerGuideBook",
"0x38 0x39, ExShowScreenMessage",
"0x39 0x3a, PledgeSkillListPacket",
"0x3a 0x3b, PledgeSkillListAddPacket",
"0x3b 0x3c, PledgePowerGrade",
"0x3c 0x3d, PledgePowerInfo",
"0x3d 0x3e, PledgeMemberInfo", 
"0x3e 0x3f, PledgeWarList",
"0x3f 0x40, SubPledgeCreated",
"0x40 0x41, ExRedSkyPacket",
"0x41 0x42, PledgeReceiveUpdatePower",
"0x42 0x43, FlySelfDestinationPacket",
"0x43 0x44, ShowPCCafeCouponShowUI",
"0x44 0x45, ExSearchOrc",
"0x45 0x46, Cursedweaponlist",
"0x46 0x47, CursedWeaponLocation",
"0x47 0x48, ExRestartClient",
"0x48 0x49, RequestHackShield",
"0x49 0x4a, ExUseSharedGroupItem",
"0x4a 0x4b, ExMultiPartyCommandChannelMPCCShowPartyMemberInfo",
"0x4b 0x4c, ExDuelAskStart",
"0x4c 0x4d, ExDuelReady",
"0x4d 0x4e, ExDuelStart",
"0x4e 0x4f, ExDuelEnd",
"0x4f 0x50, ExDuelUpdateUserInfo",
"0x50 0x51, ExShowVariationMakeWindow",
"0x51 0x52, ExShowVariationCancelWindow",
"0x52 0x53, ExPutItemResultForVariationMake",
"0x53 0x54, ExPutIntensiveResultForVariationMake",
"0x54 0x55, ExPutCommissionResultForVariationMake",
"0x55 0x56, ExVariationResult",
"0x56 0x57, ExPutItemResultForVariationCancel",
"0x57 0x58, ExVariationCancelResult",
"0x58 59, ExDuelEnemyRelation",
"0x59 5a, ExPlayAnimation!!!!!!!!!!!!!!!",
"0x5a 5b, ExMultiPartyCommandChannelMPCCPartyInfoUpdate",
"0x5b 5c, ExPlayScene!!!!!!!!!!",
"0x5c 5d, ExSpawnEmitterPacket",
"0x5d 5e, ExEnchantSkillInfoDetailPacket",
"0x5e 5f, ExBasicActionList",
//ct1 packets
"0x5f, 18 PartySummonAdd",
"60, ExAirShipInfo",
"61, ExAttributeEnchantResultPacket",
"62, ExChooseInventoryAttributeItemPacket",
"63, ExGetOnAirShipPacket",
"64, ExGetOffAirShipPacket",
"65, ExMoveToLocationAirShipPacket",
"66, ExStopMoveAirShipPacket",
"67, ShowTrace",
"68  ExItemAuctionInfoPacket",
"69  ExNeedToChangeName",
"6a  ExPartyPetWindowDelete",
"6b  ExTutorialList",
"6c  ExRpItemLink",
"6d  ExMoveToLocationInAirShipPacket",
"6e  ExStopMoveInAirShipPacket",
"6f  ExValidateLocationInAirShipPacket",
"70  ExUISettingPacket",
"71  ExMoveToTargetInAirShipPacket",
"72  ExAttackInAirShipPacket",
"73  ExMagicSkillUseInAirShipPacket",
"74  ExShowBaseAttributeCancelWindow",
"75  ExBaseAttributeCancelResult",
"76  ExSubPledgetSkillAdd",
"77  ExResponseFreeServer",
"78  ExShowProcureCropDetailPacket",
"0x23 79  ExHeroListPacket",
"0x29 7a  ExOlympiadUserInfoPacket",
"0x2a 7b  ExOlympiadSpelledInfoPacket",
"0x2b 7c  ExOlympiadModePacket",
"0x7d",
"0x7e",
"0x7f",
"0x80",
"0x81",
"0x82",
"0x83",
"0x84",
"0x85",
"0x86",
"0x87",
"0x88",
"0x89",
"0x8a",
"0x8b",
"0x8c",
"0x8d",
"0x8e",
"0x8f",
"0x90",
"0x91",
"0x92",
"0x93",
"0x94",
"0x95",
"0x96",
"0x97",
"0x98",
"0x99",
"0x9a",
"0x9b",
"0x9c",
"0x9d",
"0x9e",
"0x9f",
"0xa0",
"0xa1",
"0xa2",
"0xa3",
"0xa4",
"0xa5",
"0xa6",
"0xa7",
"0xa8",
"0xa9",
"0xaa",
"0xab",
"0xac",
"0xad",
"0xae",
"0xaf",
"0xb0",
"0xb1",
"0xb2",
"0xb3",
"0xb4",
"0xb5",
"0xb6",
"0xb7",
"0xb8",
"0xb9",
"0xba",
"0xbb",
"0xbc",
"0xbd",
"0xbe",
"0xbf",
"0xc0",
"0xc1",
"0xc2",
"0xc3",
"0xc4",
"0xc5",
"0xc6",
"0xc7",
"0xc8",
"0xc9",
"0xca",
"0xcb",
"0xcc",
"0xcd",
"0xce",
"0xcf",
"0xd0",
"0xd1",
"0xd2",
"0xd3",
"0xd4",
"0xd5",
"0xd6",
"0xd7",
"0xd8",
"0xd9",
"0xda",
"0xdb",
"0xdc",
"0xdd",
"0xde  ExMaxLimitCount",
"0xdf",
"0xe0",
"0xe1",
"0xe2",
"0xe3",
"0xe4",
"0xe5",
"0xe6",
"0xe7",
"0xe8",
"0xe9",
"0xea",
"0xeb",
"0xec",
"0xed",
"0xee",
"0xef",
"0xf0",
"0xf1",
"0xf2",
"0xf3",
"0xf4",
"0xf5",
"0xf6",
"0xf7",
"0xf8",
"0xf9",
"0xfa",
"0xfb",
"0xfc",
"0xfd",
"0xfe",
"0xff"
};


static const char* servToClientExTXT_GF[0x159] =
{
"0xfe:0x00 :: ExDummyPacket :: maybe trigger"
,"0xfe:0x01 :: ExRegenMaxPacket ::  dccSS dddf"
,"0xfe:0x02 :: ExEventMatchUserInfoPacket ::  ddd dhd dSdddddddd"
,"0xfe:0x03 :: ExColosseumFenceInfoPacket ::  ddddddd"
,"0xfe:0x04 :: ExEventMatchSpelledInfoPacket ::  dc ddd dhd"
,"0xfe:0x05 :: ExEventMatchFirecrackerPacket ::  dddddcc"
,"0xfe:0x06 :: ExEventMatchTeamUnlockedPacket ::  dd dSddddd dc"
,"0xfe:0x07 :: ExEventMatchGMTestPacket :: maybe trigger"
,"0xfe:0x08 :: ExPartyRoomMemberPacket ::  ddSddddd dd dSddddd"
,"0xfe:0x09 :: ExClosePartyRoomPacket :: maybe trigger"
,"0xfe:0x0a :: ExManagePartyRoomMemberPacket ::  dd ddSddddd"
,"0xfe:0x0b :: ExEventMatchLockResult :: maybe trigger"
,"0xfe:0x0c :: ExAutoSoulShot ::  dd dd dd"
,"0xfe:0x0d :: ExEventMatchListPacket :: maybe trigger"
,"0xfe:0x0e :: ExEventMatchObserverPacket ::  cS dccSS"
,"0xfe:0x0f :: ExEventMatchMessagePacket ::  ddd cS"
,"0xfe:0x10 :: ExEventMatchScorePacket ::  dcd dSdddddddddd ddd"
,"0xfe:0x11 :: ExServerPrimitivePacket :: maybe trigger"
,"0xfe:0x12 :: ExOpenMPCCPacket :: maybe trigger"
,"0xfe:0x13 :: ExCloseMPCCPacket :: maybe trigger"
,"0xfe:0x14 :: ExShowCastleInfo ::  dSdd dSdd"
,"0xfe:0x15 :: ExShowFortressInfo ::  dSSd dSdd"
,"0xfe:0x16 :: ExShowAgitInfo ::  ddd dSSd"
,"0xfe:0x17 :: ExShowFortressSiegeInfo ::  ddd ddd"
,"0xfe:0x18 :: ExPartyPetWindowAdd ::  ddddSddddd ddddSddddd"
,"0xfe:0x19 :: ExPartyPetWindowUpdate ::  dddS ddddSddddd"
,"0xfe:0x1a :: ExAskJoinMPCCPacket ::  ddd Sd"
,"0xfe:0x1b :: ExPledgeEmblem ::  dhd cdSddddd"
,"0xfe:0x1c :: ExEventMatchTeamInfoPacket ::  dcd dSdddddddddd"
,"0xfe:0x1d :: ExEventMatchCreatePacket ::  dSdddddddd"
,"0xfe:0x1e :: ExFishingStartPacket ::  dddcccdc dddccc"
,"0xfe:0x1f :: ExFishingEndPacket ::  dddccc dc"
,"0xfe:0x20 :: ExShowQuestInfoPacket :: maybe trigger"
,"0xfe:0x21 :: ExShowQuestMarkPacket ::  dS"
,"0xfe:0x22 :: ExSendManorListPacket ::  Sd"
,"0xfe:0x23 :: ExShowSeedInfoPacket ::  cddd dQQQcdc"
,"0xfe:0x24 :: ExShowCropInfoPacket ::  cd ddddc"
,"0xfe:0x25 :: ExShowManorDefaultInfoPacket ::  dd ddc ddddQQQQ"
,"0xfe:0x26 :: ExShowSeedSettingPacket ::  dd ddc ddddQQcQQc"
,"0xfe:0x27 :: ExFishingStartCombatPacket ::  dddcccdc dddccc"
,"0xfe:0x28 :: ExFishingHpRegenPacket ::  cddd dQQQdc dddcccdc"
,"0xfe:0x29 :: ExEnchantSkillListPacket ::  ddddd dd dd"
,"0xfe:0x2a :: ExEnchantSkillInfoPacket ::  dd dddddd dd"
,"0xfe:0x2b :: ExShowCropSettingPacket ::  dd dddc dQQcQ"
,"0xfe:0x2c :: ExShowSellCropListPacket ::  dd dQQc"
,"0xfe:0x2d :: ExOlympiadMatchEndPacket :: maybe trigger"
,"0xfe:0x2e :: ExMailArrivedPacket :: maybe trigger"
,"0xfe:0x2f :: ExStorageMaxCountPacket ::  dccScScd ccdSdd"
,"0xfe:0x30 :: ExEventMatchManagePacket ::  Sddd Sdd dccScScd ccdSdd"
,"0xfe:0x31 :: ExMultiPartyCommandChannelInfoPacket ::  ddcdcd Sddd Sdd"
,"0xfe:0x32 :: ExPCCafePointInfoPacket ::  ddcdcd"
,"0xfe:0x33 :: ExSetCompassZoneCode ::  ddd ddd"
,"0xfe:0x34 :: ExGetBossRecord ::  SS ddd ddd"
,"0xfe:0x35 :: ExAskJoinPartyRoom ::  Sdddd SS"
,"0xfe:0x36 :: ExListPartyMatchingWaitingRoom ::  Sdddd"
,"0xfe:0x37 :: ExSetMpccRouting :: maybe trigger"
,"0xfe:0x38 :: ExShowAdventurerGuideBook :: maybe trigger"
,"0xfe:0x39 :: ExShowScreenMessage ::  ddddd dddddddddddSSSSS"
,"0xfe:0x3a :: PledgeSkillListPacket ::  dd dd"
,"0xfe:0x3b :: PledgeSkillListAddPacket ::  dd dd"
,"0xfe:0x3c :: PledgePowerGradeList ::  dSd dd"
,"0xfe:0x3d :: PledgeReceivePowerInfo ::  dSSdSS dSd"
,"0xfe:0x3e :: PledgeReceiveMemberInfo ::  dd Sddd dSSdSS"
,"0xfe:0x3f :: PledgeReceiveWarList ::  ddSS dd Sddd"
,"0xfe:0x40 :: PledgeReceiveSubPledgeCreated ::  dSSd ddSS"
,"0xfe:0x41 :: ExRedSkyPacket :: maybe trigger"
,"0xfe:0x42 :: PledgeReceiveUpdatePower :: maybe trigger"
,"0xfe:0x43 :: FlySelfDestinationPacket :: maybe trigger"
,"0xfe:0x44 :: ShowPCCafeCouponShowUI :: maybe trigger"
,"0xfe:0x45 :: ExSearchOrc :: maybe trigger"
,"0xfe:0x46 :: ExCursedWeaponList ::  dcdS ddddd"
,"0xfe:0x47 :: ExCursedWeaponLocation ::  dcdS ddddd"
,"0xfe:0x48 :: ExRestartClient :: maybe trigger"
,"0xfe:0x49 :: ExRequestHackShield :: maybe trigger"
,"0xfe:0x4a :: ExUseSharedGroupItem ::  Sdd dddd"
,"0xfe:0x4b :: ExMPCCShowPartyMemberInfo ::  ddS Sdd"
,"0xfe:0x4c :: ExDuelAskStart ::  Sd"
,"0xfe:0x4d :: ExDuelReady :: maybe trigger"
,"0xfe:0x4e :: ExDuelStart ::  Sddddddddd"
,"0xfe:0x4f :: ExDuelEnd ::  ddd Sddddddddd"
,"0xfe:0x50 :: ExDuelUpdateUserInfo ::  ddd Sddddddddd"
,"0xfe:0x51 :: ExShowVariationMakeWindow :: maybe trigger"
,"0xfe:0x52 :: ExShowVariationCancelWindow :: maybe trigger"
,"0xfe:0x53 :: ExPutItemResultForVariationMake ::  dddQd ddd"
,"0xfe:0x54 :: ExPutIntensiveResultForVariationMake ::  ddQQd dddQd"
,"0xfe:0x55 :: ExPutCommissionResultForVariationMake ::  ddd ddQQd"
,"0xfe:0x56 :: ExVariationResult ::  ddddQd ddd"
,"0xfe:0x57 :: ExPutItemResultForVariationCancel ::  ddddQd"
,"0xfe:0x58 :: ExVariationCancelResult ::  ddddd dS"
,"0xfe:0x59 :: ExDuelEnemyRelation :: maybe trigger"
,"0xfe:0x5a :: ExPlayAnimation ::  dcdS"
,"0xfe:0x5b :: ExMPCCPartyInfoUpdate ::  Sd Sddd"
,"0xfe:0x5c :: ExPlayScene ::  Sddd"
,"0xfe:0x5d :: ExSpawnEmitterPacket ::  ddddddd dddddddddcdd ddd"
,"0xfe:0x5e :: ExEnchantSkillInfoDetailPacket ::  dd dddddd dd"
,"0xfe:0x5f :: ExBasicActionList ::  dddddddd ddddddddddddddddd"
,"0xfe:0x60 :: ExBasicActionList Lindvior /or ExAirShipInfo" // ::  Qd dddddddd ddddddddddddddddd"
,"0xfe:0x61 :: ExAttributeEnchantResultPacket ::  hdh ddd"
,"0xfe:0x62 :: ExChooseInventoryAttributeItemPacket :: maybe trigger"
,"0xfe:0x63 :: ExGetOnAirShipPacket ::  SSSSS ddddd ddddd"
,"0xfe:0x64 :: ExGetOffAirShipPacket ::  dd Sd SSSSS ddddd"
,"0xfe:0x65 :: ExMoveToLocationAirShipPacket ::  ddddd ddddd ddddddd"
,"0xfe:0x66 :: ExStopMoveAirShipPacket ::  ddddd ddddd ddddd ddddd ddddd"
,"0xfe:0x67 :: ExShowTracePacket ::  dQ hdh"
,"0xfe:0x68 :: ExItemAuctionInfoPacket ::  ddddddd cdQd Qd"
,"0xfe:0x69 :: ExNeedToChangeName ::  dSdd ddS"
,"0xfe:0x6a :: ExPartyPetWindowDelete ::  dddS"
,"0xfe:0x6b :: ExTutorialList ::  Sddd"
,"0xfe:0x6c :: ExRpItemLink ::  ddddddd dddddddddcdd ddd"
,"0xfe:0x6d :: ExMoveToLocationInAirShipPacket ::  dddddd dddddd dddddd dddddddd"
,"0xfe:0x6e :: ExStopMoveInAirShipPacket :: maybe trigger"
,"0xfe:0x6f :: ExValidateLocationInAirShipPacket :: maybe trigger"
,"0xfe:0x70 :: ExUISettingPacket ::  dd dSSS"
,"0xfe:0x71 :: ExMoveToTargetInAirShipPacket ::  ddddddd ddddddd"
,"0xfe:0x72 :: ExAttackInAirShipPacket ::  ddd dd ddcdddddddh dddd"
,"0xfe:0x73 :: ExMagicSkillUseInAirShipPacket ::  hdccc ddd"
,"0xfe:0x74 :: ExShowBaseAttributeCancelWindow ::  ddd dQ"
,"0xfe:0x75 :: ExBaseAttributeCancelResult ::  ddd ddd"
,"0xfe:0x76 :: ExSubPledgetSkillAdd ::  ddd"
,"0xfe:0x77 :: ExResponseFreeServer :: maybe trigger"
,"0xfe:0x78 :: ExShowProcureCropDetailPacket ::  Sdddd ddd ddd SdSdSdd"
,"0xfe:0x79 :: ExHeroListPacket ::  Sdddddd Sddddddd Sdddd ddd ddd"
,"0xfe:0x7a :: ExOlympiadUserInfoPacket ::  dd dhd"
,"0xfe:0x7b :: ExOlympiadSpelledInfoPacket ::  dd dhd"
,"0xfe:0x7c :: ExOlympiadModePacket :: maybe trigger"
,"0xfe:0x7d :: ExShowFortressMapInfo ::  ddddd Sdd Sdd ddd"
,"0xfe:0x7e :: ExPVPMatchRecord ::  dd ddddd Sdd Sdd"
,"0xfe:0x7f :: ExPVPMatchUserDie ::  ddddSddddd dd"
,"0xfe:0x80 :: ExPrivateStoreWholeMsg ::  dS"
,"0xfe:0x81 :: ExPutEnchantTargetItemResult ::  ddd"
,"0xfe:0x82 :: ExPutEnchantSupportItemResult ::  dd dd ddd"
,"0xfe:0x83 :: ExChangeNicknameNColor ::  dd ddddSdS"
,"0xfe:0x84 :: ExGetBookMarkInfoPacket ::  QdQdS dd ddddSdS"
,"0xfe:0x85 :: ExNotifyPremiumItem :: maybe trigger"
,"0xfe:0x86 :: ExGetPremiumItemListPacket ::  dd QdQdS"
,"0xfe:0x87 :: ExPeriodicItemList ::  dd Sd dd"
,"0xfe:0x88 :: ExJumpToLocation ::  dSd ddddddd"
,"0xfe:0x89 :: ExPVPMatchCCRecord ::  dd Sd"
,"0xfe:0x8a :: ExPVPMatchCCMyRecord ::  dddddd"
,"0xfe:0x8b :: ExPVPMatchCCRetire :: maybe trigger"
,"0xfe:0x8c :: ExShowTerritory ::  ddd dd"
,"0xfe:0x8d :: ExNpcQuestHtmlMessage ::  SSSSS SSSSS dSd"
,"0xfe:0x8e :: ExSendUIEventPacket ::  dddd SSSSS SSSSS"
,"0xfe:0x8f :: ExNotifyBirthDay ::  dSSSdddddddd dd"
,"0xfe:0x90 :: ExShowDominionRegistry ::  dSSd dSSSdddddddd dd"
,"0xfe:0x91 :: ExReplyRegisterDominion ::  dddd dddddd"
,"0xfe:0x92 :: ExReplyDominionInfo ::  dSSd"
,"0xfe:0x93 :: ExShowOwnthingPos ::  ddd dddd"
,"0xfe:0x94 :: ExCleftList ::  ddddd dd"
,"0xfe:0x95 :: ExCleftState ::  dddddSS"
,"0xfe:0x96 :: ExDominionChannelSet ::  dS dddS ddd ddd"
,"0xfe:0x97 :: ExBlockUpSetList ::  ddd dd dS dddS"
,"0xfe:0x98 :: ExBlockUpSetState ::  ddddd dddddd dd ddd"
,"0xfe:0x99 :: ExStartScenePlayer ::  Qh ddQhhhQhhhhhhhh"
,"0xfe:0x9a :: ExAirShipTeleportList ::  ddddddS dd ddddd"
,"0xfe:0x9b :: ExMpccRoomInfo ::  dd dSdddddS ddddddS"
,"0xfe:0x9c :: ExListMpccWaiting ::  ddSdddd dd dSdddddS"
,"0xfe:0x9d :: ExDissmissMpccRoom :: maybe trigger"
,"0xfe:0x9e :: ExManageMpccRoomMember ::  dd dSdddd ddSdddd"
,"0xfe:0x9f :: ExMpccRoomMember ::  dd dSdddd"
,"0xfe:0xa0 :: ExVitalityPointInfo ::  dddd"
,"0xfe:0xa1 :: ExShowSeedMapInfo ::  dddd"
,"0xfe:0xa2 :: ExMpccPartymasterList ::  ddd QQdddS"
,"0xfe:0xa3 :: ExDominionWarStart ::  ddddd"
,"0xfe:0xa4 :: ExDominionWarEnd :: maybe trigger"
,"0xfe:0xa5 :: ExShowLines ::  hdccc ddd"
,"0xfe:0xa6 :: ExPartyMemberRenamed ::  ddS dd ddd ddd"
,"0xfe:0xa7 :: ExEnchantSkillResult :: maybe trigger"
,"0xfe:0xa8 :: ExRefundList ::  Qh ddQhhhQhhhhhhhh"
,"0xfe:0xa9 :: ExNoticePostArrived :: maybe trigger"
,"0xfe:0xaa :: ExShowReceivedPostList ::  Qdd dd dSSddddddd ddSSddddddd"
,"0xfe:0xab :: ExReplyReceivedPost ::  dddddddddddddSSSd dddddSSSd dddSSSd Qdd"
,"0xfe:0xac :: ExShowSentPostList ::  dd dSSdddddd"
,"0xfe:0xad :: ExReplySentPost ::  dddSSSd Qd"
,"0xfe:0xae :: ExResponseShowStepOne ::  cS"
,"0xfe:0xaf :: ExResponseShowStepTwo ::  dS cS"
,"0xfe:0xb0 :: ExResponseShowContents :: maybe trigger"
,"0xfe:0xb1 :: ExShowPetitionHtml ::  dcS"
,"0xfe:0xb2 :: ExReplyPostItemList :: maybe trigger"
,"0xfe:0xb3 :: ExChangePostState ::  dd dd"
,"0xfe:0xb4 :: ExReplyWritePost ::  dh"
,"0xfe:0xb5 :: ExInitializeSeed :: maybe trigger"
,"0xfe:0xb6 :: ExRaidReserveResult ::  chd"
,"0xfe:0xb7 :: ExBuySellListPacket ::  Qddh dh"
,"0xfe:0xb8 :: ExCloseRaidSocket ::  dddddddSS"
,"0xfe:0xb9 :: ExPrivateMarketListPacket ::  dd dSddd dd"
,"0xfe:0xba :: ExRaidCharacterSelected ::  Qd"
,"0xfe:0xbb :: ExAskCoupleAction ::  ddddd dd"
,"0xfe:0xbc :: ExBrBroadcastEventState ::  dddddddSS"
,"0xfe:0xbd :: ExBR_LoadEventTopRankersPacket ::  Sd ddddd"
,"0xfe:0xbe :: ExChangeNPCState ::  dd dd"
,"0xfe:0xbf :: ExAskModifyPartyLooting ::  dd Sd"
,"0xfe:0xc0 :: ExSetPartyLooting ::  dd"
,"0xfe:0xc1 :: ExRotation ::  dd"
,"0xfe:0xc2 :: ExChangeClientEffectInfo ::  cQddcd cSdddddQd dd ddd"
,"0xfe:0xc3 :: ExMembershipInfo ::  dc dcd"
,"0xfe:0xc4 :: ExReplyHandOverPartyMaster ::  dc dcd"
,"0xfe:0xc5 :: ExQuestNpcLogList ::  ddddd dc dcd"
,"0xfe:0xc6 :: ExQuestItemListPacket ::  Sdh"
,"0xfe:0xc7 :: ExGMViewQuestItemListPacket ::  ddddd ddddd Sdh"
,"0xfe:0xc8 :: ExResartResponse ::  dd ddd"
,"0xfe:0xc9 :: ExVoteSystemInfoPacket ::  ddddd"
,"0xfe:0xca :: ExShuttuleInfoPacket ::  ddddd dddddd dddddddddd dd"
,"0xfe:0xcb :: ExSuttleGetOnPacket ::  ddddd ddddd"
,"0xfe:0xcc :: ExSuttleGetOffPacket ::  dddddd ddddd"
,"0xfe:0xcd :: ExSuttleMovePacket ::  dddddddd dddddd"
,"0xfe:0xce :: ExMTLInSuttlePacket ::  dddddd dddddddd"
,"0xfe:0xcf :: ExStopMoveInShuttlePacket ::  dddddd dddddd"
,"0xfe:0xd0 :: ExValidateLocationInShuttlePacket ::  ddddd dddddd"
,"0xfe:0xd1 :: ExAgitAuctionCmdPacket :: maybe trigger"
,"0xfe:0xd2 :: ExConfirmAddingPostFriend ::  dddSS cddQddQ SSQQQd Sd"
,"0xfe:0xd3 :: ExReceiveShowPostFriend ::  SSddddd dd dddSS cddQddQ SSQQQd"
,"0xfe:0xd4 :: ExReceiveOlympiadPacket :: maybe trigger"
,"0xfe:0xd5 :: ExBR_GamePointPacket ::  dhddddcccccdd dQd"
,"0xfe:0xd6 :: ExBR_ProductListPacket ::  ddd dddd dhddddcccccdd"
,"0xfe:0xd7 :: ExBR_ProductInfoPacket ::  ddd dddd"
,"0xfe:0xd8 :: ExBR_BuyProductPacket :: maybe trigger"
,"0xfe:0xd9 :: ExBR_PremiumStatePacket ::  dc"
,"0xfe:0xda :: ExBrExtraUserInfo :: maybe trigger"
,"0xfe:0xdb :: ExBrBuffEventState ::  dd dddd"
,"0xfe:0xdc :: ExBR_RecentProductListPacket ::  dddd dSd dhddddcccccdd"
,"0xfe:0xdd :: ExBR_MinigameLoadScoresPacket ::  dddd dddd dSd"
,"0xfe:0xde :: ExBR_AgathionEnergyInfoPacket ::  ddddd"
,"0xfe:0xdf :: ExShowChannelingEffectPacket ::  dd ddd dd ddd"
,"0xfe:0xe0 :: ExGetCrystalizingEstimation ::  dS SS SS dddd dd dQf"
,"0xfe:0xe1 :: ExGetCrystalizingFail :: maybe trigger"
,"0xfe:0xe2 :: ExNavitAdventPointInfoPacket ::  cd"
,"0xfe:0xe3 :: ExNavitAdventEffectPacket ::  dhddd cd"
,"0xfe:0xe4 :: ExNavitAdventTimeChangePacket ::  dh dhddd cd"
,"0xfe:0xe5 :: ExAbnormalStatusUpdateFromTargetPacket ::  dh dhddd"
,"0xfe:0xe6 :: ExStopScenePlayerPacket ::  dddddddddddddddddddd"
,"0xfe:0xe7 :: ExFlyMove ::  dddddddddd"
,"0xfe:0xe8 :: ExDynamicQuestPacket ::  Sdhh ccdd cdd cd ddd ddd Sddd"
,"0xfe:0xe9 :: ExSubjobInfo ::  df cddd dddc"
,"0xfe:0xea :: ExChangeMPCost ::  dSddhhddSddSccdS df"
,"0xfe:0xeb :: ExFriendDetailInfo ::  dSddhhddSddSccdS"
,"0xfe:0xec :: ExBlockAddResult :: maybe trigger"
,"0xfe:0xed :: ExBlockRemoveResult ::  SS"
,"0xfe:0xee :: ExBlockDefailInfo ::  dddShh"
,"0xfe:0xef :: ExLoadInzonePartyHistory ::  dddShh"
,"0xfe:0xf0 :: ExFriendNotifyNameChange :: maybe trigger"
,"0xfe:0xf1 :: ExShowCommission ::  ddQQd"
,"0xfe:0xf2 :: ExResponseCommissionItemList ::  dd"
,"0xfe:0xf3 :: ExResponseCommissionInfo ::  ddQQd"
,"0xfe:0xf4 :: ExResponseCommissionRegister :: maybe trigger"
,"0xfe:0xf5 :: ExResponseCommissionDelete ::  ddQ"
,"0xfe:0xf6 :: ExResponseCommissionList ::  cd QQd"
,"0xfe:0xf7 :: ExResponseCommissionBuyInfo ::  cd"
,"0xfe:0xf8 :: ExResponseCommissionBuyItem ::  dd"
,"0xfe:0xf9 :: ExAcquirableSkillListByClass ::  dd ddddddddffd dd"
,"0xfe:0xfa :: ExMagicAttackInfo ::  dd"
,"0xfe:0xfb :: ExAcquireSkillInfo ::  ddQQ"
,"0xfe:0xfc :: ExNewSkillToLearnByLevelUp :: maybe trigger"
,"0xfe:0xfd :: ExCallToChangeClass ::  dd"
,"0xfe:0xfe :: ExChangeToAwakenedClass :: maybe trigger"
,"0xfe:0xff :: ExTacticalSign ::  dd"
,"0xfe:0x100 :: ExLoadStatWorldRank ::  dd hdSQhdd hdSQhdd"
,"0xfe:0x101 :: ExLoadStatUser ::  ddQQ"
,"0xfe:0x102 :: ExLoadStatHotLink ::  dQdd dQd dS ddQdd ddQd"
,"0xfe:0x103 :: ExWaitWaitingSubStituteInfo ::  dd ddddddd"
,"0xfe:0x104 :: ExRegistWaitingSubstituteOk ::  dd dd"
,"0xfe:0x105 :: ExRegistPartySubstitute ::  dd"
,"0xfe:0x106 :: ExDeletePartySubstitute ::  dd"
,"0xfe:0x107 :: ExTimeOverPartySubstitute ::  dc"
,"0xfe:0x108 :: ExGet24HzSessionID :: maybe trigger"
,"0xfe:0x109 :: Ex2NDPasswordCheckPacket ::  dd dd"
,"0xfe:0x10a :: Ex2NDPasswordVerifyPacket ::  cdd dd"
,"0xfe:0x10b :: Ex2NDPasswordAckPacket ::  cdd"
,"0xfe:0x10c :: ExFlyMoveBroadcast ::  dddddddddd"
,"0xfe:0x10d :: ExShowUsmPacket ::  cddd dddc"
,"0xfe:0x10e :: ExShowStatPage :: maybe trigger"
,"0xfe:0x10f :: ExIsCharNameCreatable :: maybe trigger"
,"0xfe:0x110 :: ExGoodsInventoryChangedNotiPacket ::  QcSdQ QdSSQccSSh dd"
,"0xfe:0x111 :: ExGoodsInventoryInfoPacket ::  QcSdQ QdSSQccSSh dd"
,"0xfe:0x112 :: ExGoodsInventoryResultPacket ::  ddd"
,"0xfe:0x113 :: ExAlterSkillRequest ::  dSddd ddd"
,"0xfe:0x114 :: ExNotifyFlyMoveStart :: maybe trigger"
,"0xfe:0x115 :: ExDummyPacket :: maybe trigger"
,"0xfe:0x116 :: ExCloseCommission :: maybe trigger"
,"0xfe:0x117 :: ExChangeAttributeItemList ::  dddddd dddddddddd dd"
,"0xfe:0x118 :: ExChangeAttributeInfo ::  ddd"
,"0xfe:0x119 :: ExChangeAttributeOk :: maybe trigger"
,"0xfe:0x11a :: ExChangeAttributeFail :: maybe trigger"
,"0xfe:0x11b :: ExExchangeSubstitute ::  dQd"
,"0xfe:0x11c :: ExLightingCandleEvent :: maybe trigger"
,"0xfe:0x11d :: ExVitalityEffectInfo ::  dd dddd"
,"0xfe:0x11e :: ExLoginVitalityEffectInfo ::  dddd dd"
,"0xfe:0x11f :: ExBR_PresentBuyProductPacket ::  dc"
,"0xfe:0x120 :: ExMentorList ::  Sdd"
,"0xfe:0x121 :: ExMentorAdd ::  dd"
//,"0xfe:0x122 :: ExChoose_Shape_Shifting_Item ::  dd"
//,"0xfe:0x123 :: ExPut_Shape_Shifting_Target_Item_Result :: maybe trigger"
//,"0xfe:0x124 :: ExPut_Shape_Shifting_Extraction_Item_Result ::  ddd"
//,"0xfe:0x125 :: ExShape_Shifting_Result ::  ddd"
//,"0xfe:0x126 :: ExCheck_SpeedHack :: maybe trigger"
,"0xfe:0x122 :: ListMenteeWaitingPacket ::" //  dddddSddddQfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddcccddhhddddccdccddhhhhhhhhdd ddd Sdd
,"0xfe:0x123 :: ExInzoneWaitingInfo ::  dd dd"
,"0xfe:0x124 :: ExCuriousHouseState ::  dSdddd"
,"0xfe:0x125 :: ExCuriousHouseEnter :: maybe trigger"
,"0xfe:0x126 :: ExCuriousHouseLeave :: maybe trigger"
,"0xfe:0x127 :: ExCuriousHouseMemberList ::  ddddd"
,"0xfe:0x128 :: ExCuriousHouseMemberUpdate ::  ddddd"
,"0xfe:0x129 :: ExCuriousHouseRemainTime ::  hd Sddd"
,"0xfe:0x12a :: ExCuriousHouseResult ::  dShd"
,"0xfe:0x12b :: ExCuriousHouseObserveList ::  dShd"
,"0xfe:0x12c :: ExCuriousHouseObserveMode ::  dd"
,"0xfe:0x12d :: ExChoose_Shape_Shifting_Item ::  dd"
,"0xfe:0x12e :: ExPut_Shape_Shifting_Target_Item_Result :: maybe trigger"
,"0xfe:0x12f :: ExPut_Shape_Shifting_Extraction_Item_Result ::  ddd"
,"0xfe:0x130 :: ExShape_Shifting_Result ::  dd"
,"0xfe:0x131 :: ExCastleState ::  dd"
,"0xfe:0x132 :: ExNCGuardReceiveDataFromServer ::  maybe trigger"
//lidvior ex
,"0xFE:0x133: ExCastleState"
,"0xFE:0x134: ExNCGuardReceiveDataFromServer"
,"0xFE:0x135: ExKalieEvent"
,"0xFE:0x136: ExPledgeUnionState"
,"0xFE:0x137: ExPledgeUnionFlow"
,"0xFE:0x138: ExPledgeUnionStateInfo"
,"0xFE:0x139: ExUnionPoint"
,"0xFE:0x13A: ExKalieEventJackpotUser"
,"0xFE:0x13B: ExAbnormalVisualEffectInfo"
,"0xFE:0x13C: ExNpcSpeedInfo"
,"0xFE:0x13D: ExSetPledgeEmblemAck"
,"0xFE:0x13E: ExShowBeautyMenuPacket"
,"0xFE:0x14F: ExResponseBeautyListPacket"
,"0xFE:0x140: ExResponseBeautyRegistResetPacket"
,"0xFE:0x141: ExResponseResetListPacket"
,"0xFE:0x142: ExShuffleSeedAndPublicKey"
,"0xFE:0x143: ExCheck_SpeedHack"
,"0xFE:0x144: ExBR_NewIConCashBtnWnd"
,"0xFE:0x145: ExEvent_Campaign_Info"
,"0xFE:0x146: ExUnReadMailCount"
,"0xFE:0x147: ExPledgeCount"
,"0xFE:0x148: ExAdenaInvenCount"
,"0xFE:0x149: ExPledgeRecruitInfo"
,"0xFE:0x14A: ExPledgeRecruitApplyInfo"
,"0xFE:0x14B: ExPledgeRecruitBoardSearch"
,"0xFE:0x14C: ExPledgeRecruitBoardDetail"
,"0xFE:0x14D: ExPledgeWaitingListApplied"
,"0xFE:0x14E: ExPledgeWaitingList"
,"0xFE:0x15F: ExPledgeWaitingUser"
,"0xFE:0x150: ExPledgeDraftListSearch"
,"0xFE:0x151: ExPledgeWaitingListAlarm"
,"0xFE:0x152: ExValidateActiveCharacter"
,"0xFE:0x153: ExCloseCommissionRegister"
,"0xFE:0x154: ExTeleportToLocationActivate"
,"0xFE:0x155: ExNotifyWebPetitionReplyAlarm"
,"0xFE:0x156: ExEventShowXMasWishCard"
,"0xFE:0x157: ExInvitation_Event_UI_Setting"
,"0xFE:0x158: ExInvitation_Event_Ink_Energy"

};








static const BYTE servToClientEx[112] =
	{
	/*0*/	0x00, // ExDummy
	/*1*/	0x01, // ExRegenMax
	/*2*/	0x0D, // ExEventMatchList
	/*3*/	0x0E, // ExEventMatchObserver
	/*4*/	0x0F, // ExEventMatchMessage
	/*5*/	0x10, // ExEventMatchScore
	/*6*/	0x1C, // ExEventMatchTeamInfo
	/*7*/	0x1D, // ExEventMatchCreate
	/*8*/	0x02, // ExEventMatchUserInfo
	/*9*/	0x03, // ExColosseumFenceInfo
	/*a*/	0x04, // ExEventMatchSpelledInfo
	/*b*/	0x05, // ExEventMatchFirecracker
	/*c*/	0x06, // ExEventMatchTeamUnlocked
	/*d*/	0x07, // ExEventMatchGMTest
	/*e*/	0x08, // ExPartyRoomMember
	/*f*/	0x09, // ExClosePartyRoom
	/*10*/	0x0A, // ExManagePartyRoomMember
	/*11*/	0x0B, // ExEventMatchLockResult
	/*12*/	0x0C, // ExAutoSoulShot
	/*13*/	0x1E, // ExFishingStart
	/*14*/	0x1F, // ExFishingEnd
	/*15*/	0x27, // ExStartCombat
	/*16*/	0x28, // ExHpRegen
	/*17*/	0x29, // ExEnchantSkillList
	/*18*/	0x2A, // ExEnchantSkillInfo
	/*19*/	0x20, // ExShowQuestInfo
	/*1a*/	0x21, // ExShowQuestMark
	/*1b*/	0x22, // ExSendManorList
	/*1c*/	0x23, // ExSendSeedInfo
	/*1d*/	0x14, //AllCastle 0x24, // ExSendCropInfo
	/*1e*/	0x15, //Allfortress 0x25, // ExShowManorDefaultInfo
	/*1f*/	0x16, //Allagit 0x26, // ExShowSeedSetting
	/*20*/	0x2B, // ExShowCropSetting
	/*21*/	0x2C, // ExShowSellCropList
	/*22*/	0x78, // ExShowProcureCropDetail
	/*23*/	0x79, // ExHeroList
	/*24*/	0x11, // ExServerPrimitive
	/*25*/	0x12, // ExOpenMPCC
	/*26*/	0x13, // ExCloseMPCC
	/*27*/	0x1A, // ExAskJoinMPCC
	/*28*/	0x1B, // ExPledgeCrestLarge
	/*29*/	0x7A, // ExOlympiadUserInfo
	/*2a*/	0x7B, // ExOlympiadSpelledInfo
	/*2b*/	0x7C, // OlympiadMode
	/*2c*/	0x2D, // OlympiadMatchEnd
	/*2d*/	0x2E, // ExMailArrived
	/*2e*/	0x2F, // ExStorageMaxCount
	/*2f*/	0x30, // ExEventMatchManage
	/*30*/	0x31,  // ExMultiPartyCommandChannelInfo
	/*31*/	0x32,  // 
	/*32*/	0x33,  // 
	/*33*/	0x34,		//?? BossRecord
	/*34*/	0x35,  // 
	/*35*/	0x36,  // 
	/*36*/	0x37,  // 
	/*37*/	0x38,  // 
	/*38*/	0x39,		// Show Screen Message
	/*39*/	0x3a,  // 
	/*3a*/	0x3b,		//?? PledgeSetAcademyMaster
	/*3b*/	0x3c,		// PledgePowerGrade
	/*3c*/	0x3d,		// PledgePowerInfo
	/*3d*/	0x3e,		// PledgeMemberInfo 
	/*3e*/	0x3f,		// PledgeWarList
	/*3f*/	0x40,		// SubPledgeCreated
	/*40*/	0x41,  // 
	/*41*/	0x42,  // 
	/*42*/	0x43,  // 
	/*43*/	0x44,  // 
	/*44*/	0x45,  // 
	/*45*/	0x46,		// Cursedweaponlist
	/*46*/	0x47,		// CursedWeaponLocation
	/*47*/	0x48,  // 
	/*48*/	0x49,			// RequestHackShield
	/*49*/	0x4a,  // 
	/*4a*/	0x4b,  // 
	/*4b*/	0x4c,  // 
	/*4c*/	0x4d,  // 
	/*4d*/	0x4e,  // 
	/*4e*/	0x4f,  // 
	/*4f*/	0x50,  // 
	/*50*/	0x51,  // 
	/*51*/	0x52,  // 
	/*52*/	0x53,  // 
	/*53*/	0x54,  // 
	/*54*/	0x55,  // 
	/*55*/	0x56,  // 
	/*56*/	0x57,  // 
	/*57*/	0x58,  // 
	/*58*/	0x59,  // 
	/*59*/	0x5a,  // 
	/*5a*/	0x5b,  // 
	/*5b*/	0x5c,  // 
	/*5c*/	0x5d,			//SpawnEmiter
	/*5d*/	0x5e,  // 
	/*5e*/	0x5f,			// ExBasicActionList
	/*5f*/	0x18,  //partySummonAdd 
	/*60*/	0x60,  // 
	/*61*/	0x61,  // 
	/*62*/	0x62,  // 
	/*63*/	0x63,  // 
	/*64*/	0x64,  // 
	/*65*/	0x65,  // 
	/*66*/	0x66,   //
	/*67*/	0x67,   // ShowTrace
	/*68*/	0x68,   
	/*69*/	0x69,   
	/*6a*/	0x6a, //partySummonDel 

	/*6b*/	0x6b,    
	/*6c*/	0x6c,    
	/*6d*/	0x6d,    
	/*6e*/	0x6e,    
	/*6f*/	0x6f    
	};

	
	static BYTE servToClient[0x101] = 
	{
	/*0*/	0x00,//0x2E, // VersionCheck
	/*1*/	0x01,//0x2F, // MoveToLocation
	/*2*/	0x30, // NPC Say
	/*3*/	0x31, // CharInfo
	/*4*/	0x32, // User Info
	/*5*/	0x33, // Attack
	/*6*/	0x00, // Die
	/*7*/	0xEE, //use Hena packets for our needs  //0x01, // Revive
	/*8*/	0x02, // AttackOutOfRange
	/*9*/	0x03, // AttackInCoolTime
	/*a*/	0x04, // AttackDeadTarget
	/*b*/	0x05, // Spawn Item
	/*c*/	0x16, // Drop Item
	/*d*/	0x17, // Get Item
	/*e*/	0x18, // Status Update
	/*f*/	0x19, // NPC HTML Message
	/*10*/	0x06, // SellList
	/*11*/	0x07, // BuyList
	/*12*/	0x08, // DeleteObject
#ifdef	__KAMAEL_PACKETS_SEND__
	/*13*/	0xE5, //0x09, // CharacterSelectionInfo
#else
	/*13*/	0x09, // CharacterSelectionInfo
#endif
	/*14*/	0x0A, // LoginFail
	/*15*/	0x0b, // CharacterSelected
	/*16*/	0x0c, // NpcInfo
	/*17*/	0x0d, // NewCharacterSucess
	/*18*/	0x0e, // NewCharacterFail
	/*19*/	0x0f, // CharacterCreatesuccess
	/*1a*/	0x10, // CharacterCreateFail
	/*1b*/	0x11, // ItemList
	/*1c*/	0x12, // SunRise
	/*1d*/	0x13, // SunSet 2d
	/*1e*/	0x14, // TradeStart
	/*1f*/	0x15, // TradeStartOk
	/*20*/	0x1a, // TradeOwnAdd
	/*21*/	0x1b, // TradeOtherAdd
	/*22*/	0x1c, // TradeDone
	/*23*/	0x1d, // CharacterDeletesuccess
	/*24*/	0x1e, // CharacterDeleteFail
	/*25*/	0x1f, // ActionFail
	/*26*/	0x20, // SeverClose
	/*27*/	0x21, // InventoryUpdate
	/*28*/	0x22, // TeleportToLocaton
	/*29*/	0x23, // TargetSelected
	/*2a*/	0x24, // TargetUnselecte
	/*2b*/	0x25, // AutoAttackStart
	/*2c*/	0x26, // AutoAttackStop
	/*2d*/	0x27, // SocialAction
	/*2e*/	0x28, // ChangeMoveType
	/*2f*/	0x29, // ChangeWaitType
	/*30*/	0x2a, // ManagePledgePower
	/*31*/	0x2b, // CreatePledge
	/*32*/	0x2c, // AskJoinPledge
	/*33*/	0x2d, // JoinPledge
	/*34*/	0x34, // WithdrawalPledge
	/*35*/	0x35, // OustPledgeMembe
	/*36*/	0x36, // SetOustPledgeMeber
	/*37*/	0x37, // DismissPledge
	/*38*/	0x38, // SetDismissPledge
	/*39*/	0x39, // AskJoinParty
	/*3a*/	0x3a, // JoinParty
	/*3b*/	0x3b, // WithdrawalParty
	/*3c*/	0x3c, // OustPartyMember
	/*3d*/	0x3d, // SetOustPartyMemer
	/*3e*/	0x3e, // DismissParty
	/*3f*/	0x3f, // SetDismissParty
	/*40*/	0x40, // MagicAndSkillList
	/*41*/	0x41, // WareHouseDeposiList
	/*42*/	0x42, // WareHouseWithdrwList
	/*43*/	0x43, // WareHouseDone
	/*44*/	0x44, // ShortCutRegister
	/*45*/	0x45, // ShortCutInit
	/*46*/	0x46, // ShortCutDelete
	/*47*/	0x47, // StopMove
	/*48*/	0x48, // MagicSkillUse
	/*49*/	0x49, // MagicSkillCanceed
	/*4a*/	0x4a, // Say2
	/*4b*/	0x4b, // EquipUpdate
	/*4c*/	0x4c, // DoorInfo
	/*4d*/	0x4d, // DoorStatusUpdate
	/*4e*/	0x4e, // PartySmallWindowAll
	/*4f*/	0x4f, // PartySmallWindowAdd
	/*50*/	0x50, // PartySmallWindowDeleteAll
	/*51*/	0x51, // PartySmallWindowDelete
	/*52*/	0x52, // PartySmallWindowUpdate
	/*53*/	0x5a, // PledgeShowMembeListAll
	/*54*/	0x5b, // PledgeShowMembeListUpdate
	/*55*/	0x5c, // PledgeShowMembeListAdd
	/*56*/	0x5d, // PledgeShowMembeListDelete
	/*57*/	0x5e, // MagicList
	/*58*/	0x5f, // SkillList
	/*59*/	0x60, // VehicleInfo
	/*5a*/	0x6c, // VehicleDeparture
	/*5b*/	0x6d, // VehicleCheckLoction
	/*5c*/	0x6e, // GetOnVehicle
	/*5d*/	0x6f, // GetOffVehicle
	/*5e*/	0x70, // TradeRequest
	/*5f*/	0x71, // RestartResponse
	/*60*/	0x72, // MoveToPawn
	/*61*/	0x79, // ValidateLocation
	/*62*/	0x7a, // StartRotating
	/*63*/	0x61, // FinishRotating
	/*64*/	0x62, // SystemMessage
	/*65*/	0x63, // StartPledgeWar
	/*66*/	0x64, // ReplyStartPledgWar
	/*67*/	0x65, // StopPledgeWar
	/*68*/	0x66, // ReplyStopPledgeWar
	/*69*/	0x67, // SurrenderPledgeWar
	/*6a*/	0x68, // ReplySurrenderPedgeWar
	/*6b*/	0x69, // SetPledgeCrest
	/*6c*/	0x6a, // PledgeCrest
	/*6d*/	0x6b, // SetupGauge
	/*6e*/	0x7b, // ShowBoard
	/*6f*/	0x7c, // ChooseInventoryItem
	/*70*/	0x7d, // Dummy
	/*71*/	0x7e, // MoveToLocationIVehicle
	/*72*/	0x7f, // StopMoveInVehice
	/*73*/	0x80, // ValidateLocatioInVehicle
	/*74*/	0x81, // TradeUpdate
	/*75*/	0x53, // TradePressOwnOk
	/*76*/	0x54, // MagicSkillLaunced
	/*77*/	0x55, // FriendAddRequesResult
	/*78*/	0x56, // FriendAdd
	/*79*/	0x57, // FriendRemove
	/*7a*/	0x58, // FriendList
	/*7b*/	0x59, // FriendStatus
	/*7c*/	0x82, // TradePressOtherOk
	/*7d*/	0x83, // FriendAddRequest
	/*7e*/	0x84, // LogOutOk
	/*7f*/	0x85, // AbnormalStatusUdate
	/*80*/	0x86, // QuestList
	/*81*/	0x87, // EnchantResult
	/*82*/	0x88, // PledgeShowMembeListDeleteAll
	/*83*/	0x89, // PledgeInfo
	/*84*/	0x8a, // PledgeExtendedInfo
	/*85*/	0x8b, // SurrenderPersonlly
	/*86*/	0x8c, // Ride
	/*87*/	0x8d, // unk
	/*88*/	0x8e, // PledgeShowInfoUdate
	/*89*/	0x8f, // ClientAction
	/*8a*/	0x90, // AcquireSkillList
	/*8b*/	0x91, // AcquireSkillInfo
	/*8c*/	0x92, // ServerObjectInfo
	/*8d*/	0x93, // GMHide
	/*8e*/	0x94, // AcquireSkillDone
	/*8f*/	0x95, // GMViewCharacterInfo
	/*90*/	0x96, // GMViewPledgeInfo
	/*91*/	0x97, // GMViewSkillInfo
	/*92*/	0x98, // GMViewMagicInfo
	/*93*/	0x99, // GMViewQuestInfo
	/*94*/	0x9a, // GMViewItemList
	/*95*/	0x9b, // GMViewWarehouseithdrawList
	/*96*/	0x9c, // ListPartyWating
	/*97*/	0x9d, // PartyRoomInfo
	/*98*/	0x9e, // PlaySound
	/*99*/	0x9f, // StaticObject
	/*9a*/	0xa0, // PrivateStoreMangeListSell
	/*9b*/	0xa1, // PrivateStoreList
	/*9c*/	0xa2, // PrivateStoreMsg
	/*9d*/	0xa3, // ShowMinimap
	/*9e*/	0xa4, // ReviveRequest
	/*9f*/	0xa5, // AbnormalVisualEfect
	/*a0*/	0xa6, // TutorialShowHtml
	/*a1*/	0xa7, // TutorialShowQuestionMark
	/*a2*/	0xa8, // TutorialEnableCientEvent
	/*a3*/	0xa9, // TutorialCloseHtml
	/*a4*/	0xaa, // ShowRadar
	/*a5*/	0xb8, // DeleteRadar
	/*a6*/	0xb9, // MyTargetSelected
	/*a7*/	0xba, // PartyMemberPosition
	/*a8*/	0xbb, // AskJoinAlliance
	/*a9*/	0xbc, // JoinAlliance
	/*aa*/	0xab, // WithdrawAlliance
	/*ab*/	0xac, // OustAllianceMemerPledge
	/*ac*/	0xad, // DismissAlliance
	/*ad*/	0xae, // SetAllianceCrest
	/*ae*/	0xaf, // AllianceCrest
	/*af*/	0xb0, // ServerCloseSocket
	/*b0*/	0xb1, // PetStatusShow
	/*b1*/	0xb2, // PetInfo
	/*b2*/	0xb3, // PetItemList
	/*b3*/	0xb4, // PetInventoryUpdate
	/*b4*/	0xb5, // AllianceInfo
	/*b5*/	0xb6, // PetStatusUpdate
	/*b6*/	0xb7, // PetDelete
	/*b7*/	0xbd, // PrivateStoreBuyManageList
	/*b8*/	0xbe, // PrivateStoreBuyList
	/*b9*/	0xbf, // PrivateStoreBuyMsg
	/*ba*/	0xc0, // VehicleStart
	/*bb*/	0xc1, // RequestTimeCheck
	/*bc*/	0xc2, // StartAllianceWar
	/*bd*/	0xc3, // ReplyStartAlliaceWar
	/*be*/	0xc4, // StopAllianceWar
	/*bf*/	0xc5, // ReplyStopAllianeWar
	/*c0*/	0xc6, // SurrenderAllianeWar
	/*c1*/	0xc7, // SkillCoolTime
	/*c2*/	0xc8, // PackageToList
	/*c3*/	0xd2, // PackageSendableList
	/*c4*/	0xd3, // EarthQuake
	/*c5*/	0xd4, // FlyToLoaction
	/*c6*/	0xd5, // BlockList
	/*c7*/	0xd6, // SpecialCamera
	/*c8*/	0xd7, // NormalCamera
	/*c9*/	0xc9, // CastleSiegeInfo
	/*ca*/	0xca, // CastleSiegeAttakerList
	/*cb*/	0xcb, // CastleSiegeDefederList
	/*cc*/	0xcc, // NickNameChanged
	/*cd*/	0xcd, // PledgeStatusChaged
	/*ce*/	0xce, // RelationChanged
	/*cf*/	0xcf, // EventTrigger
	/*d0*/	0xd0, // MultiSellList
	/*d1*/	0xd1, // SetSummonRemainTime
	/*d2*/	0xd8, // SkillRemainSec
	/*d3*/	0xd9, // NetPing
	/*d4*/	0xda, // Dice
	/*d5*/	0xdb, // Snoop
	/*d6*/	0xdc, // RecipeBookItemList
	/*d7*/	0xdd, // RecipeItemMakeInfo
	/*d8*/	0xde, // RecipeShopManagList
	/*d9*/	0xdf, // RecipeShopSellList
	/*da*/	0xe0, // RecipeShopItemInfo
	/*db*/	0xe1, // RecipeShopMsg
	/*dc*/	0xe2, // ShowCalc
	/*dd*/	0xe3, // MonRaceInfo
	/*de*/	0xea, // ShowTownMap
	/*df*/	0xeb, // ObserverStart
	/*e0*/	0xec, // ObserverEnd
	/*e1*/	0xed, // ChairSit
	/*e2*/	0xee, // HennaEquipList
	/*e3*/	0xe4, // HennaItemInfo
	/*e4*/	0xe5, // HennaInfo
	/*e5*/	0xe6, // HennaUnequipList
	/*e6*/	0xe7, // HennaUnequipInfo
	/*e7*/	0xe8, // MacroList
	/*e8*/	0xe9, // BuyListSeed
	/*e9*/	0xef, // SellListProcure
	/*ea*/	0xf0, // GMHennaInfo
	/*eb*/	0xf1, // RadarControl
	/*ec*/	0xf2, // ClientSetTime
	/*ed*/	0xf3, // ConfirmDlg
	/*ee*/	0xf4, // PartySpelled
	/*ef*/	0xf5, // ShopPreviewList
	/*f0*/	0xf6, // ShopPreviewInfo
	/*f1*/	0xf7, // CameraMode
	/*f2*/	0xf8, // ShowXMasSeal
	/*f3*/	0xf9, // EtcStatusUpdate
	/*f4*/	0xfa, // ShortBuffStatusUpdate
	/*f5*/	0xfb, // SSQStatus
	/*f6*/	0xfc, // PetitionVote
	/*f7*/	0xfd, // AgitDecoInfo
	/*f8*/	0x73, // SSQInfo
	/*f9*/	0x74, // GameGuardQuery
	/*fa*/	0x75, // L2FriendList
	/*fb*/	0x76, // L2Friend
	/*fc*/	0x77, // L2FriendStatus
	/*fd*/	0x78, // L2FriendSay
	/*fe*/	0xFE,  // UserEx
	/*ff*/	0xFF,  // ???
	0
	};



	//-=================================================================
/*
//CHANGED SYSTEM MESSAGE
static const DWORD RemainTimeC2[8]=
{ //e1(c2) -> A3(C3)
0x00508be2,
0x00508bff,
0x00508c22,
0x00508c45,
0x00508c68,
0x00508c88,
0x00508ca8,
0x00508cc8
};
*/


static const DWORD C1OpcodePatch1[60]=
{
0x0049DEFB, // 01 broadcast moving to location
0x0049DE7A, // 01 broadcast moving to location
0x004A7E0B,	// 98 broadcast music
0x004A7B7C, // original c1: dd, BROADCAST EARTHQUAKE
0x00446Aca, // c5
0x00446c52, // 48
0x00446e72, // 2f
0x00446f88, // 2b
0x00447068, // 2c
0x00447386, // 48
0x004477d6, // 28
0x00447b2a, // 2d
0x00447cd2, // 2e
0x004481d5, // 29
0x004482f0, // 2a
0x004484d9, // 73 Validate Location in vehicle
0x004485cc, // 73 Validate Location in vehicle
0x00448649, // 61
0x004487aa, // 9f   
0x00448947, // 0e
0x004489a9, // 0e
0x0044f5d7, // 0e
0x0045012e, // 06
//0x00452287, // 07 revive
0x00481fb3, // 64
0x00482124, // 8c
0x004839ca, // 64
0x0048406e, // 5c Get On Vehicle
0x0048419d, // 5d Get Off Vehicle
0x0049152e, // 1c sunrise
0x00491567, // 1d sunset
0x0049e047, // 60
0x0049e22d, // 72 Stop Move In Vehicle
0x0049e39e, // 47
0x0049e6a3, // 48
0x0049e7bb, // 49
0x0049e931, // 76
0x0049ea73, // 05
0x0049ebf3, // 05
0x0049ef78, // 71 Move to location in vehicle
0x0049f402, // 71 Move to location in vehicle
0x0049f93f, // 48
0x004a0bd7, // 76
0x004f0b1f, // 4a
0x004f2f7b, // 06
0x0050ae0f, // 62
0x0050af21, // 63
0x0051a0b9, // 59 Vehicle Info
0x0051a12e, // 5a
0x0051c70e, // 4a
0x0051c860, // 98
0x00531bf7, // 60
0x0055a8bf, // 0d
//new c3 canges
//0x004A6F4F, //original c1: e0, new hexed c2: c7 WHY HEXED? NEED UN-HEX!!! see in patches
0x004A7CC8, // original c1: e0, new hexed c2: c7 OK - BROADCAST SPECIAL CAMERA
//new CT1 changes
0x00495e69, // 02 //ct1 NPCSay 6a026810655b00
0
};

//0x006B8DCB, // orifinal c1: bd (show radar) new Hexed c2: 5b (vehicle check location) WHY, maybe un-HEX
//0x006B8DE4, // orifinal c1: bd (show radar) new Hexed c2: 5b (vehicle check location) WHY, maybe un-HEX


/*
static BYTE C1OpcodeOriginal[0xEF]=
{
//  0x00,0x01,0x02,0x03,0x04,0xF0,0x05,0x05,0xFF,0xFF,0xFF,0x06,0x07,0x08,0x09,
0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,
//  0x0A,0xFF,0xFF,0xFF,0xF0,0xF0,0x0B,0x0C,0x0D,0xFF,0xFF,0x0E,0x0F,0x10,0x11,0x12,
0x0f, 0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,
//  0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,0x1B,0x1C,0x1D,0xF0,0xF0,0xF0,0xF0,0x1E,
0x1f, 0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,
//  0xF0,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,
0x2f, 0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,
//  0x2F,0xF0,0xF0,0xF0,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,
    0x3f,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,
//  0x3D,0x3E,0x3F,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0xF0,0x4A,0x4B,
0x4f, 0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,
//  0xFF,0x4C,0x4D,0xF0,0x4E,0x4F,0x50,0x51,0x52,0x53,0x54,0x55,0x56,0xF0,0x58,0x59,
0x5f, 0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,
//  0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,0x60,0x61,0x62,0x63,0xFF,0x64,0xF0,0xF0,0x65,0x66,
0x6f, 0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,
//  0x67,0x68,0x69,0x6A,0xF0,0x6C,0x6D,0x6E,0x6F,0xF0,0x71,0x72,0x73,0x74,0xF0,0x76,
0x7f, 0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,
//  0x77,0xF0,0xF0,0xF0,0xF0,0xF0,0x7D,0x7E,0x7F,0x80,0x81,0xF0,0x82,0x83,0x84,0x85,
0x8f, 0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,
//  0x86,0xF0,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x90,0x91,0x92,0x93,0x94,0x95,
0x9f, 0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,
//  0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,
0xaf, 0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,
//  0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xF0,0xAE,0xF0,0xB0,0xB1,0xB2,0xB3,0xF0,0xB5,
0xbf, 0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,
//  0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,
0xcf, 0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,
//  0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,0xD1,0xD2,0xD3,0x00
0xdf, 0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0x00
};
*/

/*
static BYTE C1OpcodePatch_OLD[0xEF]=
{
  0x00,0x01,0x02,0x03,0x04,0xF0,0x05,0x05,0xFF,0xFF,0xFF,0x06,0x07,0x08,0x09,
//0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,
  0x0A,0xFF,0xFF,0xFF,0xF0,0xF0,0x0B,0x0C,0x0D,0xFF,0xFF,0x0E,0x0F,0x10,0x11,0x12,
//0x0f 0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,
  0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,0x1B,0x1C,0x1D,0xF0,0xF0,0xF0,0xF0,0x1E,
//0x1f 0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,
  0xF0,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,
//0x2f 0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,
  0x2F,0xF0,0xF0,0xF0,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,
//0x3f 0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,
  0x3D,0x3E,0x3F,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0xF0,0x4A,0x4B,
//0x4f 0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,
  0xFF,0x4C,0x4D,0xF0,0x4E,0x4F,0x50,0x51,0x52,0x53,0x54,0x55,0x56,0xF0,0x58,0x59,
//0x5f 0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,
  0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,0x60,0x61,0x62,0x63,0xFF,0x64,0xF0,0xF0,0x65,0x66,
//0x6f 0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,
  0x67,0x68,0x69,0x6A,0xF0,0x6C,0x6D,0x6E,0x6F,0xF0,0x71,0x72,0x73,0x74,0xF0,0x76,
//0x7f 0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,
  0x77,0xF0,0xF0,0xF0,0xF0,0xF0,0x7D,0x7E,0x7F,0x80,0x81,0xF0,0x82,0x83,0x84,0x85,
//0x8f 0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,
  0x86,0xF0,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x90,0x91,0x92,0x93,0x94,0x95,
//0x9f 0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,
  0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,
//0xaf 0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,
  0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xF0,0xAE,0xF0,0xB0,0xB1,0xB2,0xB3,0xF0,0xB5,
//0xbf 0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,
  0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,
//0xcf 0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,
  0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,0xD1,0xD2,0xD3,0xEB,0x00
//0xdf 0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee
};
*/

static BYTE C1OpcodePatch[0xEF]=
{
  0x00,0x01,0x02,0x03,0x04,0xF0,0x05,0x05,0xFF,0xFF,0xFF,0x06,0x07,0x08,0x09,
//0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,
  0x0A,0xFF,0xFF,0xFF,0xF0,0xF0,0x0B,0x0C,0x0D,0xFF,0xFF,0x0E,0x0F,0x10,0x11,0x12,
//0x0f 0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,
  0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1A,0x1B,0x1C,0x1D,0xF0,0xF0,0xF0,0xF0,0x1E,
//0x1f 0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,
  0x1f,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,
//0x2f 0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,
  0x2F,0xF0,0xF0,0xF0,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,
//0x3f 0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,
  0x3D,0x3E,0x3F,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0xF0,0x4A,0x4B,
//0x4f 0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,
  0xFF,0x4C,0x4D,0xF0,0x4E,0x4F,0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,
//0x5f 0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,
  0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,0x60,0x61,0x62,0x63,0x01,0x64,0xF0,0xF0,0x65,0x66,
//0x6f 0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,
  0x67,0x68,0x69,0x6A,0x6B,0x6C,0x6D,0x6E,0x6F,0xF0,0x71,0x72,0x73,0x74,0x75,0x76,
//0x7f 0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,
  0x77,0x78,0x79,0xFA,0x7b,0x7c,0x7D,0x7E,0x7F,0x80,0x81,0xF0,0x82,0x83,0x84,0x85,
//0x8f 0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,
  0x86,0xF0,0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,0x90,0x91,0x92,0x93,0x94,0x95,
//0x9f 0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,
  0x96,0x97,0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,
//0xaf 0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,
  0xA6,0xA7,0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,
//0xbf 0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,
  0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,
//0xcf 0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,
  0xC6,0xC7,0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,0xD1,0xD2,0xD3,0xEB,0xFE
//0xdf 0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee
};



static BYTE CT1OpcodePatch[0xEF]=
{
//if change first 2 to correct values 2E,2F npc server packets will be affected - no npcs in world
0x00,0x01,0x30,0x31,0x32,0xF6,0x33,0x33,0xFF,0xFF,0xFF,0x00,0xEE,0x02,0x03,
//0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,
0x04,0xFF,0xFF,0xFF,0xF6,0xF6,0x05,0x16,0x17,0xFF,0xFF,0x18,0x19,0x06,0x07,0x08,
//0x0f 0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,
/*0x09*/0xE5,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,0x11,0x12,0x13,0xF6,0xF6,0xF6,0xF6,0x14,
//0x1f 0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,
0x15,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0x20,0x21,0x28,0x23,0x24,0x25,0x26,0x27,0x28,
//0x2f 0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,
0x29,0xF6,0xF6,0xF6,0x2B,0x2C,0x2D,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x3B,0x3C,
//0x3f 0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,
0x3D,0x3E,0x3F,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0xF6,0x4A,0x4B,
//0x4f 0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,
0xFF,0x4C,0x4D,0xF6,0x4E,0x4F,0x50,0x51,0x52,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,0x60,
//0x5f 0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,
0x6C,0x6D,0x6E,0x6F,0x70,0x71,0x72,0x79,0x7A,0x61,0x2F,0x62,0xF6,0xF6,0x63,0x64,
//0x6f 0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,
0x65,0x66,0x67,0x68,0x69,0x6A,0x6B,0x7B,0x7C,0xF6,0x7E,0x7F,0x80,0x81,0x53,0x54,
//0x7f 0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,
0x55,0x56,0x57,0x75,0x59,0x82,0x83,0x84,0x85,0x86,0x87,0xF6,0x88,0x89,0x8A,0x8B,
//0x8f 0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,
0x8C,0xF6,0x8E,0x8F,0x90,0x91,0x92,0x93,0x94,/*0x95*/0xE4,0x96,0x97,0x98,0x99,0x9A,0x9B,
//0x9f 0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,
0x9C,0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xB8,
//0xaf 0xb0,0xb1,0xb2,0xb3,0xb4,0xb5,0xb6,0xb7,0xb8,0xb9,0xba,0xbb,0xbc,0xbd,0xbe,
0xB9,0xBA,0xBB,0xBC,0xAB,0xAC,0xAD,0xAE,0xAF,0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,
//0xbf 0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,
0xB7,0xBD,0xBE,0xBF,0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xD2,0xD3,0xD4,
//0xcf 0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,
0xD5,0xD6,0xD7,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,0xD0,0xD1,0xD8,0xD9,0xF1,0xFE
//0xdf 0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee
};



	static const char* servToClientTXT_Kamael[255] = 
	{
"0x6 0x00, Die",
"0x7 0x01, Revive",
"0x8 0x02, AttackOutOfRange",
"0x9 0x03, AttackInCoolTime",
"0xa 0x04, AttackDeadTarget",
"0xb 0x05, Spawn Item",
"0x10 0x06, SellList",
"0x11 0x07, BuyList",
"0x12 0x08, DeleteObject",
"0x13 0x09, CharacterSelectionInfo",
"0x14 0x0A, LoginFail",
"0x15 0x0b, CharacterSelected",
"0x16 0x0c, NpcInfo",
"0x17 0x0d, NewCharacterSucess",
"0x18 0x0e, NewCharacterFail",
"0x19 0x0f, CharacterCreatesuccess",
"0x1a 0x10, CharacterCreateFail",
"0x1b 0x11, ItemList",
"0x1c 0x12, SunRise",
"0x1d 0x13, SunSet 2d",
"0x1e 0x14, TradeStart",
"0x1f 0x15, TradeStartOk",
"0xc 0x16, Drop Item",
"0xd 0x17, Get Item",
"0xe 0x18, Status Update",
"0xf 0x19, NPC HTML Message",
"0x20 0x1a, TradeOwnAdd",
"0x21 0x1b, TradeOtherAdd",
"0x22 0x1c, TradeDone",
"0x23 0x1d, CharacterDeletesuccess",
"0x24 0x1e, CharacterDeleteFail",
"0x25 0x1f, ActionFail",
"0x26 0x20, SeverClose",
"0x27 0x21, InventoryUpdate",
"0x28 0x22, TeleportToLocaton",
"0x29 0x23, TargetSelected",
"0x2a 0x24, TargetUnselecte",
"0x2b 0x25, AutoAttackStart",
"0x2c 0x26, AutoAttackStop",
"0x2d 0x27, SocialAction",
"0x2e 0x28, ChangeMoveType",
"0x2f 0x29, ChangeWaitType",
"0x30 0x2a, ManagePledgePowr",
"0x31 0x2b, CreatePledge",
"0x32 0x2c, AskJoinPledge",
"0x33 0x2d, JoinPledge",
"0x0 0x2E, VersionCheck",
"0x1 0x2F, MoveToLocation",
"0x2 0x30, NPC Say",
"0x3 0x31, CharInfo",
"0x4 0x32, User Info",
"0x5 0x33, Attack",
"0x34 0x34, WithdrawalPledge",
"0x35 0x35, OustPledgeMember",
"0x36 0x36, SetOustPledgeMeber",
"0x37 0x37, DismissPledge",
"0x38 0x38, SetDismissPledge",
"0x39 0x39, AskJoinParty",
"0x3a 0x3a, JoinParty",
"0x3b 0x3b, WithdrawalParty",
"0x3c 0x3c, OustPartyMember",
"0x3d 0x3d, SetOustPartyMemer",
"0x3e 0x3e, DismissParty",
"0x3f 0x3f, SetDismissParty",
"0x40 0x40, MagicAndSkillList",
"0x41 0x41, WareHouseDeposiList",
"0x42 0x42, WareHouseWithdrwList",
"0x43 0x43, WareHouseDone",
"0x44 0x44, ShortCutRegister",
"0x45 0x45, ShortCutInit",
"0x46 0x46, ShortCutDelete",
"0x47 0x47, StopMove",
"0x48 0x48, MagicSkillUse",
"0x49 0x49, MagicSkillCanceled",
"0x4a 0x4a, Say2",
"0x4b 0x4b, EquipUpdate",
"0x4c 0x4c, DoorInfo",
"0x4d 0x4d, DoorStatusUpdate",
"0x4e 0x4e, PartySmallWindowAll",
"0x4f 0x4f, PartySmallWindowAdd",
"0x50 0x50, PartySmallWindowDeleteAll",
"0x51 0x51, PartySmallWindowDelete",
"0x52 0x52, PartySmallWindowUpdate",
"0x75 0x53, TradePressOwnOk",
"0x76 0x54, MagicSkillLaunced",
"0x77 0x55, FriendAddRequesResult",
"0x78 0x56, FriendAdd",
"0x79 0x57, FriendRemove",
"0x7a 0x58, FriendList",
"0x7b 0x59, FriendStatus",
"0x53 0x5a, PledgeShowMembeListAll",
"0x54 0x5b, PledgeShowMembeListUpdate",
"0x55 0x5c, PledgeShowMembeListAdd",
"0x56 0x5d, PledgeShowMembeListDelete",
"0x57 0x5e, MagicList",
"0x58 0x5f, SkillList",
"0x59 0x60, VehicleInfo",
"0x63 0x61, FinishRotating",
"0x64 0x62, SystemMessage",
"0x65 0x63, StartPledgeWar",
"0x66 0x64, ReplyStartPledgWar",
"0x67 0x65, StopPledgeWar",
"0x68 0x66, ReplyStopPledgeWar",
"0x69 0x67, SurrenderPledgeWar",
"0x6a 0x68, ReplySurrenderPedgeWar",
"0x6b 0x69, SetPledgeCrest",
"0x6c 0x6a, PledgeCrest",
"0x6d 0x6b, SetupGauge",
"0x5a 0x6c, VehicleDeparture",
"0x5b 0x6d, VehicleCheckLoction",
"0x5c 0x6e, GetOnVehicle",
"0x5d 0x6f, GetOffVehicle",
"0x5e 0x70, TradeRequest",
"0x5f 0x71, RestartResponse",
"0x60 0x72, MoveToPawn",
"0xf8 0x73, SSQInfo",
"0xf9 0x74, GameGuardQuery",
"0xfa 0x75, L2FriendList",
"0xfb 0x76, L2Friend",
"0xfc 0x77, L2FriendStatus",
"0xfd 0x78, L2FriendSay",
"0x61 0x79, ValidateLocation",
"0x62 0x7a, StartRotating",
"0x6e 0x7b, ShowBoard",
"0x6f 0x7c, ChooseInventoryItem",
"0x70 0x7d, Dummy",
"0x71 0x7e, MoveToLocationIVehicle",
"0x72 0x7f, StopMoveInVehice",
"0x73 0x80, ValidateLocatioInVehicle",
"0x74 0x81, TradeUpdate",
"0x7c 0x82, TradePressOtherOk",
"0x7d 0x83, FriendAddRequest",
"0x7e 0x84, LogOutOk",
"0x7f 0x85, AbnormalStatusUdate",
"0x80 0x86, QuestList",
"0x81 0x87, EnchantResult",
"0x82 0x88, PledgeShowMembeListDeleteAll",
"0x83 0x89, PledgeInfo",
"0x84 0x8a, PledgeExtendedInfo",
"0x85 0x8b, SurrenderPersonlly",
"0x86 0x8c, Ride",
"0x87 0x8d, unkn",
"0x88 0x8e, PledgeShowInfoUdate",
"0x89 0x8f, ClientAction",
"0x8a 0x90, AcquireSkillList",
"0x8b 0x91, AcquireSkillInfo",
"0x8c 0x92, ServerObjectInfo",
"0x8d 0x93, GMHide",
"0x8e 0x94, AcquireSkillDone",
"0x8f 0x95, GMViewCharacterInfo",
"0x90 0x96, GMViewPledgeInfo",
"0x91 0x97, GMViewSkillInfo",
"0x92 0x98, GMViewMagicInfo",
"0x93 0x99, GMViewQuestInfo",
"0x94 0x9a, GMViewItemList",
"0x95 0x9b, GMViewWarehouseithdrawList",
"0x96 0x9c, ListPartyWating",
"0x97 0x9d, PartyRoomInfo",
"0x98 0x9e, PlaySound",
"0x99 0x9f, StaticObject",
"0x9a 0xa0, PrivateStoreMangeListSell",
"0x9b 0xa1, PrivateStoreList",
"0x9c 0xa2, PrivateStoreMsg",
"0x9d 0xa3, ShowMinimap",
"0x9e 0xa4, ReviveRequest",
"0x9f 0xa5, AbnormalVisualEfect",
"0xa0 0xa6, TutorialShowHtml",
"0xa1 0xa7, TutorialShowQuestionMark",
"0xa2 0xa8, TutorialEnableCientEvent",
"0xa3 0xa9, TutorialCloseHtml",
"0xa4 0xaa, ShowRadar",
"0xaa 0xab, WithdrawAlliance",
"0xab 0xac, OustAllianceMemerPledge",
"0xac 0xad, DismissAlliance",
"0xad 0xae, SetAllianceCrest",
"0xae 0xaf, AllianceCrest",
"0xaf 0xb0, ServerCloseSocket",
"0xb0 0xb1, PetStatusShow",
"0xb1 0xb2, PetInfo",
"0xb2 0xb3, PetItemList",
"0xb3 0xb4, PetInventoryUpdate",
"0xb4 0xb5, AllianceInfo",
"0xb5 0xb6, PetStatusUpdate",
"0xb6 0xb7, PetDelete",
"0xa5 0xb8, DeleteRadar",
"0xa6 0xb9, MyTargetSelected",
"0xa7 0xba, PartyMemberPosition",
"0xa8 0xbb, AskJoinAlliance",
"0xa9 0xbc, JoinAlliance",
"0xb7 0xbd, PrivateStoreBuyManageList",
"0xb8 0xbe, PrivateStoreBuyList",
"0xb9 0xbf, PrivateStoreBuyMsg",
"0xba 0xc0, VehicleStart",
"0xbb 0xc1, RequestTimeCheck",
"0xbc 0xc2, StartAllianceWar",
"0xbd 0xc3, ReplyStartAlliaceWar",
"0xbe 0xc4, StopAllianceWar",
"0xbf 0xc5, ReplyStopAllianeWar",
"0xc0 0xc6, SurrenderAllianeWar",
"0xc1 0xc7, SkillCoolTime",
"0xc2 0xc8, PackageToList",
"0xc9 0xc9, CastleSiegeInfo",
"0xca 0xca, CastleSiegeAttakerList",
"0xcb 0xcb, CastleSiegeDefederList",
"0xcc 0xcc, NickNameChanged",
"0xcd 0xcd, PledgeStatusChaged",
"0xce 0xce, RelationChanged",
"0xcf 0xcf, EventTrigger",
"0xd0 0xd0, MultiSellList",
"0xd1 0xd1, SetSummonRemainTime",
"0xc3 0xd2, PackageSendableList",
"0xc4 0xd3, EarthQuake",
"0xc5 0xd4, FlyToLoaction",
"0xc6 0xd5, BlockList",
"0xc7 0xd6, SpecialCamera",
"0xc8 0xd7, NormalCamera",
"0xd2 0xd8, SkillRemainSec",
"0xd3 0xd9, NetPing",
"0xd4 0xda, Dice",
"0xd5 0xdb, Snoop",
"0xd6 0xdc, RecipeBookItemList",
"0xd7 0xdd, RecipeItemMakeInfo",
"0xd8 0xde, RecipeShopManagList",
"0xd9 0xdf, RecipeShopSellList",
"0xda 0xe0, RecipeShopItemInfo",
"0xdb 0xe1, RecipeShopMsg",
"0xdc 0xe2, ShowCalc",
"0xdd 0xe3, MonRaceInfo",
"0xe3 0xe4, HennaItemInfo",
"0xe4 0xe5, HennaInfo",
"0xe5 0xe6, HennaUnequipList",
"0xe6 0xe7, HennaUnequipInfo",
"0xe7 0xe8, MacroList",
"0xe8 0xe9, BuyListSeed",
"0xde 0xea, ShowTownMap",
"0xdf 0xeb, ObserverStart",
"0xe0 0xec, ObserverEnd",
"0xe1 0xed, ChairSit",
"0xe2 0xee, HennaEquipList",
"0xe9 0xef, SellListProcure",
"0xea 0xf0, GMHennaInfo",
"0xeb 0xf1, RadarControl",
"0xec 0xf2, ClientSetTime",
"0xed 0xf3, ConfirmDlg",
"0xee 0xf4, PartySpelled",
"0xef 0xf5, ShopPreviewList",
"0xf0 0xf6, ShopPreviewInfo",
"0xf1 0xf7, CameraMode",
"0xf2 0xf8, ShowXMasSeal",
"0xf3 0xf9, EtcStatusUpdate",
"0xf4 0xfa, ShortBuffStatusUpdate",
"0xf5 0xfb, SSQStatus",
"0xf6 0xfc, PetitionVote",
"0xf7 0xfd, AgitDecoInfo",
"0xfe 0xFE  UserEx"
};



//C1 opcodes
/*
Server -> Client 
0x01 loginfail2 
0x02 accountKicked1 
0x03 loginok 
0x04 serverlist 
0x05 serverfail 
0x06 playfail 
0x07 playok 
0x08 accountKicked 
0x09 blockedAccMsg 
0x20 protocol version different 

0x00 VersionCheck 
0x01 MoveToLocation 
0x02 NpcSay 
0x03 CharInfo 
0x04 UserInfo 
0x06 Attack 
0x07 talk 
0x08 Attacked 
0x09 talked
0x0a AttackCanceld 
0x0b Die 
0x0c Revive 
0x0d AttackOutOfRange 
0x0e AttackInCoolTime 
0x0f AttackDeadTarget 
0x10 LeaveWorld 
0x11 AuthLoginSuccess 
0x12 AuthLoginFail
0x13NOTFOUND
0x14NOTFOUND
0x15 SpawnItem 
0x16 DropItem 
0x17 GetItem 
0x18 EquipItem 
0x19 UnequipItem 
0x1a StatusUpdate 
0x1b NpcHtmlMessage 
0x1c SellList 
0x1d BuyList 
0x1e DeleteObject 
0x1f CharSelectInfo
0x20 LoginFail 
0x21 CharSelected
0x22 NpcInfo 
0x23 NewCharacterSuccessPacket 
0x24 NewCharacterFailPacket 
0x25 CharCreateOk 
0x26 CharCreateFail 
0x27 ItemList 
0x28 SunRise 
0x29 SunSet 
0x2a EquipItemSuccess (deprecated) 
0x2b EquipItemFail (deprecated) 
0x2c UnEquipItemSuccess (deprecated) 
0x2d UnEquipItemFail (deprecated) 
0x2e TradeStart 
0x2f TradeStartOk (deprecated) ------------ 
0x30 TradeOwnAdd 
0x31 TradeOtherAdd 
0x32 TradeDone 
0x33 CharDeleteSuccess 
0x34 CharDeleteFail 
0x35 ActionFail 
0x36 ServerClose 
0x37 InventoryUpdate 
0x38 TeleportToLocation 
0x39 TargetSelected 
0x3a TargetUnselected 
0x3b AutoAttackStart 
0x3c AutoAttackStop 
0x3d SocialAction 
0x3e ChangeMoveType 
0x3f ChangeWaitType 
0x40 NetworkFail (deprecated) 
0x41NOTFOUND
0x42NOTFOUND
0x43 CreatePledge 
0x44 AskJoinPledge 
0x45 JoinPledge 
0x46 WithdrawalPledge 
0x47 OustPledgeMember 
0x48 SetOutPledgeMember 
0x49 DismissPledge 
0x4a SetDismissPledge 
0x4b AskJoinParty 
0x4c JoinParty 
0x4d WithdrawalParty 
0x4e OustPartyMember 
0x4f SetOustPartyMember 
0x50 DismissParty 
0x51 SetDismissParty 
0x52 MagicAndSkillList 
0x53 WarehouseDepositList 
0x54 WarehouseWithdrawalList 
0x55 WarehouseDone 
0x56 ShortCutRegister 
0x57 ShortCutInit 
0x58 ShortCutDelete 
0x59 StopMove 
0x5a MagicSkillUse 
0x5b MagicSkillCanceld 
0x5d CreatureSay 
0x5e EquipUpdate 
0x5f StopMoveWithLocation 
0x60 DoorInfo 
0x61 DoorStatusUpdate 
0x62NOTFOUND
0x63 PartySmallWindowAll 
0x64 PartySmallWindowAdd 
0x65 PartySmallWindowDeleteAll 
0x66 PartySmallWindowDelete 
0x67 PartySmallWindowUpdate 
0x68 PledgeShowMemberListAll 
0x69 PledgeShowMemberListUpdate 
0x6a PledgeShowMemberListAdd 
0x6b PledgeShowMemberListDelete 
0x6c MagicList (deprecated) --------------------
0x6d SkillList 
0x6e VehicleInfo 
0x6f VehicleDeparture 
0x70 VehicleCheckLocation 
0x71 GetOnVehicle 
0x72 GetOffVehicle 
0x73 TradeRequest 
0x74 RestartResponse 
0x75 MoveToPawn 
0x76 SetTo 
0x77 StartRotating 
0x78 FinishRotating 
0x79 MoveBackwardToLocation --------!!!!!!!!!!
0x7a SystemMessage 
0x7bNOTFOUND
0x7cNOTFOUND
0x7d StartPledgeWar 
0x7e ReplyStartPledgeWar 
0x7f StopPledgeWar 
0x80 ReplyStopPledgeWar 
0x81 SurrenderPledgeWar 
0x82 ReplySurrenderPledgeWar 
0x83 SetPledgeCrest (deprecated) --------------
0x84 PledgeCrest 
0x85 SetupGauge 
0x86 ShowBoard 
0x87 ChooseInventoryItem 
0x88 TargetuserFromMenu (Deprecated) ???????????????
0x89 MoveToLocationInVehicle 
0x8a StopMoveInVehicle 
0x8b ValidateLocationInVehicle 
0x8c TradeOtherAdd2 
0x8d TradePressOwnOK (deprecated) ----------
0x8e MagicSkillLaunched 
0x8f FriendAddRequestResult 
0x90 FriendAdd (deprecated) ----------
0x91 FriendRemove (deprecated) --------------
0x92 FriendList (deprecated) ----------------
0x93 FriendStatus (deprecated) ---------------
0x94 TradePressOtherOk (deprecated) -----------
0x95 FriendAddRequest 
0x96 LeaveWorld2 Logout 
0x97 AbnormalStatusUpdate 
0x98 QuestList , quest
0x99 EnchantResult 
0x9a AuthServerList (deprecated) 
0x9b PledgeShowMemberListDeleteAll 
0x9c PledgeInfo 
0x9d PledgeExtendedInfo 
0x9e SurrenderPersonally 
0x9f Ride 
0xa0 GiveNickNamePacket (deprecated)
0xa1 PledgeShowInfoUpdate 
0xa2 ClientAction 
0xa3 AquireSkillList 
0xa4 AquireSkillInfo 
0xa5 ServerObjectInfo 
0xa6 HideGm 
0xa7 AquireSkillDone 
0xa8 GMViewCharacterInfo 
0xa9 GMViewPledgeInfo 
0xaa GMViewSkillInfo 
0xab GMviewMagicInfo 
0xac GMViewQuestInfo 
0xad GMViewItemList 
0xae GMViewWarehouseWithdrawList 
0xaf PartyMatchList 
0xb0 PartyMatchDetail 
0xb1 PlaySound 
0xb2 StaticObject 
0xb3 PrivateSellList2 
0xb4 PrivateBuyList2 
0xb5 PrivateStoreMsg 
0xb6 ShowMinimapPacket 
0xb7 ReviveRequest (deprecated) 
0xb8 AbnormalVisualEffect 
0xb9 TutorialShowHtml 
0xba TutorialShowQuestionMark 
0xbb TutorialEnableClientEvent 
0xbc TutorialClose 
0xbd ShowRadar 
0xbe DeleteRadar 
0xbf MyTargetSelected 
0xc0 PartyMemberPosition 
0xc1 AskJoinAlliance 
0xc2 JoinAlliance 
0xc3 WithdrawAlliance 
0xc4 OustAllianceMemberPledge 
0xc5 DismissAlliance 
0xc6 SetAllianceCrest (deprecated) ---------------
0xc7 ReceiveAllyCrest 
0xc8 ServerCloseSocket (deprecated) ----------------
0xc9 PetStatusShow 
0xca PetInfo 
0xcb PetItemList 
0xcc PetInventoryUpdate 
0xcd AllianceInfo (deprecated) ---------------
0xce PetStatusUpdate 
0xcf PetDelete 
0xd0 PrivateSellList 
0xd1 PrivateBuyList 
0xd2 PrivateStoreMsg 
0xd3 VehicleStart 
0xd4 RequestTimeCheck 
0xd5 StartAllianceWar 
0xd6 ReplyStartAllianceWar (deprecated) 
0xd7 StopAllianceWar 
0xd8 ReplyStopAllianceWar (deprecated) 
0xd9 SurrenderAllianceWar (deprecated) 
0xda SkillCoolTimePacket 
0xdb PackageToListPacket 
0xdc PackageSendableListPacket 
0xdd EarthQuake 
0xde FlyToLocation 
0xdf BlockList (deprecated) 
0xe0 SpecialCamera 
0xe1 NormalCamera 
0xe2 CastleSiegeInfoPacket 
0xe3 CastleSiegeAttackerList 
0xe4 CastleSiegeDefenderList 
0xe5 NickNameChanged 
0xe6 PledgeStatusChanged 
0xe7 RelationChanged 
0xe8 OnEventTrigger 
0xe9 MultiSellListPacket 
0xea SetSummonRemainTime 
0xeb OnSkillRemainSec 
0xec NetPingPacket 

*/


//4dfb70	CSocket::SendV(const char* format, va_list va)
//4dfc70	CSocket::Send(const char* format, ...)




extern "C" BYTE g_ServerToClientOpcodes[255] = 
{
	/*0*/	0x2E, // VersionCheck
	/*1*/	0x2F, // MoveToLocation
	/*2*/	0x30, // NPC Say
	/*3*/	0x31, // CharInfo
	/*4*/	0x32, // User Info
	/*5*/	0x33, // Attack
	/*6*/	0x00, // Die
	/*7*/	0x01, // Revive
	/*8*/	0x02, // AttackOutOfRange
	/*9*/	0x03, // AttackInCoolTime
	/*a*/	0x04, // AttackDeadTarget
	/*b*/	0x05, // Spawn Item
	/*c*/	0x16, // Drop Item
	/*d*/	0x17, // Get Item
	/*e*/	0x18, // Status Update
	/*f*/	0x19, // NPC HTML Message
	/*10*/	0x06, // SellList
	/*11*/	0x07, // BuyList
	/*12*/	0x08, // DeleteObject
	/*13*/	0x09, // CharacterSelectionInfo
	/*14*/	0x0A, // LoginFail
	/*15*/	0x0b, // CharacterSelected
	/*16*/	0x0c, // NpcInfo
	/*17*/	0x0d, // NewCharacterSucess
	/*18*/	0x0e, // NewCharacterFail
	/*19*/	0x0f, // CharacterCreatesuccess
	/*1a*/	0x10, // CharacterCreateFail
	/*1b*/	0x11, // ItemList
	/*1c*/	0x12, // SunRise
	/*1d*/	0x13, // SunSet 2d
	/*1e*/	0x14, // TradeStart
	/*1f*/	0x15, // TradeStartOk
	/*20*/	0x1a, // TradeOwnAdd
	/*21*/	0x1b, // TradeOtherAdd
	/*22*/	0x1c, // TradeDone
	/*23*/	0x1d, // CharacterDeletesuccess
	/*24*/	0x1e, // CharacterDeleteFail
	/*25*/	0x1f, // ActionFail
	/*26*/	0x20, // SeverClose
	/*27*/	0x21, // InventoryUpdate
	/*28*/	0x22, // TeleportToLocaton
	/*29*/	0x23, // TargetSelected
	/*2a*/	0x24, // TargetUnselecte
	/*2b*/	0x25, // AutoAttackStart
	/*2c*/	0x26, // AutoAttackStop
	/*2d*/	0x27, // SocialAction
	/*2e*/	0x28, // ChangeMoveType
	/*2f*/	0x29, // ChangeWaitType
	/*30*/	0x2a, // ManagePledgePowr
	/*31*/	0x2b, // CreatePledge
	/*32*/	0x2c, // AskJoinPledge
	/*33*/	0x2d, // JoinPledge
	/*34*/	0x34, // WithdrawalPledge
	/*35*/	0x35, // OustPledgeMembe
	/*36*/	0x36, // SetOustPledgeMeber
	/*37*/	0x37, // DismissPledge
	/*38*/	0x38, // SetDismissPledge
	/*39*/	0x39, // AskJoinParty
	/*3a*/	0x3a, // JoinParty
	/*3b*/	0x3b, // WithdrawalParty
	/*3c*/	0x3c, // OustPartyMember
	/*3d*/	0x3d, // SetOustPartyMemer
	/*3e*/	0x3e, // DismissParty
	/*3f*/	0x3f, // SetDismissParty
	/*40*/	0x40, // MagicAndSkillList
	/*41*/	0x41, // WareHouseDeposiList
	/*42*/	0x42, // WareHouseWithdrwList
	/*43*/	0x43, // WareHouseDone
	/*44*/	0x44, // ShortCutRegister
	/*45*/	0x45, // ShortCutInit
	/*46*/	0x46, // ShortCutDelete
	/*47*/	0x47, // StopMove
	/*48*/	0x48, // MagicSkillUse
	/*49*/	0x49, // MagicSkillCanceed
	/*4a*/	0x4a, // Say2
	/*4b*/	0x4b, // EquipUpdate
	/*4c*/	0x4c, // DoorInfo
	/*4d*/	0x4d, // DoorStatusUpdate
	/*4e*/	0x4e, // PartySmallWindowAll
	/*4f*/	0x4f, // PartySmallWindowAdd
	/*50*/	0x50, // PartySmallWindowDeleteAll
	/*51*/	0x51, // PartySmallWindowDelete
	/*52*/	0x52, // PartySmallWindowUpdate
	/*53*/	0x5a, // PledgeShowMembeListAll
	/*54*/	0x5b, // PledgeShowMembeListUpdate
	/*55*/	0x5c, // PledgeShowMembeListAdd
	/*56*/	0x5d, // PledgeShowMembeListDelete
	/*57*/	0x5e, // MagicList
	/*58*/	0x5f, // SkillList
	/*59*/	0x60, // VehicleInfo
	/*5a*/	0x6c, // VehicleDeparture
	/*5b*/	0x6d, // VehicleCheckLoction
	/*5c*/	0x6e, // GetOnVehicle
	/*5d*/	0x6f, // GetOffVehicle
	/*5e*/	0x70, // TradeRequest
	/*5f*/	0x71, // RestartResponse
	/*60*/	0x72, // MoveToPawn
	/*61*/	0x79, // ValidateLocation
	/*62*/	0x7a, // StartRotating
	/*63*/	0x61, // FinishRotating
	/*64*/	0x62, // SystemMessage
	/*65*/	0x63, // StartPledgeWar
	/*66*/	0x64, // ReplyStartPledgWar
	/*67*/	0x65, // StopPledgeWar
	/*68*/	0x66, // ReplyStopPledgeWar
	/*69*/	0x67, // SurrenderPledgeWar
	/*6a*/	0x68, // ReplySurrenderPedgeWar
	/*6b*/	0x69, // SetPledgeCrest
	/*6c*/	0x6a, // PledgeCrest
	/*6d*/	0x6b, // SetupGauge
	/*6e*/	0x7b, // ShowBoard
	/*6f*/	0x7c, // ChooseInventoryItem
	/*70*/	0x7d, // Dummy
	/*71*/	0x7e, // MoveToLocationIVehicle
	/*72*/	0x7f, // StopMoveInVehice
	/*73*/	0x80, // ValidateLocatioInVehicle
	/*74*/	0x81, // TradeUpdate
	/*75*/	0x53, // TradePressOwnOk
	/*76*/	0x54, // MagicSkillLaunced
	/*77*/	0x55, // FriendAddRequesResult
	/*78*/	0x56, // FriendAdd
	/*79*/	0x57, // FriendRemove
	/*7a*/	0x58, // FriendList
	/*7b*/	0x59, // FriendStatus
	/*7c*/	0x82, // TradePressOtherOk
	/*7d*/	0x83, // FriendAddRequest
	/*7e*/	0x84, // LogOutOk
	/*7f*/	0x85, // AbnormalStatusUdate
	/*80*/	0x86, // QuestList
	/*81*/	0x87, // EnchantResult
	/*82*/	0x88, // PledgeShowMembeListDeleteAll
	/*83*/	0x89, // PledgeInfo
	/*84*/	0x8a, // PledgeExtendedInfo
	/*85*/	0x8b, // SurrenderPersonlly
	/*86*/	0x8c, // Ride
	/*87*/	0x8d, // unk
	/*88*/	0x8e, // PledgeShowInfoUdate
	/*89*/	0x8f, // ClientAction
	/*8a*/	0x90, // AcquireSkillList
	/*8b*/	0x91, // AcquireSkillInfo
	/*8c*/	0x92, // ServerObjectInfo
	/*8d*/	0x93, // GMHide
	/*8e*/	0x94, // AcquireSkillDone
	/*8f*/	0x95, // GMViewCharacterInfo
	/*90*/	0x96, // GMViewPledgeInfo
	/*91*/	0x97, // GMViewSkillInfo
	/*92*/	0x98, // GMViewMagicInfo
	/*93*/	0x99, // GMViewQuestInfo
	/*94*/	0x9a, // GMViewItemList
	/*95*/	0x9b, // GMViewWarehouseithdrawList
	/*96*/	0x9c, // ListPartyWating
	/*97*/	0x9d, // PartyRoomInfo
	/*98*/	0x9e, // PlaySound
	/*99*/	0x9f, // StaticObject
	/*9a*/	0xa0, // PrivateStoreMangeListSell
	/*9b*/	0xa1, // PrivateStoreList
	/*9c*/	0xa2, // PrivateStoreMsg
	/*9d*/	0xa3, // ShowMinimap
	/*9e*/	0xa4, // ReviveRequest
	/*9f*/	0xa5, // AbnormalVisualEfect
	/*a0*/	0xa6, // TutorialShowHtml
	/*a1*/	0xa7, // TutorialShowQuestionMark
	/*a2*/	0xa8, // TutorialEnableCientEvent
	/*a3*/	0xa9, // TutorialCloseHtml
	/*a4*/	0xaa, // ShowRadar
	/*a5*/	0xb8, // DeleteRadar
	/*a6*/	0xb9, // MyTargetSelected
	/*a7*/	0xba, // PartyMemberPosition
	/*a8*/	0xbb, // AskJoinAlliance
	/*a9*/	0xbc, // JoinAlliance
	/*aa*/	0xab, // WithdrawAlliance
	/*ab*/	0xac, // OustAllianceMemerPledge
	/*ac*/	0xad, // DismissAlliance
	/*ad*/	0xae, // SetAllianceCrest
	/*ae*/	0xaf, // AllianceCrest
	/*af*/	0xb0, // ServerCloseSocket
	/*b0*/	0xb1, // PetStatusShow
	/*b1*/	0xb2, // PetInfo
	/*b2*/	0xb3, // PetItemList
	/*b3*/	0xb4, // PetInventoryUpdate
	/*b4*/	0xb5, // AllianceInfo
	/*b5*/	0xb6, // PetStatusUpdate
	/*b6*/	0xb7, // PetDelete
	/*b7*/	0xbd, // PrivateStoreBuyManageList
	/*b8*/	0xbe, // PrivateStoreBuyList
	/*b9*/	0xbf, // PrivateStoreBuyMsg
	/*ba*/	0xc0, // vehicleStart
	/*bb*/	0xc1, // RequestTimeCheck
	/*bc*/	0xc2, // StartAllianceWar
	/*bd*/	0xc3, // ReplyStartAlliaceWar
	/*be*/	0xc4, // StopAllianceWar
	/*bf*/	0xc5, // ReplyStopAllianeWar
	/*c0*/	0xc6, // SurrenderAllianeWar
	/*c1*/	0xc7, // SkillCoolTime
	/*c2*/	0xc8, // PackageToList
	/*c3*/	0xd2, // PackageSendableList
	/*c4*/	0xd3, // EarthQuake
	/*c5*/	0xd4, // FlyToLoaction
	/*c6*/	0xd5, // BlockList
	/*c7*/	0xd6, // SpecialCamera
	/*c8*/	0xd7, // NormalCamera
	/*c9*/	0xc9, // CastleSiegeInfo
	/*ca*/	0xca, // CastleSiegeAttakerList
	/*cb*/	0xcb, // CastleSiegeDefederList
	/*cc*/	0xcc, // NickNameChanged
	/*cd*/	0xcd, // PledgeStatusChaged
	/*ce*/	0xce, // RelationChanged
	/*cf*/	0xcf, // EventTrigger
	/*d0*/	0xd0, // MultiSellList
	/*d1*/	0xd1, // SetSummonRemainTime
	/*d2*/	0xd8, // SkillRemainSec
	/*d3*/	0xd9, // NetPing
	/*d4*/	0xda, // Dice
	/*d5*/	0xdb, // Snoop
	/*d6*/	0xdc, // RecipeBookItemList
	/*d7*/	0xdd, // RecipeItemMakeInfo
	/*d8*/	0xde, // RecipeShopManagList
	/*d9*/	0xdf, // RecipeShopSellList
	/*da*/	0xe0, // RecipeShopItemInfo
	/*db*/	0xe1, // RecipeShopMsg
	/*dc*/	0xe2, // ShowCalc
	/*dd*/	0xe3, // MonRaceInfo
	/*de*/	0xea, // ShowTownMap
	/*df*/	0xeb, // ObserverStart
	/*e0*/	0xec, // ObserverEnd
	/*e1*/	0xed, // ChairSit
	/*e2*/	0xee, // HennaEquipList
	/*e3*/	0xe4, // HennaItemInfo
	/*e4*/	0xe5, // HennaInfo
	/*e5*/	0xe6, // HennaUnequipList
	/*e6*/	0xe7, // HennaUnequipInfo
	/*e7*/	0xe8, // MacroList
	/*e8*/	0xe9, // BuyListSeed
	/*e9*/	0xef, // SellListProcure
	/*ea*/	0xf0, // GMHennaInfo
	/*eb*/	0xf1, // RadarControl
	/*ec*/	0xf2, // ClientSetTime
	/*ed*/	0xf3, // ConfirmDlg
	/*ee*/	0xf4, // PartySpelled
	/*ef*/	0xf5, // ShopPreviewList
	/*f0*/	0xf6, // ShopPreviewInfo
	/*f1*/	0xf7, // CameraMode
	/*f2*/	0xf8, // ShowXMasSeal
	/*f3*/	0xf9, // EtcStatusUpdate
	/*f4*/	0xfa, // ShortBuffStatusUpdate
	/*f5*/	0xfb, // SSQStatus
	/*f6*/	0xfc, // PetitionVote
	/*f7*/	0xfd, // AgitDecoInfo
	/*f8*/	0x73, // SSQInfo
	/*f9*/	0x74, // GameGuardQuery
	/*fa*/	0x75, // L2FriendList
	/*fb*/	0x76, // L2Friend
	/*fc*/	0x77, // L2FriendStatus
	/*fd*/	0x78, // L2FriendSay
	/*fe*/	0xFE  // UserEx
};





//---------------------------------------
// OPCODES TAUTI 449
//
// they inserted new packet: Packet: PledgeSkillListRemovePacket, Opcode: FE:3C
// but only russian and english , korean client still clear
//
//
//---------------------------------------
/*

Packet: ExDummyPacket, Opcode: FE:0
Packet: ExRegenMaxPacket, Opcode: FE:1
Packet: ExEventMatchUserInfoPacket, Opcode: FE:2
Packet: ExColosseumFenceInfoPacket, Opcode: FE:3
Packet: ExEventMatchSpelledInfoPacket, Opcode: FE:4
Packet: ExEventMatchFirecrackerPacket, Opcode: FE:5
Packet: ExEventMatchTeamUnlockedPacket, Opcode: FE:6
Packet: ExEventMatchGMTestPacket, Opcode: FE:7
Packet: ExPartyRoomMemberPacket, Opcode: FE:8
Packet: ExClosePartyRoomPacket, Opcode: FE:9
Packet: ExManagePartyRoomMemberPacket, Opcode: FE:A
Packet: ExEventMatchLockResult, Opcode: FE:B
Packet: ExAutoSoulShot, Opcode: FE:C
Packet: ExEventMatchListPacket, Opcode: FE:D
Packet: ExEventMatchObserverPacket, Opcode: FE:E
Packet: ExEventMatchMessagePacket, Opcode: FE:F
Packet: ExEventMatchScorePacket, Opcode: FE:10
Packet: ExServerPrimitivePacket, Opcode: FE:11
Packet: ExOpenMPCCPacket, Opcode: FE:12
Packet: ExCloseMPCCPacket, Opcode: FE:13
Packet: ExShowCastleInfo, Opcode: FE:14
Packet: ExShowFortressInfo, Opcode: FE:15
Packet: ExShowAgitInfo, Opcode: FE:16
Packet: ExShowFortressSiegeInfo, Opcode: FE:17
Packet: ExPartyPetWindowAdd, Opcode: FE:18
Packet: ExPartyPetWindowUpdate, Opcode: FE:19
Packet: ExAskJoinMPCCPacket, Opcode: FE:1A
Packet: ExPledgeEmblem, Opcode: FE:1B
Packet: ExEventMatchTeamInfoPacket, Opcode: FE:1C
Packet: ExEventMatchCreatePacket, Opcode: FE:1D
Packet: ExFishingStartPacket, Opcode: FE:1E
Packet: ExFishingEndPacket, Opcode: FE:1F
Packet: ExShowQuestInfoPacket, Opcode: FE:20
Packet: ExShowQuestMarkPacket, Opcode: FE:21
Packet: ExSendManorListPacket, Opcode: FE:22
Packet: ExShowSeedInfoPacket, Opcode: FE:23
Packet: ExShowCropInfoPacket, Opcode: FE:24
Packet: ExShowManorDefaultInfoPacket, Opcode: FE:25
Packet: ExShowSeedSettingPacket, Opcode: FE:26
Packet: ExFishingStartCombatPacket, Opcode: FE:27
Packet: ExFishingHpRegenPacket, Opcode: FE:28
Packet: ExEnchantSkillListPacket, Opcode: FE:29
Packet: ExEnchantSkillInfoPacket, Opcode: FE:2A
Packet: ExShowCropSettingPacket, Opcode: FE:2B
Packet: ExShowSellCropListPacket, Opcode: FE:2C
Packet: ExOlympiadMatchEndPacket, Opcode: FE:2D
Packet: ExMailArrivedPacket, Opcode: FE:2E
Packet: ExStorageMaxCountPacket, Opcode: FE:2F
Packet: ExEventMatchManagePacket, Opcode: FE:30
Packet: ExMultiPartyCommandChannelInfoPacket, Opcode: FE:31
Packet: ExPCCafePointInfoPacket, Opcode: FE:32
Packet: ExSetCompassZoneCode, Opcode: FE:33
Packet: ExGetBossRecord, Opcode: FE:34
Packet: ExAskJoinPartyRoom, Opcode: FE:35
Packet: ExListPartyMatchingWaitingRoom, Opcode: FE:36
Packet: ExSetMpccRouting, Opcode: FE:37
Packet: ExShowAdventurerGuideBook, Opcode: FE:38
Packet: ExShowScreenMessage, Opcode: FE:39
Packet: PledgeSkillListPacket, Opcode: FE:3A
Packet: PledgeSkillListAddPacket, Opcode: FE:3B
Packet: PledgeSkillListRemovePacket, Opcode: FE:3C
Packet: PledgePowerGradeList, Opcode: FE:3D
Packet: PledgeReceivePowerInfo, Opcode: FE:3E
Packet: PledgeReceiveMemberInfo, Opcode: FE:3F
Packet: PledgeReceiveWarList, Opcode: FE:40
Packet: PledgeReceiveSubPledgeCreated, Opcode: FE:41
Packet: ExRedSkyPacket, Opcode: FE:42
Packet: PledgeReceiveUpdatePower, Opcode: FE:43
Packet: FlySelfDestinationPacket, Opcode: FE:44
Packet: ShowPCCafeCouponShowUI, Opcode: FE:45
Packet: ExSearchOrc, Opcode: FE:46
Packet: ExCursedWeaponList, Opcode: FE:47
Packet: ExCursedWeaponLocation, Opcode: FE:48
Packet: ExRestartClient, Opcode: FE:49
Packet: ExRequestHackShield, Opcode: FE:4A
Packet: ExUseSharedGroupItem, Opcode: FE:4B
Packet: ExMPCCShowPartyMemberInfo, Opcode: FE:4C
Packet: ExDuelAskStart, Opcode: FE:4D
Packet: ExDuelReady, Opcode: FE:4E
Packet: ExDuelStart, Opcode: FE:4F
Packet: ExDuelEnd, Opcode: FE:50
Packet: ExDuelUpdateUserInfo, Opcode: FE:51
Packet: ExShowVariationMakeWindow, Opcode: FE:52
Packet: ExShowVariationCancelWindow, Opcode: FE:53
Packet: ExPutItemResultForVariationMake, Opcode: FE:54
Packet: ExPutIntensiveResultForVariationMake, Opcode: FE:55
Packet: ExPutCommissionResultForVariationMake, Opcode: FE:56
Packet: ExVariationResult, Opcode: FE:57
Packet: ExPutItemResultForVariationCancel, Opcode: FE:58
Packet: ExVariationCancelResult, Opcode: FE:59
Packet: ExDuelEnemyRelation, Opcode: FE:5A
Packet: ExPlayAnimation, Opcode: FE:5B
Packet: ExMPCCPartyInfoUpdate, Opcode: FE:5C
Packet: ExPlayScene, Opcode: FE:5D
Packet: ExSpawnEmitterPacket, Opcode: FE:5E
Packet: ExEnchantSkillInfoDetailPacket, Opcode: FE:5F
Packet: ExBasicActionList, Opcode: FE:60
Packet: ExAirShipInfo, Opcode: FE:61
Packet: ExAttributeEnchantResultPacket, Opcode: FE:62
Packet: ExChooseInventoryAttributeItemPacket, Opcode: FE:63
Packet: ExGetOnAirShipPacket, Opcode: FE:64
Packet: ExGetOffAirShipPacket, Opcode: FE:65
Packet: ExMoveToLocationAirShipPacket, Opcode: FE:66
Packet: ExStopMoveAirShipPacket, Opcode: FE:67
Packet: ExShowTracePacket, Opcode: FE:68
Packet: ExItemAuctionInfoPacket, Opcode: FE:69
Packet: ExNeedToChangeName, Opcode: FE:6A
Packet: ExPartyPetWindowDelete, Opcode: FE:6B
Packet: ExTutorialList, Opcode: FE:6C
Packet: ExRpItemLink, Opcode: FE:6D
Packet: ExMoveToLocationInAirShipPacket, Opcode: FE:6E
Packet: ExStopMoveInAirShipPacket, Opcode: FE:6F
Packet: ExValidateLocationInAirShipPacket, Opcode: FE:70
Packet: ExUISettingPacket, Opcode: FE:71
Packet: ExMoveToTargetInAirShipPacket, Opcode: FE:72
Packet: ExAttackInAirShipPacket, Opcode: FE:73
Packet: ExMagicSkillUseInAirShipPacket, Opcode: FE:74
Packet: ExShowBaseAttributeCancelWindow, Opcode: FE:75
Packet: ExBaseAttributeCancelResult, Opcode: FE:76
Packet: ExSubPledgetSkillAdd, Opcode: FE:77
Packet: ExResponseFreeServer, Opcode: FE:78
Packet: ExShowProcureCropDetailPacket, Opcode: FE:79
Packet: ExHeroListPacket, Opcode: FE:7A
Packet: ExOlympiadUserInfoPacket, Opcode: FE:7B
Packet: ExOlympiadSpelledInfoPacket, Opcode: FE:7C
Packet: ExOlympiadModePacket, Opcode: FE:7D
Packet: ExShowFortressMapInfo, Opcode: FE:7E
Packet: ExPVPMatchRecord, Opcode: FE:7F
Packet: ExPVPMatchUserDie, Opcode: FE:80
Packet: ExPrivateStoreWholeMsg, Opcode: FE:81
Packet: ExPutEnchantTargetItemResult, Opcode: FE:82
Packet: ExPutEnchantSupportItemResult, Opcode: FE:83
Packet: ExChangeNicknameNColor, Opcode: FE:84
Packet: ExGetBookMarkInfoPacket, Opcode: FE:85
Packet: ExNotifyPremiumItem, Opcode: FE:86
Packet: ExGetPremiumItemListPacket, Opcode: FE:87
Packet: ExPeriodicItemList, Opcode: FE:88
Packet: ExJumpToLocation, Opcode: FE:89
Packet: ExPVPMatchCCRecord, Opcode: FE:8A
Packet: ExPVPMatchCCMyRecord, Opcode: FE:8B
Packet: ExPVPMatchCCRetire, Opcode: FE:8C
Packet: ExShowTerritory, Opcode: FE:8D
Packet: ExNpcQuestHtmlMessage, Opcode: FE:8E
Packet: ExSendUIEventPacket, Opcode: FE:8F
Packet: ExNotifyBirthDay, Opcode: FE:90
Packet: ExShowDominionRegistry, Opcode: FE:91
Packet: ExReplyRegisterDominion, Opcode: FE:92
Packet: ExReplyDominionInfo, Opcode: FE:93
Packet: ExShowOwnthingPos, Opcode: FE:94
Packet: ExCleftList, Opcode: FE:95
Packet: ExCleftState, Opcode: FE:96
Packet: ExDominionChannelSet, Opcode: FE:97
Packet: ExBlockUpSetList, Opcode: FE:98
Packet: ExBlockUpSetState, Opcode: FE:99
Packet: ExStartScenePlayer, Opcode: FE:9A
Packet: ExAirShipTeleportList, Opcode: FE:9B
Packet: ExMpccRoomInfo, Opcode: FE:9C
Packet: ExListMpccWaiting, Opcode: FE:9D
Packet: ExDissmissMpccRoom, Opcode: FE:9E
Packet: ExManageMpccRoomMember, Opcode: FE:9F
Packet: ExMpccRoomMember, Opcode: FE:A0
Packet: ExVitalityPointInfo, Opcode: FE:A1
Packet: ExShowSeedMapInfo, Opcode: FE:A2
Packet: ExMpccPartymasterList, Opcode: FE:A3
Packet: ExDominionWarStart, Opcode: FE:A4
Packet: ExDominionWarEnd, Opcode: FE:A5
Packet: ExShowLines, Opcode: FE:A6
Packet: ExPartyMemberRenamed, Opcode: FE:A7
Packet: ExEnchantSkillResult, Opcode: FE:A8
Packet: ExRefundList, Opcode: FE:A9
Packet: ExNoticePostArrived, Opcode: FE:AA
Packet: ExShowReceivedPostList, Opcode: FE:AB
Packet: ExReplyReceivedPost, Opcode: FE:AC
Packet: ExShowSentPostList, Opcode: FE:AD
Packet: ExReplySentPost, Opcode: FE:AE
Packet: ExResponseShowStepOne, Opcode: FE:AF
Packet: ExResponseShowStepTwo, Opcode: FE:B0
Packet: ExResponseShowContents, Opcode: FE:B1
Packet: ExShowPetitionHtml, Opcode: FE:B2
Packet: ExReplyPostItemList, Opcode: FE:B3
Packet: ExChangePostState, Opcode: FE:B4
Packet: ExReplyWritePost, Opcode: FE:B5
Packet: ExInitializeSeed, Opcode: FE:B6
Packet: ExRaidReserveResult, Opcode: FE:B7
Packet: ExBuySellListPacket, Opcode: FE:B8
Packet: ExCloseRaidSocket, Opcode: FE:B9
Packet: ExPrivateMarketListPacket, Opcode: FE:BA
Packet: ExRaidCharacterSelected, Opcode: FE:BB
Packet: ExAskCoupleAction, Opcode: FE:BC
Packet: ExBrBroadcastEventState, Opcode: FE:BD
Packet: ExBR_LoadEventTopRankersPacket, Opcode: FE:BE
Packet: ExChangeNPCState, Opcode: FE:BF
Packet: ExAskModifyPartyLooting, Opcode: FE:C0
Packet: ExSetPartyLooting, Opcode: FE:C1
Packet: ExRotation, Opcode: FE:C2
Packet: ExChangeClientEffectInfo, Opcode: FE:C3
Packet: ExMembershipInfo, Opcode: FE:C4
Packet: ExReplyHandOverPartyMaster, Opcode: FE:C5
Packet: ExQuestNpcLogList, Opcode: FE:C6
Packet: ExQuestItemListPacket, Opcode: FE:C7
Packet: ExGMViewQuestItemListPacket, Opcode: FE:C8
Packet: ExResartResponse, Opcode: FE:C9
Packet: ExVoteSystemInfoPacket, Opcode: FE:CA
Packet: ExShuttuleInfoPacket, Opcode: FE:CB
Packet: ExSuttleGetOnPacket, Opcode: FE:CC
Packet: ExSuttleGetOffPacket, Opcode: FE:CD
Packet: ExSuttleMovePacket, Opcode: FE:CE
Packet: ExMTLInSuttlePacket, Opcode: FE:CF
Packet: ExStopMoveInShuttlePacket, Opcode: FE:D0
Packet: ExValidateLocationInShuttlePacket, Opcode: FE:D1
Packet: ExAgitAuctionCmdPacket, Opcode: FE:D2
Packet: ExConfirmAddingPostFriend, Opcode: FE:D3
Packet: ExReceiveShowPostFriend, Opcode: FE:D4
Packet: ExReceiveOlympiadPacket, Opcode: FE:D5
Packet: ExBR_GamePointPacket, Opcode: FE:D6
Packet: ExBR_ProductListPacket, Opcode: FE:D7
Packet: ExBR_ProductInfoPacket, Opcode: FE:D8
Packet: ExBR_BuyProductPacket, Opcode: FE:D9
Packet: ExBR_PremiumStatePacket, Opcode: FE:DA
Packet: ExBrExtraUserInfo, Opcode: FE:DB
Packet: ExBrBuffEventState, Opcode: FE:DC
Packet: ExBR_RecentProductListPacket, Opcode: FE:DD
Packet: ExBR_MinigameLoadScoresPacket, Opcode: FE:DE
Packet: ExBR_AgathionEnergyInfoPacket, Opcode: FE:DF
Packet: ExShowChannelingEffectPacket, Opcode: FE:E0
Packet: ExGetCrystalizingEstimation, Opcode: FE:E1
Packet: ExGetCrystalizingFail, Opcode: FE:E2
Packet: ExNavitAdventPointInfoPacket, Opcode: FE:E3
Packet: ExNavitAdventEffectPacket, Opcode: FE:E4
Packet: ExNavitAdventTimeChangePacket, Opcode: FE:E5
Packet: ExAbnormalStatusUpdateFromTargetPacket, Opcode: FE:E6
Packet: ExStopScenePlayerPacket, Opcode: FE:E7
Packet: ExFlyMove, Opcode: FE:E8
Packet: ExDynamicQuestPacket, Opcode: FE:E9
Packet: ExSubjobInfo, Opcode: FE:EA
Packet: ExChangeMPCost, Opcode: FE:EB
Packet: ExFriendDetailInfo, Opcode: FE:EC
Packet: ExBlockAddResult, Opcode: FE:ED
Packet: ExBlockRemoveResult, Opcode: FE:EE
Packet: ExBlockDefailInfo, Opcode: FE:EF
Packet: ExLoadInzonePartyHistory, Opcode: FE:F0
Packet: ExFriendNotifyNameChange, Opcode: FE:F1
Packet: ExShowCommission, Opcode: FE:F2
Packet: ExResponseCommissionItemList, Opcode: FE:F3
Packet: ExResponseCommissionInfo, Opcode: FE:F4
Packet: ExResponseCommissionRegister, Opcode: FE:F5
Packet: ExResponseCommissionDelete, Opcode: FE:F6
Packet: ExResponseCommissionList, Opcode: FE:F7
Packet: ExResponseCommissionBuyInfo, Opcode: FE:F8
Packet: ExResponseCommissionBuyItem, Opcode: FE:F9
Packet: ExAcquirableSkillListByClass, Opcode: FE:FA
Packet: ExMagicAttackInfo, Opcode: FE:FB
Packet: ExAcquireSkillInfo, Opcode: FE:FC
Packet: ExNewSkillToLearnByLevelUp, Opcode: FE:FD
Packet: ExCallToChangeClass, Opcode: FE:FE
Packet: ExChangeToAwakenedClass, Opcode: FE:FF
Packet: ExTacticalSign, Opcode: FE:100
Packet: ExLoadStatWorldRank, Opcode: FE:101
Packet: ExLoadStatUser, Opcode: FE:102
Packet: ExLoadStatHotLink, Opcode: FE:103
Packet: ExWaitWaitingSubStituteInfo, Opcode: FE:104
Packet: ExRegistWaitingSubstituteOk, Opcode: FE:105
Packet: ExRegistPartySubstitute, Opcode: FE:106
Packet: ExDeletePartySubstitute, Opcode: FE:107
Packet: ExTimeOverPartySubstitute, Opcode: FE:108
Packet: ExGet24HzSessionID, Opcode: FE:109
Packet: Ex2NDPasswordCheckPacket, Opcode: FE:10A
Packet: Ex2NDPasswordVerifyPacket, Opcode: FE:10B
Packet: Ex2NDPasswordAckPacket, Opcode: FE:10C
Packet: ExFlyMoveBroadcast, Opcode: FE:10D
Packet: ExShowUsmPacket, Opcode: FE:10E
Packet: ExShowStatPage, Opcode: FE:10F
Packet: ExIsCharNameCreatable, Opcode: FE:110
Packet: ExGoodsInventoryChangedNotiPacket, Opcode: FE:111
Packet: ExGoodsInventoryInfoPacket, Opcode: FE:112
Packet: ExGoodsInventoryResultPacket, Opcode: FE:113
Packet: ExAlterSkillRequest, Opcode: FE:114
Packet: ExNotifyFlyMoveStart, Opcode: FE:115
Packet: ExDummyPacket, Opcode: FE:116
Packet: ExCloseCommission, Opcode: FE:117
Packet: ExChangeAttributeItemList, Opcode: FE:118
Packet: ExChangeAttributeInfo, Opcode: FE:119
Packet: ExChangeAttributeOk, Opcode: FE:11A
Packet: ExChangeAttributeFail, Opcode: FE:11B
Packet: ExExchangeSubstitute, Opcode: FE:11C
Packet: ExLightingCandleEvent, Opcode: FE:11D
Packet: ExVitalityEffectInfo, Opcode: FE:11E
Packet: ExLoginVitalityEffectInfo, Opcode: FE:11F
Packet: ExBR_PresentBuyProductPacket, Opcode: FE:120
Packet: ExMentorList, Opcode: FE:121
Packet: ExMentorAdd, Opcode: FE:122
Packet: ListMenteeWaitingPacket, Opcode: FE:123
Packet: ExInzoneWaitingInfo, Opcode: FE:124
Packet: ExCuriousHouseState, Opcode: FE:125
Packet: ExCuriousHouseEnter, Opcode: FE:126
Packet: ExCuriousHouseLeave, Opcode: FE:127
Packet: ExCuriousHouseMemberList, Opcode: FE:128
Packet: ExCuriousHouseMemberUpdate, Opcode: FE:129
Packet: ExCuriousHouseRemainTime, Opcode: FE:12A
Packet: ExCuriousHouseResult, Opcode: FE:12B
Packet: ExCuriousHouseObserveList, Opcode: FE:12C
Packet: ExCuriousHouseObserveMode, Opcode: FE:12D
Packet: ExSysstring, Opcode: FE:12E
Packet: ExChoose_Shape_Shifting_Item, Opcode: FE:12F
Packet: ExPut_Shape_Shifting_Target_Item_Result, Opcode: FE:130
Packet: ExPut_Shape_Shifting_Extraction_Item_Result, Opcode: FE:131
Packet: ExShape_Shifting_Result, Opcode: FE:132
Packet: ExCastleState, Opcode: FE:133
Packet: ExNCGuardReceiveDataFromServer, Opcode: FE:134
Packet: ExCheck_SpeedHack, Opcode: FE:135
0xFE:0x142: ExTeleportToLocationActivate

*/


//Lindvior
/*
package l2p.gameserver.network.serverpackets.components;

public class ServerPacket
{
    // standart packets
    public static final int Die = 0x00;
    public static final int Revive = 0x01;
    public static final int AttackOutOfRange = 0x02;
    public static final int AttackinCoolTime = 0x03;
    public static final int AttackDeadTarget = 0x04;
    public static final int SpawnItem = 0x05;
    public static final int SellList = 0x06;
    public static final int BuyList = 0x07;
    public static final int DeleteObject = 0x08;
    public static final int CharacterSelectionInfo = 0x09;
    public static final int LoginFail = 0x0A;
    public static final int CharacterSelected = 0x0B;
    public static final int NpcInfo = 0x0C;
    public static final int NewCharacterSuccess = 0x0D;
    public static final int NewCharacterFail = 0x0E;
    public static final int CharacterCreateSuccess = 0x0F;
    public static final int CharacterCreateFail = 0x10;
    public static final int ItemList = 0x11;
    public static final int SunRise = 0x12;
    public static final int SunSet = 0x13;
    public static final int TradeStart = 0x14;
    public static final int TradeStartOk = 0x15;
    public static final int DropItem = 0x16;
    public static final int GetItem = 0x17;
    public static final int StatusUpdate = 0x18;
    public static final int NpcHtmlMessage = 0x19;
    public static final int TradeOwnAdd = 0x1A;
    public static final int TradeOtherAdd = 0x1B;
    public static final int TradeDone = 0x1C;
    public static final int CharacterDeleteSuccess = 0x1D;
    public static final int CharacterDeleteFail = 0x1E;
    public static final int ActionFail = 0x1F;
    public static final int SeverClose = 0x20;
    public static final int InventoryUpdate = 0x21;
    public static final int TeleportToLocation = 0x22;
    public static final int TargetSelected = 0x23;
    public static final int TargetUnselected = 0x24;
    public static final int AutoAttackStart = 0x25;
    public static final int AutoAttackStop = 0x26;
    public static final int SocialAction = 0x27;
    public static final int ChangeMoveType = 0x28;
    public static final int ChangeWaitType = 0x29;
    public static final int ManagePledgePower = 0x2A;
    public static final int CreatePledge = 0x2B;
    public static final int AskJoinPledge = 0x2C;
    public static final int JoinPledge = 0x2D;
    public static final int VersionCheck = 0x2E;
    public static final int MTL = 0x2F;
    public static final int NS = 0x30;
    public static final int CI = 0x31;
    public static final int UI = 0x32;
    public static final int Attack = 0x33;
    public static final int WithdrawalPledge = 0x34;
    public static final int OustPledgeMember = 0x35;
    public static final int SetOustPledgeMember = 0x36;
    public static final int DismissPledge = 0x37;
    public static final int SetDismissPledge = 0x38;
    public static final int AskJoinParty = 0x39;
    public static final int JoinParty = 0x3A;
    public static final int WithdrawalParty = 0x3B;
    public static final int OustPartyMember = 0x3C;
    public static final int SetOustPartyMember = 0x3D;
    public static final int DismissParty = 0x3E;
    public static final int SetDismissParty = 0x3F;
    public static final int MagicAndSkillList = 0x40;
    public static final int WareHouseDepositList = 0x41;
    public static final int WareHouseWithdrawList = 0x42;
    public static final int WareHouseDone = 0x43;
    public static final int ShortCutRegister = 0x44;
    public static final int ShortCutInit = 0x45;
    public static final int ShortCutDelete = 0x46;
    public static final int StopMove = 0x47;
    public static final int MagicSkillUse = 0x48;
    public static final int MagicSkillCanceled = 0x49;
    public static final int Say2 = 0x4A;
    public static final int EquipUpdate = 0x4B;
    public static final int DoorInfo = 0x4C;
    public static final int DoorStatusUpdate = 0x4D;
    public static final int PartySmallWindowAll = 0x4E;
    public static final int PartySmallWindowAdd = 0x4F;
    public static final int PartySmallWindowDeleteAll = 0x50;
    public static final int PartySmallWindowDelete = 0x51;
    public static final int PartySmallWindowUpdate = 0x52;
    public static final int TradePressOwnOk = 0x53;
    public static final int MagicSkillLaunched = 0x54;
    public static final int FriendAddRequestResult = 0x55;
    public static final int FriendAdd = 0x56;
    public static final int FriendRemove = 0x57;
    public static final int FriendList = 0x58;
    public static final int FriendStatus = 0x59;
    public static final int PledgeShowMemberListAll = 0x5A;
    public static final int PledgeShowMemberListUpdate = 0x5B;
    public static final int PledgeShowMemberListAdd = 0x5C;
    public static final int PledgeShowMemberListDelete = 0x5D;
    public static final int MagicList = 0x5E;
    public static final int SkillList = 0x5F;
    public static final int VehicleInfo = 0x60;
    public static final int FinishRotating = 0x61;
    public static final int SystemMessage = 0x62;
    public static final int StartPledgeWar = 0x63;
    public static final int ReplyStartPledgeWar = 0x64;
    public static final int StopPledgeWar = 0x65;
    public static final int ReplyStopPledgeWar = 0x66;
    public static final int SurrenderPledgeWar = 0x67;
    public static final int ReplySurrenderPledgeWar = 0x68;
    public static final int SetPledgeCrest = 0x69;
    public static final int PledgeCrest = 0x6A;
    public static final int SetupGauge = 0x6B;
    public static final int VehicleDeparture = 0x6C;
    public static final int VehicleCheckLocation = 0x6D;
    public static final int GetOnVehicle = 0x6E;
    public static final int GetOffVehicle = 0x6F;
    public static final int TradeRequest = 0x70;
    public static final int RestartResponse = 0x71;
    public static final int MoveToPawn = 0x72;
    public static final int SSQInfo = 0x73;
    public static final int GameGuardQuery = 0x74;
    public static final int L2FriendList = 0x75;
    public static final int L2Friend = 0x76;
    public static final int L2FriendStatus = 0x77;
    public static final int L2FriendSay = 0x78;
    public static final int ValidateLocation = 0x79;
    public static final int StartRotating = 0x7A;
    public static final int ShowBoard = 0x7B;
    public static final int ChooseInventoryItem = 0x7C;
    public static final int Dummy1 = 0x7D;
    public static final int MoveToLocationInVehicle = 0x7E;
    public static final int StopMoveInVehicle = 0x7F;
    public static final int ValidateLocationInVehicle = 0x80;
    public static final int TradeUpdate = 0x81;
    public static final int TradePressOtherOk = 0x82;
    public static final int FriendAddRequest = 0x83;
    public static final int LogOutOk = 0x84;
    public static final int AbnormalStatusUpdate = 0x85;
    public static final int QuestList = 0x86;
    public static final int EnchantResult = 0x87;
    public static final int PledgeShowMemberListDeleteAll = 0x88;
    public static final int PledgeInfo = 0x89;
    public static final int PledgeExtendedInfo = 0x8A;
    public static final int SurrenderPersonally = 0x8B;
    public static final int Ride = 0x8C;
    public static final int Dummy2 = 0x8D;
    public static final int PledgeShowInfoUpdate = 0x8E;
    public static final int ClientAction = 0x8F;
    public static final int AcquireSkillList = 0x90;
    public static final int AcquireSkillInfo = 0x91;
    public static final int ServerObjectInfo = 0x92;
    public static final int GMHide = 0x93;
    public static final int AcquireSkillDone = 0x94;
    public static final int GMViewCharacterInfo = 0x95;
    public static final int GMViewPledgeInfo = 0x96;
    public static final int GMViewSkillInfo = 0x97;
    public static final int GMViewMagicInfo = 0x98;
    public static final int GMViewQuestInfo = 0x99;
    public static final int GMViewItemList = 0x9A;
    public static final int GMViewWarehouseWithdrawList = 0x9B;
    public static final int ListPartyWating = 0x9C;
    public static final int PartyRoomInfo = 0x9D;
    public static final int PlaySound = 0x9E;
    public static final int StaticObject = 0x9F;
    public static final int PrivateStoreManageList = 0xA0;
    public static final int PrivateStoreList = 0xA1;
    public static final int PrivateStoreMsg = 0xA2;
    public static final int ShowMinimap = 0xA3;
    public static final int ReviveRequest = 0xA4;
    public static final int AbnormalVisualEffect = 0xA5;
    public static final int TutorialShowHtml = 0xA6;
    public static final int TutorialShowQuestionMark = 0xA7;
    public static final int TutorialEnableClientEvent = 0xA8;
    public static final int TutorialCloseHtml = 0xA9;
    public static final int ShowRadar = 0xAA;
    public static final int WithdrawAlliance = 0xAB;
    public static final int OustAllianceMemberPledge = 0xAC;
    public static final int DismissAlliance = 0xAD;
    public static final int SetAllianceCrest = 0xAE;
    public static final int AllianceCrest = 0xAF;
    public static final int ServerCloseSocket = 0xB0;
    public static final int PetStatusShow = 0xB1;
    public static final int PetInfo = 0xB2;
    public static final int PetItemList = 0xB3;
    public static final int PetInventoryUpdate = 0xB4;
    public static final int AllianceInfo = 0xB5;
    public static final int PetStatusUpdate = 0xB6;
    public static final int PetDelete = 0xB7;
    public static final int DeleteRadar = 0xB8;
    public static final int MyTargetSelected = 0xB9;
    public static final int PartyMemberPosition = 0xBA;
    public static final int AskJoinAlliance = 0xBB;
    public static final int JoinAlliance = 0xBC;
    public static final int PrivateStoreBuyManageList = 0xBD;
    public static final int PrivateStoreBuyList = 0xBE;
    public static final int PrivateStoreBuyMsg = 0xBF;
    public static final int VehicleStart = 0xC0;
    public static final int RequestTimeCheck = 0xC1;
    public static final int StartAllianceWar = 0xC2;
    public static final int ReplyStartAllianceWar = 0xC3;
    public static final int StopAllianceWar = 0xC4;
    public static final int ReplyStopAllianceWar = 0xC5;
    public static final int SurrenderAllianceWar = 0xC6;
    public static final int SkillCoolTime = 0xC7;
    public static final int PackageToList = 0xC8;
    public static final int CastleSiegeInfo = 0xC9;
    public static final int CastleSiegeAttackerList = 0xCA;
    public static final int CastleSiegeDefenderList = 0xCB;
    public static final int NickNameChanged = 0xCC;
    public static final int PledgeStatusChanged = 0xCD;
    public static final int RelationChanged = 0xCE;
    public static final int EventTrigger = 0xCF;
    public static final int MultiSellList = 0xD0;
    public static final int SetSummonRemainTime = 0xD1;
    public static final int PackageSendableList = 0xD2;
    public static final int EarthQuake = 0xD3;
    public static final int FlyToLocation = 0xD4;
    public static final int BlockList = 0xD5;
    public static final int SpecialCamera = 0xD6;
    public static final int NormalCamera = 0xD7;
    public static final int SkillRemainSec = 0xD8;
    public static final int NetPing = 0xD9;
    public static final int Dice = 0xDA;
    public static final int Snoop = 0xDB;
    public static final int RecipeBookItemList = 0xDC;
    public static final int RecipeItemMakeInfo = 0xDD;
    public static final int RecipeShopManageList = 0xDE;
    public static final int RecipeShopSellList = 0xDF;
    public static final int RecipeShopItemInfo = 0xE0;
    public static final int RecipeShopMsg = 0xE1;
    public static final int ShowCalc = 0xE2;
    public static final int MonRaceInfo = 0xE3;
    public static final int HennaItemInfo = 0xE4;
    public static final int HennaInfo = 0xE5;
    public static final int HennaUnequipList = 0xE6;
    public static final int HennaUnequipInfo = 0xE7;
    public static final int MacroList = 0xE8;
    public static final int BuyListSeed = 0xE9;
    public static final int ShowTownMap = 0xEA;
    public static final int ObserverStart = 0xEB;
    public static final int ObserverEnd = 0xEC;
    public static final int ChairSit = 0xED;
    public static final int HennaEquipList = 0xEE;
    public static final int SellListProcure = 0xEF;
    public static final int GMHennaInfo = 0xF0;
    public static final int RadarControl = 0xF1;
    public static final int ClientSetTime = 0xF2;
    public static final int ConfirmDlg = 0xF3;
    public static final int PartySpelled = 0xF4;
    public static final int ShopPreviewList = 0xF5;
    public static final int ShopPreviewInfo = 0xF6;
    public static final int CameraMode = 0xF7;
    public static final int ShowXMasSeal = 0xF8;
    public static final int EtcStatusUpdate = 0xF9;
    public static final int ShortBuffStatusUpdate = 0xFA;
    public static final int SSQStatus = 0xFB;
    public static final int PetitionVote = 0xFC;
    public static final int AgitDecoInfo = 0xFD;
    // extended packets
 

	

}




*/

static const char* servToClientExTXT_Classic[0x171] =
{
	"0xfe:0x00 :: ExDummyPacket :: maybe trigger",
    "EX :: ExRegenMax = 0x01",
    "EX :: ExEventMatchUserInfo = 0x02",
    "EX :: ExColosseumFenceInfo = 0x03",
    "EX :: ExEventMatchSpelledInfo = 0x04",
    "EX :: ExEventMatchFirecracker = 0x05",
    "EX :: ExEventMatchTeamUnlocked = 0x06",
    "EX :: ExEventMatchGMTest = 0x07",
    "EX :: ExPartyRoomMember = 0x08",
    "EX :: ExClosePartyRoom = 0x09",
    "EX :: ExManagePartyRoomMember = 0x0A",
    "EX :: ExEventMatchLockResult = 0x0B",
    "EX :: ExAutoSoulShot = 0x0C",
    "EX :: ExEventMatchList = 0x0D",
    "EX :: ExEventMatchObserver = 0x0E",
    "EX :: ExEventMatchMessage = 0x0F",
    "EX :: ExEventMatchScore = 0x10",
    "EX :: ExServerPrimitive = 0x11",
    "EX :: ExOpenMPCC = 0x12",
    "EX :: ExCloseMPCC = 0x13",
    "EX :: ExShowCastleInfo = 0x14",
    "EX :: ExShowFortressInfo = 0x15",
    "EX :: ExShowAgitInfo = 0x16",
    "EX :: ExShowFortressSiegeInfo = 0x17",
    "EX :: ExPartyPetWindowAdd = 0x18",
    "EX :: ExPartyPetWindowUpdate = 0x19",
    "EX :: ExAskJoinMPCC = 0x1A",
    "EX :: ExPledgeEmblem = 0x1B",
    "EX :: ExEventMatchTeamInfo = 0x1C",
    "EX :: ExEventMatchCreate = 0x1D",
    "EX :: ExFishingStart = 0x1E",
    "EX :: ExFishingEnd = 0x1F",
    "EX :: ExShowQuestInfo = 0x20",
    "EX :: ExShowQuestMark = 0x21",
    "EX :: ExSendManorList = 0x22",
    "EX :: ExShowSeedInfo = 0x23",
    "EX :: ExShowCropInfo = 0x24",
    "EX :: ExShowManorDefaultInfo = 0x25",
    "EX :: ExShowSeedSetting = 0x26",
    "EX :: ExFishingStartCombat = 0x27",
    "EX :: ExFishingHpRegen = 0x28",
    "EX :: ExEnchantSkillList = 0x29",
    "EX :: ExEnchantSkillInfo = 0x2A",
    "EX :: ExShowCropSetting = 0x2B",
    "EX :: ExShowSellCropList = 0x2C",
    "EX :: ExOlympiadMatchEnd = 0x2D",
    "EX :: ExMailArrived = 0x2E",
    "EX :: ExStorageMaxCount = 0x2F",
    "EX :: ExEventMatchManage = 0x30",
    "EX :: ExMultiPartyCommandChannelInfo = 0x31",
    "EX :: ExPCCafePointInfo = 0x32",
    "EX :: ExSetCompassZoneCode = 0x33",
    "EX :: ExGetBossRecord = 0x34",
    "EX :: ExAskJoinPartyRoom = 0x35",
    "EX :: ExListPartyMatchingWaitingRoom = 0x36",
    "EX :: ExSetMpccRouting = 0x37",
    "EX :: ExShowAdventurerGuideBook = 0x38",
    "EX :: ExShowScreenMessage = 0x39",
    "EX :: PledgeSkillList = 0x3A",
    "EX :: PledgeSkillListAdd = 0x3B",
    "EX :: PledgeSkillListRemove = 0x3C",
    "EX :: PledgePowerGradeList = 0x3D",
    "EX :: PledgeReceivePowerInfo = 0x3E",
    "EX :: PledgeReceiveMemberInfo = 0x3F",
    "EX :: PledgeReceiveWarList = 0x40",
    "EX :: PledgeReceiveSubPledgeCreated = 0x41",
    "EX :: ExRedSky = 0x42",
    "EX :: PledgeReceiveUpdatePower = 0x43",
    "EX :: FlySelfDestination = 0x44",
    "EX :: ShowPCCafeCouponShowUI = 0x45",
    "EX :: ExSearchOrc = 0x46",
    "EX :: ExCursedWeaponList = 0x47",
    "EX :: ExCursedWeaponLocation = 0x48",
    "EX :: ExRestartClient = 0x49",
    "EX :: ExRequestHackShield = 0x4A",
    "EX :: ExUseSharedGroupItem = 0x4B",
    "EX :: ExMPCCShowPartyMemberInfo = 0x4C",
    "EX :: ExDuelAskStart = 0x4D",
    "EX :: ExDuelReady = 0x4E",
    "EX :: ExDuelStart = 0x4F",
    "EX :: ExDuelEnd = 0x50",
    "EX :: ExDuelUpdateUserInfo = 0x51",
    "EX :: ExShowVariationMakeWindow = 0x52",
    "EX :: ExShowVariationCancelWindow = 0x53",
    "EX :: ExPutItemResultForVariationMake = 0x54",
    "EX :: ExPutIntensiveResultForVariationMake = 0x55",
    "EX :: ExPutCommissionResultForVariationMake = 0x56",
    "EX :: ExVariationResult = 0x57",
    "EX :: ExPutItemResultForVariationCancel = 0x58",
    "EX :: ExVariationCancelResult = 0x59",
    "EX :: ExDuelEnemyRelation = 0x5A",
    "EX :: ExPlayAnimation = 0x5B",
    "EX :: ExMPCCPartyInfoUpdate = 0x5C",
    "EX :: ExPlayScene = 0x5D",
    "EX :: ExSpawnEmitter = 0x5E",
    "EX :: ExEnchantSkillInfoDetail = 0x5F",
    "EX :: ExBasicActionList = 0x60",
    "EX :: ExAirShipInfo = 0x61",
    "EX :: ExAttributeEnchantResult = 0x62",
    "EX :: ExChooseInventoryAttributeItem = 0x63",
    "EX :: ExGetOnAirShip = 0x64",
    "EX :: ExGetOffAirShip = 0x65",
    "EX :: ExMoveToLocationAirShip = 0x66",
    "EX :: ExStopMoveAirShip = 0x67",
    "EX :: ExShowTrace = 0x68",
    "EX :: ExItemAuctionInfo = 0x69",
    "EX :: ExNeedToChangeName = 0x6A",
    "EX :: ExPartyPetWindowDelete = 0x6B",
    "EX :: ExTutorialList = 0x6C",
    "EX :: ExRpItemLink = 0x6D",
    "EX :: ExMoveToLocationInAirShip = 0x6E",
    "EX :: ExStopMoveInAirShip = 0x6F",
    "EX :: ExValidateLocationInAirShip = 0x70",
    "EX :: ExUISetting = 0x71",
    "EX :: ExMoveToTargetInAirShip = 0x72",
    "EX :: ExAttackInAirShip = 0x73",
    "EX :: ExMagicSkillUseInAirShip = 0x74",
    "EX :: ExShowBaseAttributeCancelWindow = 0x75",
    "EX :: ExBaseAttributeCancelResult = 0x76",
    "EX :: ExSubPledgeSkillAdd = 0x77",
    "EX :: ExResponseFreeServer = 0x78",
    "EX :: ExShowProcureCropDetail = 0x79",
    "EX :: ExHeroList = 0x7A",
    "EX :: ExOlympiadUserInfo = 0x7B",
    "EX :: ExOlympiadSpelledInfo = 0x7C",
    "EX :: ExOlympiadMode = 0x7D",
    "EX :: ExShowFortressMapInfo = 0x7E",
    "EX :: ExPVPMatchRecord = 0x7F",
    "EX :: ExPVPMatchUserDie = 0x80",
    "EX :: ExPrivateStoreWholeMsg = 0x81",
    "EX :: ExPutEnchantTargetItemResult = 0x82",
    "EX :: ExPutEnchantSupportItemResult = 0x83",
    "EX :: ExChangeNicknameNColor = 0x84",
    "EX :: ExGetBookMarkInfo = 0x85",
    "EX :: ExNotifyPremiumItem = 0x86",
    "EX :: ExGetPremiumItemList = 0x87",
    "EX :: ExPeriodicItemList = 0x88",
    "EX :: ExJumpToLocation = 0x89",
    "EX :: ExPVPMatchCCRecord = 0x8A",
    "EX :: ExPVPMatchCCMyRecord = 0x8B",
    "EX :: ExPVPMatchCCRetire = 0x8C",
    "EX :: ExShowTerritory = 0x8D",
    "EX :: ExNpcQuestHtmlMessage = 0x8E",
    "EX :: ExSendUIEvent = 0x8F",
    "EX :: ExNotifyBirthDay = 0x90",
    "EX :: ExShowDominionRegistry = 0x91",
    "EX :: ExReplyRegisterDominion = 0x92",
    "EX :: ExReplyDominionInfo = 0x93",
    "EX :: ExShowOwnthingPos = 0x94",
    "EX :: ExCleftList = 0x95",
    "EX :: ExCleftState = 0x96",
    "EX :: ExDominionChannelSet = 0x97",
    "EX :: ExBlockUpSetList = 0x98",
    "EX :: ExBlockUpSetState = 0x99",
    "EX :: ExStartScenePlayer = 0x9A",
    "EX :: ExAirShipTeleportList = 0x9B",
    "EX :: ExMpccRoomInfo = 0x9C",
    "EX :: ExListMpccWaiting = 0x9D",
    "EX :: ExDissmissMpccRoom = 0x9E",
    "EX :: ExManageMpccRoomMember = 0x9F",
    "EX :: ExMpccRoomMember = 0xA0",
    "EX :: ExVitalityPointInfo = 0xA1",
    "EX :: ExShowSeedMapInfo = 0xA2",
    "EX :: ExMpccPartymasterList = 0xA3",
    "EX :: ExDominionWarStart = 0xA4",
    "EX :: ExDominionWarEnd = 0xA5",
    "EX :: ExShowLines = 0xA6",
    "EX :: ExPartyMemberRenamed = 0xA7",
    "EX :: ExEnchantSkillResult = 0xA8",
    "EX :: ExRefundList = 0xA9",
    "EX :: ExNoticePostArrived = 0xAA",
    "EX :: ExShowReceivedPostList = 0xAB",
    "EX :: ExReplyReceivedPost = 0xAC",
    "EX :: ExShowSentPostList = 0xAD",
    "EX :: ExReplySentPost = 0xAE",
    "EX :: ExResponseShowStepOne = 0xAF",
    "EX :: ExResponseShowStepTwo = 0xB0",
    "EX :: ExResponseShowContents = 0xB1",
    "EX :: ExShowPetitionHtml = 0xB2",
    "EX :: ExReplyPostItemList = 0xB3",
    "EX :: ExChangePostState = 0xB4",
    "EX :: ExReplyWritePost = 0xB5",
    "EX :: ExInitializeSeed = 0xB6",
    "EX :: ExRaidReserveResult = 0xB7",
    "EX :: ExBuySellList = 0xB8",
    "EX :: ExCloseRaidSocket = 0xB9",
    "EX :: ExPrivateMarketList = 0xBA",
    "EX :: ExRaidCharacterSelected = 0xBB",
    "EX :: ExAskCoupleAction = 0xBC",
    "EX :: ExBR_BroadcastEventState = 0xBD",
    "EX :: ExBR_LoadEventTopRankers = 0xBE",
    "EX :: ExChangeNPCState = 0xBF",
    "EX :: ExAskModifyPartyLooting = 0xC0",
    "EX :: ExSetPartyLooting = 0xC1",
    "EX :: ExRotation = 0xC2",
    "EX :: ExChangeClientEffectInfo = 0xC3",
    "EX :: ExMembershipInfo = 0xC4",
    "EX :: ExReplyHandOverPartyMaster = 0xC5",
    "EX :: ExQuestNpcLogList = 0xC6",
    "EX :: ExQuestItemList = 0xC7",
    "EX :: ExGMViewQuestItemList = 0xC8",
    "EX :: ExRestartResponse = 0xC9",
    "EX :: ExVoteSystemInfo = 0xCA",
    "EX :: ExShuttleInfo = 0xCB",
    "EX :: ExShuttleGetOn = 0xCC",
    "EX :: ExShuttleGetOff = 0xCD",
    "EX :: ExShuttleMove = 0xCE",
    "EX :: ExMTLInShuttle = 0xCF",
    "EX :: ExStopMoveInShuttle = 0xD0",
    "EX :: ExValidateLocationInShuttle = 0xD1",
    "EX :: ExAgitAuctionCmd = 0xD2",
    "EX :: ExConfirmAddingPostFriend = 0xD3",
    "EX :: ExReceiveShowPostFriend = 0xD4",
    "EX :: ExReceiveOlympiad = 0xD5",
    "EX :: ExBR_GamePoint = 0xD6",
    "EX :: ExBR_ProductList = 0xD7",
    "EX :: ExBR_ProductInfo = 0xD8",
    "EX :: ExBR_BuyProduct = 0xD9",
    "EX :: ExBR_PremiumState = 0xDA",
    "EX :: ExBR_ExtraUserInfo = 0xDB",
    "EX :: ExBR_BuffEventState = 0xDC",
    "EX :: ExBR_RecentProductList = 0xDD",
    "EX :: ExBR_MiniGameLoadScores = 0xDE",
    "EX :: ExBR_AgathionEnergyInfo = 0xDF",
    "EX :: ExShowChannelingEffect = 0xE0",
    "EX :: ExGetCrystalizingEstimation = 0xE1",
    "EX :: ExGetCrystalizingFail = 0xE2",
    "EX :: ExNavitAdventPointInfo = 0xE3",
    "EX :: ExNavitAdventEffect = 0xE4",
    "EX :: ExNavitAdventTimeChange = 0xE5",
    "EX :: ExAbnormalStatusUpdateFromTarget = 0xE6",
    "EX :: ExStopScenePlayer = 0xE7",
    "EX :: ExFlyMove = 0xE8",
    "EX :: ExDynamicQuest = 0xE9",
    "EX :: ExSubjobInfo = 0xEA",
    "EX :: ExChangeMPCost = 0xEB",
    "EX :: ExFriendDetailInfo = 0xEC",
    "EX :: ExBlockAddResult = 0xED",
    "EX :: ExBlockRemoveResult = 0xEE",
    "EX :: ExBlockDefailInfo = 0xEF",
    "EX :: ExLoadInzonePartyHistory = 0xF0",
    "EX :: ExFriendNotifyNameChange = 0xF1",
    "EX :: ExShowCommission = 0xF2",
    "EX :: ExResponseCommissionItemList = 0xF3",
    "EX :: ExResponseCommissionInfo = 0xF4",
    "EX :: ExResponseCommissionRegister = 0xF5",
    "EX :: ExResponseCommissionDelete = 0xF6",
    "EX :: ExResponseCommissionList = 0xF7",
    "EX :: ExResponseCommissionBuyInfo = 0xF8",
    "EX :: ExResponseCommissionBuyItem = 0xF9",
    "EX :: ExAcquirableSkillListByClass = 0xFA",
    "EX :: ExMagicAttackInfo = 0xFB",
    "EX :: ExAcquireSkillInfo = 0xFC",
    "EX :: ExNewSkillToLearnByLevelUp = 0xFD",
    "EX :: ExCallToChangeClass = 0xFE",
    "EX :: ExChangeToAwakenedClass = 0xFF",
    "EX :: ExTacticalSign = 0x100",
    "EX :: ExLoadStatWorldRank = 0x101",
    "EX :: ExLoadStatUser = 0x102",
    "EX :: ExLoadStatHotLink = 0x103",
    "EX :: ExWaitWaitingSubStituteInfo = 0x104",
    "EX :: ExRegistWaitingSubstituteOk = 0x105",
    "EX :: ExRegistPartySubstitute = 0x106",
    "EX :: ExDeletePartySubstitute = 0x107",
    "EX :: ExTimeOverPartySubstitute = 0x108",
    "EX :: ExGet24HzSessionID = 0x109",
    "EX :: Ex2ndPasswordCheck = 0x10A",
    "EX :: Ex2ndPasswordVerify = 0x10B",
    "EX :: Ex2ndPasswordAck = 0x10C",
    "EX :: ExFlyMoveBroadcast = 0x10D",
    "EX :: ExShowUsm = 0x10E",
    "EX :: ExShowStatPage = 0x10F",
    "EX :: ExIsCharNameCreatable = 0x110",
    "EX :: ExGoodsInventoryChangedNotify = 0x111",
    "EX :: ExGoodsInventoryInfo = 0x112",
    "EX :: ExGoodsInventoryResult = 0x113",
    "EX :: ExAlterSkillRequest = 0x114",
    "EX :: ExNotifyFlyMoveStart = 0x115",
    "EX :: ExDummy = 0x116",
    "EX :: ExCloseCommission = 0x117",
    "EX :: ExChangeAttributeItemList = 0x118",
    "EX :: ExChangeAttributeInfo = 0x119",
    "EX :: ExChangeAttributeOk = 0x11A",
    "EX :: ExChangeAttributeFail = 0x11B",
    "EX :: ExExchangeSubstitute = 0x11C",
    "EX :: ExLightingCandleEvent = 0x11D",
    "EX :: ExVitalityEffectInfo = 0x11E",
    "EX :: ExLoginVitalityEffectInfo = 0x11F",
    "EX :: ExBR_PresentBuyProduct = 0x120",
    "EX :: ExMentorList = 0x121",
    "EX :: ExMentorAdd = 0x122",
    "EX :: ListMenteeWaiting = 0x123",
    "EX :: ExInZoneWaitingInfo = 0x124",
    "EX :: ExCuriousHouseState = 0x125",
    "EX :: ExCuriousHouseEnter = 0x126",
    "EX :: ExCuriousHouseLeave = 0x127",
    "EX :: ExCuriousHouseMemberList = 0x128",
    "EX :: ExCuriousHouseMemberUpdate = 0x129",
    "EX :: ExCuriousHouseRemainTime = 0x12A",
    "EX :: ExCuriousHouseResult = 0x12B",
    "EX :: ExCuriousHouseObserveList = 0x12C",
    "EX :: ExCuriousHouseObserveMode = 0x12D",
    "EX :: ExSysstring = 0x12E",
    "EX :: ExChooseShapeShiftingItem = 0x12F",
    "EX :: ExPutShapeShiftingTargetItemResult = 0x130",
    "EX :: ExPutShapeShiftingExtractionItemResult = 0x131",
    "EX :: ExShapeShiftingResult = 0x132",
    "EX :: ExCastleState = 0x133",
    "EX :: ExNCGuardReceiveDataFromServer = 0x134",
    "EX :: ExKalieEvent = 0x135",
    "EX :: ExPledgeUnionState = 0x136",
    "EX :: ExPledgeUnionFlow = 0x137",
    "EX :: ExPledgeUnionStateInfo = 0x138",
    "EX :: ExUnionPoint = 0x139",
    "EX :: ExKalieEventJackpotUser = 0x13A",
    "EX :: ExAbnormalVisualEffectInfo = 0x13B",
    "EX :: ExNpcSpeedInfo = 0x13C",
    "EX :: ExSetPledgeEmblemAck = 0x13D",
    "EX :: ExAdenaInvenCount = 0x13E 558- ExShowBeautyMenu",
    "EX :: ExResponseBeautyList = 0x13F",
    "EX :: ExResponseBeautyRegistReset = 0x140",
    "EX :: ExResponseResetList = 0x141",
    "EX :: ExShuffleSeedAndPublicKey = 0x142",
    "EX :: ExCheck_SpeedHack = 0x143",
    "EX :: ExBR_NewIConCashBtnWnd = 0x144",
    "EX :: ExEvent_Campaign_Info = 0x145",
    "EX :: ExUnReadMailCount = 0x146",
    "EX :: ExPledgeCount = 0x147",
    "EX :: ExAdenaInvenCount = 0x148",
    "EX :: ExPledgeRecruitInfo = 0x149",
//    "EX :: ExPledgeRecruitApplyInfo = 0x14A",
//    "EX :: ExPledgeRecruitBoardSearch = 0x14B",
 //   "EX :: ExPledgeRecruitBoardDetail = 0x14C",
 //   "EX :: ExPledgeWaitingListApplied = 0x14D",
 //   "EX :: ExPledgeWaitingList = 0x14E",
 //   "EX :: ExPledgeWaitingUser = 0x14F",
 //   "EX :: ExPledgeDraftListSearch = 0x150",
 //   "EX :: ExPledgeWaitingListAlarm = 0x151",
 //   "EX :: ExValidateActiveCharacter = 0x152",
 //   "EX :: ExCloseCommissionRegister = 0x153",
 "EX :: ExTeleportToLocationActivate = 0x154  Classic:14A",
    "EX :: ExNotifyWebPetitionReplyAlarm = 0x155 14B",
    "EX :: ExEventShowXMasWishCard = 0x156 14C",
	    "EX 0x14C+ ::Special packet by smeli",
	    "EX 0x14D ::ExPutEnchantScrollItemResult ",
		"EX 0x14E ::ExRemoveEnchantSupportItemResult",
		"EX 0x150 ::ExShowCardRewardList::TeleportActivate575 ",
		"EX 0x151 ::ExPartySmallWindowUpdateVital",
		"EX 0x152 ::ExPartySmallWindowUpdateHPMPCP",
		"EX 0x153 ::ExPartySmallWindowUpdateSubtitute",
		"EX 0x154 ::ExGmViewCharacterInfo 558-ExTeleportToLocationActivate",
		"EX 0x155 ::ExUserInfo 558-ExNotifyWebPetitionReplyAlarm",
		"EX 0x156 ::ExUserInfoEquipSlot 558-ExEventShowXMasWishCard",
		"EX 0x157 ::ExUserInfoCubic 558-ExInvitation_Event_UI_Setting",
		"EX 0x158 ::ExUserInfoAbnormalVisualEffect 558-ExInvitation_Event_Ink_Energy",
		"EX 0x159 ::ExUserInfoFishing 558-Ex_Check_Abusing",
		"EX 0x15A ::ExPartySpelledInfoUpdate 558-ExGMVitalityEffectInfo",
		"EX 0x15B::ExDivideAdenaStart 558-ExPathToAwakeningAlarm",
		"EX 0x15C::ExDivideAdenaCancel 558-ExPartySmallWindowUpdateVital",
		"EX 0x15D ::ExDivideAdenaDone 558-ExPartySmallWindowUpdateHPMPCP",
		"EX 0x15E ::ExPetInfo 558-ExPartySmallWindowUpdateSubtitute",
		"EX 0x15F ::ExSummonInfo 558-ExGmViewCharacterInfo",
		"EX 0x160 ::ExNpcInfo 558-ExUserInfo",
		"EX 0x161 ::558-ExUserEquipSlot 19 ExAcquirePotentialSkillList",
		"EX 0x162 ::558-ExUserInfoCubic",
		"EX 0x163 ::558-ExUserInfoAbnormalVisualEffect",
		"EX 0x164 ::558-ExUserInfoFishing",
		"EX 0x165 ::558-ExPetInfo",
		"EX 0x166 ::ExUserInfoInvenWeight 558-ExSummon",
		"EX 0x167 ::558-ExNPCInfo",
		"EX 0x168 ::558-ExStartLuckyGame",
		"EX 0x169 ::558-ExBeatingLuckyGameResult",
		"EX 0x16A ::558-ExTrainingZoneAdmission",
		"EX 0x16B ::558-ExTainingZoneLeaving",
		"EX 0x16C ::558-ExPeriodicHenna",
		"EX 0x16D ::558-ExNPCInfoState",
		"EX 0x16E ::558-ExNPCInfoAbnormalVisualEffect",
		"EX 0x16F ::558-ExUserInfoInvenWeight",
		"EX 0x170 ::558-ExShowCardRewardList"
	};


	

	